Package: CrispRVariants
Type: Package
Title: Tools for counting and visualising mutations in a target
        location
Version: 1.40.0
Authors@R: c(person(given = "Helen", family = "Lindsay", role = c("aut", "cre"), email =
          "helen.lindsay@chuv.ch"))
Author: Helen Lindsay [aut, cre]
Description: CrispRVariants provides tools for analysing the results of a
    CRISPR-Cas9 mutagenesis sequencing experiment, or other sequencing experiments
    where variants within a given region are of interest. These tools allow users to
    localize variant allele combinations with respect to any genomic location (e.g.
    the Cas9 cut site), plot allele combinations and calculate mutation rates with
    flexible filtering of unrelated variants.
biocViews: ImmunoOncology, CRISPR, GenomicVariation, VariantDetection,
        GeneticVariability, DataRepresentation, Visualization,
        Sequencing
Depends: R (>= 4.3.0), ggplot2 (>= 2.2.0)
Encoding: UTF-8
License: GPL-2
Imports: AnnotationDbi, BiocParallel, Biostrings, methods,
        GenomeInfoDb, GenomicAlignments, GenomicRanges, grDevices,
        grid, gridExtra, IRanges, reshape2, Rsamtools, S4Vectors (>=
        0.9.38), utils
Suggests: BiocStyle, GenomicFeatures, knitr, rmarkdown, readxl,
        rtracklayer, sangerseqR, testthat, VariantAnnotation
VignetteBuilder: knitr
NeedsCompilation: no
RoxygenNote: 7.2.3
git_url: https://git.bioconductor.org/packages/CrispRVariants
git_branch: RELEASE_3_23
git_last_commit: c855e6f
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-28 21:29:19 UTC; biocbuild
Maintainer: Helen Lindsay <helen.lindsay@chuv.ch>

# CrisprSet class definition -----
#'@title CrisprSet class
#'@description A ReferenceClass container for holding a set of narrowed alignments,
#'each corresponding to the same target region.  Individual samples are
#'represented as CrisprRun objects.  CrisprRun objects with no on-target
#'reads are excluded.
#'CrisprSet objects are constructed with \code{\link{readsToTarget}} or
#'\code{\link{readsToTargets}}.  For most use cases, a CrisprSet object should not
#'be initialized directly.
#'@param crispr.runs A list of CrisprRun objects, typically representing individual samples
#'within an experiment
#'@param reference The reference sequence, must be the same length as the target region
#'@param target The target location (GRanges).  Variants will be counted over this region.
#'Need not correspond to the guide sequence.
#'@param rc Should the alignments be reverse complemented,
#'i.e. displayed w.r.t the reverse strand? (default: FALSE)
#'@param names A list of names for each of the samples, e.g. for displaying in plots.
#'If not supplied, the names of the crispr.runs are used, which default to the filenames
#'of the bam files if available (Default: NULL)
#'@param renumbered Should the variants be renumbered using target.loc as the zero point?
#'If TRUE, variants are described by the location of their 5'-most base with respect to the
#'target.loc.  A 3bp deletion starting 5bp 5' of the cut site would be labelled
#' as -5:3D (Default: TRUE)
#'@param target.loc The location of the Cas9 cut site with respect to the supplied target.
#'(Or some other central location).  Can be displayed on plots and used as the zero point
#'for renumbering variants. For a target region with the PAM location from bases 21-23,
#'the target.loc is base 17 (default: 17)
#'@param match.label Label for sequences with no variants (default: "no variant")
#'@param mismatch.label Label for sequences with only single nucleotide variants
#'  (default: "SNV")
#'@param bpparam A BiocParallel parameter object specifying how many cores to use.
#'The parallelisable step is calling SNVs. Parallelisation is by sample.
#' (default: SerialParam, i.e. no parallelization)
#'@param verbose If true, prints information about initialisation progress (default: TRUE)
#'@field crispr_runs A list of CrisprRun objects, typically corresponding to samples
#'of an experiment.
#'@field ref The reference sequence for the target region, as a Biostrings::DNAString object
#'@field cigar_freqs A matrix of counts for each variant
#'@field target The target location, as a GRanges object
#'@author Helen Lindsay
#'@seealso \code{\link{readsToTarget}} and \code{\link{readsToTargets}}
#'for initialising a CrisprSet, \code{\link{CrisprRun}} container for sample data.
#'@examples
#'# Load the metadata table
#'md_fname <- system.file("extdata", "gol_F1_metadata_small.txt", package = "CrispRVariants")
#'md <- read.table(md_fname, sep = "\t", stringsAsFactors = FALSE)
#'
#'# Get bam filenames and their full paths
#'bam_fnames <- sapply(md$bam.filename, function(fn){
#'  system.file("extdata", fn, package = "CrispRVariants")})
#'
#'reference <- Biostrings::DNAString("GGTCTCTCGCAGGATGTTGCTGG")
#'gd <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399), strand = "+")
#'
#'crispr_set <- readsToTarget(bam_fnames, target = gd, reference = reference,
#'                            names = md$experiment.name, target.loc = 17)
#'@export CrisprSet
#'@exportClass CrisprSet
CrisprSet = setRefClass(
  Class = "CrisprSet",
  fields = c(crispr_runs = "list",
             ref = "DNAString",
             insertion_sites = "data.frame",
             cigar_freqs = "matrix",
             target = "GRanges",
             genome_to_target = "integer",
             pars = "list")
) # -----

# CrisprSet initializer -----
CrisprSet$methods(
  initialize = function(crispr.runs, reference, target, rc = FALSE,
                        names = NULL, renumbered = TRUE, target.loc = 17,
                        match.label = "no variant", mismatch.label = "SNV",
                        bpparam = BiocParallel::SerialParam(),
                        verbose = TRUE, ...){

    # Assume: initializer not called directly, inputs checked by readsToTarget
    # To do: test if checks for empty CrisprRuns are redundant
    # Note: genomeToTargetLocs uses the strand of the target,
    # change strand of target if orientation = "positive"?
    # TO DO: REMOVE VARIANT COUNTING PARAMS FROM INITIALISER
    
    # Setting up code to allow for a Cpf1 setting in future
    enzyme <- "Cas9"

    if (isTRUE(verbose)){
      message(sprintf("Initialising CrisprSet %s:%s-%s with %s samples",
                  as.character(seqnames(target)), start(target), end(target),
                  length(crispr.runs)))
    }

    if (isTRUE(renumbered) & is.na(target.loc)){
      stop("Must specify target.loc for renumbering variant locations.\n",
           "The target.loc is the zero point with respect to the reference string.\n",
           "This is typically 17 for a 23 bp Crispr-Cas9 guide sequence")
    }

    target <<- target
    ref <<- reference
    pars <<- list("match_label" = match.label, "target.loc" = target.loc,
                  "mismatch_label" = mismatch.label, "renumbered" = renumbered,
                  "all_chimeric" = FALSE, "rc" = rc, "enzyme" = enzyme)

    crispr_runs <<- crispr.runs

    if (is.null(names)) {
      names(.self$crispr_runs) <- sapply(.self$crispr_runs, function(x) x$name)
    }else {
      names(.self$crispr_runs) <- names
    }
    
    nonempty_runs <- sapply(.self$crispr_runs, function(x) {
      ! ( length(x$alns) == 0 & length(x$chimeras) == 0 )
    })

    .self$crispr_runs <<- .self$crispr_runs[nonempty_runs]
    if (length(.self$crispr_runs) == 0) stop("no on target reads in any sample")

    is_plus <- as.character(strand(target)) %in% c("+", "*")
    
    if (unique(sapply(.self$crispr_runs, function(x) length(x$alns)) == 0)){
      pars["all_chimeric"] <<- TRUE
      dummy <- .self$.genomeToTargetLocs(target.loc, start(target),
                                end(target), plus_strand = is_plus,
                                gs = start(target), ge = end(target))
      return()
    }
                
    dummy <- .self$.genomeToTargetLocs(target.loc, start(target),
                                       end(target), plus_strand = is_plus)

    
  }, # -----

  # show -----
  show = function(){
    cat(sprintf(paste0("CrisprSet object containing %s CrisprRun samples\n",
                         "Target location:\n"), length(.self$crispr_runs)))
    print(.self$target)
    print("Most frequent variants:")
    print(.self$.getFilteredCigarTable(top.n = 6))
  }, # -----

  # .checkSamplesAndAlleles -----
  .checkSamplesAndAlleles = function(alleles, samples){
    # Not currently used
    # checks before removing alleles from particular samples 
    
    if (is.null(samples)) return()
    stopifnot(identical(length(alleles), length(samples)))
    if (is.character(samples) & ! 
        all(samples %in% names(.self$crispr_runs))){
      stop("Samples should be either sample names or numeric indices")
    }
    if (is.numeric(samples)){
      nsamples <- length(.self$crispr_runs)
      too_large <- samples > nsamples
      if (any(too_large)){
        stop(sprintf("Cannot select sample %s as there are only %s samples",
                     which(too_large)[1], nsamples))
      }
    }
    missing_alleles <- setdiff(unique(alleles), rownames(.self$cigar_freqs))
    if (any(missing_alleles)){
      warning(sprintf("Alleles not found: %s", 
                      paste(missing_alleles, sep = ", ")))
    }
  }, # -----
  
  # .setCigarLabels -----
  setCigarLabels = function(labels = NULL, label.func = NULL, verbose = FALSE, ...){
    #Optional params include:
    #split.snv Should single nucleotide variants (SNVs) be shown for
    #          reads without an insertion or deletion? (default: TRUE)
    #upstream.snv  If split.snv = TRUE, how many bases upstream of the
    #              target.loc should SNVs be shown?  (default: 8)
    #downstream.snv If split.snv = TRUE, how many bases downstream of 
    #               the target.loc should SNVs be shown? (default: 6)
    
      # To do: add checks that replacement alleles still have same indel combinations
      # or write a consensus function for alleles with different indels 
      # Make return value self instead of labels
      # (long term switching to pure S4 class)
    
      if (isTRUE(verbose)) message("Renaming cigar strings\n")
    
      if (! is.null(label.func)){
        labels <- label.func(alns(.self), ...)
      }

      if (! is.null(labels)){
        if (! all(lengths(labels) == lengths(alns(.self)))){
          stop("Lengths of labels not identical to length of alignments")
        }
        
        dummy <- lapply(seq_along(labels), function(i){
          crun <- .self$crispr_runs[[i]]
          mcols(crun$alns)$allele <- labels[[i]]
          crun$field("cigar_labels", labels[[i]])
        })
        cig_by_run <- labels
      
      } else { 
        cig_by_run <- .defaultCigarLabels(.self, ...)
      }
    
      if (isTRUE(verbose)) message("Counting variant combinations\n")
      .self$.countCigars(cig_by_run)
      .self$.getInsertions()
      invisible(cig_by_run)
  }, # -----

  # .countCigars -----
  .countCigars = function(cig_by_run = NULL, nonvar_first = TRUE){
    # Note that this function does not consider starts, two alignments starting at
    # different locations but sharing a cigar string are considered equal

    if (is.null(cig_by_run)){
      cig_by_run <- lapply(.self$crispr_runs, function(crun) crun$cigar_label)
    }

    unique_cigars <- unique(unlist(cig_by_run))

    chimera_combs <- lapply(.self$crispr_runs, function(crun) crun$chimera_combs)

    m <- matrix(unlist(lapply(cig_by_run, function(x) table(x)[unique_cigars])),
                nrow = length(unique_cigars),
                dimnames = list(unique_cigars, names(.self$crispr_runs)))

    m[is.na(m)] <- 0
    m <- m[order(rowSums(m), decreasing = TRUE),, drop = FALSE]

    if (nonvar_first){
      is_ref <- grep(.self$pars["match_label"], rownames(m))
      is_snv <- grep(.self$pars["mismatch_label"], rownames(m))
      new_order <- setdiff(1:nrow(m), c(is_ref,is_snv))
      m <- m[c(is_ref,is_snv, setdiff(1:nrow(m), c(is_ref,is_snv))),, drop = FALSE]
    }

    .self$field("cigar_freqs", m)
  }, # -----

  # filterUniqueLowQual -----
  filterUniqueLowQual = function(min_count = 2, max_n = 0, verbose = TRUE){
'
Description:
  Deletes reads containing rare variant combinations and more than
  a minimum number of ambiguity characters within the target region.
  These are assumed to be alignment errors.

Input parameters:
  min_count:    the number of times a variant combination must occur across
                all samples to keep (default: 2, i.e. a variant must occur
                at least twice in one or more samples to keep)
  max_n:        maximum number of ambiguity ("N") bases a read with a rare
                variant combination may contain.  (default: 0)
  verbose:      If TRUE, print the number of sequences removed (default: TRUE)
'
    # Find low frequency variant combinations, then find the corresponding samples
    low_freq <- .self$cigar_freqs[rowSums(.self$cigar_freqs) < min_count, , drop = FALSE]
    lf_cig_by_run <- apply(low_freq, 2, function(x) names(x)[x != 0])
    lns <- lapply(lf_cig_by_run, length)
    lf_cig_by_run <- lf_cig_by_run[lns > 0]

    # Find the corresponding reads, count the ambiguity characters
    rm_cset <- unlist(lapply(names(lf_cig_by_run), function(name){
      crun <- cset$crispr_runs[[name]]
      get_idxs <- match(lf_cig_by_run[[name]], crun$cigar_labels)
      sqs <- mcols(crun$alns[get_idxs])$seq
      to_remove <- get_idxs[as.numeric(Biostrings::letterFrequency(sqs, "N")) > max_n]
      cset_to_remove <- match(crun$cigar_labels[to_remove], rownames(cset$cigar_freqs))
      if (length(to_remove) > 0) crun$removeSeqs(to_remove)
      return(cset_to_remove)
    }))
    if (isTRUE(verbose)){
      message(sprintf("Removing %s rare sequence(s) with ambiguities\n",
                      length(rm_cset)))
    }
    if ( length(rm_cset) > 0){
      .self$field("cigar_freqs", .self$cigar_freqs[-rm_cset,,drop = FALSE])
    }
  }, # -----

  # .getFilteredCigarTable -----
  .getFilteredCigarTable = function(top.n = nrow(.self$cigar_freqs),
                                    min.count = 1, min.freq = 0,
                                    include.chimeras = TRUE,
                                    include.nonindel = TRUE,
                                    exclude = NULL,
                                    type = c("counts", "proportions")){

    # Consider reordering by proportion instead of count at initialisation?

    result <- match.arg(type)

    # Add the chimeric alignments to the bottom
    if (isTRUE(include.chimeras)){
      ch_cnts <- sapply(.self$crispr_runs, function(crun) {
        length(unique(names(crun$chimeras)))
      })

      m <- .self$cigar_freqs
      if (length(m) > 0 & sum(ch_cnts) > 0){
        m_nms <- rownames(m)
        m <- rbind(m, ch_cnts)
        rownames(m) <- c(m_nms, "Other")
      } else if (length(m) == 0){
        m <- matrix(ch_cnts, nrow = 1,
                    dimnames =list("Other", names(ch_cnts)))
      }
      # If all rows should be returned, add 1 to top.n
      if (top.n == nrow(.self$cigar_freqs)) top.n <- top.n + 1
    } else {
      m <- .self$cigar_freqs
      if (nrow(m) == 0) return(NULL)
    }
    
    # Filtering takes precedence over removing nonvariants
    # and selecting top.n

    # Default freq cutoff drops "Other" if there are no chimeras
    propns <- prop.table(m,2) * 100
    # At least one column has proportion greater than cutoff
    keep_freq <- rowSums(propns >= min.freq) > 0
    keep_count <- rowSums(m >= min.count) > 0
    propns <- propns[keep_freq & keep_count,, drop = FALSE]

    # Top variants are calculated by proportional contributions
    rs <- rowSums(propns)
    topn <- rank(-rs) <= top.n

    if (result == "proportions"){
      # Return proportions
      m <- propns[topn ,, drop = FALSE]
    } else {
      # Return counts
      m <- m[keep_freq & keep_count,, drop = FALSE][topn,, drop = FALSE]
    }

    # Filtering
    if (include.nonindel == FALSE){
      nvr <- sprintf("%s|%s", .self$pars$match_label, .self$pars$mismatch_label)
      m <- m[!grepl(nvr, rownames(m)),,drop = FALSE]
    }
    if (! is.null(exclude)){
      m <- m[! rownames(m) %in% exclude,, drop = FALSE]
    }
    
    m
  }, # -----

  # .getUniqueIndelRanges -----
  .getUniqueIndelRanges = function(add_chr = TRUE, add_to_ins = TRUE){
    # Note this only gets the ranges, not the sequences, inserted sequences may differ
    # Returns a GRanges object of all insertions and deletions, with names = variant names
    # if "add_chr" == TRUE, chromosome names start with "chr"
    # if add_to_ins == TRUE, adds one to end of insertions, as required for VariantAnnotation

    cig_by_run <- lapply(.self$crispr_runs, function(crun) crun$cigar_labels)
    all_cigars <- unlist(cig_by_run)
    unique_cigars <- !duplicated(all_cigars) & 
      ! all_cigars %in% c(.self$pars$match_label, .self$pars$mismatch_label)

    x <- alns(.self)

    ir <- cigarRangesAlongReferenceSpace(unlist(cigar(x)),
                pos = unlist(GenomicAlignments::start(x)),
                ops = c("I","D"), with.ops = TRUE)
    
    ir <- ir[unique_cigars]
    el <- elementNROWS(ir)
    ir <- unlist(ir)

    if (add_to_ins){
      ins_idxs <- names(ir) == "I"
      #ins_idxs <- unlist(co[idxs] == "I")
      end(ir[ins_idxs]) <- end(ir[ins_idxs]) + 1
   }

   names(ir) <- rep(all_cigars[unique_cigars], el)

   chrom <- as.character(seqnames(.self$target))
   if (add_chr & ! grepl('^chr', chrom)){
      chrom <- paste0("chr", chrom)
   }

    GenomicRanges::GRanges(chrom, ir)
  }, # -----

  # filterVariants -----
  filterVariants = function(cig_freqs = NULL, names = NULL, columns = NULL,
                            include.chimeras = TRUE){
'
Description:
  Relabels specified variants in a table of variant allele counts as 
  non-variant, e.g. variants known to exist in control samples.
  Accepts either a size, e.g. "1D", or a specific mutation, e.g. "-4:3D".
  For alleles that include one variant to be filtered and one other variant,
  the other variant will be retained.
  If SNVs are included, these will be removed entirely, but note that SNVs
  are only called in reads that do not contain an insertion/deletion variant

Input parameters:
  cig_freqs:        A table of variant allele counts 
                    (Default: NULL, i.e. .self$cigar_freqs)
  names:            Labels of variants alleles to remove (Default: NULL)
  columns:          Indices or names of control samples.  Remove all variants that 
                    occur in these columns.  (Default: NULL)
  include.chimeras: Should chimeric reads be included? (Default: TRUE)
'

    # Potential improvements:
    # Column must include only column names from .self$cigar_freqs
    # Cannot exclude complex variants?

    if (is.null(cig_freqs)){
      cig_freqs <- .self$.getFilteredCigarTable(include.chimeras = include.chimeras)
    }
    vars <- strsplit(rownames(cig_freqs), ",")
 
    if (length(columns) > 0){
      # Select the rownames that occur in columns
      cols <- rownames(cig_freqs)[rowSums(cig_freqs[,columns, drop=FALSE]) > 0]
    } else {
      cols <- NULL
    }

    to_remove <- c(names, cols)
    rm_snv <- grepl(.self$pars$mismatch_label, to_remove)
    has_loc <- grepl(":", to_remove) & ! rm_snv
    by_loc <- to_remove[has_loc]
    by_size <- to_remove[!(has_loc|rm_snv)]
    
    # Remove SNVs - SNVS have format SNV:-1,-5, other vars -1:3D etc
    rm_snv <- gsub(".*:(.*)", "\\1", names[rm_snv])
    temp <- gsub(".*:(.*)", "\\1", unlist(vars))
    rm_snvs <- sapply(relist(temp %in% rm_snv, vars), any)
    vars[rm_snvs] <- NULL
    cig_freqs <- cig_freqs[!rm_snvs, , drop=FALSE]

    # Reclassify indel variants as non-variant
    loc_mask <- rep(TRUE, length(unlist(vars)))
    size_mask <- loc_mask

    # Remove by location
    if (length(by_loc) > 0){
      loc_mask <- !grepl(paste(by_loc, collapse = "|"), unlist(vars))
    }
    # Remove by size - cannot be mutation combinations
    if (length(by_size) > 0){
      size_mask <- !(gsub(".*:", "", unlist(vars)) %in% by_size)
    }
    mask <- relist(loc_mask & size_mask, vars)
    vars <- as.list(IRanges::CharacterList(vars)[mask])
    vars <- lapply(vars, base::paste, sep = ",", collapse = ",")

    vars[vars == ""] <- .self$pars$match_label
    cig_freqs <- rowsum(cig_freqs, unlist(vars))
    cig_freqs
  }, # -----

  # .getSNVs -----
  .getSNVs = function(min.freq = 0.25, include.chimeras = TRUE){
    # Potential improvements:
    # Inconsistency between input (0-1) and output (0-100)
    
    cig_fqs <- .self$.getFilteredCigarTable(include.chimeras = include.chimeras)
    snv <- .self$pars["mismatch_label"]
    snv_nms <- rownames(cig_fqs)[grep(snv, rownames(cig_fqs))]
    all_snv_locs <- strsplit(gsub(sprintf("%s|:", snv), "", snv_nms), ",")
    snv_locs <- unique(unlist(all_snv_locs))
    asv <- unlist(all_snv_locs)
    total_count <- colSums(cig_fqs)
    
    snv_fqs <- structure(vector(length = length(snv_locs)), names = snv_locs)
    for (snv_loc in snv_locs){
      # Check if this SNV location occurs within the allele
      nms <- snv_nms[sapply(relist(asv == snv_loc, all_snv_locs), any)]
      snv_count <- colSums(cig_fqs[nms,, drop = FALSE])
      fq <- snv_count/total_count * 100
      snv_fqs[snv_loc] <- max(fq)
    }
    snv_fqs[snv_fqs >= min.freq*100]
  }, # -----

  # mutationEfficiency -----
  mutationEfficiency = function(snv = c("non_variant", "include","exclude"),
                                include.chimeras = TRUE,
                                exclude.cols = NULL, group = NULL,
                                filter.vars = NULL, filter.cols = NULL,
                                count.alleles = FALSE, per.sample = TRUE,
                                min.freq = 0){
'
Description:
  Calculates summary statistics for the mutation efficiency, i.e.
  the percentage of reads that contain a variant.  Reads that do not
  contain and insertion or deletion, but do contain a single nucleotide
  variant (snv) can be considered as mutated, non-mutated, or not
  included in efficiency calculations as they are ambiguous.
  Note: mutationEfficiency does not treat partial alignments differently


Input parameters:
  snv:    One of "include" (consider reads with mismatches to be mutated),
          "exclude" (do not include reads with snvs in efficiency calculations),
          and "non_variant" (consider reads with mismatches to be non-mutated).
  include.chimeras: Should chimeras be counted as variants?  (Default: TRUE)
  exclude.cols:   A list of column names to exclude from calculation, e.g. if one
                  sample is a control (default: NULL, i.e. include all columns)
  group:          A grouping variable.  Efficiency will be calculated per group,
                  instead of for individual.
                  Cannot be used with exclude.cols.
  filter.vars:    Variants that should not be counted as mutations.
  filter.cols:    Column names to be considered controls.  Variants occuring in
                  a control sample will not be counted as mutations.
  count.alleles:  If TRUE, also report statistics about the number of alleles
                  per sample/per group. (Default:  FALSE)
  per.sample:     Return efficiencies for each sample (Default: TRUE)
  min.freq:       Minimum frequency for counting alleles.  Does not apply to
                  calculating efficiency.  To filter when calculating 
                  efficiency, first use "variantCounts".
                  (Default: 0, i.e. no filtering)
Return value:
  A vector of efficiency statistics per sample and overall, or a
  matrix if a group is supplied.

'
    if (! is.null(group) && ! is.null(exclude.cols)){
      stop("Only one of group or exclude.cols may be supplied")
    }

    snv <- match.arg(snv)
    freqs <- .self$cigar_freqs
    if (isTRUE(include.chimeras)){
      freqs <- .self$.getFilteredCigarTable(include.chimeras = include.chimeras)
    }

    # Exclude unwanted columns, e.g. controls
    exclude.idxs <- match(exclude.cols, colnames(freqs))
    if (any(is.na(exclude.idxs))){
      nf <- exclude.cols[is.na(exclude.idxs)]
      stop(sprintf("Column(s) %s not found in variant counts table",
                   paste(nf, collapse = " ")))
    }

    if (length(filter.vars) > 0 | length(filter.cols) > 0){
      freqs <- .self$filterVariants(cig_freqs = freqs, names = filter.vars,
                                    columns = filter.cols)
    }

    if (length(exclude.idxs) > 0){
      freqs <- freqs[,-exclude.idxs, drop = FALSE]
    }

    is_snv <- grep(.self$pars$mismatch_label, rownames(freqs))

    if (snv == "exclude"){
      if (length(is_snv) > 0) freqs <- freqs[-is_snv,,drop = FALSE]
    }

    total_seqs <- colSums(freqs)
    names(total_seqs) <- colnames(freqs)
    not_mutated <- grep(.self$pars$match_label, rownames(freqs))
    if (snv == "non_variant") not_mutated <- c(not_mutated, is_snv)

    if (length(not_mutated) > 0) freqs <- freqs[-not_mutated,,drop = FALSE]

    if (! is.null(group)){
      if (! is.factor(group)) group <- as.factor(group)
      result <- lapply(levels(group), function(g){
        eff <- .self$.calculateEfficiency(freqs[,group == g, drop = FALSE],
                                          total_seqs, count.alleles,
                                          per.sample, min.freq)
        
      })
      result <- do.call(rbind, result)
      rownames(result) <- levels(group)
      return(result)
    }

    .self$.calculateEfficiency(freqs, total_seqs, count.alleles, 
                               per.sample, min.freq)
  }, # -----

  # .calculateEfficiency -----
  .calculateEfficiency = function(freqs, total_seqs, count.alleles, 
                                  per.sample, min.freq = 0){
     mutants <- colSums(freqs)
     ts <- total_seqs[colnames(freqs)]
     mutant_efficiency = mutants/ts * 100
     average <- mean(mutant_efficiency)
     median <- median(mutant_efficiency)
     overall <- sum(mutants)/ sum(ts) * 100
     sds <- sd(mutants)
     result <- round(c(mutant_efficiency, average, median, overall, sds, 
                       sum(ts)),2)
     names(result) <- c(colnames(freqs), "Average","Median","Overall",
                        "StDev","ReadCount")
     
     if (isTRUE(count.alleles)){
       result <- c(result, .self$.countVariantAlleles(freqs, ts,
                                        min.freq))
     }
     if (! isTRUE(per.sample)){
       result <- result[!names(result) %in% colnames(freqs)]
     }
     result
  }, # -----

  # .countVariantAlleles ----
  .countVariantAlleles = function(freqs, total_seqs, min.freq){
    # how many nonzero entries per sample (absolute and percentage)
    # This step removes variants that never occur in this sample group
    
    freqs/total_seqs * 100
    
    if (min.freq > 0){
      propn <- freqs/total_seqs * 100
      freqs[propn < min.freq] <- 0
    }
    freqs <- freqs[rowSums(freqs) > 0,, drop = FALSE]
    
    if (nrow(freqs) == 0) return(vector())
    alleles <- colSums(freqs > 0)
    alleles_pc <- alleles/nrow(freqs)*100
    
    # Rate of new alleles (how many sequences per allele)
    # Produces "NA" if any samples have 0 alleles
    allele_rate <- colSums(freqs)/alleles
    nvars <- nrow(freqs)
    
    result <- c(mean(alleles), mean(alleles_pc), mean(allele_rate), min(alleles),
                max(alleles), nvars)
    result <- sapply(result, round, 2)
    names(result) <- c("AvAlleles","AvPctAlleles","SeqsPerAllele", 
                       "MinAlleles", "MaxAlleles","TotalAlleles")
    result
  }, # -----

  # classifyVariantsByType -----
  classifyVariantsByType = function(...){
'
Description:
  Classifies variants as insertions, deletions, or complex (combinations).
  In development
Input parameters:
  ...   Optional arguments to "variantCounts" for filtering variants
        before classification
Return value:
  A named vector classifying variant alleles as insertions, deletions, etc
'
   
    filter_pars <- dispatchDots(.self$.getFilteredCigarTable, ...) 
    nms <- rownames(do.call(.self$.getFilteredCigarTable, filter_pars))
    vars <- rep(NA, length(nms))
    names(vars) <- nms
    is_snv <- grepl(.self$pars$mismatch_label, nms)
    is_ref <- grepl(.self$pars$match_label, nms)
    is_ins <- grepl("I", nms)
    is_del <- grepl("D", nms)
    is_complex <- grepl(",", nms)
    ins_and_del <- is_ins & is_del
    vars[is_ref] <- .self$pars$match_label
    vars[is_snv] <- .self$pars$mismatch_label
    vars[which(nms == "Other")] <- "Other"
    vars[is_ins] <- "insertion"
    vars[is_del] <- "deletion"
    vars[ins_and_del] <- "insertion/deletion"
    vars[is_complex & is_ins & ! ins_and_del] <- "multiple insertions"
    vars[is_complex & is_del & ! ins_and_del] <- "multiple deletions"
    
    vars
  }, # -----

  # classifyVariantsByLoc -----
  classifyVariantsByLoc = function(txdb, add_chr = TRUE, verbose = TRUE, ...){
  '
Description:
  Uses the VariantAnnotation package to look up the location of the
  variants.  VariantAnnotation allows multiple classification tags per variant,
  this function returns a single tag.  The following preference order is used:
  spliceSite > coding > intron > fiveUTR > threeUTR > promoter > intergenic

Input parameters:
  txdb:     A BSgenome transcription database
  add_chr:  Add "chr" to chromosome names to make compatible with UCSC (default: TRUE)
  verbose:  Print progress (default: TRUE)
  ...:      Filtering arguments for variantCounts

Return value:
  A vector of classification tags, matching the rownames of .self$cigar_freqs
  (the variant count table)
  '

    if (isTRUE(verbose)) message("Looking up variant locations\n")

    stopifnot(requireNamespace("VariantAnnotation"))

    gr <- .self$.getUniqueIndelRanges(add_chr)
    locs <- VariantAnnotation::locateVariants(gr, txdb, VariantAnnotation::AllVariants())
    if (isTRUE(verbose)) message("Classifying variants\n")

    locs_codes <- paste(seqnames(locs), start(locs), end(locs), sep = "_")
    # Note that all indels have the same range
    indel_codes <- paste(seqnames(gr), start(gr), end(gr), sep = "_")
    indel_to_loc <- lapply(indel_codes, function(x) locs$LOCATION[which(locs_codes == x)])

    var_levels <- c("spliceSite","coding","intron","fiveUTR",
                    "threeUTR","promoter", "intergenic")
    result <- unlist(lapply(indel_to_loc, function(x){
      y <- factor(x,levels = var_levels)
      if (length(y) == 0) return(NA)
      var_levels[min(as.numeric(y))]}))
    names(result) <- names(gr)

    filter_pars <- dispatchDots(.self$.getFilteredCigarTable, ...)
    vars <- rownames(do.call(.self$.getFilteredCigarTable, filter_pars))
    classification <- rep("", length(vars))
    names(classification) <- vars

    no_var <- grep(.self$pars$match_label, vars)
    classification[no_var] <- .self$pars$match_label
    snv <- grep(.self$pars$mismatch_label, vars)
    classification[snv] <- .self$pars$mismatch_label
    classification[which(vars == "Other")] <- "Other"

    result <- result[names(result) %in% vars]
    ord <- match(names(result), vars)
    classification[ord] <- result
    classification
  }, # -----

  # classifyCodingBySize -----
  classifyCodingBySize = function(var_type, cutoff = 10){
'
Description:
    This is a naive classification of variants as frameshift or in-frame
    Coding indels are summed, and indels with sum divisible by 3 are
    considered frameshift.  Note that this may not be correct for variants
    that span an intron-exon boundary
Input paramters:
    var_type:   A vector of var_type. Only variants with var_type == "coding" 
                are considered.  Intended to work with classifyVariantsByLoc
    cutoff:     Variants are divided into those less than and greater 
                than "cutoff" (Default: 10)
Result:
    A character vector with a classification for each variant allele
'

    is_coding <- var_type == "coding" & ! is.na(var_type)

    indels <- .self$.getFilteredCigarTable()[is_coding,,drop = FALSE]
    if (length(indels) > 0){
      temp <- lapply(rownames(indels), function(x) strsplit(x, ",")[[1]])
      indel_grp <- rep(c(1:nrow(indels)), elementNROWS(temp))
      indel_ln <- rowsum(as.numeric(gsub("^.*:([0-9]+)[DI]", "\\1", unlist(temp))),
                         indel_grp)

      inframe <- indel_ln %% 3 == 0
      is_short <- indel_ln < cutoff

      indel_grp <- rep(sprintf("inframe indel < %s", cutoff), nrow(indels))
      indel_grp[is_short &! inframe] <- sprintf("frameshift indel < %s", cutoff)
      indel_grp[!is_short & inframe] <- sprintf("inframe indel > %s", cutoff)
      indel_grp[!is_short & !inframe] <- sprintf("frameshift indel > %s", cutoff)
      var_type[is_coding] <- indel_grp
    }

    var_type
  }, # -----

  # heatmapCigarFreqs -----
  heatmapCigarFreqs = function(as.percent = TRUE, x.size = 8, y.size = 8,
                               x.axis.title = NULL, x.angle = 90,
                               min.freq = 0, min.count = 0,
                               top.n = nrow(.self$cigar_freqs),
                               type = c("counts", "proportions"),
                               header = c("default", "counts", "efficiency"),
                               order = NULL, alleles = NULL, 
                               create.plot = TRUE, ...){

    '
Description:
    Internal method for CrispRVariants:plotFreqHeatmap, optionally filters the table
    of variants, then a table of variant counts, coloured by counts or proportions.

Input parameters:
    as.percent:   Should colours represent the percentage of reads per sample 
                  (TRUE) or the actual counts (FALSE)?  (Default: TRUE)
    x.size:       Font size for x axis labels (Default: 8)
    y.size:       Font size for y axis labels (Default: 8)
    x.axis.title: Title for x axis
    min.freq:     Include only variants with frequency at least min.freq in at 
                  least one sample
    min.count:    Include only variants with count at least min.count in at 
                  least one sample
    top.n:        Include only the n most common variants
    type:         Should labels show counts or proportions?  (Default: counts)
    header:       What should be displayed in the header of the heatmap.
                  Default: total count for type = "counts" or proportion of
                  reads shown in the matrix for type = "proportions".
                  If "counts" is selected, total counts will be shown for both
                  types.  "efficiency" shows the mutation efficiency
                  (calculated with default settings)
    order:        Reorder the columns according to this order (Default: NULL)
    alleles:      Names of alleles to include.  Selection of alleles takes
                  place after filtering (Default: NULL).
    exclude:      Names of alleles to exclude (Default: NULL)
    create.plot:  Should the plot be created (TRUE, default), or the data used in
                  the plot returned.
    ...:          Extra filtering or plotting options

Return value:
    A ggplot2 plot object.  Call "print(obj)" to display

See also:
    CrispRVariants::plotFreqHeatmap
    '

    filter_fun <- .self$.getFilteredCigarTable
    filter.args <- suppressWarnings(dispatchDots(filter_fun,
                           top.n = top.n, min.count = min.count,
                           min.freq = min.freq, type = type, ...))
    
    cig_freqs <- do.call(filter_fun, filter.args)

    # Alleles determines row order and alleles included
    if (! is.null(alleles)){
      # Move "Other" to the end for consistency with plotAlignments
      is_other <- which(alleles == "Other")
      alleles <- alleles[c(setdiff(seq_along(alleles), is_other), is_other)]
      row_ord <- match(alleles, rownames(cig_freqs))
      if (any(is.na(row_ord))){
        warning(sprintf("After filtering, alleles %s not found.", 
                        paste(alleles[is.na(row_ord)], collapse = ", ")))
      }
      cig_freqs <- cig_freqs[na.omit(row_ord),, drop = FALSE]
    }
    
    header_type <- match.arg(header)
    header_name <- "Total"
    type <- match.arg(type)
    
    if (header_type == "default" | header_type == "counts"){
      header <- colSums(.self$.getFilteredCigarTable())
    } else if (header_type == "efficiency"){
      header <- .self$mutationEfficiency()[1:ncol(cig_freqs)]
      header_name <- "Mutation efficiency"
    }

    if (type == "proportions"){
      # If type == proportions, default means proportions not counts
      if (header_type == "default") header <- round(colSums(cig_freqs), 2)
      cig_freqs <- round(cig_freqs, 2)
      col_sums <- rep(100, ncol(cig_freqs))
    } else if (type == "counts"){
      col_sums <- colSums(.self$.getFilteredCigarTable())
    }

    # Order the columns
    if (! is.null(order)){
      cig_freqs <- cig_freqs[,order, drop = FALSE]
      header <- header[order]
      col_sums <- col_sums[order]
    }

    freq_heatmap_args <- list(obj = cig_freqs, header = header,
                              header.name = header_name,
                              col.sums = col_sums, as.percent = as.percent,
                              x.size = x.size, y.size = y.size,
                              x.axis.title = x.axis.title,
                              x.angle = x.angle, add.other = TRUE)
    
    freq_heatmap_args <- modifyList(freq_heatmap_args, list(...))
    
    if (! isTRUE(create.plot)){
       return(freq_heatmap_args)
    }
    
    p <- plotFreqHeatmap(cig_freqs, header = header, header.name = header_name,
                         col.sums = col_sums, as.percent = as.percent,
                         x.size = x.size, y.size = y.size,
                         x.axis.title = x.axis.title,
                         x.angle = x.angle, add.other = TRUE, ...)
    return(p)
  }, # -----

  # plotVariants -----
  plotVariants = function(min.freq = 0, min.count = 0,
                   top.n = nrow(.self$cigar_freqs), alleles = NULL,
                   renumbered = .self$pars["renumbered"],
                   add.other = TRUE, create.plot = TRUE,
                   plot.regions = NULL, allow.partial = TRUE, ...){
'
Description:
  Internal method for CrispRVariants:plotAlignments, optionally filters the table
  of variants, then plots variants with respect to the reference sequence,
  collapsing insertions and displaying insertion sequences below the plot.

Input parameters:
  min.freq:         i(%) include variants that occur in at least i% of reads
                    in at least one sample
  min.count         i (integer) include variants that occur at leas i times in
                    at least one sample
  top.n:            n (integer) Plot only the n most frequent variants
                    (default: plot all)
                    Note that if there are ties in variant ranks,
                    top.n only includes ties with all members ranking <= top.n
  alleles:          Alleles to include after filtering.  Default NULL means use all
                    alleles that pass filtering.
  renumbered:       If TRUE, the x-axis is numbered with respect to the target
                    (cut) site.  If FALSE, x-axis shows genomic locations.
                    (default: TRUE)
  add.other         Add a blank row named "Other" for chimeric alignments,
                    if there are any (Default: TRUE)
  create.plot       Data is plotted if TRUE and returned without if FALSE.
                    (Default: TRUE)
  plot.regions      Subregion of the target to plot (Default: NULL)
  allow.partial     Should partial alignments be allowed?  (Default: TRUE)
  ...               additional arguments for plotAlignments

Return value:
  A ggplot2 plot object.  Call "print(obj)" to display
'
    dots <- list(...)
    
    # Potential improvement: user supplied filter_fun
    # Filter by frequency, count etc
    filter_fun <- .self$.getFilteredCigarTable  
    filter.args <- suppressWarnings(dispatchDots(filter_fun,
                                top.n = top.n, min.count = min.count,
                                min.freq = min.freq, ...))
    cig_freqs <- do.call(filter_fun, filter.args)
    
    # Filter by name specify a row order
    if (! is.null(alleles)){
      row_ord <- match(alleles, rownames(cig_freqs))
      if (any(is.na(row_ord))){
        warning(sprintf("After filtering, alleles %s not found.", 
                        paste(alleles[is.na(row_ord)], collapse = ", ")))
      }
      cig_freqs <- cig_freqs[na.omit(row_ord),, drop = FALSE]
    }
    
    # Remove "Other" alignments (if there are any) before making alignment
    # strings
    if ("Other" %in% rownames(cig_freqs)){
      cig_freqs <- cig_freqs[rownames(cig_freqs) != "Other",, drop = FALSE]
    } else {
      add.other <- FALSE
    }

    # Make the alignment strings to be displayed in the plot
    alns <- .self$makePairwiseAlns(cig_freqs, allow_partial = allow.partial)

    # Set the location for the vertical line indicating the zero point
    tloc <- ifelse(is.na(.self$pars$target.loc), 17, .self$pars$target.loc)
        
    ins.sites <- .self$insertion_sites

    # If necessary, reverse complement the inserted sequences
    if (isTRUE(.self$pars$rc)){
      temp <- seq_along(1:width(.self$target))
      starts <- rev(temp) +1 # +1 because considering the leftmost point
      names(starts) <- temp
      ins.sites$start <- starts[ins.sites$start]
      ins.sites$seq <- as.character(reverseComplement(DNAStringSet(ins.sites$seq)))
    }
    
    # Get coordinates with respect to target instead of genome
    if (isTRUE(renumbered)){
      genomic_coords <- c(start(.self$target):end(.self$target))
      target_coords <- .self$genome_to_target[as.character(genomic_coords)]
      if (isTRUE(.self$pars$rc)){
        target_coords <- rev(target_coords)
      }
      #xbreaks = which(target_coords %% 5 == 0 | abs(target_coords) == 1)
      #target_coords <- target_coords[xbreaks]
      #args <- list(obj = .self$ref, alns = alns, ins.sites = ins.sites,
      #             xtick.labs = target_coords, xtick.breaks = xbreaks,
      #             target.loc =  tloc, add.other = add.other)
      
      xtcks <- .getAxisCoords(seq_along(target_coords), target_coords)
      
      args <- list(obj = .self$ref, alns = alns, ins.sites = ins.sites,
                  xtick.labs = xtcks$tick_labs, xtick.breaks = xtcks$tick_locs,
                  target.loc =  tloc, add.other = add.other)
      
    } else {
      args <- list(obj = .self$ref, alns = alns, ins.sites = ins.sites,
                   target.loc = tloc, add.other = add.other)
    }
    
    args <- modifyList(args, dots)
    
    # If displaying the reverse complement, target loc is to the left
    strd <- as.character(strand(.self$target))

    reverse_tloc <- (strd == "+" & isTRUE(.self$pars$rc)) |
                    (strd == "-" & ! isTRUE(.self$pars$rc))
    
    if (isTRUE(reverse_tloc)){
        tloc <- width(.self$target) - tloc
        args["target.loc"] <- tloc
        args["pam.start"] <- tloc - 5
        args["pam.end"] <- tloc - 3
        args[["guide.loc"]] <- IRanges::IRanges(tloc - 5, tloc + 17)
    }

    args <- modifyList(args, dots)
    
    if (! is.null(plot.regions)){
      args <- .self$.truncatePlot(args, plot.regions, target_coords)
      if (! "plot.text.size" %in% args){ args$plot.text.size <- 3 }
    }
    
    if (! isTRUE(create.plot)) return(args)
    
    p <- do.call(plotAlignments, args)
    return(p)
  }, # -----

  # .truncatePlot -----
  .truncatePlot = function(plot_args, keep, target_coords){
    # To do: fix the box location if it is truncated

    
    trunc_result <- selectAlnRegions(alns = plot_args$alns,
                                     reference = plot_args$obj,
                                     target = .self$target,
                                     keep)
    
    new_starts <- .adjustRelativeInsLocs(target = .self$target,
                                         keep = trunc_result$keep,
                                         starts = plot_args$ins.sites$start,
                                         trunc_result$nchar_join)
    
    lb <- c(start(keep)[2:length(keep)], end(keep)[1:length(keep)-1])
    keep_tcks <- ! trunc_result$indices == 0
    xtcks <- .getAxisCoords(trunc_result$indices[keep_tcks],
                            target_coords[keep_tcks],
                            loc.boundaries = trunc_result$indices[lb])
    
     
    plot_args$alns <- trunc_result$alns
    plot_args$obj <- trunc_result$ref
    plot_args$ins.sites$start <- new_starts
    plot_args$xtick.labs <- xtcks$tick_labs
    plot_args$xtick.breaks <- xtcks$tick_locs
    
    # guide.loc, target.loc, pam.start, pam.end
    plot_args
  }, # -----

  # .getInsertions -----
  .getInsertions = function(){
    # Used by plotVariants for getting a table of insertions

      all_ins <- lapply(seq_along(.self$crispr_runs), function(i){
          ins <- .self$crispr_runs[[i]]$getInsertionSeqs(.self$target)
          if (! is.null(ins)) ins$sample <- i
          ins  
      })
    
      all_ins <- do.call(rbind, all_ins)
      if (is.null(all_ins)){
        all_ins <- data.frame()
      } else {
        all_ins <- all_ins[order(all_ins$start),]
        all_ins$cigar_label <- as.character(all_ins$cigar_label)
      }      
      
    .self$field("insertion_sites", all_ins)
  }, # -----

  # consensusAlleles -----
  consensusAlleles = function(cig_freqs = .self$cigar_freqs, return_nms = TRUE,
                              match.ops = c("M","X","=")){
'
Description:
Get variants by their cigar string, make the pairwise alignments for the consensus
sequence for each variant allele

Input parameters:
cig_freqs:  A table of variant allele frequencies (by default: .self$cigar_freqs,
but could also be filtered)
return_nms: If true, return a list of sequences and labels (Default:FALSE)
match.ops:  CIGAR operations for 1-1 alignments

Return:
A DNAStringSet of the consensus sequences for the specified alleles,
or a list containing the consensus sequences and names for the labels
if return_nms = TRUE
'
    
    # Note: with old pac bio data, reads can have different cigars
    # but same label for insertions and deletions
    
    alns <- unname(unlist(alns(.self)))
    cigs <- cigar(alns)
    cig_labels <- mcols(alns)$allele
    
    # calling by name with duplicates returns the first match
    names(cigs) <- cig_labels
  
    # Get read indices per label, match row order of cig_freqs
    splits <- split(seq_along(cig_labels), cig_labels)
    splits <- splits[match(rownames(cig_freqs), names(splits))]
    
    # Convert names to cigar strings 
    splits_labels <- names(splits)
    names(splits) <- cigs[names(splits)]
    
    # Find alignments where a deletion spans the target region
    grep_str <- paste(match.ops, collapse = "|")
    all_d <- grep(grep_str, names(splits), invert = TRUE)
    
    all_alns <- unlist(alns(.self), use.names = FALSE)
    
    seqs <- c()
    starts <- c()
    
    for (i in seq_along(splits)){
      idxs <- splits[[i]]
      start <- start(all_alns[idxs])
      sqs <- mcols(all_alns[idxs])$seq
      
      if (i %in% all_d){
        seqs[i] <- ""
        starts[i] <- start[1]
      }
      else {
        if (length(unique(start)) > 1 | 
            length(unique(width(sqs))) > 1){

          warning("Sequences do not all have the same start")
          tt <- table(start)
          starts[i] <- as.numeric(names(tt))[order(tt, decreasing = TRUE)][1]
          cigs <- cigar(all_alns[idxs])
          
          result <- GenomicAlignments::sequenceLayer(sqs, cigs,
                                                     to = "pairwise",
                                                     D.letter = "-",
                                                     N.letter = "N")
          shifts <- start - GenomicAlignments::start(.self$target)
          
          # CHECK WITH MORE COMPLEX EXAMPLE
          aln_sqs <- Biostrings::stackStrings(result, shift = shifts,
                                            from = 1,
                                            to = max(nchar(result)),
                                            Lpadding.letter = "+",
                                            Rpadding.letter = ".")
          
          cm <- consensusMatrix(aln_sqs)
          sq <- rownames(cm)[apply(cm, 2, which.max)]
          sq <- paste0(sq[! sq %in% c("-", "+", ".")], collapse = "")
          seqs[i] <- sq
          
        }  else {
          cig <- names(splits[[i]])
          seqs[i] <- consensusString(sqs)
          starts[i] <- start[1]
        }
      }
    }
    
    seqs <- Biostrings::DNAStringSet(seqs)
    
    if (isTRUE(return_nms)){
      mcols(seqs) <- data.frame(cigar = names(splits), 
                      label = splits_labels, start = starts)
    }

    names(seqs) <- splits_labels
    seqs
  }, # -----


  # makePairwiseAlns -----
  makePairwiseAlns = function(cig_freqs = .self$cigar_freqs, ...){
'
Description:
Get variants by their cigar string, make the pairwise alignments for the consensus
sequence for each variant allele

Input parameters:
cig_freqs:  A table of variant allele frequencies (by default: .self$cigar_freqs,
            but could also be filtered)
...:        Extra arguments for CrispRVariants::seqsToAln, e.g. which symbol
            should be used for representing deleted bases
'

    # The short cigars (not renumbered) do not have enough information,
    # use the full cigars for sorting
    # Do this just for the alns to be displayed?
    temp <- .self$consensusAlleles(cig_freqs, return_nms = TRUE)
    
    alns <- seqsToAln(mcols(temp)$cigar, temp, target = .self$target,
                 aln_start = mcols(temp)$start, 
                 reverse_complement = .self$pars$rc, ...)

    names(alns) <- mcols(temp)$label
    alns
  }, # -----

   # .genomeToTargetLocs -----
  .genomeToTargetLocs = function(target.loc, target_start, target_end, plus_strand, 
                                 gs = NULL, ge = NULL){
    # target.loc should be relative to the start of the target sequence, even if the
    # target is on the negative strand
    # target.loc is the left side of the cut site (Will be numbered -1)
    # target_start and target_end are genomic coordinates, with target_start < target_end
    # plus_strand: is the target on the positive strand wrt the reference?
    # returns a vector of genomic locations and target locations

    # Example:  target.loc = 5
    # Before: 1  2  3  4  5  6  7  8
    # After: -5 -4 -3 -2 -1  1  2  3
    # Left =  original - target.loc - 1
    # Right = original - target.loc

    stopifnot(isTRUEorFALSE(plus_strand))
    if (all(lengths(alns(.self))) == 0) return(NULL)
    
    if (is.null(gs) | is.null(ge)){
      gs <- min(sapply(.self$crispr_runs, function(x) min(start(x$alns))))
      ge <- max(sapply(.self$crispr_runs, function(x) max(end(x$alns))))
    }
    
    if (! isTRUE(plus_strand)){
      tg <- target_end - (target.loc - 1)
      new_numbering <- rev(c(seq(-1*(ge - (tg -1)),-1), c(1:(tg - gs))))

    } else {
      tg <- target_start + target.loc - 1
      new_numbering <- c(seq(-1*(tg - (gs-1)),-1), c(1:(ge - tg)))
    }
    
    names(new_numbering) <- c(gs:ge)

    .self$field("genome_to_target", new_numbering)
    new_numbering
  } # -----
)

# Setup data
context("Initialization of CrisprSet objects")


test_that("readsToTargets correctly separates reads by PCR primer",{    
    wdths <- c(10,10,5,3)
    gr <- GenomicRanges::GRanges("chr1", 
               IRanges::IRanges(start = c(5,7,4,13), width = wdths),
               cigar = sprintf("%sM", wdths), strand = "+", 
               flag=c(0,0,0,2048))
    names(gr) <- c("A", "B", "C","C")
    seqs <- Biostrings::DNAStringSet(subseq(rep("ACTGACTGAC",
                                            length(gr)),1, width(gr)))
    gr$seq <- seqs
    galnsl <- GenomicAlignments::GAlignmentsList(list(as(gr, "GAlignments")))
    targets <- GenomicRanges::GRanges("chr1",
                        IRanges::IRanges(c(10, 12), width = 2), strand = "+")
    primer.ranges <- GenomicRanges::GRanges("chr1", 
                        IRanges::IRanges(c(4, 7), width = c(11,10)))
    references <- Biostrings::DNAStringSet(c("AA","CC"))

    # test that reads can't be separated without primer ranges
    csets <- suppressWarnings(readsToTargets(galnsl, targets,
               references = references, target.loc = 1, verbose = FALSE))
    # There should be no reads as all are ambiguous
    # and chimeras cannot be distinguished with default tolerance of 5
    expect_equal(length(csets), 0)

    csets <- readsToTargets(galnsl, targets,
                            references = references,
                            target.loc = 1, primer.ranges = primer.ranges,
                            chimera.to.target = 0, verbose = FALSE)
  
    expect_equal(names(csets[[1]]$crispr_runs[[1]]$alns), "A")
    expect_equal(names(csets[[2]]$crispr_runs[[1]]$alns), "B")
    # Chimeras can be resolved with zero tolerance
    expect_equal(names(csets[[2]]$crispr_runs[[1]]$chimeras),c("C","C"))
    expect_equal(length(csets[[1]]$crispr_runs[[1]]$chimeras), 0)
})

# Construct data for checking SNVs -----
bam <- system.file("extdata", "bam/ab1_ptena_wildtype_looking_embryo_1_s.bam",
                      package="CrispRVariants")
reference <- Biostrings::DNAString("GCCATGGGCTTTCCAGCCGAACGATTGGAAGGT")
gdl <- GenomicRanges::GRanges("chr17", IRanges(23648469, 23648501),
           strand = "-")

# Constructed alignments for checking snvs
snv <- rep(GRanges("chr17", IRanges(start = 23648469, width = 33),
                   cigar = "33M"),5)
strand(snv) <- c("+","-","+","-","+")
names(snv) <- c("u8","u7","d5","d6","rc")
mcols(snv)$seq <-  Biostrings::DNAStringSet(
                     c("ACCTTCCAATCGTTCGGCTCGAAAGCCCATGGC",
                       "ACCTTCCAATCGTTCGGCCGGAAAGCCCATGGC",
                       "ACCTTGCAATCGTTCGGCTGGAAAGCCCATGGC",
                       "ACCGTCCAATCGTTCGGCTGGAAAGCCCATGGC",
                       "GCCATGGGCTTTCCAGCCGAACGATTGGAAGGT"))
# ----

test_that("Excluding reads by name works correctly", {
    # This bam file contains four non-chimeric and one chimeric read.
    # Here the non-chimeric reads are excluded by name
    
    # To do: exclude.names gives a warning as is.null used with vector
    cset <- suppressWarnings(readsToTarget(bam, gdl, reference = reference,
                exclude.names = c("AB2017","AB2018","AB2021","AB2024")))

    expect_equal(length(cset$crispr_runs[[1]]$alns), 0)
    expect_equal(length(cset$crispr_runs[[1]]$chimeras), 2)
})


test_that("Ambiguous nucleotides are not considered SNVs",{
    # There is an ambiguous nucleotide 19 bases upstream of the cut site
    # in one of these sequences
    cset <- readsToTarget(bam, target = gdl, reference = reference,
                          target.loc = 22, upstream.snv = 18)
    expect_equal(length(grep("SNV", cset$crispr_runs[[1]]$cigar_labels)), 0)
})


test_that("Arguments for calling SNVs are passed on",{
    # There is a nucleotide mismatch at position 19 upstream of target.loc
    
    # Counting 7 bases downstream, no SNVs are present
    cset <- readsToTarget(bam, target = gdl, reference = reference,
                          target.loc = 22, downstream.snv = 7)
    expect_equal(length(grep("SNV", cset$crispr_runs[[1]]$cigar_labels)), 0)

    # Re-initialise increasing detection window.
    # SNV should now be detected
    cset <- readsToTarget(bam, target = gdl, reference = reference,
                          target.loc = 22, upstream.snv = 19)
    expect_equal(length(grep("SNV", cset$crispr_runs[[1]]$cigar_labels)), 1)
    
    # Check that large detection ranges don't cause and error
    cset <- readsToTarget(bam, target = gdl, reference = reference,
                          target.loc = 22, upstream.snv = 30,
                          downstream.snv = 40)
    expect_equal(length(grep("SNV", cset$crispr_runs[[1]]$cigar_labels)), 1)
    
    # More checking with constructed alignments
    snv <- GenomicAlignments::GAlignmentsList(sample1 = as(snv, "GAlignments"))
    cset <- readsToTarget(snv, target = gdl,
                          reference = reference,
                          target.loc = 22)
    
    # Test that variant at position 8 downstream is not counted
    expect_true(all(c("SNV:-8G", "SNV:6C") %in%
                      rownames(variantCounts(cset))))

    expect_equal(variantCounts(cset)["no variant",], 2)
    
    # With changed parameters, neither of these SNVs are counted
    cset2 <- readsToTarget(snv, target = gdl, reference = reference,
                           target.loc = 22, upstream.snv = 7,
                           downstream.snv = 5)
    expect_equal(variantCounts(cset2)["no variant",], 4)
    
})

test_that("Mismatched reference and target detected",{
    snv <- GenomicAlignments::GAlignmentsList(sample1 = as(snv, "GAlignments"))
    cset <- readsToTarget(snv, target = gdl,
                          reference = Biostrings::reverseComplement(reference),
                          target.loc = 22)
    # Expect: there are no indel sequences
    expect_equal(length(variantCounts(cset, include.nonindel = FALSE)), 0)
    
    # Expect: only one non-snv read
    # (test via mutationEfficiency to also test snv recognition)
    expect_equal(mutationEfficiency(cset, snv = "exclude")[["ReadCount"]], 1)
  
})

test_that("readsToTargets (signature character) returns a list of CrisprSets",{
    # Here testing with a single bam, but should still run
    bam <- system.file("extdata",
                       "bam/ab1_ptena_wildtype_looking_embryo_2_s.bam",
                        package="CrispRVariants")

    refs <- Biostrings::DNAStringSet(c("GCCATGGGCTTTCCAGCCGAACGATTGGAAGGT",
                                        "AAAAACCCCCTTTTTGGGGG"))
    # gol plus a dummy guide
    gdl <- GenomicRanges::GRanges(c("chr17", "chr1"),
                IRanges(start = c(23648469, 1), end = c(23648501, 20)),
           strand = c("-", "+"))
    # This will warn that no reads map to the dummy guide
    csets <- suppressWarnings(readsToTargets(bam, targets = gdl,
                references = refs, target.loc = 17, verbose = FALSE))

    expect_true(class(csets[[1]]) == "CrisprSet")
})

test_that("Strand is chosen correctly", {
    expect_equal(rcAlns("+","target"), FALSE)
    expect_equal(rcAlns("-","target"), TRUE)
    expect_equal(rcAlns("+","opposite"), TRUE)
    expect_equal(rcAlns("-","opposite"), FALSE)
    expect_equal(rcAlns("+","positive"), FALSE)
    expect_equal(rcAlns("-","positive"), FALSE)
})




# To do:
# test that reads are not separated when exact match required (allow.partial = FALSE)
# test separateChimeras that chimera away from cut is excluded
# same test via readsToTarget
# test separateChimeras that guide within chimera is not chimeric
# test function of chimera.to.target
# test chimera options "count","exclude","ignore", "merge"
# test snvs with indels

#'@title Reverses the order of operations in a cigar string
#'@description For example, the string "20M5D15M" would become "15M5D20M"
#'@param cigars the cigar strings.
#'@return The reversed cigar string
reverseCigar <- function(cigars){
  wdths <- explodeCigarOpLengths(cigars)
  ops <- explodeCigarOps(cigars)
  temp <- rev(relist(rev(paste0(unlist(wdths), unlist(ops))), rev(wdths)))
  result <- as.character(Map(base::paste, temp, collapse = ""))
}

# readsToTarget generic -----
#'@title Trims reads to a target region.
#'@description Trims aligned reads to one or several target regions,
#'optionally reverse complementing the alignments.
#'@param reads A GAlignments object, or a character vector of the filenames
#'@param target A GRanges object specifying the range to narrow alignments to
#'@author Helen Lindsay
#'@rdname readsToTarget
#'
#'@import methods
#'@import BiocParallel
#'@import Biostrings
#'@import ggplot2
#'@import GenomicAlignments
#'@import GenomicRanges
#'@import IRanges
#'@import Rsamtools
#'@import S4Vectors
#'@importFrom grDevices colorRampPalette
#'@importFrom grid gpar grid.rect
#'@importFrom gridExtra grid.arrange arrangeGrob
#'@importFrom reshape2 melt
#'@importFrom AnnotationDbi select
#'@importFrom GenomeInfoDb seqlengths
#'@importFrom utils modifyList
#'@export
setGeneric("readsToTarget", function(reads, target, ...) {
  standardGeneric("readsToTarget")})
# -----

# readsToTarget GAlignments, GRanges -----
#'@param name An experiment name for the reads.  (Default: NULL)
#'@param reverse.complement (Default: TRUE)  Should the alignments be
#' oriented to match the strand of the target? If TRUE, targets located 
#  on the postive strand are displayed with respect to the postive 
#' strand and targets on the negative strand with respect to the 
#' negative strand. If FALSE, the parameter 'orientation' must be set
#' to determine the orientation.  
#' 'reverse.complement' will be replaced by 'orientation' in a later release. 
#'@param collapse.pairs  If reads are paired, should pairs be collapsed? 
#' (Default: FALSE) Note: only collapses primary alignments, 
#' and assumes that there is only one primary alignment per read.
# May fail with blat alignments converted to bam.
#'@param use.consensus Take the consensus sequence for non-matching pairs? If FALSE,
#'the sequence of the first read is used.  Can be very slow. (Default: FALSE)
#'@param store.chimeras Should chimeric reads be stored?  (Default: FALSE)
#'@param orientation One of "target" (reads are displayed on the same
#' strand as the target) "opposite" (reads are displayed on the opposite)
#' strand from the target or "positive" (reads are displayed on the forward
#' strand regardless of the strand of the target)   (Default:"target") 
#'@param verbose Print progress and statistics (Default: TRUE)
#'@param minoverlap Minimum number of bases the aligned read must 
#' share with the target site.  If not specified, the aligned
#' read must completely span the target region.  (Default: NULL)
#'@return (signature("GAlignments", "GRanges")) A \code{\link{CrisprRun}} object
#'@examples
#'# Load the metadata table
#'md_fname <- system.file("extdata", "gol_F1_metadata_small.txt", package = "CrispRVariants")
#'md <- read.table(md_fname, sep = "\t", stringsAsFactors = FALSE)
#'
#'# Get bam filenames and their full paths
#'bam_fnames <- sapply(md$bam.filename, function(fn){
#'  system.file("extdata", fn, package = "CrispRVariants")})
#'
#'reference <- Biostrings::DNAString("GGTCTCTCGCAGGATGTTGCTGG")
#'gd <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399),
#'        strand = "+")
#'
#'crispr_set <- readsToTarget(bam_fnames, target = gd, reference = reference,
#'                            names = md$experiment.name, target.loc = 17)
#'
#'@rdname readsToTarget
setMethod("readsToTarget", signature("GAlignments", "GRanges"),
          function(reads, target, ..., reverse.complement = TRUE,
                   chimeras = NULL, collapse.pairs = FALSE,
                   use.consensus = FALSE, store.chimeras = FALSE, 
                   verbose = TRUE, name = NULL, minoverlap = NULL,
                   orientation = c("target","opposite","positive")){

    orientation <- match.arg(orientation)
    dots <- list(...)
    
    # If calling directly rather than internally, run checks
    if (! "checked" %in% names(dots) & isTRUE(dots$checked)){
      .checkReadsToTarget(target, reference = NULL, target.loc = NULL,
                          reverse.complement, orientation,
                          chimeras)
      .checkForPaired(reads)
    }

    keep.unpaired <- TRUE
    if ("keep.unpaired" %in% names(dots)){
        keep.unpaired <- dots["keep.unpaired"]
    }
    
    # Choose which strand to orient reads to
    if (isTRUE(reverse.complement) & as.character(strand(target)) == "*"){
      message(paste0("Target does not have a strand, ",
                     "but reverse.complement is TRUE.\n",
                     "Orienting reads to reference strand."))
      rc = FALSE
    } else {
      rc <- rcAlns(as.character(strand(target)), orientation)
    }
    
    # If there are no non-chimeric reads, chimeras can still be stored
    if (length(reads) == 0){
      if (length(chimeras) == 0) {return(NULL)}
      crun <- CrisprRun(reads, target, rc = rc,
                        name = name, chimeras = chimeras, 
                        verbose = verbose)
      return(crun)
    }

    # Check if alignments are paired and should be collapsed
    if (isTRUE(collapse.pairs)){
      if (is.null(names(reads)) | ! ("flag" %in% names(mcols(reads))) ){
        stop("Reads must include names and bam flags for collapsing pairs")
      }
    }

    if (is.null(chimeras)) {
      chimeras <- GenomicAlignments::GAlignments()
      if (isTRUE(store.chimeras)) {
        # There is no way to specify tolerance here, or to use target.loc
        temp <- separateChimeras(reads, target, by.flag = collapse.pairs,
                                 verbose = verbose)
        reads <- temp$bam
        chimeras <- temp$chimeras[[1]]
      }
    }

    # To do: check whether this is redundant with narrowAlignments
    # Filter out reads that don't span the target region
    # Not using findOverlaps because reads may be paired, i.e. names nonunique
    if (is.null(minoverlap)){
      bam <- reads[start(reads) <= start(target) & end(reads) >= end(target) &
                   seqnames(reads) == as.character(seqnames(target))]
    } else { bam <- reads }

    if (isTRUE(verbose)){
      message(sprintf("%s of %s nonchimeric reads span the target range\n",
                  length(bam), length(reads)))
    }

    # If bam and chimeras are empty, no further calculation needed
    if (length(bam) == 0 & length(chimeras) == 0) return(NULL)

    if (length(bam) == 0){
      crun <- CrisprRun(bam, target, rc = rc,
                  name = name, chimeras = chimeras, verbose = verbose)
      return(crun)
    }

    # If bam is non-empty, orient and narrow the reads to the target

    # narrow aligned reads
    result <- narrowAlignments(bam, target, reverse.complement = rc,
                            verbose = verbose, minoverlap = minoverlap)
    
    # Collapse pairs of narrowed reads

    if (isTRUE(collapse.pairs)){
      gen_ranges <- GenomicAlignments::cigarRangesAlongReferenceSpace(
                       cigar(result), pos = start(result))
      
      result <- collapsePairs(result, genome.ranges = gen_ranges,
                              use.consensus = use.consensus,
                              keep.unpaired = keep.unpaired, verbose = verbose)

      result <- result$alignments
    }

    if (length(result) == 0){
      if (length(chimeras) == 0){
        return(NULL)
      }
      crun <- CrisprRun(result, target, rc = rc, name = name,
                        chimeras = chimeras, verbose = verbose)
      return(crun)
    }

    crun <- CrisprRun(result, target, rc = rc, name = name,
                      chimeras = chimeras, verbose = verbose)
    crun
}) # -----


# readsToTarget GAlignmentsList, GRanges -----
#'@rdname readsToTarget
setMethod("readsToTarget", signature("GAlignmentsList", "GRanges"),
          function(reads, target, ..., reference = reference,
                   names = NULL, reverse.complement = TRUE, target.loc = 17,
                   chimeras = NULL, collapse.pairs = FALSE, use.consensus = FALSE,
                   orientation = c("target","opposite","positive"),
                   minoverlap = NULL, verbose = TRUE){

    # To do: Deal with potentially empty chimeras

    orientation <- match.arg(orientation)
    
    # Always run checks as this function is not called by others
    .checkReadsToTarget(target, reference = NULL, target.loc = NULL,
                        reverse.complement, orientation,
                        chimeras)
    
    # Check: if chimeras and reads are supplied, they should have equal length
    nch <- length(chimeras)
    nreads <- length(reads)
    
    if (nreads > 0 & nch > 0 & ! nreads == nch){
      stop("Chimeras must be either NULL or a GAlignmentsList ",
           "of length equal to reads")
    }

    # Collapse pairs if required and initialise CrisprSet object
    cset <- alnsToCrisprSet(reads, reference, target, reverse.complement,
                            collapse.pairs, names, use.consensus, target.loc,
                            verbose, chimeras = chimeras, minoverlap = minoverlap,
                            orientation = orientation, checked = TRUE, ...)
    
    cset
}) # -----


# readsToTarget character, GRanges -----
#'@param names Experiment names for each bam file.  If not supplied, filenames are used.
#'@param chimeras Flag to determine how chimeric reads are treated.  One of
#'"ignore", "exclude", and "merge".  Default "count", "merge" not implemented yet
#'@param reference The reference sequence
#'@param exclude.ranges Ranges to exclude from consideration, e.g. homologous to a pcr primer.
#'@param exclude.names Alignment names to exclude
#'@param ... Extra arguments for initialising CrisprSet
#'@return (signature("character", "GRanges")) A \code{\link{CrisprSet}} object
#'@rdname readsToTarget
setMethod("readsToTarget", signature("character", "GRanges"),
          function(reads, target, ..., reference, reverse.complement = TRUE,
                   target.loc = 17, exclude.ranges = GRanges(), exclude.names = NA,
                   chimeras = c("count","exclude","ignore", "merge"),
                   collapse.pairs = FALSE, use.consensus = FALSE,
                   orientation = c("target","opposite","positive"),
                   names = NULL, minoverlap = NULL, verbose = TRUE){

    # Prepare input parameters
    args <- list(...)
    chimeras <- match.arg(chimeras)
    orientation <- match.arg(orientation)
    
    # If reading in alignments, always run checks
    .checkFnamesExist(reads)
    .checkReadsToTarget(target, reference, target.loc,
                        reverse.complement, orientation, chimeras)
            
    if (! is(reference, "DNAString")){
      reference <- Biostrings::DNAString(reference[[1]])
    }
    
    c_to_t <- 5
    if ("chimera.to.target" %in% names(args)){
       c_to_t <- args[["chimera.to.target"]]
    }
       
    # Read in the bam files, separate chimeric and non-chimeric reads
    temp <- lapply(reads, readTargetBam, target = target,
                   exclude.ranges = exclude.ranges,
                   exclude.names = exclude.names,
                   chimeras = chimeras, by.flag = collapse.pairs,
                   chimera.to.target = c_to_t,
                   verbose = verbose)

    alns <- lapply(temp, "[[", "bam")
    chimeras <- lapply(temp, "[[", "chimeras")

    # If names are not specified, set them to the filenames
    if (is.null(names)){
       names <- basename(reads)
    }
    names <- as.character(names)

    # Collapse pairs, count insertions, create CrisprSet objects
    cset <- alnsToCrisprSet(alns, reference, target, reverse.complement,
                            collapse.pairs, names = names,
                            use.consensus = use.consensus,
                            target.loc = target.loc, verbose = verbose,
                            chimeras = chimeras, minoverlap = minoverlap,
                            orientation = orientation, checked = TRUE, ...)
     cset
}) # -----

#__________________________________________________________________
# readsToTargets (for alignments to multiple guides)
#__________________________________________________________________
# readsToTargets -----
#'@export
#'@rdname readsToTarget
setGeneric("readsToTargets", function(reads, targets, ...) {
  standardGeneric("readsToTargets")})

#'@param targets A set of targets to narrow reads to
#'@param references A set of reference sequences matching the targets.
#'References for negative strand targets should be on the negative strand.
#'@param primer.ranges A set of GRanges, corresponding to the targets.
#'Read lengths are typically greater than target regions, and it can
#'be that reads span multiple targets.  If primer.ranges are available,
#'they can be used to assign such reads to the correct target.
#'@param target.loc The zero point for renumbering (Default: 17)
#'@param ignore.strand Should strand be considered when finding overlaps?
#'(See \code{\link[GenomicAlignments]{findOverlaps}} )
#'@param bpparam A BiocParallel parameter for parallelising across reads.
#'Default: no parallelisation.  (See \code{\link[BiocParallel]{bpparam}})
#'@param chimera.to.target Number of bases that may separate a chimeric read
#'set from the target.loc for it to be assigned to the target. (Default: 5)
#'@rdname readsToTarget
setMethod("readsToTargets", signature("character", "GRanges"),
          function(reads, targets, ..., references, primer.ranges = NULL,
                   target.loc = 17, reverse.complement = TRUE,
                   collapse.pairs = FALSE, use.consensus = FALSE,
                   ignore.strand = TRUE, names = NULL,
                   bpparam = BiocParallel::SerialParam(),
                   orientation = c("target","opposite","positive"),
                   chimera.to.target = 5, verbose = TRUE){

            dummy <- .checkReadsToTargets(targets, primer.ranges, references)
            .checkFnamesExist(reads)
            
            if (is.null(names)){
              names <- reads
            }

            param <- Rsamtools::ScanBamParam(what = c("seq", "flag"))
            args <- list(...)
            ntargets <- length(targets)

            bams <- BiocParallel::bplapply(seq_along(reads), function(i){
              if (verbose) message(sprintf("Loading alignments for %s\n\n",
                                       names[i]))
              bam <- GenomicAlignments::readGAlignments(reads[i],
                                              param = param, use.names = TRUE)
              if (length(bam) == 0){
                if (verbose) message("No reads in alignment\n")
                return(NULL)
              }
              return(bam)
           }, BPPARAM = bpparam)

           bams <- GAlignmentsList(bams)
           if (collapse.pairs == FALSE) dummy <- .checkForPaired(bams)

           orientation <- match.arg(orientation)
           result <- readsToTargets(bams, targets, references = references,
                       target.loc = target.loc, verbose = verbose,
                       reverse.complement = reverse.complement,
                       ignore.strand = ignore.strand,
                       collapse.pairs = collapse.pairs, names = names,
                       bpparam = bpparam, use.consensus = use.consensus,
                       chimera.to.target = chimera.to.target,
                       orientation = orientation)
          result

          })


#'@rdname readsToTarget
setMethod("readsToTargets", signature("GAlignmentsList", "GRanges"),
          function(reads, targets, ..., references, primer.ranges = NULL,
                   target.loc = 17, reverse.complement = TRUE, 
                   collapse.pairs = FALSE, use.consensus = FALSE,
                   ignore.strand = TRUE, names = NULL, 
                   bpparam = BiocParallel::SerialParam(),
                   chimera.to.target = 5, 
                   orientation = c("target", "opposite", "positive"),
                   verbose = TRUE){

    # To do:
    # Currently this returns a list with the non-empty CrisprSets
    # consider making the list the length of the supplied targets

    dummy <- .checkReadsToTargets(targets, primer.ranges, references)
    if (collapse.pairs == FALSE) dummy <- .checkForPaired(reads)

    if (is.null(names)){
      if (! is.null(names(reads))){
        names <- names(reads)
      }else{
        names <- sprintf("Sample %s",seq_along(reads))
      }
    }

    orientation <- match.arg(orientation)

    byPCR <- BiocParallel::bplapply(reads, function(bam){

      if (verbose) message(sprintf("Assigning chimeric reads to targets \n"))

      # Change to default: just supply the cut site (target.loc)
      ch_tgts <- resize(resize(targets, target.loc + 1, fix="start"), 2, fix = "end")

      temp <- separateChimeras(bam, ch_tgts, chimera.to.target,
                              by.flag = collapse.pairs, verbose = verbose)
      bam <- temp$bam
      chimerasByPCR <- temp$chimeras

      # If primer.ranges are provided, match reads to primers
      # If not, match reads to targets
      if (! is.null(primer.ranges)){
        hits <- readsByPCRPrimer(bam, primer.ranges, verbose = verbose)
        splits <- split(queryHits(hits), subjectHits(hits))
      } else{
        hits <- findOverlaps(targets, bam, type = "within", ignore.strand = TRUE)
        duplicates <- (duplicated(subjectHits(hits)) |
                       duplicated(subjectHits(hits), fromLast = TRUE))
        if (verbose){
          msg <- paste0("%s (%.2f%%) reads of %s overlap a target\n",
                        "  %s (%.2f%%) of these overlapping multiple targets removed\n",
                        "  %s (%.2f%%) reads mapped to a single target\n\n")
          rhits <- length(unique(subjectHits(hits)))
          bl <- length(bam)
          ndups <- sum(duplicated(subjectHits(hits)))
          nndups <- sum(!duplicates)
          message(sprintf(msg, rhits, rhits/bl*100, bl, ndups, ndups/rhits*100,
                      nndups, nndups/bl*100))
        }
        hits <- hits[!duplicates]
        splits <- split(subjectHits(hits), queryHits(hits))
      }
      bamByPCR <- as.list(rep(NA, length(targets)))
      names(bamByPCR) <- seq_along(targets)
      for (nm in names(splits)){
        bamByPCR[[nm]] <- bam[splits[[nm]]]
      }
      byPCR <- list(bamByPCR = bamByPCR, chimerasByPCR = chimerasByPCR)
      byPCR
    }, BPPARAM = bpparam)

    # Remove any empty alignments
    to_keep <- which(lapply(byPCR, length) > 0)
    byPCR <- byPCR[to_keep]
    names <- names[to_keep]
    
    if (length(names) == 0){
      stop("No files contain on target reads")
    }

    # Reformat to list by guides instead of samples
    tlist <- function(i) {
      lapply(temp, "[[", i)
    }
    temp <- lapply(byPCR, "[[", "chimerasByPCR")
    chimerasByPCR <- lapply(seq_along(temp[[1]]), tlist)
    temp <- lapply(byPCR, "[[", "bamByPCR")
    bamByPCR <- lapply(seq_along(temp[[1]]), tlist)
    tg_gr <- as(targets, "GRangesList")
    

    result <- BiocParallel::bplapply(seq_along(bamByPCR), function(i){
      bams <- bamByPCR[[i]]
      tgt <- tg_gr[[i]]
      mcols(tgt) <- mcols(targets[i])
      chs <- chimerasByPCR[[i]]
      ref <- references[[i]]
      if (isTRUE(verbose)){
        message(sprintf("\n\nWorking on target %s\n", names(tgt)))
      }
      
      cset <- alnsToCrisprSet(bams, ref, tgt, reverse.complement,
                              collapse.pairs, names, use.consensus, target.loc,
                              verbose, chimeras = chs,
                              orientation = orientation, ...)
    }, BPPARAM = bpparam)

    if (length(result) == 0){
      warning("No reads span a target")
      return(result)
    }

    if (!is.null(names(targets))) {
      names(result) <- names(targets)
    }

    result <- result[!sapply(result, is.null)]
    result
  }) # -----


#__________________________________________________________________
# Data import and processing
#__________________________________________________________________

# separateChimeras -----
separateChimeras <- function(bam, targets, tolerance = 5,
                             by.flag = TRUE, verbose = FALSE){

  # The supplementary alignment flag must be set to distinguish paired from
  # chimeric reads. Tolerance is added on both sides
  # A better approach might be to explicitly consider where chimeras
  # join w.r.t read
  # Worth warning if there are chimeras independent of the guide?

  # Find chimeras
  ch_idxs <- findChimeras(bam, by.flag)
  chimeras <- bam[ch_idxs]
  original_ln <- length(chimeras)

  # Setup return data
  chimerasByPCR <- vector("list", length(targets))
  names(chimerasByPCR) <- as.character(seq_along(targets))

  # If the target is completely contained within one member of the
  # chimeric set (two members if paired), do not count it as a chimera
  guide_within <- subjectHits(findOverlaps(targets, chimeras,
                              ignore.strand = TRUE, type = "within"))
  ordered <- unique(guide_within[order(guide_within)])

  # If any targets contained within a chimeric read, remove all members of set
  if (length(ordered) > 0){
    lns_rle <- rle(names(chimeras)[ordered])$lengths
    grps <- rep(1:length(lns_rle), lns_rle)
    is_first <- paste(grps, bitwAnd(mcols(chimeras)$flag[ordered], 64),
                      sep = ".")
    not_dup <- !(duplicated(is_first) | duplicated(is_first, fromLast = TRUE))

    # Remove all chimeras with guides included from the chimeric sets
    non_ch <- names(chimeras) %in% names(chimeras)[ordered][not_dup]
    ch_idxs <- ch_idxs[!non_ch]
    chimeras <- bam[ch_idxs]
  }

  # Assign chimeras to targets
  tgt_plus_tol <- targets + tolerance
  hits <- findOverlaps(chimeras, tgt_plus_tol, ignore.strand = TRUE)

  # Exclude members that match multiple targets
  is_dup <- duplicated(queryHits(hits)) | duplicated(queryHits(hits), fromLast = TRUE)
  hits <- hits[!is_dup]
  splits <- split(queryHits(hits), subjectHits(hits))

  #For each hit, collect all alignments with the same name
  idx_by_primer <- lapply(splits, function(idxs){
    ch_idxs[names(chimeras) %in% names(chimeras)[idxs]]
  })

  ibp <- unlist(idx_by_primer)

  alnsByPCR <- lapply(idx_by_primer, function(ids){ bam[ids]})
  chimerasByPCR[names(splits)] <- alnsByPCR

  if (isTRUE(verbose)){
    # How many chimeric sets were not assigned?
    n_inc <- length(unique(ibp))
    n_total <- length(ch_idxs)
    n_dup <- sum(duplicated(ibp) | duplicated(ibp, fromLast = TRUE))
    pct_inc <- n_inc/n_total * 100
    pct_multi <- n_dup/n_total * 100
    removed <- original_ln - length(chimeras)

    rm_pct <- removed/original_ln * 100
    message(sprintf(paste0("%s from %s (%.2f%%) chimeras did not involve guide\n",
                    "%s from %s (%.2f%%) remaining chimeric reads included\n",
                    "%s (%.2f%%) assigned to more than one target\n"),
                removed, original_ln, rm_pct, n_inc, n_total,
                pct_inc, n_dup, pct_multi))
  }

  # Remove chimeras from the bam
  if (length(ch_idxs) >= 2){
    bam <- bam[-ch_idxs]
  }
  # Return list of chimerasByPCR and bam
  result <- list(bam = bam, chimerasByPCR = chimerasByPCR)
  result
} # -----


# alnsToCrisprSet -----
#@param label.alleles  (logical(1)) Calculate allele labels using the
#default counting method.  If FALSE, allele labels are not set at 
#initialisation (Default: TRUE).
alnsToCrisprSet <- function(alns, reference, target, reverse.complement,
                            collapse.pairs, names, use.consensus, target.loc,
                            verbose, orientation, chimeras = NULL,
                            store.chimeras = FALSE, minoverlap = NULL,
                            allele.labels = TRUE, ...){

    # Flag for whether variants should be counted w.r.t the negative strand
    rc <- rcAlns(as.character(strand(target)), orientation)
  
    # The reference is with respect to the guide.  If the opposite
    # strand is being displayed, reverse the reference.
    # For display wrt target, rc is TRUE for -ve, FALSE for +v
    is_neg <- as.character(strand(target)) == "-"
  
    #if (! (is_neg == rc)){
    #  reference <- Biostrings::reverseComplement(reference)
    #}
  
    # Narrow alignments for each sample
    crispr.runs <- lapply(seq_along(alns), function(i){
      aln <- alns[[i]]

      if (! is(aln, "GAlignments")) {
        aln <- GenomicAlignments::GAlignments()
      }

      chim <- chimeras[[i]]
      if (is.null(chim)) {chim <- GenomicAlignments::GAlignments()}
      checked <- "checked" %in% names(list(...))
      crun <- readsToTarget(aln, target = target,
                reverse.complement = reverse.complement, chimeras = chim,
                collapse.pairs = collapse.pairs, use.consensus = use.consensus,
                verbose = verbose, name = names[i], orientation = orientation,
                minoverlap = minoverlap, target.loc = target.loc,
                checked = checked)
      crun
    })

    # Remove empty samples
    to_rm <- sapply(crispr.runs, is.null)
    if (any(to_rm)){
      if (verbose){
        rm_nms <- paste0(names[to_rm], collapse = ",", sep = "\n")
        message(sprintf("Excluding samples that have no on target reads:\n%s",
                    rm_nms))
      }
      crispr.runs <- crispr.runs[!to_rm]
      names <- names[!to_rm]
      if (length(crispr.runs) == 0) {
        warning("Could not narrow reads to target, ",
                "no samples have on-target alignments")
        return()
      }
    }
    
    # Combine samples into a single object
    cset <- CrisprSet(crispr.runs, reference, target, rc = rc,
                      target.loc = target.loc, 
                      verbose = verbose, names = names, ...)
    
    # Set the allele labels
    if (isTRUE(allele.labels) & ! all(lengths(alns(cset)) == 0)){
        cig_labs_defaults = list(renumbered = TRUE,
                                 match_label = "no variant",
                                 mismatch_label = "SNV",
                                 split.snv = TRUE,
                                 upstream.snv = 8,
                                 downstream.snv = 6,
                                 bpparam = BiocParallel::SerialParam())
        dots <- list(...)
        cig_labs_defaults <- modifyList(cig_labs_defaults, 
                dots[names(dots) %in% names(cig_labs_defaults)])
        do.call(cset$setCigarLabels, cig_labs_defaults)
    }
    cset
} # -----


# readTargetBam -----
#'@title Internal CrispRVariants function for reading and filtering a bam file
#'@description Includes options for excluding reads either by name or range.
#'The latter is useful if chimeras are excluded.  Reads are excluded before
#'chimeras are detected, thus a chimeric read consisting of two sections, one of
#'which overlaps an excluded region, will not be considered chimeric.
#'Chimeric reads can be ignored, excluded, which means that all sections of a
#'chimeric read will be removed, or merged, which means that chimeras will be
#'collapsed into a single read where possible. (Not implemented yet)
#'If chimeras = "merge", chimeric reads are merged if all segments
# are from the same chromosome, do not overlap, and are aligned to the same strand.
# It is assumed that sequences with two alignments are chimeras, not alternate mappings
#'@param file The name of a bam file to read in
#'@param target A GRanges object containing a single target range
#'@param exclude.ranges A GRanges object of regions that should not be counted,
#'e.g. primer or cloning vector sequences that have a match in the genome
#'@param exclude.names A vector of read names to exclude.
#'@param chimera.to.target Maximum distance between endpoints of chimeras and
#'target.loc for assigning chimeras to targets (default: 5)
#'@param chimeras Flag to determine how chimeric reads are treated.  One of
#'"ignore", "exclude", "count" and "merge".  Default "ignore".
#'@param max.read.overlap Maximum number of bases mapped to two positions
#'for chimeras to be merged (Default: 10)
#'@param max.unmapped Maximum number of bases that are unmapped for chimeras
#'to be merged (Default: 4)
#'@param verbose Print stats about number of alignments read and filtered.  (Default: TRUE)
#'@param by.flag Is the supplementary alignment flag set?  Used for identifying chimeric
#'alignments, function is much faster if TRUE.  Not all aligners set this flag.  If FALSE,
#'chimeric alignments are identified using read names (Default: TRUE)
#'@return A GenomicAlignments::GAlignment obj
readTargetBam <- function(file, target, exclude.ranges = GRanges(),
                          exclude.names = NA, chimera.to.target = 5,
                          chimeras = c("count", "ignore","exclude","merge"),
                          max.read.overlap = 10, max.unmapped = 4,
                          by.flag = TRUE, verbose = TRUE){

    ch.action <- match.arg(chimeras)
    if (ch.action == "ignore"){
      # If chimeras are not to be excluded or merged,
      # we only need to read in reads overlapping the target region
      if (! file.exists(paste0(file, ".bam"))){
        Rsamtools::indexBam(file)
      }
      param <- Rsamtools::ScanBamParam(what = c("seq", "flag"), which = target)
    } else {
      # In this case, must read in the entire bam to be sure of finding chimeric reads
      param <- Rsamtools::ScanBamParam(what = c("seq", "flag"))
    }
    bam <- GenomicAlignments::readGAlignments(file, param = param, use.names = TRUE)
    if (length(bam) == 0){
      return(list(bam = GenomicAlignments::GAlignments(),
                  chimeras = GenomicAlignments::GAlignments()))
    }

    # Check that "seq" is not empty
    unq_wdths <- unique(width(mcols(bam)$seq))
    if (length(unq_wdths) == 0){
      if (unq_wdths == 0) stop("No sequence found in bam file")
    }

    #Exclude reads by name or range
    temp <- excludeFromBam(bam, exclude.ranges, exclude.names)

    if (isTRUE(verbose)){
      original <- length(bam)
      message(sprintf("Read %s alignments, excluded %s\n", original,
                      original - length(temp)))
    }
    bam <- temp

    if (length(bam) == 0 | ch.action == "ignore"){
      return(list(bam = bam, chimeras = GenomicAlignments::GAlignments()))
    }

    chimera_idxs <- findChimeras(bam, by.flag = by.flag)

    if (chimeras == "exclude"){
      if( length(chimera_idxs) >= 2){
        bam <- bam[-chimera_idxs]
      }
      if (isTRUE(verbose)){
        message(sprintf("%s reads after filtering chimeras\n", length(bam)))
      }
      return(list(bam = bam, chimeras = GenomicAlignments::GAlignments()))
    }
    if (chimeras == "count"){
      temp <- separateChimeras(bam, target, tolerance = chimera.to.target,
                               by.flag = by.flag, verbose = verbose)
      return(list(bam = temp$bam, chimeras = temp$chimeras[[1]]))
    }
    if (chimeras == "merge"){
      result <- mergeChimeras(bam, chimera_idxs, 
                              max_read_overlap = max.read.overlap,
                              max_unmapped = max.unmapped,
                              verbose = verbose)
      return(list(bam = c(bam[-chimera_idxs], result$merged),
                  chimeras = result$unmerged))
    }
} # -----


# rcAlns -----
#'@title Internal CrispRVariants function for determining read orientation
#'@description Function for determining whether reads should be oriented to the
#'target strand, always displayed on the positive strand, or oriented to 
# the strand opposite the target.
#'@param target.strand  The target strand (one of "+","-","*") 
#'@param orientation One of "target", "opposite" and "positive" (Default: "target")
#'@return A logical value indicating whether reads should be reverse complemented
#'@author Helen Lindsay
rcAlns <- function(target.strand, orientation){

    if (orientation %in% c("opposite","target") & target.strand == "*"){
        warning(paste0("Target does not have a strand\n",
                       "Orienting reads to reference strand."))
      return(FALSE)
    }
    if (orientation == "positive") return(FALSE)
    if (orientation == "target"){
      if (target.strand == "-") return(TRUE)
    } 
    if (orientation == "opposite"){
      if (target.strand == "+") return(TRUE)
    } 
    return(FALSE)
              
} # -----


# collapsePairs -----
#'@title Internal CrispRVariants function for collapsing pairs with concordant indels
#'@description Given a set of alignments to a target region, finds read pairs.
#'Compares insertion/deletion locations within pairs using the cigar string.
#'Pairs with non-identical indels are excluded.  Pairs with identical indels are
#'collapsed to a single read, taking the consensus sequence of the pairs.
#'@param alns A GAlignments object.  We do not use GAlignmentPairs because amplicon-seq
#'can result in pairs in non-standard pairing orientation.
#'Must include BAM flag, must not include unmapped reads.
#'@param use.consensus Should the consensus sequence be used if pairs have a mismatch?
#'Setting this to be TRUE makes this function much slower (Default: TRUE)
#'@param keep.unpaired Should unpaired and chimeric reads be included?  (Default: TRUE)
#'@param verbose Report statistics on reads kept and excluded
#'@param ... Additional items with the same length as alns,
#'that should be filtered to match alns.
#'@return The alignments, with non-concordant pairs removed and concordant pairs
#'represented by a single read.
#'@author Helen Lindsay
collapsePairs <- function(alns, use.consensus = TRUE, keep.unpaired = TRUE,
                          verbose = TRUE, ...){
    dots <- list(...)
 
    if (length(dots) > 0){
      if (! unique(sapply(dots, length)) == length(alns)){
        stop("Each ... argument supplied must have the ",
             "same length as the alignments")
      }
    }
  
    # 1 = 2^0 = paired flag
    # 2048 = 2^11 = supplementary alignment flag
    is_primary <- !(bitwAnd(mcols(alns)$flag, 2048) & bitwAnd(mcols(alns)$flag, 1))
    pairs <- findChimeras(alns[is_primary], by.flag = FALSE) 
    # Above just matches read names

    # If there are no pairs, no need to do anything further
    if (length(pairs) == 0){
      if (isTRUE(keep.unpaired)){
        return(c(list("alignments" = alns), dots))
      } else {
        return(NULL)
      }
    }
    # Pairs are primary alignments with the same name
    nms <- rle(names(alns)[is_primary][pairs])
    nms_codes <- rep(1:length(nms$lengths), nms$lengths)

    # If reads have the same insertions and deletions, they have identical cigar strings
    cig_runs <- rle(paste(cigar(alns)[is_primary][pairs], nms_codes, sep = "."))$lengths
    concordant <- rep(cig_runs, cig_runs) == rep(nms$lengths,nms$lengths)

    # Keep first alignment from all concordant pairs
    # Flag 64 = 2^6 = first alignment in pair
    is_pair <- which(is_primary)[pairs]
    is_first <- as.logical(bitwAnd(mcols(alns)$flag[is_pair], 64))
    keep <- is_pair[concordant & is_first]

    if (verbose){
      nunpaired <- length(alns) - length(is_pair)
      cc_true <- sum(concordant)/2
      cc_false <- sum(!concordant)/2
      stats <- paste0("\nCollapsing paired alignments:\n",
                "%s original alignments\n",
                "  %s are not part of a primary alignment pair\n",
                "     (singletons and chimeras)\n",
                "  %s reads are paired \n",
                "    %s pairs have the same insertions/deletions\n",
                "    %s pairs have different insertions/deletions\n",
                "Keeping the first member of %s concordant read pairs\n")
      message(sprintf(stats, length(alns), nunpaired, length(is_pair),
                  cc_true, cc_false, cc_true))
    }
    if (keep.unpaired){
      # Keep non-pairs, including non-primary and singletons
      keep <- c(keep, setdiff(c(1:length(alns)),is_pair))
      if (verbose) message(sprintf("Keeping %s unpaired reads\n", nunpaired))
    }
    keep_alns <- alns[keep]

    if (use.consensus){
      seq_runs <- rle(paste0(nms_codes, mcols(alns[is_primary][pairs])$seq))$lengths
      same_seq <- rep(seq_runs, seq_runs) == rep(nms$lengths, nms$lengths)
  
      ncc_seqs <- mcols(alns[is_primary][pairs][concordant & !same_seq])$seq
      if (verbose){
        message(sprintf("Finding consensus for %s pairs with mismatches\n",
                    length(ncc_seqs)/2))
      }
      if (length(ncc_seqs) >= 2){
        consensus <- sapply(seq(1,length(ncc_seqs), by = 2), function(i){
        Biostrings::consensusString(ncc_seqs[i:(i+1)])
        })
        # Overwrite the sequence of the non-concordant pairs.
        # The concordant alignments are at the start of keep
        ncc_idxs <- cumsum(concordant & is_first)[concordant & is_first & !same_seq]
        mcols(keep_alns[ncc_idxs])$seq <- Biostrings::DNAStringSet(consensus)
      }
    }
    if (length(keep) == 0) return(NULL)
    filtered.dots <- lapply(dots, function(x) x[keep])

    result <- c(list("alignments" = keep_alns), filtered.dots)
    result
} # -----

#'@title getInsertionsTable
#'@description Returns a table of insertion sequences present in
#'a GAlignments object.  This table is aggregated and used by
#'plotAlignments.
#'@author Helen Lindsay
#'@param alns A GAlignments object
#'@param pos (Integer(1)) The amount by which to shift genomic
#'coordinates upstream to get coordinates relative to a display region
#'@return A data frame of insertion sequences, genomic and
#'relative locations
getInsertionsTable <- function(alns, pos = 1L){
    ins_on_qry <- cigarRangesAlongQuerySpace(cigar(alns), ops = "I")
    if (all(lengths(ins_on_qry) == 0)){ return(NULL) }
    ins_on_genome <- cigarRangesAlongReferenceSpace(cigar(alns),
                                                    pos = start(alns),
                                                    ops = "I") 
    
    ins_seqs <- extractAt(mcols(alns)$seq, ins_on_qry)
    # Subtract 1 to get coordinates of the leftmost mapped base
    genome_starts <- start(ins_on_genome) - 1
    relative_starts <- start(unlist(shift(ins_on_genome, 1 - pos)))
    
    df <- data.frame(start = relative_starts,
                     seq = as.character(unlist(ins_seqs)),
                     genomic_start = unlist(genome_starts),
                     idx = rep(seq_along(ins_seqs), lengths(ins_seqs)),
                     stringsAsFactors = FALSE)
    df
}

# .formatVarLabels -----
#'@title formatVarLabels
#'@description Internal CrispRVariants function for creating allele
#'labels given variants and positions
#'@param grl  (GRangesList) A GRangesList of variants.  The position
#'of the variants is used in labels 
#'@param labels (character(n)) A vector of labels for each variant.
#'In CrispRVariants, this is the size and type of the variant, e.g. "9D"
#'for a 9 bp deletion.
#'@param position One of "start" and "end".  Determines whether the
#'start or the end coordinate is used when labeling variants.
#'@param genome.to.pos Optional named vector for transforming 
#'variant coordinates into another coordinate system (Default: NULL)
#'@param pos.to.lab (character(1)) Character to join positions and labels
#'(Default: ":", e.g. -3:9D)
#'@param as.string Should individual variant labels be pasted into
#'a single comma separated string when one alignment has multiple variants?
#' (Default: TRUE)
#'@rdname alleleLabelsHelpers
.formatVarLabels <- function(grl, labels, position = c("start", "end"),
                             genome.to.pos = NULL, pos.to.lab = ":",
                             as.string = TRUE){
  
    # Select either the start or end of the operation as the op position
    position <- match.arg(position)
    
    if (position == "start"){
      glocs <- start(grl)
    } else {
      glocs <- end(grl)
    } 
    glocs <- as.character(unlist(glocs))
    
    # Map position to another value if a mapping is given
    if (! is.null(genome.to.pos)){
      glocs <- genome.to.pos[glocs]
    }
    
    # Add location to cigar operations
    lns <- lengths(grl)
    op_labs <- paste(glocs, unlist(labels), sep = pos.to.lab)
    op_labs <- relist(op_labs, IRanges::PartitioningByWidth(lns))
    
    # Reverse each member of the list if using the end as the position 
    if (position == "end"){
      op_labs <- rev(relist(rev(unlist(op_labs)), rev(op_labs)))
    }
    
    # Collapse into a single string
    if (isTRUE(as.string)){
      op_labs <- paste(op_labs, collapse = ",")
    }
    
    op_labs
} # -----

# indelLabels -----
#'@title indelLabels
#'@description Makes allele labels for insertion / deletion variants
#'@author Helen Lindsay
#'@param alns (GAligments) aligned reads for finding variants
#'@param rc Should the variants be displayed with respect to the 
#'negative strand? (Default: FALSE)
#'@param genome.to.pos A vector with names being genomic locations and
#'values being positions to use in labels (Default: NULL)
#'@param keep.ops CIGAR operations to remain in the variant label
#'(usually indels)
#'@param regions  IRanges(k) Regions for counting insertions and
#'deletions.  Insertions on the right border are not counted.
#'@param as.string Return labels as strings (Default: TRUE)
#'@param ... extra formatting arguments
#'@return A vector of labels for alns
indelLabels = function(alns, rc = FALSE, genome.to.pos = NULL,
                       keep.ops = c("I","D","N"), regions = NULL,
                       as.string = TRUE, ...){
    
    # MAKE CONSISTENT: USE GENOMIC OR RELATIVE COORDS
    cigs <- GenomicAlignments::cigar(alns)
    op_locs <- selectOps(cigs, ops = keep.ops,
                         op.regions = regions,
                         pos = start(alns))
    
    position <- ifelse(isTRUE(rc), "end", "start")
    

    op_labs <- .formatVarLabels(op_locs$op_rngs, op_locs$op_labels,
                                position = position, as.string = as.string,
                                genome.to.pos = genome.to.pos, ...)
    
    op_labs
} # -----


# .resolveRefStrand -----
# If the reference provided maps to the negative strand, use
# the reverse complement when finding mismatches using the bam file
.resolveRefStrand <- function(strand, reference){
    if (strand == "*") strand <- "+"
    if (! strand %in% c("+","-","*")){
      stop('Strand should be either "+" or "-"')
    }
    # If reference is negative, use the positive to match bam format
    if (strand == "-"){
      reference <- Biostrings::reverseComplement(reference)
    }
    reference
} # -----

# findMismatches -----
# As only a single reference is provided, assume that alns start and end 
# at the same position
#'@title findMismatches
#'@description Assume that the reference may be on the negative strand and
#'regions are given with respect to the reference sequence.
#'@param alns A GAlignments object, where the aligned sequences should span the
#'reference sequence
#'@param ref.start (numeric(1)) The genomic start position of the reference sequence
#'@param ref.seq A DNAString object, the sequence for comparison when checking
#'for mismatches.  The sequence does not necessarily have to match the mapping
#'reference sequence.  Must span all regions if regions are provided.
#'@param regions A GRanges object, regions to check for mismatches with coordinates
#'relative to the reference sequence 
#'@param strand One of "+", "-"
#'@param min.pct (numeric(1), between 0 and 100) Only return SNVs that occur
#'at in least min.pct % of reads.  This tests the occurrence of the exact base
#'change, not any change at a position. 
#'@return A data frame of sequence indices, genomic position of mismatch
#'and mismatch base
#'@rdname alleleLabelsHelpers
.findMismatches <- function(alns, ref.seq, ref.start, regions = NULL,
                            strand = "+", min.pct = 0){
  
    # Using a single reference, rather than a reference per region,
    # as CrispRVariants considers variants within individual reads 
    # Sequences with deletions do not count towards min.pct for each column
 
    rwdth = nchar(ref.seq)
    
    # Check that regions are within the reference range
    if (! is.null(regions)){
      if (! all(regions %within% IRanges(1, rwdth))){
        stop("Region for counting mismatches longer than reference sequence")
      }
      # Convert regions to positive strand if they are negative
      if (as.character(strand) == "-"){
        temp <- structure(rev(1:nchar(ref.seq)), names = 1:nchar(ref.seq))
        strt <- temp[as.character(start(regions))]
        end <- temp[as.character(end(regions))]
        regions <- IRanges(end, strt)
      }
    }
    
    # As the alignments are to the +ve strand, get the +ve strand reference
    strand <- as.character(strand)
    ref.seq <- .resolveRefStrand(strand, ref.seq)
    
    # Get sequences aligned to the reference region, i.e. insertions ignored
    sqs <- sequenceLayer(mcols(alns)$seq, cigar(alns))
    if (! all(start(alns) == ref.start)){
      sqs <- stackStrings(sqs, from = 1,
                          shift = start(alns) - ref.start,
                          to = rwdth,
                          Lpadding.letter = "N",
                          Rpadding.letter = "N")
    }

    # Positions will be used for the labels
    posns <- ref.start:(ref.start + rwdth - 1)
    names(posns) <- 1:rwdth
    
    # HERE TO LOOP OVER REGIONS
    # unlist(unname(GAlignmentsList(alns[[1]])))
    
    
    
    # Note: using replaceAt as looking at single base positions
    if (! is.null(regions)){
      del_regions <- gaps(regions, start = 1, end = rwdth)
      sqs <- Biostrings::replaceAt(sqs, del_regions, "")
      posns <- posns[as.logical(coverage(regions, width = rwdth))]
      ref.seq <- replaceAt(ref.seq, del_regions, "")
    } 
    
    sqsm <- as.matrix(sqs)
    ref <- as.matrix(ref.seq)
    eq_ref <- t(t(sqsm) == as.vector(ref))
    
    is_base <- matrix(sqsm %in% c("A","C","T","G"), nrow = nrow(sqsm))
    snv <- is_base & ! eq_ref
    wh.snv <- which(snv, arr.ind = TRUE)
    if (strand == "-"){
      rc_base <- as.character(reverseComplement(DNAStringSet(sqsm[snv])))
      result <- data.frame(seq = wh.snv[,1],
                           pos = posns[wh.snv[,2]],
                           base = rc_base)
    } else {
      result <- data.frame(seq = wh.snv[,1],
                           pos = posns[wh.snv[,2]],
                           base = sqsm[snv])      
    }

    result <- result[order(result$seq), ]
    
    if (min.pct > 0){
      pcts <- prop.table(consensusMatrix(sqs)[c("A","C","T","G"),], 2) * 100
      # Note: keep includes reference but will not appear in result table
      keep <- which(pcts >= min.pct, arr.ind = TRUE)
      keep <- paste(posns[keep[,2]], rownames(keep))
      pos_base <- paste(result$pos, result$base)
      result <- result[pos_base %in% keep,]
    }
    
    result
  
} # -----

# nonindelLabels -----
#'@title nonindelLabels
#'@description Make variant labels for variants without an insertion or deletion
#'@param alns A GAlignments object, where the aligned sequences should span the
#'reference sequence
#'@param target (GRanges(1)) The region for counting mismatches 
#'@param ref.seq A DNAString object, the sequence for comparison when checking
#'for mismatches.  The sequence does not necessarily have to match the mapping
#'reference sequence.  Must span all regions if regions are provided.
#'@param regions A GRanges object, regions to check for mismatches with coordinates
#'relative to the reference sequence 
#'@param min.pct (numeric(1), between 0 and 100) Only return SNVs that occur
#'at in least min.pct % of reads.  This tests the occurrence of the exact base
#'change, not any change at a position. 
#'@param mismatch.label (character(1)) Label to append to the start of mismatch
#'strings, if returning as a single string (Default: "SNV:")
#'@param genome.to.pos Optional named vector for transforming 
#'variant coordinates into another coordinate system (Default: NULL)
#'@param as.string Should individual variant labels be pasted into
#'a single comma separated string when one alignment has multiple variants?
#' (Default: TRUE)
#'@return A data frame of sequence indices, genomic position of mismatch
#'and mismatch base
mismatchLabels <- function(alns, target, ref.seq, 
                           regions = NULL, min.pct = 0,
                           mismatch.label = "SNV",
                           genome.to.pos = NULL,
                           as.string = TRUE){
    # Multiple counting rules
    # Check rules don't overlap
    # Each rule may have from bases?  and to bases
  

    mm <- .findMismatches(alns, ref.seq = ref.seq,
                          ref.start = start(target),
                          regions = regions,
                          strand = as.character(strand(target)),
                          min.pct = min.pct)
    
    allele_labels <- rep("", length(alns))
    if (nrow(mm) == 0){
      return(allele_labels)
    }
    
    if (! is.null(genome.to.pos)){
      mm$pos <- genome.to.pos[as.character(mm$pos)]
    } 
    
    mm_labs <- paste0(mm$pos, mm$base)
    temp <- split(mm_labs, mm$seq)
    temp <- relist(unlist(unname(temp)),
                   PartitioningByWidth(lengths(temp)))
    
    if (isTRUE(as.string)){
      temp <- paste(temp, collapse = ",")
      tnms <- names(temp)
      temp <- paste(mismatch.label, temp, sep = ":")
      names(temp) <- tnms
    }
    
    allele_labels[as.numeric(names(temp))] <- unname(temp)
    allele_labels
  
} # -----


matchLabels <- function(alns, target, match.label = "No variant"){
    # Label partial alignments differently to perfect matches
    # RENAMING PARTIAL, NONMATCHING ALNS NOT FINISHED

    spans <- start(alns) <= start(target) & end(alns) >= end(target)
    nsp_cigar <- cigar(alns)[! spans] 
    rngs <- unname(ranges(alns))[! spans]
    splt <- split(rngs, cigar(alns)[! spans])
    nunq <- splt(lengths(splt) > 1)

    aln_labels <- rep(match.label, length(alns))
    aln_labels[! spans] <- cigar(alns)[! spans]
}


# .defaultCigarLabels -----
# temporary function until CrisprRun class is removed
.defaultCigarLabels = function(cset, renumbered = TRUE,
                               match_label = "no variant",
                               mismatch_label = "SNV",
                               split.snv = TRUE,
                               upstream.snv = 8, downstream.snv = 6,
                               bpparam = BiocParallel::SerialParam()){
  
    # Are the match and mismatch labels already set in the cset?
    if (all(lengths(alns(cset))) == 0) return(NULL)
  
    g_to_t <- NULL
    target.loc = cset$pars$target.loc
    target_start = start(cset$target)
    target_end = end(cset$target)
    rc = cset$pars$rc
    ref = cset$ref
  
    if (isTRUE(renumbered)){
      if (any(is.na(c(target_start, target_end, rc)))){
        stop("Must specify target.loc (cut site), target_start,
             target_end and rc for renumbering")
      }

      g_to_t <- cset$.genomeToTargetLocs(target.loc, target_start, target_end, 
                       as.character(strand(cset$target)) %in% c("+", "*"))
    }
  
    # rc means "display on negative strand"
    # Reversing ranges is dealt with in .findMismatches

    # This section is slow
    cig_by_run <- BiocParallel::bplapply(cset$crispr_runs,
                           function(crun)  crun$getCigarLabels(
                             target = cset$target,
                             target.loc = target.loc, #cut.site,
                             genome_to_target = g_to_t,
                             ref = ref,
                             separate.snv = split.snv,
                             match.label = cset$pars$match_label,
                             mismatch.label = cset$pars$mismatch_label,
                             rc = rc, upstream = upstream.snv,
                             downstream = downstream.snv), BPPARAM = bpparam)
  
    cig_by_run
} # -----


splitInsertions = function(cset, alleles = NULL, sample.pct = NULL, ...){
    # Split insertions if the inserted sequence is greater than
    # sample.pct percentage in any sample
    # ... arguments for indelLabels
      
    cat("alleles = ", alleles, "\n")
    vc <- variantCounts(cset, result = "proportions")
    
    if (! is.null(sample.pct)){
      
      if (! sample.pct >= 0 & sample.pct <= 100){
        stop("sample.pct should be between 0 and 100")
      }
      
      keep <- apply(vc, 1, function(x) any(x >= sample.pct))
      alleles <- c(names(keep)[keep], alleles)
    }
    
    if (is.null(alleles)){
      stop("Either sample.pct or alleles must not be NULL")
    } 

    missing_alleles <- setdiff(alleles, rownames(vc))
    cat(sprintf("missing alleles: %s\n", paste(missing_alleles, collapse = ",")))
    
    
    if (any(missing_alleles)){
      warning(sprintf("Alleles not found: %s",
                      paste(missing_alleles, collapse = "")))
    }
    
    cset_alns <- alns(cset)
    aln_lens <- lengths(cset_alns)
    cset_alns <- unlist(cset_alns)
    new_labels <- SummarizedExperiment::mcols(cset_alns)$"allele"
    to_change <- new_labels %in% alleles & grepl("I", cigar(cset_alns))
    
    if (! TRUE %in% to_change){
      warning("No alleles to change")
      invisible(return(cset))
    }
    
    alns <- cset_alns[to_change]
    indel_labs <- CrispRVariants:::indelLabels(alns, rc = cset$pars$rc,
                        genome.to.pos = cset$genome_to_target,
                        as.string = FALSE, ...)
    
    indel_locs <- GenomicAlignments::cigarRangesAlongQuerySpace(cigar(alns),
                                                          ops = c("I","D","N"))
    indel_seqs <- Biostrings::extractAt(SummarizedExperiment::mcols(alns)$seq,
                                        indel_locs)
    indel_seqs <- relist(sprintf("(%s)", as.character(unlist(indel_seqs))),
                         indel_seqs)
    indel_labs <- paste(indel_labs, indel_seqs, collapse = "", sep = "")
    new_labels[to_change] <- indel_labs
    dummy <- cset$setCigarLabels(labels = 
                  relist(new_labels, IRanges::PartitioningByWidth(aln_lens)))
    cset
}

# variantCounts -----
#'@title Get variant counts
#'@description Returns a matrix of counts where rows are sequence variants
#' and columns are samples
#'@param obj An object containing variant counts
#'@param ... Additional arguments
#'@return A matrix of counts where rows are variants and columns are samples
#'@author Helen Lindsay
#'@rdname variantCounts
#'@export
setGeneric("variantCounts", function(obj, ...) {
  standardGeneric("variantCounts")})

#'@param min.freq (Float n%) Return variants with frequency at least n% in at
#'least one sample (Default: 0)
#'@param min.count (Integer n) Return variants with count greater than n
#'in at least one sample (Default: 0)
#'@param top.n  (Integer n) If specified, return variants ranked at least n
#' according to frequency across all samples (Default: 0, i.e. no cutoff)
#'@param include.chimeras Should chimeric reads be included in the counts
#' table? (Default: TRUE)
#'@param include.nonindel Should sequences without indels be returned?
#'(Default:TRUE)
#'@param result Return variants as either counts ("counts", default) or
#'proportions ("proportions")
#'@param filter.vars  Labels of variants alleles to remove (Default: NULL)
#'@rdname variantCounts
#'@examples
#'data("gol_clutch1")
#'
#'#Return a matrix of the 5 most frequent variants
#'variantCounts(gol, top.n = 5)
setMethod("variantCounts", signature("CrisprSet"),
          function(obj, ..., top.n = NULL, min.freq = 0, min.count = 1,
              include.chimeras = TRUE, include.nonindel=TRUE,
              result = "counts", filter.vars = NULL){

    top.n <- ifelse(is.null(top.n), nrow(obj$cigar_freqs), top.n)
    result <- obj$.getFilteredCigarTable(top.n = top.n, min.freq = min.freq,
                                         min.count = min.count,
                                         include.chimeras = include.chimeras,
                                         include.nonindel = include.nonindel,
                                         type = result)
    if (! is.null(filter.vars)){
      result <- obj$filterVariants(cig_freqs = result, names = filter.vars)
    }
    result
}) # -----


# mutationEfficiency -----
#'@title Get mutation efficiency
#'@description  Returns the percentage of sequences that contain at least
#' one mutation.
#'@param obj An object containing variant counts
#'@param ... additional arguments
#'@author Helen Lindsay
#'@rdname mutationEfficiency
#'@export
setGeneric("mutationEfficiency", function(obj, ...) {
  standardGeneric("mutationEfficiency")})

#'@param snv  Single nucleotide variants (SNVs) may be considered as
#'mutations ("include"), treated as ambiguous sequences and not counted
#'at all ("exclude"), or treated as non-mutations, e.g. sequencing errors
#'or pre-existing SNVs ("non_variant", default)
#'@param include.chimeras Should chimeric alignments be counted as variants
#'when calculating mutation efficiency (Default: TRUE
#'@param exclude.cols A vector of names of columns in the variant counts table
#'that will not be considered when counting mutation efficiency
#'@param filter.vars Variants to remove before calculating efficiency.
#'May be either a variant size, e.g. "1D", or a particular 
#'variant/variant combination, e.g. -5:3D
#'@param filter.cols A vector of control sample names.  Any variants present in the control
#'samples will be counted as non-variant, unless they also contain another indel.  Note that
#'this is not compatible with counting snvs as variants.
#'@param group A grouping vector.  If provided, efficiency will be calculated
#'per group (Default: NULL)
#'@rdname mutationEfficiency
#'@return A vector of efficiency statistics per sample and overall, or 
#'a matrix of efficiency statistics per group if a group is provided
#'@examples
#'data("gol_clutch1")
#'mutationEfficiency(gol)
setMethod("mutationEfficiency", signature("CrisprSet"),
          function(obj, ..., snv = c("non_variant", "include","exclude"),
                   include.chimeras = TRUE, exclude.cols = NULL,
                   filter.vars = NULL, filter.cols = NULL, group = NULL){
    result <- obj$mutationEfficiency(snv = snv,
                                  include.chimeras = include.chimeras,
                                  exclude.cols = exclude.cols,
                                  filter.vars = filter.vars,
                                  filter.cols = filter.cols,
                                  group = group, ...)
    result
}) # -----


# findSNVs -----
#'@title Find frequent SNVs
#'@description Find single nucleotide variants (SNVs) above a specified frequency
#'in a table of variants.
#'@param obj An object containing variant counts
#'@param ... additional arguments
#'@author Helen Lindsay
#'@rdname findSNVs
#'@export
setGeneric("findSNVs", function(obj, ...) {
  standardGeneric("findSNVs")})


#'@rdname findSNVs
#'@param freq minimum frequency snv to return (Default: 0.25)
#'@param include.chimeras include chimeric reads when calculating SNV frequencies
#'(Default: TRUE)
#'@return A vector of SNVs and their frequencies
setMethod("findSNVs", signature("CrisprSet"),
          function(obj, ..., freq = 0.25, include.chimeras = TRUE){
            result <- obj$.getSNVs(min.freq = freq,
                                  include.chimeras = include.chimeras)
            result
          }) # -----


# getChimeras -----
#'@title Get chimeric alignments
#'@description Return chimeric alignments from a collection of aligned sequences
#'@param obj An object containing aligned sequences
#'@param ... additional arguments
#'@author Helen Lindsay
#'@rdname getChimeras
#'@export
setGeneric("getChimeras", function(obj, ...) {
  standardGeneric("getChimeras")})

#'@rdname getChimeras
#'@param sample The sample name or sample index to return
#'@return A GAlignment object containing the chimeric read groups
#'@examples
#'data("gol_clutch1")
#'chimeras <- getChimeras(gol, sample = 2)
setMethod("getChimeras", signature("CrisprSet"),
          function(obj, ..., sample){
            if (length(sample) > 1){
              stop("This function accepts a single sample name or index")
            }
            obj$crispr_runs[[sample]]$chimeras
          }) # -----


# consensusSeqs -----
#'@title Get consensus sequences for variant alleles
#'@description Return consensus sequences of variant alleles.  At
#'present, chimeric alignments are not included.
#'@param obj An object containing aligned sequences
#'@param ... additional arguments
#'@author Helen Lindsay
#'@rdname consensusSeqs
#'@export
setGeneric("consensusSeqs", function(obj, ...) {
  standardGeneric("consensusSeqs")})

#'@rdname consensusSeqs
#'@param min.freq (Float n%) Return variants with frequency at least n% in at
#'least one sample (Default: 0)
#'@param min.count (Integer n) Return variants with count greater than n
#'in at least one sample (Default: 0)
#'@param top.n  (Integer n) If specified, return variants ranked at least n according
#' to frequency across all samples (Default: 0, i.e. no cutoff)
#'@return A DNAStringSet of consensus sequences on the positive strand.
#'@examples
#'data("gol_clutch1")
#'seqs <- consensusSeqs(gol, sample = 2)
setMethod("consensusSeqs", signature("CrisprSet"),
          function(obj, ..., top.n = NULL, min.freq = 0, min.count = 1){
            top.n <- ifelse(is.null(top.n), nrow(obj$cigar_freqs), top.n)
            cig_freqs <- obj$.getFilteredCigarTable(top.n = top.n,
                                                    min.freq = min.freq,
                                                    min.count = min.count,
                                                    include.chimeras = FALSE,
                                                    include.nonindel = TRUE,
                                                    type = "counts")

            obj$consensusAlleles(cig_freqs)

}) # -----

# alns -----
#'@title Get alignments
#'@description Return alignments from an object that contains them.
#'For a CrisprSet object, these are truncated, non-chimeric alignments 
#'@param obj An object containing aligned sequences
#'@param ... additional arguments
#'@author Helen Lindsay
#'@rdname alns
#'@export
setGeneric("alns", function(obj, ...) {
  standardGeneric("alns")})

#'@rdname alns
#'@return A GAlignmentsList of consensus sequences on the positive strand.
#'@examples
#'data("gol_clutch1")
#'alns <- alns(gol)
setMethod("alns", signature("CrisprSet"),
          function(obj, ...){
            alns <- lapply(obj$crispr_runs, function(x) x$alns)
            GAlignmentsList(alns)
}) # -----

# alleles -----
#'@title Get allele names 
#'@description Function to access allele names 
#'@param obj An object containing variant alleles
#'@param ... additional arguments
#'@author Helen Lindsay
#'@rdname alleles
#'@export
setGeneric("alleles", function(obj, ...) {
  standardGeneric("alleles")})

#'@rdname alleles
#'@return A data frame relating CIGAR strings to variant labels
#'@examples
#'data("gol_clutch1")
#'alleles <- alleles(gol)
setMethod("alleles", signature("CrisprSet"),
          function(obj, ...){
            
            alns <- unlist(unname(alns(obj)))
            cigars <- GenomicAlignments::cigar(alns)
            labels <- mcols(alns)$allele
            result <- data.frame(label = as.character(labels), 
                                 cigar = as.character(cigars),
                                 genomic.loc = start(alns),
                                 stringsAsFactors = FALSE)
            result <- unique(result)
            result  
})

#'@title Finds overlaps between aligned reads and PCR primers
#'@description Short reads amplified with PCR primers should start and end
#'at defined positions.  However, the ends of an aligned read may be clipped
#'as sequencing technologies are prone to making errors at the start and end.
#'readsByPCRPrimer extrapolates the genomic location of entire reads
#'from their aligned sections by adding clipped sections, then finds near
#'exact matches to a set of PCR primers.  Note that this is not always a good
#'assumption, and is misleading in the case of chimeric reads where sections
#'clipped in one part of a chimera are aligned in another.
#'@param bam A set of aligned reads
#'@param primers A set of ranges that the unclipped reads may map to
#'@param ... Additional arguments
#'@author Helen Lindsay
#'@rdname readsByPCRPrimer
#'@export
setGeneric("readsByPCRPrimer", function(bam, primers, ...) {
           standardGeneric("readsByPCRPrimer")})

#'@param tolerance Number of bases by which reads and primers may differ
#'at each end (Default: 0)
#'@param verbose Print number of full and partial matches (Default: TRUE)
#'@param ignore.strand Passed to \code{\link[GenomicAlignments]{findOverlaps}}
#'and \code{\link[GenomicRanges]{disjoin}}. Should strand be ignored when
#'finding overlaps.  (Default: TRUE)
#'@param allow.partial Should reads that do not match the PCR boundaries, but
#'map to a region covered by only one primer be considered matches?  (Default: TRUE)
#'@param chimera.idxs Indices of chimeric reads within the bam.  If specified,
#'chimeras overlapping multiple pcr primers will be removed.
#'@return A \code{\link[S4Vectors]{Hits}} object where "query" is the index with
#'respect to bam and "subject" is the index with respect to the primers.
#'@seealso \code{\link[GenomicRanges]{GRanges}}, \code{\link[GenomicAlignments]{GAlignments}}
#'@rdname readsByPCRPrimer
setMethod("readsByPCRPrimer", signature("GAlignments", "GRanges"),
          function(bam, primers, ..., tolerance=0, verbose = TRUE,
                   ignore.strand = TRUE, allow.partial = TRUE,
                   chimera.idxs = NULL){

            bamgr <- addClipped(bam)
            readsByPCRPrimer(bamgr, primers, tolerance = tolerance,
                   verbose = verbose, ignore.strand = ignore.strand,
                   allow.partial = allow.partial, chimera.idxs = chimera.idxs, ...)
        })


#'@rdname readsByPCRPrimer
setMethod("readsByPCRPrimer", signature("GRanges", "GRanges"),
          function(bam, primers, ..., tolerance=0, verbose = TRUE,
                   ignore.strand = TRUE, allow.partial = TRUE,
                   chimera.idxs = NULL){

            if (verbose){
              message("Finding overlaps between reads and primers\n")
            }
            hits_pcr <- findOverlaps(bam, primers, ignore.strand = ignore.strand,
                                     type = "equal", maxgap = tolerance)
            if (verbose){
              hits_pcr_l <- length(unique(queryHits(hits_pcr)))
              message(sprintf("%s from %s (%.2f%%) reads overlap a pcr region
                              almost exactly\n",
                          hits_pcr_l, length(bam), hits_pcr_l/length(bam)*100))
            }
            if (any(duplicated(queryHits(hits_pcr)))){
              warning("Cannot distinguish all pcr targets with this tolerance")
            }
            if (allow.partial){
              # find the unique regions of the pcr primers
              get_dups <- function(x) duplicated(x) | duplicated(x, fromLast = TRUE)

              disjoint <- disjoin(primers, ignore.strand = ignore.strand)
              dj_to_primer <- findOverlaps(disjoint, primers)
              is_dup <- get_dups(queryHits(dj_to_primer))
              dj_to_primer <- dj_to_primer[!is_dup]

              # find overlaps between the remaining reads and the unique regions
              remaining <- setdiff(c(1:length(bam)), queryHits(hits_pcr))
              rhits <- findOverlaps(bam[remaining], disjoint[queryHits(dj_to_primer)])
              is_dup <- get_dups(queryHits(rhits))

              if (verbose & any(is_dup)) {
                message(sprintf("Excluded %s reads which map to unique regions of
                                multiple primers\n",
                    length(unique(queryHits(rhits[is_dup])))))
              }
              rhits <- rhits[!is_dup]
              rhits_to_primer <- S4Vectors::remapHits(rhits,
                  Lnodes.remapping = factor(remaining,
                                            levels = c(1:length(bam))),
                  Rnodes.remapping = factor(subjectHits(dj_to_primer),
                                            levels = c(1:length(primers))))
              if (verbose){
                rhitsl <- length(unique(queryHits(rhits)))
                message(sprintf("Of the %s reads that do not exactly match a pcr region,
%s (%.2f%%) partially overlap exactly one pcr region\n\n",
                    (length(bam)-hits_pcr_l),
                    rhitsl, rhitsl/(length(bam)-hits_pcr_l)*100))
              }
              hits_pcr <- union(hits_pcr, rhits_to_primer)
            }
            if (!is.null(chimera.idxs)){
              hits_pcr <- rmMultiPCRChimera(names(bam), hits_pcr, chimera.idxs,
                                            verbose = verbose)
            }
            if (verbose){
              message(sprintf("Found matches for %s reads from %s\n\n",
                          length(hits_pcr), length(bam)))
            }
            hits_pcr
          })


#'@title Extrapolates mapping location from clipped, aligned reads
#'@description Extrapolates the mapping location of a read by assuming that
#'the clipped regions should map adjacent to the mapped locations.  This
#'is not always a good assumption, particularly in the case of chimeric reads!
#'@author Helen Lindsay
#'@rdname addClipped
setGeneric("addClipped", function(bam, ...) {
  standardGeneric("addClipped")})

#'@param bam A GAlignments object
#'@param ... additional arguments
#'@return A \code{\link[GenomicRanges]{GRanges}} representation of the extended
#'mapping locations
#'@rdname addClipped
setMethod("addClipped", signature("GAlignments"),
          function(bam, ...){
            l_clip <- as.numeric(gsub(".*[A-Z].*", 0, gsub("[HS].*","", cigar(bam))))
            r_clip <- as.numeric(gsub("^$", 0, gsub('.*M|[HS]$', "", cigar(bam))))
            bamgr <- GenomicRanges::GRanges(seqnames(bam),
                              IRanges(start(bam) - l_clip, end(bam) + r_clip))
            names(bamgr) <- names(bam)
            bamgr
          })



#'@title Remove chimeric reads overlapping multiple primers
#'@description Finds and removes sets of chimeric read alignments
#' that overlap more than one guide, i.e. that cannot be unambiguously
#' assigned to a single guide. 
#'@param readnames A set of read names, used for identifying chimeric read sets
#'@param pcrhits A mapping between indices of reads and a set of pcr primers
#'@param chimera_idxs location of chimeric reads within the bam
#'@param ... Additional arguments
#'@return pcrhits, with chimeric reads mapping to different primers omitted.
#'@author Helen Lindsay
#'@rdname rmMultiPCRChimera
setGeneric("rmMultiPCRChimera", function(readnames, pcrhits, chimera_idxs, ...) {
  standardGeneric("rmMultiPCRChimera")})


#'@param verbose Display information about the chimeras (Default: TRUE)
#'@rdname rmMultiPCRChimera
setMethod("rmMultiPCRChimera", signature("character", "Hits", "integer"),
          function(readnames, pcrhits, chimera_idxs, ..., verbose = TRUE){
            chs <- chimera_idxs[chimera_idxs %in% queryHits(pcrhits)]
            get_dups <- function(x) duplicated(x) | duplicated(x, fromLast = TRUE)
            nms <- readnames[chs]
            is_dup <- get_dups(nms)
            dnms <- nms[is_dup]
            ch_to_pcr <- match(chs[is_dup], queryHits(pcrhits))
            pcr <- subjectHits(pcrhits)[ch_to_pcr]
            pcr <- rle(paste(pcr, dnms, sep = "."))
            dnms <- rle(dnms)
            one_primer <- rep(dnms$lengths, dnms$lengths) == rep(pcr$lengths, pcr$lengths)
            if (verbose){
              message(sprintf("%s (%.2f%%) of the chimeric reads overlap a pcr primer.
  For %s (%2.f%% reads) of these, at least 2 segments of the chimera
overlap a primer.
    Of these, %s (%.2f%%) overlap different primers\n",
                   length(chs), length(chs)/length(chimera_idxs) * 100,
                   sum(is_dup), sum(is_dup)/length(chs)*100,
                   sum(!one_primer), length(unique(dnms[!one_primer]))))
            }
            pcrhits[-ch_to_pcr[!one_primer]]
          })

## ----eval = FALSE-------------------------------------------------------------
# crispr_set <- readsToTarget(reads, target = target, reference = reference,
#                             target.loc = target.loc)
# plotVariants(crispr_set)
# # or use plotVariants(crispr_set, txdb) to additionally show the target
# # location with respect to the transcripts if a Transcript Database
# # txdb is available

## ----message=FALSE, warning=FALSE---------------------------------------------
library(CrispRVariants)
library(sangerseqR)

# List AB1 filenames, get sequence names,  make names for the fastq files
# Note that we only include one ab1 file with CrispRVariants because
# of space constraints.  All bam files are included

data_dir <- system.file(package="CrispRVariants", "extdata/ab1/ptena")
fq_dir <- tempdir()
ab1_fnames <- dir(data_dir, "ab1$", recursive=TRUE, full=TRUE)
sq_nms <- gsub(".ab1","",basename(ab1_fnames))

# Replace spaces and slashes in filename with underscores
fq_fnames  <- paste0(gsub("[\ |\\/]", "_", dirname(ab1_fnames)), ".fastq")

# abifToFastq to read AB1 files and write to FASTQ
dummy <- mapply( function(u,v,w) {
        abifToFastq(u,v,file.path(fq_dir,w))
}, sq_nms, ab1_fnames, fq_fnames)

## ----message=FALSE, warning = FALSE-------------------------------------------
length(unique(ab1_fnames))
length(unique(fq_fnames))

## ----message = FALSE, warning=FALSE, eval=FALSE-------------------------------
# library("Rsamtools")
# 
# # BWA indices were generated using bwa version 0.7.10
# bwa_index <- "GRCHz10.fa.gz"
# bam_dir <- system.file(package="CrispRVariants", "extdata/bam")
# fq_fnames <- file.path(fq_dir,unique(fq_fnames))
# bm_fnames <- gsub(".fastq$",".bam",basename(fq_fnames))
# srt_bm_fnames <- file.path(bam_dir, gsub(".bam","_s",bm_fnames))
# 
# # Map, sort and index the bam files, remove the unsorted bams
# for(i in 1:length(fq_fnames)) {
#   cmd <- paste0("bwa mem ", bwa_index, " ", fq_fnames[i],
#                 " | samtools view -Sb - > ", bm_fnames[i])
#   message(cmd, "\n"); system(cmd)
#   indexBam(sortBam(bm_fnames[i],srt_bm_fnames[i]))
#   unlink(bm_fnames[i])
# }

## ----message=FALSE------------------------------------------------------------
# The metadata and bam files for this experiment are included with CrispRVariants
library("readxl")
md_fname <- system.file(package="CrispRVariants", "extdata/metadata/metadata.xls")
md <- readxl::read_xls(md_fname, 1)
md

# Get the bam filenames from the metadata table
bam_dir <- system.file(package="CrispRVariants", "extdata/bam")
bam_fnames <- file.path(bam_dir, md$bamfile)

# check that all files exist
all( file.exists(bam_fnames) )

## ----message=FALSE------------------------------------------------------------
library(rtracklayer)
# Represent the guide as a GenomicRanges::GRanges object
gd_fname <- system.file(package="CrispRVariants", "extdata/bed/guide.bed")
gd <- rtracklayer::import(gd_fname)
gd

## ----message=FALSE------------------------------------------------------------
gdl <- GenomicRanges::resize(gd, width(gd) + 10, fix = "center")

## ----eval=FALSE---------------------------------------------------------------
# system("samtools faidx GRCHz10.fa.gz")
# 
# reference=system(sprintf("samtools faidx GRCHz10.fa.gz %s:%s-%s",
#                          seqnames(gdl)[1], start(gdl)[1], end(gdl)[1]),
#                  intern = TRUE)[[2]]
# 
# # The guide is on the negative strand, so the reference needs to be reverse complemented
# reference=Biostrings::reverseComplement(Biostrings::DNAString(reference))
# save(reference, file = "ptena_GRCHz10_ref.rda")

## -----------------------------------------------------------------------------
ref_fname <- system.file(package="CrispRVariants", "extdata/ptena_GRCHz10_ref.rda")
load(ref_fname)
reference

## ----tidy = FALSE-------------------------------------------------------------
# First read the alignments into R.  The alignments must include
# the read sequences and the MD tag
alns <- GenomicAlignments::readGAlignments(bam_fnames[[1]], 
          param = Rsamtools::ScanBamParam(tag = "MD", what = c("seq", "flag")),
          use.names = TRUE)

# Then reconstruct the reference for the target region.
# If no target region is given, this function will reconstruct
# the complete reference sequence for all reads.
rfa <- refFromAlns(alns, gdl)

# The reconstructed reference sequence is identical to the sequence
# extracted from the reference above
print(rfa == reference)

## ----message=FALSE------------------------------------------------------------
# Note that the zero point (target.loc parameter) is 22
crispr_set <- readsToTarget(bam_fnames, target = gdl, reference = reference,
                            names = md$Short.name, target.loc = 22)
crispr_set

# The counts table can be accessed with the "variantCounts" function
vc <- variantCounts(crispr_set)
print(class(vc))

## ----eval = FALSE-------------------------------------------------------------
# # In R
# library(GenomicFeatures)
# gtf_fname <- "Danio_rerio.GRCz10.81_chr17.gtf"
# txdb <- GenomicFeatures::makeTxDbFromGFF(gtf_fname, format = "gtf")
# saveDb(txdb, file= "GRCz10_81_chr17_txdb.sqlite")

## ----echo=FALSE, message=FALSE------------------------------------------------
library(GenomicFeatures)
txdb_fname <- system.file("extdata/GRCz10_81_ptena_txdb.sqlite", 
                          package="CrispRVariants")
txdb <- loadDb(txdb_fname)

## ----message = FALSE----------------------------------------------------------
# The gridExtra package is required to specify the legend.key.height 
# as a "unit" object.  It is not needed to call plotVariants() with defaults
library(gridExtra)

# Match the clutch id to the column names of the variants
group <- md$Group

## ----ptena-plot, fig.width = 8.5, fig.height = 7.5, message = FALSE, fig.cap = "(Top) schematic of gene structure showing guide location (left) consensus sequences for variants (right) variant counts in each embryo."----
p <- plotVariants(crispr_set, txdb = txdb, gene.text.size = 8, 
    row.ht.ratio = c(1,8), col.wdth.ratio = c(4,2),
    plotAlignments.args = list(line.weight = 0.5, ins.size = 2, 
                               legend.symbol.size = 4),
    plotFreqHeatmap.args = list(plot.text.size = 3, x.size = 8, group = group, 
                                legend.text.size = 8, 
                                legend.key.height = grid::unit(0.5, "lines"))) 

## -----------------------------------------------------------------------------
# Calculate the mutation efficiency, excluding indels that occur in the "control" sample
# and further excluding the "control" sample from the efficiency calculation
eff <- mutationEfficiency(crispr_set, filter.cols = "control", exclude.cols = "control")
eff

# Suppose we just wanted to filter particular variants, not an entire sample.
# This can be done using the "filter.vars" argument
eff2 <- mutationEfficiency(crispr_set, filter.vars = "6:1D", exclude.cols = "control")

# The results are the same in this case as only one variant was filtered from the control
identical(eff,eff2)

## -----------------------------------------------------------------------------
sqs <- consensusSeqs(crispr_set)
sqs

# The ptena guide is on the negative strand.
# Confirm that the reverse complement of the "no variant" allele
# matches the reference sequence:
Biostrings::reverseComplement(sqs[["no variant"]]) == reference

## -----------------------------------------------------------------------------
ch <- getChimeras(crispr_set, sample = "ptena 4")

# Confirm that all chimeric alignments are part of the same read
length(unique(names(ch))) == 1

# Set up points to annotate on the plot
annotations <- c(resize(gd, 1, fix = "start"), resize(gd, 1, fix = "end"))
annotations$name <- c("ptena_start", "ptena_end")

plotChimeras(ch, annotations = annotations)


## -----------------------------------------------------------------------------
mutationEfficiency(crispr_set, filter.cols = "control", exclude.cols = "control",
                   include.chimeras = FALSE)

## ----fig.width = 8.5, fig.height = 7.5, message = FALSE, warning = FALSE------

crispr_set_rev <- readsToTarget(bam_fnames, target = gdl, reference = reference,
                                names = md$Short.name, target.loc = 22, 
                                orientation = "opposite")
plotVariants(crispr_set_rev)

## ----warning = FALSE----------------------------------------------------------
# We create a longer region to use as the "target"
# and the corresponding reference sequence
gdl <- GenomicRanges::resize(gd, width(gd) + 20, fix = "center")
reference <- Biostrings::DNAString("TCATTGCCATGGGCTTTCCAGCCGAACGATTGGAAGGTGTTTA")

# At this stage, target should be the entire region to display and target.loc should
# be the zero point with respect to this region
crispr_set <- readsToTarget(bam_fnames, target = gdl, reference = reference,
                            names = md$Short.name, target.loc = 10,
                            verbose = FALSE)

# Multiple guides are added at the stage of plotting
# The boundaries of the guide regions must be specified with respect to the
# given target region
p <- plotVariants(crispr_set, 
       plotAlignments.args = list(pam.start = c(6,35),
                              target.loc = c(10, 32),
                              guide.loc = IRanges::IRanges(c(6, 25),c(20, 37))))
p

## ----message = FALSE----------------------------------------------------------
# Setup for ptena data set
library("CrispRVariants")
library("rtracklayer")
library("GenomicFeatures")
library("readxl")

# Load the guide location
gd_fname <- system.file(package="CrispRVariants", "extdata/bed/guide.bed")
gd <- rtracklayer::import(gd_fname)
gdl <- resize(gd, width(gd) + 10, fix = "center")

# The saved reference sequence corresponds to the guide 
# plus 5 bases on either side, i.e. gdl
ref_fname <- system.file(package="CrispRVariants", 
                         "extdata/ptena_GRCHz10_ref.rda")
load(ref_fname)

# Load the metadata table, which gives the sample names
md_fname <- system.file(package="CrispRVariants",
                        "extdata/metadata/metadata.xls")
md <- readxl::read_xls(md_fname, 1)

# Get the list of bam files
bam_dir <- system.file(package="CrispRVariants", "extdata/bam")
bam_fnames <- file.path(bam_dir, md$bamfile)

# Check that all files were found
all(file.exists(bam_fnames))

crispr_set <- readsToTarget(bam_fnames, target = gdl, reference = reference,
                            names = md$Short.name, target.loc = 22,
                            verbose = FALSE)

# Load the transcript database
txdb_fname <- system.file("extdata/GRCz10_81_ptena_txdb.sqlite", 
                          package="CrispRVariants")
txdb <- AnnotationDbi::loadDb(txdb_fname)


## ----fig.height = 5, warning = FALSE------------------------------------------
p <- plotVariants(crispr_set, txdb = txdb)

## ----fig.height = 5, warning = FALSE------------------------------------------
p <- plotVariants(crispr_set, txdb = txdb, row.ht.ratio = c(1,3))

## ----fig.height = 5, message = FALSE, warning = FALSE-------------------------
p <- plotVariants(crispr_set, txdb = txdb, col.wdth.ratio = c(4,1))

## -----------------------------------------------------------------------------
# Load gol data set
library("CrispRVariants")
data("gol_clutch1")

## ----fig.height = 2.5, message = FALSE, warning = FALSE-----------------------
library(GenomicFeatures)
p <- plotVariants(gol, plotAlignments.args = list(top.n = 3),
             plotFreqHeatmap.args = list(top.n = 3),
             left.plot.margin = ggplot2::unit(c(0.1,0,5,0.2), "lines"))

## ----fig.height = 2.5, message = FALSE, warning = FALSE-----------------------
plotVariants(gol, plotAlignments.args = list(top.n = 3),
             plotFreqHeatmap.args = list(top.n = 3, order = c(1,5,3)),
             left.plot.margin = ggplot2::unit(c(0.1,0,5,0.2), "lines"))

## ----fig.height = 2.5, warning = FALSE----------------------------------------
plotAlignments(gol, top.n = 3, ins.size = 6)

## ----fig.height = 2.5---------------------------------------------------------
plotAlignments(gol, top.n = 3, legend.symbol.size = 6)

## ----fig.height = 3, warning = FALSE------------------------------------------
plotAlignments(gol, top.n = 5, max.insertion.size = 25)

## ----fig.height = 3, warning = FALSE------------------------------------------
# Here we set a fairly high value of 50% for min.insertion.freq
# As ambiguous nucleotides occur frequently in this data set,
# there are no alleles passing this cutoff.
plotAlignments(gol, top.n = 5, min.insertion.freq = 50)

## ----fig.height = 3, warning = FALSE------------------------------------------
plotAlignments(gol, top.n = 5, max.insertion.size = 25, min.insertion.freq = 50)

## ----fig.height = 2.5, warning = FALSE----------------------------------------
# No white space between rows
plotAlignments(gol, top.n = 3, tile.height = 1)

## ----fig.height = 3, warning = FALSE------------------------------------------
# More white space between rows
plotAlignments(gol, top.n = 3, tile.height = 0.3)

## ----fig.height = 2.5, warning = FALSE----------------------------------------
plotAlignments(gol, top.n = 3, highlight.guide = FALSE)

## ----fig.height = 3, message = FALSE------------------------------------------
library(IRanges)
guide <- IRanges::IRanges(15,28)
plotAlignments(gol, top.n = 3, guide.loc = guide)

## ----fig.height = 2.5---------------------------------------------------------
# Here we increase the size of the axis labels and make
# two columns for the legend
plotAlignments(gol, top.n = 5, axis.text.size = 12, 
               legend.text.size = 12, legend.cols = 2)


## ----fig.height = 3, warning = FALSE------------------------------------------
# Don't highlight the PAM sequence
plotAlignments(gol, top.n = 3, highlight.pam = FALSE)

## ----fig.height = 3, warning = FALSE------------------------------------------

# Highlight 3 bases upstream to 3 bases downstream of the target.loc
plotAlignments(gol, top.n = 3, pam.start = 19, pam.end = 25)

## ----fig.height = 3, warning = FALSE------------------------------------------

plotAlignments(gol, top.n = 3, guide.loc = IRanges(5,10),
               pam.start = 8, pam.end = 13)


## ----fig.height = 3, warning = FALSE------------------------------------------
plotAlignments(gol, top.n = 3, line.weight = 3)

## ----fig.height = 3, warning = FALSE------------------------------------------
plotAlignments(gol, top.n = 3, codon.frame = 1)

## ----eval = FALSE-------------------------------------------------------------
# plot_data <- plotAlignments(gol, top.n = 3, create.plot = FALSE)
# names(plot_data)
# # This data can be modified as required, then replotted using:
# do.call(plotAlignments, plot_data)

## ----hmap-default, fig.height = 3, fig.width = 4, fig.align='center', fig.cap = "plotFreqHeatmap with default options"----
# Save the plot to a variable then add a title using ggplot2 syntax.
# If the plot is not saved to a variable the unmodified plot is displayed.
p <- plotFreqHeatmap(gol, top.n = 3)
p + labs(title = "A. plotFreqHeatmap with default options")

## ----fig.height = 2.5, fig.width = 5, fig.align='center', fig.cap = "plotFreqHeatmap showing allele proportions"----
    
plotFreqHeatmap(gol, top.n = 3, type = "proportions")

## ----fig.height = 2.5, fig.width = 4, fig.align='center', fig.cap = "plotFreqHeatmap with X-axis labels coloured by experimental group and tiles coloured by count instead of proportion"----
ncolumns <- ncol(variantCounts(gol))
ncolumns
grp <- rep(c(1,2), each = ncolumns/2)
p <- plotFreqHeatmap(gol, top.n = 3, group = grp, as.percent = FALSE)
p + labs(title = "B. coloured X labels with tiles coloured by count")

## ----fig.height = 2.5, fig.width = 5, fig.align='center', fig.cap = "plotFreqHeatmap with labels showing allele proportions, header showing counts per sample and modified legend position."----
grp_clrs <- c("red", "purple")
p <- plotFreqHeatmap(gol, top.n = 3, group = grp, group.colours = grp_clrs,
                type = "proportions", header = "counts",
                legend.position = "bottom")
p <- p + labs(title = "C. Modified plotFreqHeatmap")
p

## ----fig.height = 2.5, fig.width = 4, fig.align='center'----------------------
plotFreqHeatmap(gol, top.n = 3, 
                legend.key.height = ggplot2::unit(1.5, "lines"))

## ----eval = FALSE-------------------------------------------------------------
# var_counts <- variantCounts(gol, top.n = 3)
# # (additional modifications to var_counts can be added here)
# plotFreqHeatmap(var_counts)

## ----fig.height = 2.5---------------------------------------------------------
barplotAlleleFreqs(crispr_set, txdb = txdb)

## ----fig.height = 2.5, message = FALSE----------------------------------------
barplotAlleleFreqs(crispr_set, txdb = txdb, palette = "bluered")

## ----fig.height = 2.5, message = FALSE----------------------------------------
barplotAlleleFreqs(crispr_set, txdb = txdb, include.table = FALSE)

## ----fig.height = 2.5---------------------------------------------------------
var_counts <- variantCounts(crispr_set)
barplotAlleleFreqs(var_counts)

## ----fig.height = 2.5---------------------------------------------------------
rainbowPal10 <- c("#781C81","#3F479B",
                  "#4277BD","#529DB7",
                  "#62AC9B","#86BB6A",
                  "#C7B944","#E39C37",
                  "#E76D2E","#D92120")

barplotAlleleFreqs(var_counts, classify = FALSE, bar.colours = rainbowPal10)


## ----fig.height = 2.5---------------------------------------------------------
# Classify variants as insertion/deletion/mixed
byType <- crispr_set$classifyVariantsByType()
byType

# Classify variants by their location, without considering size
byLoc <- crispr_set$classifyVariantsByLoc(txdb=txdb)
byLoc
# Coding variants can then be classified by setting a size cutoff
byLoc <- crispr_set$classifyCodingBySize(byLoc, cutoff = 6)
byLoc

# Combine filtering and variant classification, using barplotAlleleFreqs.matrix
vc <- variantCounts(crispr_set)

# Select variants that occur in at least two samples
keep <- names(which(rowSums(vc > 0) > 1))
keep

# Use this classification and the selected variants
barplotAlleleFreqs(vc[keep,], category.labels = byLoc[keep])

## ----fig.height = 2.5---------------------------------------------------------
p <- plotAlignments(gol, top.n = 3)
p + theme(legend.margin = ggplot2::unit(0, "cm"))

## ----fig.height = 1-----------------------------------------------------------

# Get a reference sequence
library("CrispRVariants")
data("gol_clutch1")
ref <- gol$ref

#Then to make the plot:
plotAlignments(ref, alns = NULL, target.loc = 22, ins.sites = data.frame())


## ----message = FALSE, warning = FALSE-----------------------------------------
library(Biostrings)
library(CrispRVariants)
library(rtracklayer)

## ----warning = FALSE----------------------------------------------------------
# This is a small, manually generated data set with a variety of different mutations 
bam_fname <- system.file("extdata", "cntnap2b_test_data_s.bam", 
                         package = "CrispRVariants")
guide_fname <- system.file("extdata", "cntnap2b_test_data_guide.bed",
                           package = "CrispRVariants")
guide <- rtracklayer::import(guide_fname)
guide <- guide + 5
reference <- Biostrings::DNAString("TAGGCGAATGAAGTCGGGGTTGCCCAGGTTCTC")

cset <- readsToTarget(bam_fname, guide, reference = reference, verbose = FALSE, 
                      name = "Default")
cset2 <- readsToTarget(bam_fname, guide, reference = reference, verbose = FALSE, 
                       chimera.to.target = 100, name = "Including long dels")

default_var_counts <- variantCounts(cset)
print(default_var_counts)
print(c("Total number of reads: ", colSums(default_var_counts)))

# With chimera.to.target = 100, an additional read representing a large deletion is 
# reported in the "Other" category.
var_counts_inc_long_dels <- variantCounts(cset2)
print(var_counts_inc_long_dels)
print(c("Total number of reads: ", colSums(var_counts_inc_long_dels)))

# This alignment can be viewed using `plotChimeras` 
ch <- getChimeras(cset2, sample = 1)
plotChimeras(ch, annotations = cset2$target)

## -----------------------------------------------------------------------------
sessionInfo()

# mergeCrisprSets -----
#'@title Merge two CrisprSets
#'@description Merge two CrisprSet objects sharing a reference and target location
#'@author Helen Lindsay
#'@rdname mergeCrisprSets
setGeneric("mergeCrisprSets", function(x,y, ...) {
  standardGeneric("mergeCrisprSets")})


#'@rdname mergeCrisprSets
#'@param x A CrisprSet object
#'@param y A second CrisprSet object
#'@param order A list of sample names, matching the names in x and y,
#'specifying the order of the samples in the new CrisprSet. (Not implemented yet)
#'@param x.samples A subset of column names or indices to keep from CrispRSet x
#'(Default: NULL, i.e. keep all)
#'@param y.samples A subset of column names or indices to keep from CrispRSet y
#'(Default: NULL, i.e. keep all)
#'@param names New names for the merged CrisprSet object (Default: NULL)
#'@param ... extra arguments
#'@return A merged CrisprSet object
#'@examples
#'# Load the metadata table
#'md_fname <- system.file("extdata", "gol_F1_metadata_small.txt", package = "CrispRVariants")
#'md <- read.table(md_fname, sep = "\t", stringsAsFactors = FALSE)
#'
#'# Get bam filenames and their full paths
#'bam_fnames <- sapply(md$bam.filename, function(fn){
#'  system.file("extdata", fn, package = "CrispRVariants")})
#'
#'reference <- Biostrings::DNAString("GGTCTCTCGCAGGATGTTGCTGG")
#'gd <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399),
#'       strand = "+")
#'
#'crispr_set1 <- readsToTarget(bam_fnames[c(1:4)], target = gd,
#'       reference = reference, names = md$experiment.name[1:4], target.loc = 17)
#'crispr_set2 <- readsToTarget(bam_fnames[c(5:8)], target = gd,
#'       reference = reference, names = md$experiment.name[5:8], target.loc = 17)
#'mergeCrisprSets(crispr_set1,crispr_set2)
#'@export
setMethod("mergeCrisprSets", signature(x = "CrisprSet", y = "CrisprSet"),
          function(x,y, ..., x.samples = NULL, y.samples = NULL, names = NULL, 
                   order = NULL){
            # To do: add order vector

            warn_msg <- "CrisprSets must have the same %s for merging"
            ref = x$ref
            if (ref != y$ref){
              stop(sprintf(warn_msg, "reference sequence"))
            }
            target = x$target
            if (target != y$target){
              stop(sprintf(warn_msg, "guide sequence"))
            }
            t.loc = x$pars$target.loc
            if (t.loc != y$pars$target.loc){
              stop(sprintf(warn_msg, "target location (zero point)"))
            }
            
            if (is.null(x.samples)) x.samples <- seq_along(x$crispr_runs)
            if (is.null(y.samples)) y.samples <- seq_along(y$crispr_runs)
            cruns <- c(x$crispr_runs[x.samples], y$crispr_runs[y.samples])
            new_names <- sapply(cruns, function(x) x$name)
            
            if (! is.null(names)){
              if (! length(cruns) == length(names)){
                stop("Length of 'names' must equal the number of samples")
              }
              new_names <- names
            }
            #if (! is.null(order)){
            #  if (! length(order) == length(cruns)){
            #    stop("Length of 'order' must equal the number of samples")
            #  }
            #}
            cset <- CrisprSet(cruns, reference = ref, target = target,
                      names = new_names, target.loc = t.loc)
            
            # Recreate variant counts table
            temp <- alns(cset)
            cig_by_run <- relist(mcols(unlist(temp))$allele, temp)
            cset$.countCigars(cig_by_run)
            cset$.getInsertions()
            
            cset
            
          }) # -----

# indelCounts -----
#'@title Count the number of reads containing an insertion or deletion
#'@description Counts the number of reads containing a deletion or insertion
#'(indel) of any size in a set of aligned reads.
#'For countDeletions and countInsertions Reads may be filtered according to
#'whether they contain more than one indel of the same or different types.
#'@author Helen Lindsay
#'@param alns The aligned reads
#'@param multi.del  If TRUE, returns the exact number of deletions,
#'i.e., if one read contains 2 deletions, it contributes 2 to the
#'total count (default: FALSE)
#'@param del.and.ins If TRUE, counts deletions regardless of whether
#'reads also contain insertions.  If FALSE, counts reads that contain
#'deletions but not insertions (default: FALSE)
#'@param del.ops Cigar operations counted as deletions.  Default: c("D")
#'@param ... extra arguments
#'@rdname indelCounts
#'@examples
#'bam_fname <- system.file("extdata", "gol_F1_clutch_2_embryo_4_s.bam",
#'                          package = "CrispRVariants")
#'bam <- GenomicAlignments::readGAlignments(bam_fname, use.names = TRUE)
#'countDeletions(bam)
#'countInsertions(bam)
#'countIndels(bam)
#'indelPercent(bam)
#'@export
setGeneric("countDeletions", function(alns, ...) {
  standardGeneric("countDeletions")})


#'@return countDeletions: The number of reads containing a deletion (integer)
#'@rdname indelCounts
setMethod("countDeletions", signature("GAlignments"),
          function(alns, ..., multi.del = FALSE, del.and.ins = FALSE,
                   del.ops=c("D")){

  cigar_ops <- CharacterList(explodeCigarOps(cigar(alns)))

  if (isTRUE(multi.del)){
    has_del <- any(cigar_ops %in% del.ops)
  } else{
    has_single_del <- sum(cigar_ops %in% del.ops) == 1
  }

  if (del.and.ins){
    if (multi.del)  return(sum(has_del))
    return(sum(has_single_del))
  }

  has_ins <- any(cigar_ops == "I")

  if (multi.del){
    return(sum(has_del & ! has_ins))
  }

  sum(has_single_del & ! has_ins)
})



#'@rdname indelCounts
#'@export
setGeneric("countInsertions", function(alns, ...) {
  standardGeneric("countInsertions")})


#'@param multi.ins  If TRUE, returns the exact number of insertions,
#'i.e., if one read contains 2 insertions, it contributes 2 to the
#'total count (default: FALSE)
#'@param ins.and.del If TRUE, counts insertions regardless of whether
#'reads also contain deletions  If FALSE, counts reads that contain
#'insertions but not deletions (default: FALSE)
#'@return countInsertions: The number of reads containing an insertion (integer)
#'@rdname indelCounts
setMethod("countInsertions", signature("GAlignments"),
          function(alns, ..., ins.and.del = FALSE, multi.ins = FALSE, del.ops = c("D")){

  cigar_ops <- CharacterList(explodeCigarOps(cigar(alns)))

  if (isTRUE(multi.ins)){
    has_ins <- any(cigar_ops == "I")
  } else{
    has_single_ins <- sum(cigar_ops == "I") == 1
  }

  if (ins.and.del){
    if (multi.ins)  return(sum(has_ins))
    return(sum(has_single_ins))
  }

  has_del <- any(cigar_ops %in% del.ops)

  if (multi.ins) return(sum(has_ins &! has_del))
  result <- sum(has_single_ins &! has_del)
  result
})


#'@rdname indelCounts
#'@export
setGeneric("countIndels", function(alns) {
  standardGeneric("countIndels")})

#'@return countIndels: The number of reads containing at least one insertion
#'@rdname indelCounts
setMethod("countIndels", signature("GAlignments"),
          function(alns){
  cigar_ops <- CharacterList(explodeCigarOps(cigar(alns)))
  return(sum(any(cigar_ops %in% c("I", "D", "N"))))
})

#'@rdname indelCounts
setGeneric("indelPercent", function(alns) {
  standardGeneric("indelPercent")})


#'@rdname indelCounts
#'@return indelPercent: The percentage of reads containing an insertion or
#'deletion (numeric)
#'@export
setMethod("indelPercent", signature("GAlignments"),
          function(alns){
  return((countIndels(alns) / length(alns))*100)
}) # -----

# dispatchDots -----
#'@title dispatchDots
#'@description Update default values for func with values from dot args
#'@author Helen Lindsay
#'@param func Function to call
#'@param call If TRUE, call the function with the argument list and
#'return this result (Default: FALSE)
#'@param ... dot args to pass to function
#'@return A list of arguments to pass to func, or if call is TRUE, the result
#'of calling func with these arguments.
#'@rdname dispatchDots
#'@examples
#'# Set up a function to dispatch dot arguments to:
#'f <- function(a=1, b=2, c=3){
#'  print(c(a,b,c))
#'}
#'# Set up a function for passing dots:
#'g <- function(...){
#'  CrispRVariants:::dispatchDots(f, ...)
#'}
#'
#'g(a = 5)
#'g(a = 5, call = TRUE)
#'# Unrelated arguments will not be passed on
#'g(a = 5, d = 6)
dispatchDots <- function(func, ..., call = FALSE){
    if (isTRUE(isS4(func))){
      warning("dispatchDots may not work as expected with S4 functions")
    }
    func_defaults <- formals(func)
    #dots <- as.list(...)
    #print(dots)
    
    result <- utils::modifyList(func_defaults, list(...))[names(func_defaults)]
    if (isTRUE(call)) return(do.call(func, result))
    result
} # ------


# .getAxisCoords -----
#'@title .getAxisCoords
#'@description Manually specify x-tick locations and labels,
#'as sometimes ggplot defaults are too dense. Used internally
#'by CrispRVariants for creating alignment plot with plotAlignments.
#'@param locations character(n) Actual x coordinates, or the desired
#'range of the x coordinates.  If labels are provided, all tick locations
#'must be in locations and have a matching label.
#'@param labels character(n) labels for the x axis ticks.  Should be
#'the same length as locations if provided.  Note that if not all
#'tick locations are included in locations, it must be possible to
#'extrapolate labels from locations  (Default: NULL)
#'@param loc.boundaries numeric(i) Locations that must be included.
#'(Default: NULL)
#'@param lab.boundaries numeric(j) Labels that must be included.
#'(Default: c(-1,1), for showing the cut sites).  Boundaries must
#'be in labels and have a matching tick location.
#'@param label.at numeric(1) Add ticks when label modulo label.at
#'is zero (Default = 5)
#'@param min.tick.sep numeric(1) Minimum distance between ticks, excluding
#'boundary ticks.  (Default: 1)
#'@return A list containing vectors named tick_locs and tick_labs 
#'@author Helen Lindsay
#'@rdname getAxisCoords
.getAxisCoords <- function(locations, labels = NULL, loc.boundaries = NULL,
                           lab.boundaries = c(-1,1), label.at = 5,
                           min.tick.sep = 1){
    
    # Potential improvement:
    # Parameter min.tick.sep for preventing tick labels becoming too close
    # Parameter loc.at similar to label.at?
    # label.at if locations are character?
  
    input_labels <- labels
    
    # Input checks ----
    # If provided, labels should be the same length as locations
    if (! is.null(labels)){
      if (! length(locations) == length(labels)){
          stop("Length of locations should equal length of labels")
      }
    } else{
      labels <- locations
    }
    
    if (! is.numeric(label.at) | !
        class(loc.boundaries)  %in% c("numeric", "NULL", "integer")){
      stop("label.at and loc.boundaries should be numeric")
    }
    if (length(label.at) != 1){
      stop("label.at should be a single, numeric value")
    }
    if (! label.at > 0){
      stop("label.at can not be zero or less than zero")
    } # -----
  
    boundaries <- c(locations[locations %in% loc.boundaries],
                    locations[labels %in% lab.boundaries])

    tick_locations <- locations
    close_to_bdry <- outer(locations, boundaries, function(x,y){abs(x-y)})
    close_to_bdry <- apply(close_to_bdry, 1, min) < min.tick.sep
       
    # Select tick locations according to interval, remove ticks
    # too close to boundaries
    tick_locations <- tick_locations[labels %% label.at == 0 & ! close_to_bdry]
    tick_locations <- unique(c(tick_locations, boundaries))
    tick_locations <- tick_locations[order(tick_locations)]
  
    tick_locs_to_labels <- match(tick_locations, locations)
    tick_labels <- labels[tick_locs_to_labels]
    
    return(list(tick_locs = tick_locations, tick_labs = tick_labels))
  
} # -----


# .intersperse -----
#'@title .intersperse
#'@description create a vector of elements in outer interspersed with
#'elements in inner.  Similar to python zip. No element checking.
#'@param outer vector that will be the first and last elements
#'@param inner vector that will join elements of outer
#'@author Helen Lindsay
#'@examples CrispRVariants:::.intersperse(c(1:10), c(1:9)*10)
#'@return A vector interspersing elements of outer and inner.  If
#'outer is c(a,b,c) and inner is c(d,e), returns c(a,d,b,e,c)
#'@rdname intersperse
.intersperse <- function(outer, inner){
    result <- vector(class(outer), length(c(outer,inner)))
    result[2 * seq_along(outer) - 1] <- outer
    result[2 * seq_along(inner)] <- inner
    result
} # -----


# .explodeCigarOpCombs -----
#'@title .explodeCigarOpCombs
#'@description Breaks cigar strings into individual operations
#'@param cigar character(m) A vector of cigar strings
#'@param ops character(n) Which operations should be kept?
#'@return The operations, as a CharacterList
#'@author Helen Lindsay
#'@rdname explodeCigarOpCombs
#'@return Exploded cigar operations with operation widths
.explodeCigarOpCombs <- function(cigar, ops = GenomicAlignments::CIGAR_OPS){
    wdths <- GenomicAlignments::explodeCigarOpLengths(cigar, ops = ops)
    keep.ops <- GenomicAlignments::explodeCigarOps(cigar, ops = ops)
    result <- IRanges::CharacterList(relist(paste0(unlist(wdths),
                                                   unlist(keep.ops)),
                                            wdths))
} # -----


# selectOps -----
#'@title selectOps
#'@description select CIGAR operations in a region of interest.
#'@author Helen Lindsay
#'@rdname selectOps
setGeneric("selectOps", function(cigar, ...) {
  standardGeneric("selectOps")})


# selectOps -----
#'@param cigar CIGAR strings
#'@param ops  CIGAR operations to consider (Default: all)
#'@param op.regions (GRanges) Return operations only in these regions
#'@param pos An offset for the cigar ranges
#'@param ... Extra arguments (Not currently used)
#'@return A GRanges list of opertion locations in reference space
#'with a metadata column for the operation width in query space. 
#'@rdname selectOps
setMethod("selectOps", signature("character"),
          function(cigar, ..., ops = GenomicAlignments::CIGAR_OPS,
                   op.regions = NULL, pos = 1L){
            
    op_rngs <- cigarRangesAlongReferenceSpace(cigar, with.ops = TRUE,
                                              ops = ops, pos = pos)
    wdths <- explodeCigarOpLengths(cigar, ops = ops)
    op_labs <- .explodeCigarOpCombs(cigar, ops)
    
    temp <- unlist(op_rngs)
    mcols(temp)$qwidth <- unlist(wdths)
    op_rngs <- relist(temp, op_rngs)
    
    # If counting regions are specified, return operations in these regions
    if (! is.null(op.regions)){
       # Check for consistency - should insertions on the right border be kept?
       keep_rngs <- relist(overlapsAny(unlist(op_rngs), op.regions), op_rngs)
       op_rngs <- op_rngs[keep_rngs]
       op_labs <- op_labs[keep_rngs]
    }
    list(op_rngs = op_rngs, op_labels = op_labs)
}) # -----


isFALSE <- function(x){
  is.logical(x) && ! is.na(x) & ! isTRUE(x)
}

context("Counting mutations")

alns <- GenomicAlignments::GAlignments(seqnames=rep("1", 5), 
                                       pos=as.integer(rep(1,5)), 
                    cigar=c("10M", "5M1D5M", "4M1D6M4D2M",
                            "1M2D3M4I", "2M3I2M3I2M"), 
                    strand = S4Vectors::Rle(factor(rep("+", 5),
                                         levels = c("+","-","*"))))

test_that("countDeletions returns the expected counts", {
  expect_equal(countDeletions(alns), 1)
  expect_equal(countDeletions(alns, multi.del = TRUE), 2)
  expect_equal(countDeletions(alns, del.and.ins = TRUE), 2)
  expect_equal(countDeletions(alns, multi.del = TRUE, del.and.ins = TRUE), 3) 
  expect_equal(countDeletions(alns, del.ops=c("N")), 0) 
})

test_that("countInsertions returns the expected counts", {
  expect_equal(countInsertions(alns), 0)
  expect_equal(countInsertions(alns, multi.ins = TRUE), 1)
  expect_equal(countInsertions(alns, ins.and.del = TRUE), 1)
  expect_equal(countInsertions(alns, multi.ins = TRUE, ins.and.del = TRUE), 2) 
})

test_that("countIndels returns the expected counts", {
  expect_equal(countIndels(alns), 4)
})

test_that("indelPercent returns the expected value", {
  expect_equal(indelPercent(alns), (4/5)*100)
})


context("Accessory plotting functions")

test_that("Extraploation of x-tick labels works correctly", {

    tck <- .getAxisCoords(c(1:20), label.at = 10, lab.boundaries = c(-1,1))
    # Only boundaries within the labels are included 
    expect_equal(tck$tick_labs, c(1,10,20))
    
    # Error if labels aren't the same length as locations
    expect_error(.getAxisCoords(c(1:20), "A"))  
    
    tck <- .getAxisCoords(c(1:23), labels = c(-17:-1, 1:6),
                          label.at = 2, lab.boundaries = c(-1,1))
    
    tmp <- setdiff(c(seq(-16,6, by = 2), c(-1,1)),0)
    exp_result <- tmp[order(tmp)] 
    expect_equal(tck$tick_labs, exp_result)

    # If min.tick.sep is increased, ticks close to boundary
    # should be removed
    tck <- .getAxisCoords(c(1:23), labels = c(-17:-1, 1:6),
                          label.at = 2, lab.boundaries = c(-1,1),
                          min.tick.sep = 2)
    expect_equal(tck$tick_labs, exp_result[!exp_result %in% c(-2,2)])
})

# narrowAlignments -----
#'@title Narrow a set of aligned reads to a target region
#'@description Aligned reads are narrowed to the target region.  In
#'the case of reads with deletions spanning the boundaries of the target,
#'reads are narrowed to the start of the deletion,
#'@author Helen Lindsay
#'@rdname narrowAlignments
#'@export
setGeneric("narrowAlignments", function(alns, target, ...) {
  standardGeneric("narrowAlignments")})


#'@param alns A GAlignments object including a metadata column "seq"
#'containing the sequence
#'@param target A GRanges object
#'@param reverse.complement Should the aligned reads be reverse complemented?
#'@param verbose (Default: FALSE)
#'@param minoverlap Minimum overlapping region between alignments and target.
#'If not specified, alignments must span the entire target region.
#'(Default: NULL)
#'@param clipping.ops CIGAR operations corresponding to clipping
#'(Default: c("S","H"))
#'@param match.ops CIGAR operations corresponding to a match, i.e.
#'a non-indel position (Default: c("M","X","="))
#'@param ... additional arguments
#'@return The narrowed alignments (GAlignments)
#'@rdname narrowAlignments
#'@examples
#'bam_fname <- system.file("extdata", "gol_F1_clutch_2_embryo_4_s.bam",
#'                          package = "CrispRVariants")
#'bam <- GenomicAlignments::readGAlignments(bam_fname, use.names = TRUE)
#'target <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399),
#'           strand = "+")
#'narrowAlignments(bam, target, reverse.complement = FALSE)
setMethod("narrowAlignments", signature("GAlignments", "GRanges"),
    function(alns, target, ..., reverse.complement,
             minoverlap = NULL, verbose = FALSE,
             clipping.ops = c("S","H"), match.ops = c("M","X","=")){
       
    # Narrowing example:
    # 3-4-5-6-7-8-9-10 Read
    #     5-6-7-8      Target sequence
    # target_start 5 - (read_start 3 - 1) = index 3
    # target_end 8 - target_start 5 + cigstart 3 = index
    
    # Notes:
    # Not using cigarNarrow as the seqs aren't narrowed
    # and want to keep indel operations bordering target range
    
    if (is.null(minoverlap)){
      # alns must span target
      alns <- alns[start(alns) <= start(target) & end(alns) >= end(target) &
                     seqnames(alns) == as.character(seqnames(target))]
    } else {
      alns <- alns[queryHits(findOverlaps(alns, target,
                                          minoverlap = minoverlap,
                                          ignore.strand = TRUE))]
    }
    if (length(alns) == 0){ return(GenomicAlignments::GAlignments()) }
    
    m_cols <- as.list(mcols(alns))
    if ("qual" %in% names(m_cols) & ! "seq" %in% names(m_cols)){
      stop("Metadata col 'seq' must be present if 'qual' is present")
    }
    
    if (isTRUE(verbose)) message("narrowing alignments\n")
    
    ref_ranges <- GenomicAlignments::cigarRangesAlongReferenceSpace(cigar(alns))
    genomic <- GenomicRanges::shift(ref_ranges, start(alns)-1)
    
    # Find the on target operations
    clipped <- unlist(GenomicAlignments::explodeCigarOps(cigar(alns)))
    clipped <- clipped %in% clipping.ops
    on_target <- unlist(start(genomic) <= end(target) &
                          end(genomic) >= start(target))
    on_target <- on_target & ! clipped
    on_target <- relist(on_target, ref_ranges)
    
    # Make masks to pull out first and last on-target ranges
    first_on_tg <- ! duplicated(on_target) & on_target
    last_on_tg <- ! duplicated(on_target, fromLast = TRUE) & on_target
    
    # Find cases where the first or last on target operation is a match ("M"),
    # operations overlap boundaries (partial alignments don't need trimming)
    ops <- unlist(explodeCigarOps(cigar(alns)))
    first_op_m <- ops[unlist(first_on_tg)] %in% match.ops &
      start(alns) < start(target)
    last_op_m <- ops[unlist(last_on_tg)] %in% match.ops &
      end(alns) > end(target)
    
    # Narrow border match operations to match target
    # need to know where the target start (genomic) is wrt
    # sequence (query) coordinates
    cig <- GenomicAlignments::cigar(alns)
    q_ranges <- GenomicAlignments::cigarRangesAlongQuerySpace(cig)
    sq_starts <- start(q_ranges)[first_on_tg]
    
    genomic_offset_fom <- start(target) - start(genomic)[first_on_tg][first_op_m]
    sq_starts[first_op_m] <- sq_starts[first_op_m] + genomic_offset_fom
    
    # Adjust the genomic starting location for alignments that will be narrowed
    genomic_starts <- start(genomic)[first_on_tg]
    genomic_starts[first_op_m] <- start(target)
    
    sq_ends <- end(q_ranges)[last_on_tg]
    genomic_offset_lom <- end(target) - start(genomic)[last_on_tg][last_op_m]
    sq_ends[last_op_m] <- start(q_ranges)[last_on_tg][last_op_m] + genomic_offset_lom
    
    # Adjust reference ranges to match
    ref_ranges <- unlist(ref_ranges)
    is_first_m <- which(unlist(first_on_tg))[first_op_m]
    
    # Calculate new ends before changing starts
    is_last_m <- which(unlist(last_on_tg))[last_op_m]
    lom_ends <- as.integer(start(ref_ranges[is_last_m]) + genomic_offset_lom)
    
    # Now adjust starts and ends
    start(ref_ranges[is_first_m]) <- as.integer(start(ref_ranges[is_first_m]) +
                                                  genomic_offset_fom)
    end(ref_ranges[is_last_m]) <- lom_ends
    
    # Get the width of on target reference ranges, recreate cigars
    # The width is the reference range unless op is an insertion,
    # in which case it is the query range
    ref_ranges <- relist(ref_ranges, genomic)
    ref_ranges <- ref_ranges[on_target]
    qwdths <- unlist(width(q_ranges)[on_target])
    wdths <- width(ref_ranges)
    wdthl <- unlist(wdths)
    opsl <- ops[unlist(on_target)]
    wdthl[opsl == "I"] <- qwdths[opsl == "I"]
    new_cigs <- sapply(relist(paste0(wdthl, opsl), wdths), paste0, collapse = "")
    
    ga_params <- list(seqnames = seqnames(alns), pos = as.integer(genomic_starts),
                      cigar = new_cigs, names = names(alns), strand = strand(alns),
                      seqlengths = GenomeInfoDb::seqlengths(alns))
    
    if ("seq" %in% names(m_cols)){
      m_cols$seq <- subseq(m_cols$seq, start = as.numeric(sq_starts),
                           end = as.numeric(sq_ends))
    }
    if ("qual" %in% names(m_cols)){
      m_cols$qual <- subseq(m_cols$qual, start = as.numeric(sq_starts),
                            end = as.numeric(sq_ends))
    }
    
    ga_params <- c(ga_params, m_cols)
    new_alns <- do.call(GAlignments, ga_params)
    
    new_alns
}) # -----

# plotFreqHeatmap generic -----
#'@title Plot a table of counts with colours indicating frequency
#'@description Creates a heatmap from a matrix of counts or proportions,
#'where tiles are coloured by the proportion and labeled with the value.
#'@rdname plotFreqHeatmap
#'@export
setGeneric("plotFreqHeatmap", function(obj, ...) {
  standardGeneric("plotFreqHeatmap")})
# -----

# plotFreqHeatmap matrix -----
#'@rdname plotFreqHeatmap
#'@param obj A matrix of counts with rows = feature, columns = sample
#'@param col.sums Alternative column sums to be used for calculating
#'the tile colours if as.percent = TRUE, e.g. if "obj" is a subset of
#'a larger data set.  If "NULL" (default), the column sums of "obj" are used.
#'@param header Alternative column titles, e.g. column sums for the
#'unfiltered data set when obj is a subset.  If set to "NA", column sums
#'of obj are displayed. If "NULL", no header is displayed (Default: NA).
#'@param header.name Label for the header row (Default: "Total")
#'@param group Grouping factor for columns.  If supplied, columns are
#'ordered to match the levels  (Default: NULL)
#'@param group.colours Colours for column groups, should match levels of "group".
#'If "NULL", groups are coloured differently (Default: NULL)
#'@param as.percent  Should colours represent the percentage of reads
#'per sample (TRUE) or the actual counts (FALSE)?  (Default: TRUE)
#'@param x.axis.title A title for the x-axis.  (Default: NULL)
#'@param x.size Font size for x-labels (Default: 16)
#'@param y.size Font size for y-labels (Default: 16)
#'@param x.angle  Angle for x-labels (Default: 90, i.e. vertical)
#'@param legend.text.size Font size for legend (Default: 16)
#'@param plot.text.size Font size counts within plot (Default: 3)
#'@param line.width Line thickness of title box'
#'@param x.hjust Horizontal justification of x axis labels (Default: 1)
#'@param legend.position The position of the legend (Default: right)
#'@param x.labels X-axis labels (Default: NULL, column.names of the matrix,
#'doesn't do anything at the moment)
#'@param legend.key.height The height of the legend key, as a "unit" object.
#'(See \code{\link[grid]{unit}}).
#'@param ... additional arguments
#'@return The ggplot2 plot of the variant frequencies
setMethod("plotFreqHeatmap", signature("matrix"),
          function(obj, ..., col.sums = NULL, header = NA, header.name = "Total",
                   group = NULL, group.colours = NULL, as.percent = TRUE,
                   x.axis.title = NULL, x.size = 6, y.size = 8, x.angle = 90,
                   legend.text.size = 6, plot.text.size = 3, line.width = 1,
                   x.hjust = 1, legend.position = "right", x.labels = NULL,
                   legend.key.height = grid::unit(1, "lines")) {

  # Potential improvements:
  # Allow a separate object for colours
  # param colour.vals A matrix of the same dimensions as obj containing
  # numbers that will be used to colour the heatmap.
  
  # If there should be a header, create it and make space in plot
  add_header <- ifelse(is.null(header), FALSE, TRUE)
  
  if (isTRUE(add_header)){
    # If header is not specified, it should be colSums
    if (is.na(header[1])) header <- colSums(obj)
    
    # If header is specified, it should have enough values
    if (!length(header) == ncol(obj)){
      stop("Header length should equal to the number of columns of obj")
    }
    temp <- rownames(obj)
    obj <- rbind(Total = rep(NA, ncol(obj)), obj)
    rownames(obj) <- c(header.name, temp)
  }
  
  # If a sample group is supplied, reorder the columns of counts
  if (! is.null(group)){
    if (! length(group) == ncol(obj)){
      stop("Group should be a vector or factor the same length as ncol(obj)")
    }
    if (! is.factor(group)) group <- factor(group, levels = unique(group))

    obj <- obj[,order(group), drop = FALSE]
    if (length(header) > 1){
      header <- header[order(group)]
    }
    group <- group[order(group)]

    # if group.colours are not provided, use defaults
    if (is.null(group.colours)){
      # default is a colourblind safe palette
      clrs <- c("#000000","#0072B2","#E69F00","#009E73",
                "#56B4E9","#D55E00","#CC79A7")

      clrs <- clrs[group]
    } else {
      clrs <- group.colours[group]
    }
  }

  counts <- reshape2::melt(obj)
  colnames(counts) <- c("Feature", "Sample","Count")
  counts$Feature <- factor(counts$Feature, levels = rev(levels(counts$Feature)))

  # Create coloured tile background
  if (isTRUE(as.percent)){
    
    # If col.sums are provided, use these, otherwise use the column sums
    if (is.null(col.sums)){
      col.sums <- colSums(obj, na.rm = TRUE)
    } else if (! length(col.sums) == ncol(obj)){
      stop("Number of col.sums should equal to the number of columns of obj")
    }
    totals <- as.numeric(col.sums)
    
    m <- t(t(obj)/totals) * 100
    m <- reshape2::melt(m)
    colnames(m) <- c("Feature", "Sample","Percentage")
    m$Feature <- factor(m$Feature, levels = rev(levels(m$Feature)))
    
    g <- ggplot(m) + geom_tile(aes_(x = quote(Sample),
                                     y = quote(Feature),
                                     fill = quote(Percentage)))
  }
  else{
    g <- ggplot(counts) + geom_tile(aes_(x = quote(Sample),
                                          y = quote(Feature),
                                          fill = quote(Count)))
  }

  # Add the count numbers to the boxes,
  # if totals are included, add bold boxes to indicate these
  counts$ff <- "plain"
  box_coords <- data.frame(xmin = integer(), xmax=integer(),
                           ymin=integer(), ymax=integer())
  box_row <- 1
  panel_ranges <- ggplot_build(g)$layout$panel_ranges[[1]]
  xranges <- panel_ranges$x.range
  yranges <- panel_ranges$y.range

  if (isTRUE(add_header)){
    idxs <- which(is.na(counts$Count))
    counts$Count[idxs] <- header
    counts$ff[idxs] <- "bold"
    box_coords[box_row,] <- c(min(xranges), max(xranges),
                              nrow(obj) -0.5, max(yranges))
  }

  if (nrow(box_coords) > 0){
    g <- g + geom_rect(data = box_coords,
                       aes_(xmin = quote(xmin), xmax = quote(xmax),
                           ymin = quote(ymin), ymax = quote(ymax)),
                    color = "black", size = line.width, fill = "transparent")
  }
  # Plot the counts
  g <- g + geom_text(data = counts,
                     aes_(x = quote(Sample), y = quote(Feature),
                           label = quote(Count), fontface = quote(ff)),
                     size = plot.text.size)

  # Colour the boxes - white for 0, darkred for highest
  hmcols <- grDevices::colorRampPalette(c("white","gold","orange",
                                          "orangered","red", "darkred"))(50)

  # No colour bar legend if the max count is 1
  if (max(counts$Count) > 1){
    if (isTRUE(as.percent)){
      g <- g + scale_fill_gradientn(colours = hmcols, na.value = "white",
                                    guide = "legend", limits = c(0, 100))
    } else {
      g <- g + scale_fill_gradientn(colours = hmcols, na.value = "white",
                                    guide = "legend")
    }
  } else {
    g <- g + scale_fill_gradientn(colours = hmcols, na.value = "white",
                                  guide = "none")
  }

  # Set plot labels
   if (is.null(x.labels)) x.labels <- colnames(obj)
  g <- g + ylab(NULL) + xlab(x.axis.title) + theme_bw() +
  theme(axis.text.x = element_text(size = x.size, angle = x.angle, 
                                     hjust = x.hjust, vjust = 1),
          axis.text.y = element_text(size = y.size),
          legend.text = element_text(size = legend.text.size),
          legend.title = element_text(size = legend.text.size),
          legend.position = legend.position,
          legend.key.height = legend.key.height)

  # Colour xlabels by group, make sure not to replace original args
  if (! is.null(group)){
    g <- g + theme(axis.text.x=element_text(colour= clrs,
                   size = x.size, angle = x.angle, hjust = x.hjust))
  }

  return(g)
}) # ------


# plotFreqHeatmap CrisprSet ----- 
#'@rdname plotFreqHeatmap
#'@param top.n  Show the n top ranked variants.  Note that if the nth and n+1th
#'variants have equal rank, they will not be shown.   (Default: 50)
#'@param min.freq i (%) only plot variants with frequency >= i% in at least
#' one sample (Default: 0, i.e no frequency cutoff)
#'@param min.count i (integer) only plot variants with count >= i in at least
#' one sample (default: 0, i.e no count cutoff)
#'@param type Plot either "counts" or "proportions"
#'@param order A list of column names or indices specifying the order of the
#'columns in the plot
#'@param alleles A list of alleles to include.  Can be used to display
#'only alleles of interest or to order the alleles.
#'The default value NULL means all alleles passing the frequency cut offs 
#'will be included.
#'@examples
#'#Load a CrisprSet object for plotting
#'data("gol_clutch1")
#'
#'# Plot the frequency heatmap
#'plotFreqHeatmap(gol)
setMethod("plotFreqHeatmap", signature("CrisprSet"),
          function(obj, ..., top.n = 50, min.freq = 0, min.count = 1,
                   type = c("counts", "proportions"), order = NULL,
                   alleles = NULL) {

  result <- obj$heatmapCigarFreqs(top.n = top.n, min.freq = min.freq,
                     min.count = min.count, type = type, order = order,
                     alleles = alleles, ...)
  return(result)
}) # ------

#'@title Find chimeric reads
#'@description Find chimeric reads, assuming that the GAlignments object
#' does not contain multimapping reads. That is, read names that appear
#' more than ones in the file are considered chimeras.  Chimeric reads
#' are reads that cannot be mapped as a single, linear alignment.  Reads
#' from structual rearrangements such as inversions can be mapped as chimeras.
#' Note that the indices of all chimeric reads are returned, these are not
#' separated into individual chimeric sets.
#'@param bam  A GAlignments object, must include names
#'@param by.flag Can the chimeras be detected just using the supplementary
#'alignment flag?  (Default: FALSE).  If TRUE, detects supplementary alignments
#'and returns reads with the same name as a supplementary alignment (quicker).
#'If FALSE, all alignments with duplicated names are returned.
#'@author Helen Lindsay
#'@return A vector of indices of chimeric sequences within the original bam
#'@seealso \code{\link{plotChimeras}} for plotting chimeric alignment sets.
#'@export
#'@examples
#'bam_fname <- system.file("extdata", "gol_F1_clutch_2_embryo_4_s.bam",
#'                          package = "CrispRVariants")
#'bam <- GenomicAlignments::readGAlignments(bam_fname, use.names = TRUE)
#'chimera_indices <- findChimeras(bam)
#'chimeras <- bam[chimera_indices]
findChimeras <- function(bam, by.flag = FALSE){
  if (isTRUE(by.flag) & ! "flag" %in% names(mcols(bam))){
    stop("If 'by.flag' is TRUE, bam must have a metadata column 'flag'")
  }
  if (isTRUE(by.flag)){
    suppl <- bitwAnd(mcols(bam)$flag, 2048)
    ch_names <- names(bam[suppl != 0])
    chimera_idxs <- which(names(bam) %in% ch_names)
  } else {
    chimera_idxs <- which((duplicated(names(bam)) |
                           duplicated(names(bam), fromLast = TRUE)))
  }
  chimera_idxs <- chimera_idxs[order(as.factor(names(bam)[chimera_idxs]))]
  chimera_idxs
}

#'@title refFromAlns
#'@description Reconstruct the reference sequence from alignments reads using the CIGAR
# string and MD tags.  The reference sequence is the sequence the reads were aligned
# to.  If a location is supplied, at least one alignment must span the location.
#'@param alns  Alignments to use for inferring the reference sequence
#'@param location  The location to infer the reference for.
# containing a single range (Optional).
#'@param ... additional arguments
#'@return The reference sequences corresponding to the provided alignments
#'@author Helen Lindsay
#'@rdname refFromAlns
#'@examples 
#'bam <- system.file("extdata", "bam/ab1_ptena_wildtype_looking_embryo_1_s.bam",
#'                   package = "CrispRVariants")
#'alns <- GenomicAlignments::readGAlignments(bam,
#'           param = Rsamtools::ScanBamParam(tag = "MD", what = "seq"))
#'# To get the reference sequence from the a given location:
#'location <- GenomicRanges::GRanges("chr17", IRanges::IRanges(23648420,23648430))
#'refFromAlns(alns, location = location)
#'@export
setGeneric("refFromAlns", function(alns, location, ...) {
  standardGeneric("refFromAlns")})


#'@param keep.names Should read names be added to the result if present?
#'(Default: FALSE)
#'@return A DNAStringSet (signature = c("GAlignments", "ANY"))
#'@rdname refFromAlns
setMethod("refFromAlns", signature(alns = "GAlignments", location = "ANY"),
    function(alns, location, ..., keep.names = FALSE){
      if (! "MD" %in% names(mcols(alns))){
        stop("Alignments must contain a metadata column with the MD tag.")
      }

      if (! "seq" %in% names(mcols(alns))){
          stop("Alignments must include the read sequences")
      }
      
      # Using cigar, get alignments with respect to the reference
      onref <- GenomicAlignments::sequenceLayer(mcols(alns)$seq, cigar(alns))
      mds <- mcols(alns)$MD
      if (any(is.na(mds))){
          stop("Cannot infer reference from MD tag when MD tag is NA")
      }
      
      # Split in two steps to include the split character in the results
      all.ops <- gsub("([\\^]*[ACGT]+)", ";\\1;", mds)
      
      # Remove leading ";" if present
      all.ops <- ifelse(startsWith(all.ops, ";"),
                          substr(all.ops, 2, nchar(all.ops)),
                          all.ops)

      split.ops <- strsplit(all.ops, "[;]+")
      so <- gsub("\\^", "", unlist(split.ops))
      is.chr <- grepl("[ACTG]+", so)
      idxs <- so
      idxs[is.chr] <- nchar(so[is.chr])
      idxs <- as.numeric(idxs)


      # Find ranges of characters to substitute
      start_locs <- unlist(lapply(relist(idxs, split.ops), function(x){
          cumsum(c(1,x))[1:length(x)]
      }))
      
      rngs <- IRanges(start_locs[is.chr], width = idxs[is.chr])
      ops.per.aln <- unlist(lapply(relist(is.chr, split.ops), sum))
      rngs <- relist(rngs, IRanges::PartitioningByWidth(ops.per.aln))
      replace.vals <- relist(so[is.chr], IRanges::PartitioningByWidth(ops.per.aln))
      refs <- replaceAt(onref, rngs, replace.vals)

      if (isTRUE(keep.names) & ! is.null(names(alns))){
          names(refs) <- names(alns)
      }

      refs
})


#'@return A DNAString (signature = c("GAlignments", "GRanges"))
#'@rdname refFromAlns
setMethod("refFromAlns", signature(alns = "GAlignments", location = "GRanges"),
          function(alns, location, ...){

    if (length(location) != 1){
        stop("A single genomic location is required")
    }
    
    kalns <- alns[seqnames(alns) == as.character(seqnames(location)) & 
                  start(alns) <= start(location) & end(alns) >= end(location)]
    
    if (length(kalns) == 0){
        stop("No alignment spans this location")
    }
    
    # As the reference is the same for all reads, only one alignment is needed
    kalns <- kalns[1]
    refs <- refFromAlns(kalns, keep.names = FALSE)

    # Take the substring of the location of interest
    ir <-  IRanges::IRanges(start(location)-start(kalns) + 1,
                             end(location)-start(kalns)+ 1)
    refs <- DNAString(substr(refs, start(ir), end(ir)))
    if (as.character(strand(location)) == "-"){
       refs <- Biostrings::reverseComplement(refs)
    }
    refs
})

#'@title Append a sequence to a fastq file
#'@description  Used by abifToFastq to write sanger sequences
#'to fastq format  As abifToFastq appends output to files,
#' writeFastq checks that sequence names are unique.  This
#' function is faster with checking switched off.
#'@param outf Name of fastq file to append sequence
#'@param vals A list containing entries named "seq" (sequence) and
#'"quals" (quality scores, in ASCII format)
#'@param allow_spaces Should spaces in the sequence name be
#'substituted with underscores?  TRUE or FALSE
#'@param check Check whether reads with the same name already
#'exist in the output fastq.  (Default: TRUE)
#'@return None.  The sequences in "vals" are written to outf
#'@author Helen Lindsay
writeFastq <- function(outf, vals, allow_spaces = FALSE, check = TRUE){
  nms <- ifelse(allow_spaces, vals$seqname, gsub(" ", "_", vals$seqname))
  if (isTRUE(check) & file.exists(outf)){
    ex_nms <- readLines(outf)[c(TRUE, FALSE, FALSE, FALSE)]
    if (nms %in% ex_nms){
      warning(sprintf("File %s already contains a read named %s", 
                      outf, nms))
    }
  }
  o <- file(outf, "a")
  seqname <- sprintf("@%s", nms)
  qualname <- sprintf("+%s", nms)
  writeLines(c(seqname, vals$seq, qualname, vals$quals) , o)
  close(o)
  return()
}

#'@title Removes reads from a bam file
#'@description Returns a GAlignments excluding reads based on either name and/or location
#'@param bam a GAlignments object
#'@param exclude.ranges Regions to exclude, as \code{\link[GenomicRanges]{GRanges}}.
#'@param exclude.names A character vector of alignments names to exclude
#'@rdname excludeFromBam
#'@return The bam minus the excluded regions
#'@author Helen Lindsay
excludeFromBam <- function(bam, exclude.ranges = GRanges(), exclude.names = NA){
  if (length(exclude.ranges) > 0) bam <- excludeFromBamByRange(bam, exclude.ranges)
  if (! anyNA(exclude.names)) bam <- excludeFromBamByName(bam, exclude.names)
  bam
}

excludeFromBamByName <- function(bam, exclude.names){
  excluden <- which(names(bam) %in% exclude.names)
  bam <- bam[setdiff(seq_along(bam), excluden)]
}

excludeFromBamByRange <- function(bam, exclude.ranges){
  fo <- queryHits(findOverlaps(bam, exclude.ranges))
  bam[setdiff(seq_along(bam), fo)]
}

#'@title Display a dot plot of chimeric alignments
#'
#'@description Produces a dot plot of a set of chimeric alignments.  For chimeric alignments,
#'a single read is split into several, possibly overlapping alignmed blocks.
#'Aligned sections of chimeric reads can be separated by large genomic distances,
#'or on separate chromosomes.  plotChimeras produces a dot plot, each aligned block
#'highlighted, and chromosomes shown in different colours. Large gaps between
#'aligned segments are collapsed and indicated on the plot with horizontal lines.
#'The X-axis shows each base of the entire read. Note that the mapping to the fwd strand
#'is shown if all strands agree.  The chimeric alignments must be sorted!
#'
#'@param chimeric.alns A GAlignments object containing only the chimeric
#' reads to be plotted
#'@param max.gap If aligned segments are separated by more than max.gap,
# with respect to the genome, a gap in the y-axis will be introduced (Default 10)
#'@param tick.sep How many bases should separate tick labels on plot.  Default 20.
#'@param text.size Size of X and Y tick labels on plot.  Default 12
#'@param title.size Size of X and Y axis labels on plot.  Default 16
#'@param gap.pad How much should aligned blocks be separated by?  (Default: 20)
#'@param legend.title Title for the legend.  Default "Chromosome"
#'@param xangle Angle for x axis text (Default 90, i.e vertical)
#'@param wrt.forward Should chimeric alignments where all members map to the
#'negative strand be displayed with respect to the forward strand, i.e. as the
#'cigar strand is written (TRUE), or the negative strand (FALSE) (Default: FALSE)
#'@param annotations A list of GRanges.  Any that overlap with the chimeric alignments
#'are highlighed in the plot.
#'@param annotate.within annot_aln ranges in "annotations" within n bases of a chimeric
#'alignment (Default 50)
#'@return A ggplot2 dotplot of the chimeric alignments versus the reference sequence
#'@seealso \code{\link{findChimeras}} for finding chimeric alignment sets.
#'@author Helen Lindsay
#'@export
#'@examples
#'bam_fname <- system.file("extdata", "gol_F1_clutch_2_embryo_4_s.bam",
#'                          package = "CrispRVariants")
#'bam <- GenomicAlignments::readGAlignments(bam_fname, use.names = TRUE)
#'# Choose a single chimeric read set to plot:
#'chimeras <- bam[names(bam) == "AB3092"]
#'
#'# This read aligns in 3 pieces, all on chromosome 18.
#'# The plot shows the alignment annot_alns a small duplication and
#'# a long gap.
#'plotChimeras(chimeras)

plotChimeras <- function(chimeric.alns, max.gap = 10, tick.sep = 20,
                         text.size = 10,  title.size = 16, gap.pad = 20,
                         legend.title = "Chromosome", xangle = 90,
                         wrt.forward = FALSE, annotate.within = 20,
                         annotations = GenomicRanges::GRanges()){
  # Potential improvements:
  # - extend y-axis to annotate regions that are close but not spanned
  # - label the chromosomal regions
  # Count soft-clipped bases at ends?
  # Function for paired alignments?
  # (recall that CrispRVariants does not currently use galignmentpairs)
  # simplify offsets by calculating wrt block?

  # Sort chromosomes by minimum read start of any segment on each chr
  temp_cigs <- cigarRangesAlongQuerySpace(cigar(chimeric.alns))
  is_match <- CharacterList(explodeCigarOps(cigar(chimeric.alns))) == "M"
  sq_ord <- seqnames(chimeric.alns[order( min(start(temp_cigs[is_match])))])
  GenomeInfoDb::seqlevels(chimeric.alns) <- unique(as.character(sq_ord@values))
  chimeric.alns <- chimeric.alns[order(seqnames(chimeric.alns))]

  # Get M ranges wrt genome and read
  cigars <- cigar(chimeric.alns)
  genomic_locs <- as(chimeric.alns, "GRanges")
  is_plus <- as.vector(strand(genomic_locs) == "+")
  two_strands <- length(unique(is_plus)) > 1

  # For reference ranges, shift to actual genomic starting locations
  ref_ranges <- GenomicAlignments::cigarRangesAlongReferenceSpace(cigars)
  ref_ranges <- GenomicRanges::shift(ref_ranges, start(genomic_locs) -1)

  # Entirely negative strand chimeras may be displayed as aligned to reference
  # (wrt.forward = TRUE).  Default is wrt start of read
  if (two_strands == FALSE & wrt.forward == FALSE & ! any(is_plus)){
    cigars <- reverseCigar(cigars)
    ref_ranges <- relist(rev(unlist(rev(ref_ranges))), ref_ranges)
  }

  # Extract match ranges, these will be plotted
  ops <- IRanges::CharacterList(explodeCigarOps(cigars))
  query_ranges <- GenomicAlignments::cigarRangesAlongQuerySpace(cigars)

  # Find all "M" operations (runs of aligned bases)
  mm <- ops == "M"
  mm_idxs <- rep(1:length(genomic_locs), sum(mm))
  m_ref <- ref_ranges[mm]
  m_qry <- query_ranges[mm]

  # Split by strand and add offset for hard clipping
  hclipl <- as.numeric(gsub(".*[A-Z].*", 0, gsub("[H].*","", cigars)))
  m_qry[is_plus] <- GenomicRanges::shift(m_qry[is_plus], hclipl[is_plus])

  # If the alignment annot_alns segments to both strands, display wrt ref (+)
  if (two_strands) {
    # Want to get all query ranges with respect to the query on the forward strand
    # (As is, cigar ranges are with respect to the genome)
    hsclipr <- as.numeric(gsub("^$", 0, gsub('.*[M]|[HS]$', "", cigars)))

    # Find the distance from the end of the -ve strand M ranges to the start of the last op
    dist_to_last <- (max(end(query_ranges)[mm]) - end(query_ranges))[mm][!is_plus]

    # Remove the offset from the left, add the offset from the right
    m_qry[!is_plus] <- GenomicRanges::shift(m_qry[!is_plus], (-1*start(m_qry[!is_plus])+1))
    m_qry[!is_plus] <- GenomicRanges::shift(m_qry[!is_plus], hsclipr[!is_plus] + dist_to_last)

  } else {
  # Else if only -ve, display wrt negative
    m_qry[!is_plus] <- GenomicRanges::shift(m_qry[!is_plus], hclipl[!is_plus])
  }

  # Ord is the order of the "M" segments (can be more than number of alignments)
  plus <- rep(which(is_plus), lapply(m_qry[is_plus], length))
  minus <- rep(which(!is_plus), lapply(m_qry[!is_plus], length))
  ord <- order(c(plus,minus))

  xs <- mapply(seq, unlist(start(m_qry[is_plus])), unlist(end(m_qry[is_plus])),
               SIMPLIFY = FALSE)

  if (wrt.forward == FALSE){
    xs <- c(xs, mapply(function(x,y) rev(seq(x,y)), unlist(start(m_qry[!is_plus])),
          unlist(end(m_qry[!is_plus])), SIMPLIFY = FALSE))[ord]
  } else {
    xs <- c(xs, mapply(function(x,y) seq(x,y), unlist(start(m_qry[!is_plus])),
          unlist(end(m_qry[!is_plus])), SIMPLIFY = FALSE))
  }

  ys <- mapply(seq, unlist(start(m_ref)), unlist(end(m_ref)), SIMPLIFY = FALSE)
  chrs <- seqnames(genomic_locs)

  #____________________________
  # Introduce gaps for aligned segments separated by more than max.gap
  # NOTE: assume chimeric alns are sorted (ys segment cannot be before previous)

  y_lns <- sapply(ys, length)
  chr_to_ranges <- as.character(seqnames(genomic_locs)[mm_idxs])
  m_granges <- GRanges(chr_to_ranges, unlist(m_ref))
  y_blocks <- reduce(m_granges, min.gapwidth = max.gap)

  # Blocks that are not merged should have a gap added
  offsets <- rep(0, length(m_granges))
  ys_to_block <- subjectHits(findOverlaps(m_granges, y_blocks))
  offsets[!duplicated(ys_to_block) & ys_to_block!= 1] <- gap.pad
  # map offsets to y_block
  offsets <- offsets[!duplicated(ys_to_block)]
  ycoords <- 1:sum(width(y_blocks))
  names(ycoords) <- unlist(mapply(seq, start(y_blocks), end(y_blocks)))
  # map y_block offsets to correct y segment, add to y coordinates
  offsets <- rep(cumsum(offsets)[ys_to_block], y_lns)
  ycoords <- ycoords[as.character(unlist(ys))] + offsets

  #________________________________
  # Make boxes around each segment

  y_sums <- cumsum(y_lns)
  n_segs <- length(unlist(m_qry))

  # Setup data and plot
  pt_coords <- data.frame(x = unlist(xs), ylabs = unlist(ys))
  pt_coords$y <- ycoords

  ymax <- pt_coords$y[y_sums]
  ymin <- na.omit(c(1, pt_coords$y[y_sums +1]))

  # Make boxes around single cigar segments to distinguish indels from chimeras
  m_qry_range <- range(m_qry)
  m_qry_start <- unlist(start(m_qry_range))
  m_qry_end <- unlist(end(m_qry_range))
  aln_to_ranges <- relist(1:n_segs, m_qry)

  # This requires the ys to be in the original order
  pt_ys <- relist(pt_coords$y, ys)
  box_ranges <-  t(sapply(1:length(m_qry), function(i){
      aln_ys <- unlist(pt_ys[aln_to_ranges[[i]]])
      c(min(aln_ys), max(aln_ys))
  }))

  box_ymins <- box_ranges[,1]
  box_ymaxs <- box_ranges[,2]

  box_coords <- data.frame("xmin" = m_qry_start, "xmax" = m_qry_end,
                           "chrs" = seqnames(genomic_locs),
                           "ymin"  = box_ymins, "ymax" = box_ymaxs)

  #____________________________
  # Get coordinates of large breaks for shading

  nblocks <- length(y_blocks)
  if (nblocks > 1){
    gap_starts <- end(y_blocks)[1:(nblocks -1)]
    gap_ends <- start(y_blocks)[2:nblocks]
    chr_box_coords <- data.frame(ymin = ycoords[as.character(gap_starts)],
                                 ymax = ycoords[as.character(gap_ends)])
  } else {
    chr_box_coords <- data.frame()
  }

  #____________________________
  # Make tick labels and locations

  int_ys <- as.integer(names(ycoords))
  tick_labs <- int_ys[int_ys %% tick.sep == 0]

  # Labels for breakpoints are added if they are not too close to existing
  # axis labels.  Not elegant, but prevents overlapping labels
  chr_labs <- c(start(y_blocks), end(y_blocks))
  min_dists <- sapply(chr_labs, function(x) min(abs(x-tick_labs)))
  chr_labs <- chr_labs[min_dists > 2]

  tick_labs <- unique(c(chr_labs, tick_labs))
  tick_labs <- tick_labs[order(tick_labs)]
  tick_pos <- ycoords[as.character(tick_labs)]

  xbreaks <- seq(min(pt_coords$x), max(pt_coords$x), by = tick.sep)

  #____________________________
  # Plotting

  p <- ggplot(pt_coords) + geom_point(aes_(x=quote(x),y=quote(y))) +
       geom_rect(data = box_coords, aes_(xmin = quote(xmin),
                  xmax = quote(xmax), ymin = quote(ymin),
                  ymax = quote(ymax), fill = quote(chrs),
                  colour = quote(chrs)), alpha = 0.25) +
       xlab("Read location") + ylab("Chromosomal location") +
       guides(fill = guide_legend(title = legend.title),
              colour = guide_legend(title = legend.title)) +
       theme_bw() + theme(axis.title.y=element_text(vjust = 2, size = title.size),
                          axis.title.x=element_text(vjust = -1, size = title.size),
                          axis.text.y=element_text(size=text.size),
                          axis.text.x=element_text(size=text.size, angle = xangle),
                          plot.margin = grid::unit(c(1, 1, 1, 1), "lines"))
  if (nrow(chr_box_coords) > 0){
    p <- p + geom_rect(data = chr_box_coords, aes_(ymin = quote(ymin),
                       ymax = quote(ymax), y = NULL, x = NULL),
                       xmin = min(pt_coords$x), xmax = max(pt_coords$x),
                       fill = "gray", alpha = 0.2, colour = "gray",
                       linetype = "dotted") +
         scale_x_continuous(expand = c(0,0), breaks = xbreaks)
  }

  #____________________________
  # If a list of points to annotate is provided, annote overlapping points

  # Annotate the aligned ranges
  aln_ranges <- GRanges(chr_to_ranges, unlist(m_ref))
  annot_aln <- annotations[queryHits(findOverlaps(annotations, aln_ranges,
                                  type = "within"))]

  gap_ranges <- gaps(aln_ranges, start = min(start(aln_ranges)))
  a_to_gap <- findOverlaps(annotations, gap_ranges)

  # How far is annotation through gap range as a percentage
  a_starts <- start(annotations[queryHits(a_to_gap)])
  g_starts <- start(gap_ranges[subjectHits(a_to_gap)])
  g_to_y <- ycoords[as.character(g_starts - 1)]
  seps <- width(gap_ranges[subjectHits(a_to_gap)])
  seps[seps >= max.gap] <- tick.sep
  g_to_y <- g_to_y + ((a_starts - g_starts) /
                        width(gap_ranges[subjectHits(a_to_gap)])) * seps + 1
  g_to_y_nms <- mcols(annotations[queryHits(a_to_gap)])$name

  #Annotate boundaries between chromosomal blocks
  lblocks <- flank(y_blocks, annotate.within)
  lblocks <- setdiff(disjoin(c(lblocks, y_blocks, gap_ranges)), c(y_blocks, gap_ranges))
  annot_left <- findOverlaps(annotations, lblocks, type = "within")
  rblocks <- flank(y_blocks, annotate.within, start = FALSE)
  rblocks <- setdiff(disjoin(c(rblocks, y_blocks, gap_ranges)), c(y_blocks, gap_ranges))
  annot_right <- findOverlaps(annotations, rblocks, type = "within")

  # Distance isn't very meaningful in gaps between chromosomes,
  # so just place the annotation on the correct side
  nearest_left <- end(lblocks[subjectHits(annot_left)]) + 1
  left_locs <- ycoords[as.character(nearest_left)] -
          min((nearest_left - start(annotations[queryHits(annot_left)])), tick.sep/4)

  nearest_right <- start(rblocks[subjectHits(annot_right)]) - 1
  right_locs <- ycoords[as.character(nearest_right)] +
        min((start(annotations[queryHits(annot_right)]) - nearest_right), tick.sep/4)

  flank_nms <- mcols(annotations[c(queryHits(annot_left), queryHits(annot_right))])$name
  others <- c(g_to_y, left_locs, right_locs)

  if (length(annot_aln) > 0 | length(others) > 0){

    annot <- data.frame(yint = c(ycoords[as.character(start(annot_aln))],
                                 na.omit(others)))

    p <- p + geom_hline(data = annot, aes_(yintercept = quote(yint)),
                        linetype = "longdash", color = "red", size = 0.75)
    if ("name" %in% names(mcols(annotations))){

      vjust <- ifelse(annot$yint >= max(ycoords), 1,0)
      annot_lab <- data.frame(label = c(annot_aln$name, g_to_y_nms, flank_nms),
                              vjust = vjust,
                              yint = annot$yint)
      p <- p + geom_text(data = annot_lab, x = min(pt_coords$x) + 1,
                         aes_(label = quote(label), y = quote(yint),
                               vjust = quote(vjust)),
                         color = "red", hjust = 0)
    }
  }
  #____________________________

  ylower <- min(0, c(ycoords[as.character(start(annot_aln))], left_locs-1))
  yupper <- max(max(ymax) + 1, right_locs)

  p <- p + scale_y_continuous(expand = c(0,0), breaks = tick_pos,
                              labels = tick_labs, limits = c(ylower, yupper))
  p
}

#'Read a file in ab1 (Sanger) format and convert to fastq
#'
#'This is an R implementation of Wibowo Arindrarto's abifpy.py trimming module,
#'which itself implement's Richard Mott's trimming algorithm
#'See \url{https://github.com/bow/abifpy} for more details.
#'
#'Requires Bioconductor package SangerseqR
#'@param seqname name of sequence, to appear in fastq file
#'@param fname filename of sequence in ab1 format
#'@param outfname filename to append the fastq output to
#'@param trim should low quality bases be trimmed from the ends?  TRUE or FALSE
#'@param cutoff probability cutoff
#'@param min_seq_len minimum number of sequenced bases required in order to trim
#'the read
#'@param offset phred offset for quality scores
#'@param recall Use sangerseqR to resolve the primary sequence if two sequences
#'are present.  May cause quality scores to be ignored. (Default: FALSE)
#'@author Helen Lindsay
#'@return None.  Sequences are appended to the outfname.
#'@examples
#'\donttest{
#'# Running this code will write the fastq file to "IM2033.fastq"
#'ab1_fname <- system.file("extdata", "IM2033.ab1", package = "CrispRVariants")
#'abifToFastq("IM2033", ab1_fname, "IM2033.fastq")
#'}
#'@export
abifToFastq <- function(seqname, fname, outfname, trim = TRUE, cutoff = 0.05,
                        min_seq_len = 20, offset = 33, recall = FALSE){
    sangerseqr <- requireNamespace("sangerseqR")
    stopifnot(isTRUE(sangerseqr))

    # Translation of python function
    abif <- sangerseqR::read.abif(fname)
    if (is.null(abif@data$PCON.2)){
       message(sprintf("failed on %s", seqname))
       return()
    }

    # Remove the extra character if it exists
    nucseq <- substring(abif@data$PBAS.2, 1, length(abif@data$PLOC.2))

    # sangerSeqR PCON.2 is a UTF8-encoded character vector in release, 
    # an integer vector in devel
    if (! typeof(abif@data$PCON.2) == "integer"){
        num_quals <- utf8ToInt(abif@data$PCON.2)[1:length(abif@data$PLOC.2)]
    } else {
        num_quals <- abif@data$PCON.2[1:length(abif@data$PLOC.2)]
    }
  
    if (isTRUE(recall)){
        recalled <- sangerseqR::makeBaseCalls(sangerseqR::sangerseq(abif))
        nucseq <- sangerseqR::primarySeq(recalled, string = TRUE)
        if (nchar(nucseq) != length(num_quals)){
            trim <- FALSE
            # Set all quality scores equal
            num_quals <- rep(60, nchar(nucseq)) 
            # 60 is compatible with all phred offsets, according
            #  to Wikipedia Sanger scores do not usually exceed 60
            warning("Length of quality scores does not equal length of
                    re-called base sequence, ignoring quality scores")
        }
    }
  
    if (trim == FALSE){
        writeFastq(outfname, list("seqname" = seqname, "seq" = nucseq,
                  "quals" = rawToChar(as.raw(num_quals + offset))))
        return()
    }

    trim_msg <- paste("Sequence %s can not be trimmed because",
                      "it is shorter than the trim segment size")
    if (nchar(nucseq) <= min_seq_len){
        warning(sprintf(trim_msg, seqname))
        return()
    }

    scores = cutoff - 10^(num_quals / -10)
    running_sum <- rep(0, length(scores) + 1)

    # Note running_sum counts from zero, scores from 1
    for (i in 1:length(scores)){
        num <- scores[i] + running_sum[i]
        running_sum[i+1] <- ifelse(num < 0, 0, num)
    }

    trim_start <- min(which(running_sum > 0)) - 1
    trim_finish <- which.max(running_sum) - 2
    # -1 for running_sum offset, -1 because python doesn't include ends

    # Additional check that there is enough sequence (not in abifpy):
    if (trim_finish - trim_start < min_seq_len -1){
        warning(sprintf(trim_msg, seqname))
        return()
    }

    writeFastq(outfname, list("seqname" = seqname,
        "seq" = substring(nucseq, trim_start, trim_finish),
        "quals" = rawToChar(as.raw(num_quals[trim_start:trim_finish]+offset))))
  
    return()
}

#'@title Plots barplots of the spectrum of variants for a sample set
#'@author Helen Lindsay
#'@description For signature "matrix", this function optionally does a very
#'naive classification of variants by size.  Frameshift variant combinations are
#'those whose sum is not divisible by three.  Intron boundaries are *NOT* considered,
#'use with caution!
#'For signature "CrisprSet", the function uses the VariantAnnotation package to
#'localize variant alleles with respect to annotated transcripts.  Variants are 
#'annotated as "coding" when they are coding in any transcript.
#'@rdname barplotAlleleFreqs
#'@param obj The object to be plotted
#'@param ... additional arguments
#'@return A ggplot2 barplot of the allele distribution and optionally a table
#'of allele counts
#'@export
setGeneric("barplotAlleleFreqs", function(obj, ...) {
  standardGeneric("barplotAlleleFreqs")})


#'@description (signature("CrisprSet")) Groups variants by size and type
#'and produces a barplot showing the variant spectrum for each sample.
#'Accepts all arguments accepted by barplotAlleleFreqs for signature("matrix").
#'Requires package "VariantAnnotation"
#'@param txdb A transcript database object
#'@param min.freq Include variants with at frequency least min.freq in at least
#'one sample.  (Default: 0, i.e. no cutoff)
#'@param include.chimeras Should chimeric reads be included in results?
#'(Default: TRUE)
#'@param palette  Colour palette.  Options are "rainbow", a quantitative palette
#'(default) or "bluered", a gradient palette.
#'@rdname barplotAlleleFreqs
setMethod("barplotAlleleFreqs", signature("CrisprSet"),
  function(obj, ..., txdb, min.freq = 0, include.chimeras = TRUE, group = NULL,
           palette = c("rainbow", "bluered")){

    # Potential improvements:
    # Do filtering before variant location
    
    palette <- match.arg(palette)
    
    if (palette == "bluered"){
      clrs <- c("#3D52A1", "#3A7FC2", "#62A7DB", "#95CAEE", "#C4E4F9",
                "#EAF5F6","#FFFAD2", "#FFE6B0", "#FBC98C", "#F3A26E",
               "#E47353", "#CC443E","#AE1C3E")
    } else if (palette == "rainbow"){
      clrs <- c("#D92120","#E6642C","#D9AD3C","#B5BD4C","#7FB972",
                "#63AD99","#55A1B1","Gray","#E68E34","#488BC2",
                "#4065B1","#413B93","#781C81")
    }
    var_order <- c(obj$pars["match_label"], obj$pars["mismatch_label"],
                   "intron","fiveUTR","threeUTR","promoter", 
                   "intergenic", "Chimeric", "spliceSite",
                   "inframe indel < 10", "inframe indel > 10",
                   "frameshift indel < 10", "frameshift indel > 10")
    
    var_labels <- c(obj$pars["match_label"], obj$pars["mismatch_label"],
                    "intronic","5' UTR", "3' UTR","promoter", "intergenic",
                    "Chimeric", "splice site",
                    expression("inframe indel" <= 9),
                    "inframe indel > 10",  "frameshift indel < 9",
                    expression("frameshift indel" >= 10))
    
    var_type <- obj$classifyVariantsByLoc(txdb)
    classification <- obj$classifyCodingBySize(var_type)
    classification["Other"] <- "Chimeric"
    
    # Remove variants below the min.freq
    ac <- obj$.getFilteredCigarTable(min.freq = min.freq,
                                     include.chimeras = include.chimeras)
    rownames(ac) <- classification[rownames(ac)]
    vls <- factor(rownames(ac), levels = var_order)
    ac <- rowsum(ac, vls)
    clrs <- clrs[var_order %in% rownames(ac)]
    var_labels <- var_labels[var_order %in% rownames(ac)]
    return(barplotAlleleFreqs(ac, category.labels = var_labels,
                       bar.colours = clrs, group = group,
                       classify = FALSE, ...))
})


#'@description signature("matrix") Accepts a matrix of allele counts,
#'with rownames being alleles and column names samples.
#'@param category.labels Labels for each category, corresponding to the
#'rows of obj.  Only applicable when categories are provided, i.e.
#'"classify" is FALSE.  (Default: NULL)
#'@param group A grouping factor for the columns in obj.  Columns in the
#'same group will be displayed in the same text colour (Default: NULL)
#'@param bar.colours Colours for the categories in the barplot.
#'Colours must be provided if there are more than 6 different categories.
#'@param group.colours Colours for the text labels for the experimental groups
#'A set of 15 different colours is provided.
#'@param legend.text.size The size of the legend text, in points.
#'@param axis.text.size The size of the axis text, in points
#'@param legend.symbol.size  The size of the symbols in the legend
#'@param snv.label The row label for single nucleotide variants
#'@param novar.label The row label for non-variant sequences
#'@param include.table Should a table of allele (variant combination)
#'counts and total sequences be plotted? (Default: TRUE)
#'@param chimera.label The row label for chimeric (non-linearly aligned)
#'variant alleles
#'@param classify If TRUE, performs a naive classification by size 
#'(Default:TRUE)
#'@rdname barplotAlleleFreqs
#'@examples
#'data("gol_clutch1")
#'barplotAlleleFreqs(variantCounts(gol))
#'
#'# Just show the barplot without the counts table:
#'barplotAlleleFreqs(variantCounts(gol), include.table = FALSE)
setMethod("barplotAlleleFreqs", signature("matrix"),
          function(obj, category.labels = NULL, group = NULL, 
                   bar.colours = NULL, group.colours = NULL, 
                   legend.text.size = 10, axis.text.size = 10, 
                   legend.symbol.size = 1, snv.label = "SNV", 
                   novar.label = "no variant", chimera.label = "Other", 
                   include.table = TRUE, classify = TRUE){

  clrs <- bar.colours

  if (is.null(clrs)){
    # Colour-blind safe rainbow palette
    clrs <- c("#D92120","#E78532","#DFA53A", "#6DB388","#539EB6",
              "#3F60AE","#781C81")
  }

  ac <- obj
  if (!is.null(group)){
    group <- rev(group) # as ggplot plots bottom up
    if (is.null(group.colours)){
      # A range of dark colours chosen for readability and distinctiveness
      group.colours <- c("#332288","#661100","#0072B2","#117733","#882255",
                         "#D55E00","#AA4499","#009E73","#56B4E9","#CC79A7",
                         "#44AA99","#999933","#CC6677", "#E69F00","#88CCEE")
      }
    if (length(levels(group)) > length(group.colours)){
      stop("Too many groups for default colours.  Supply a vector of
           group.colours with length equal to the number of groups")
    }
    gp_cols <- group.colours[group]
  }
  
  if (isTRUE(classify)){
    temp <- classifyBySize(ac, snv.label, novar.label, chimera.label, clrs)
    ac <- temp$ac
    var_labels <- temp$var_labels
    var_clrs <- temp$var_clrs
  } else {
    if (! is.null(category.labels)){
      if (! length(category.labels) == nrow(ac)){
        warning("Number of categories labels should equal number of rows of obj.
                Using rownames instead.")
        var_labels <- rownames(ac)
      }
      var_labels <- category.labels
    }else{
      var_labels <- rownames(ac)
    }
    var_clrs <- clrs
    if (length(var_labels) > length(var_clrs)){
      stop(sprintf("Not enough colours in default palette.  Please supply %s colours",
                   length(var_labels)))
    }
  }

  af <- reshape2::melt(sweep(ac, 2, colSums(ac), "/"))

  colnames(af) <- c("Variant", "Sample", "Percent")
  af$Variant <- factor(af$Variant, levels = rownames(ac))
  af$Sample <- factor(af$Sample, levels = rev(unique(af$Sample)))

  # barplot
  p <- ggplot(af, aes_(x = quote(Sample), y = quote(Percent),
                        fill = quote(Variant))) +
    geom_bar(stat = "Identity", size = 10) +
    scale_y_continuous(expand = c(0,0)) + scale_x_discrete(expand = c(0,0)) +
    scale_fill_manual(values = var_clrs, labels = var_labels) +
    guides(fill=guide_legend(override.aes=list(size=legend.symbol.size),
                             ncol = 3, label.hjust = 0)) +
    xlab(NULL) + ylab(NULL) +
    theme_bw() + coord_flip() +
    theme(legend.position = "bottom", legend.title = element_blank(),
          axis.text = element_text(size = axis.text.size),
          legend.text = element_text(size = legend.text.size),
          legend.key = element_blank(),
          plot.margin = grid::unit(c(0.5,0.7,0.5,0),"lines"),
          panel.grid.major = element_blank(), panel.grid.minor = element_blank())

  if (! is.null(group)){
    p <- p + theme(axis.text.y=element_text(colour= gp_cols))
    hlines <- seq_along(group)[!duplicated(group)]
    hlines <- hlines[2:length(hlines)] - 0.5
    p <- p + geom_vline(xintercept= hlines, colour = "black", size = 1)
  }
  # table
  if (include.table == FALSE){ return(p) }

  dat <- data.frame(Sample = colnames(obj),
                    Vals = c(colSums(obj),colSums(obj != 0)),
                    Col = rep(c("Sequences","Alleles"), each = ncol(obj)))

  dat$Sample <- factor(dat$Sample, levels = rev(unique(af$Sample)))

  q <- ggplot(dat, aes_(x = quote(Col), y = quote(Sample),
                         label = quote(Vals))) +
    geom_tile(fill = "white", colour = "black", size = 1) + geom_text(size = 3) +
    scale_y_discrete(expand = c(0,0)) + scale_x_discrete(expand = c(0,0)) +
    theme_bw() + xlab(NULL) + ylab(NULL) +
    theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1),
          axis.text.y = element_blank(), axis.ticks.y = element_blank(),
          plot.margin = grid::unit(c(0.25,0.25,10,0), "lines"),
          plot.background=element_rect(fill = "transparent",
                                       colour = NA))

  pgrob <- ggplot2::ggplotGrob(p)
  ggrob <- ggplot2::ggplotGrob(q)
  ggrob$heights <- pgrob$heights

  return(gridExtra::grid.arrange(pgrob, ggrob, ncol = 2,
                                 widths = c(8,2), newpage = FALSE))
})


aggregateSNVs <- function(ac, snv.label){
  snv <- grepl(snv.label, rownames(ac))
  if (any(snv)){
    temp <- ac[!snv,,drop = FALSE]
    ac <- rbind(temp, "SNV" = colSums(ac[snv,, drop = FALSE]))
  }
  ac
}


classifyBySize <- function(ac, snv.label, novar.label, chimera.label, clrs){
  ac <- aggregateSNVs(ac, snv.label)
  no_indel <- grepl(sprintf("%s|%s|%s", novar.label, snv.label, chimera.label),
                    rownames(ac))
  
  # Classify indel variants by size
  if (any(!no_indel)){
    indels <- ac[!no_indel,,drop = FALSE]
    temp <- strsplit(rownames(indels), ",")
    indel_grp <- rep(c(1:nrow(indels)), lapply(temp, length))
    indel_ln <- rowsum(as.numeric(gsub("^.*:([0-9]+)[DI]", "\\1", unlist(temp))),
                       indel_grp)
    
    inframe <- indel_ln %% 3 == 0
    is_short <- indel_ln < 10
    
    indel_grp <- rep("inframe indel < 10", nrow(indels))
    indel_grp[is_short &! inframe] <- "frameshift indel < 10"
    indel_grp[!is_short & inframe] <- "inframe indel > 10"
    indel_grp[!is_short & !inframe] <- "frameshift indel > 10"
    
    grouped <- rowsum(indels, indel_grp)
    ac <- ac[no_indel,,drop = FALSE]
    ac <- rbind(ac, grouped)
  }
  
  var_order <- c(novar.label, snv.label, chimera.label,
                 "inframe indel < 10", "inframe indel > 10",
                 "frameshift indel < 10", "frameshift indel > 10")
  
  var_labels <- c(novar.label, snv.label, chimera.label,
                  expression("inframe indel" <= 9),
                  "inframe indel > 10",  "frameshift indel < 9",
                  expression("frameshift indel" >= 10))
  
  names(var_labels) <- var_order
  common <- intersect(var_order, rownames(ac))
  var_labels <- var_labels[common]
  ac <- ac[common,, drop=FALSE]
  var_clrs <- clrs[factor(common, levels = var_order)]
  list(ac = ac, var_labels = var_labels, var_clrs = var_clrs)
}

#' Variant sequences from golden clutch 1 (Burger et al)
#'
#' This dataset is a subset of the crispant data for the golden gene used by Burger et al (submitted).
#'
#' \itemize{
#' \item gol The variants as a CrisprSet object
#' }
#'
#' @docType data
#' @keywords datasets
#' @name gol_clutch1
#' @usage data(gol_clutch1)
#' @format A CrisprSet object countaining 8 samples
#' @aliases gol
#' @return A CrisprSet object named "gol"
NULL

# seqsToAln -----
#' @title Creates a text alignment from a set of cigar strings
#'@description Creates a one-to-one text alignment of a set of cigar strings with respect
#'to the reference sequence by collapsing insertions and introducing gaps
#'across deletions.
#'
#'When genomic coordinates for the alignment start and the target region
#'are provided, aligned sequences are cropped to the target region
#'@author Helen Lindsay
#'@param cigar A list of cigar strings to align
#'@param dnaseq The set of sequences corresponding to the cigars, as Biostrings::DNAStrings
#'@param target The target region to return, as GRanges.  Sequences overlapping
#'the target region are trimmed to exactly match it.
#'@param del_char The character to represent deleted bases. Default "-"
#'@param aln_start Genomic start locations of aligned sequences. Should be
#'used in conjunction with target_start and target_end.
#'@param reverse_complement (Default: FALSE)
#'@param allow_partial Are alignments that do not span the target region allowed?
#'(Default: FALSE)
#'@return The sequences with insertions collapsed and deletions padded
#'@rdname seqsToAln
seqsToAln <- function(cigar, dnaseq, target, del_char = "-", 
                      aln_start = NULL, reverse_complement = FALSE,
                      allow_partial = FALSE){
    # Additional trimming is necessary because deletion operations may overhang
    # boundaries of target region
    
    if (as.character(GenomicRanges::strand(target)) == "*") strand <- "+"
  
    result <- GenomicAlignments::sequenceLayer(dnaseq, cigar,
                                               D.letter = del_char,
                                               N.letter = "N")
    if (! is.null(aln_start)){
      shifts <- aln_start - GenomicAlignments::start(target)
      result <- Biostrings::stackStrings(result, shift = shifts,
                                         from = 1, to = width(target),
                                         Lpadding.letter = "+",
                                         Rpadding.letter = ".")
      if (! isTRUE(allow_partial) & isTRUE(any(grep("\\+|\\.", result)))){
        stop(paste("When allow_partial is FALSE, dnaseq to be",
                   "trimmed must span the target location"))
      }
    }

    if (isTRUE(reverse_complement)){
      result <- Biostrings::reverseComplement(result)
    }
    result <- as.character(result)
    result <- gsub("\\.", "<", gsub("\\+", ">", result))
    result
} # ------

# selectAlnRegions ------
#'@title selectAlnRegions
#'@description Given a character vector of pairwise alignments and a
#' region to display, trims alignments to the display regions, joined by
#' a separator "join".  Alignments should be equal length, e.g.
#' created by seqsToAln
#'@author Helen Lindsay
#'@param alns Character vector of pairwise alignments, with insertions removed
#'@param reference Reference sequence
#'@param keep Region to display, relative to the target region, i.e.
#'not genomic coords (IRanges or GRanges)
#'@param join character(1) String used for joining alignment segments.
#'Can accept a placeholder to fill in the number of bases deleted with
#'"%s", e.g. the default "/ %s /" will appear as "/ 3 /" if 3 bases are
#'deleted
#'@param border.gaps (logical(1)) Should bases deleted from the borders
#'be shown?  (Default: FALSE)
#'@return A list of the truncated alignments (alns) and reference (ref)
#'@rdname seqsToAln
selectAlnRegions <- function(alns, reference, target,
                             keep, join = "/ %s /",
                             border.gaps = FALSE){

    # Potential changes:
    # record how many bases deleted from each allele
    # (e.g. to make clear if deleted region was a gap or an insertion)
  
    # make keep relative to target if not already
    keep <- .checkRelativeLocs(target, keep)
    to_delete <- .invertKeepRanges(target, keep)
    if (! is(to_delete, "IRanges")) return()
    
    result <- Biostrings::extractAt(as(alns, "XStringSet"), keep)
    ref_result <- Biostrings::extractAt(as(reference, "XString"), keep)    

    ndeleted <- width(to_delete)
    ref_paste <- sprintf(join, ndeleted)    
    aln_paste <- sprintf(join, strrep(".", nchar(ndeleted)))
    seg_joins <- matrix(c(ref_paste, aln_paste), ncol = 2)
    
    # Adjust to show or hide operations at the borders 
    del_left <- min(start(keep)) > min(start(to_delete))
    del_right <- max(end(keep)) < max(end(to_delete))

    if (isTRUE(del_left) & ! isTRUE(border.gaps)){
      # The first gap is not included in the displayed plot
      seg_joins[1,] <- ""
    } 
    if (isTRUE(del_right) & ! isTRUE(border.gaps)){
      seg_joins[nrow(seg_joins),] <- ""
    }
    if (! isTRUE(del_left)){ seg_joins <- rbind("", seg_joins) }
    if (! isTRUE(del_right)){ seg_joins <- rbind(seg_joins, "") }
    
    # Offsets refer to number of characters added into plot
    offsets <- nchar(seg_joins[1:length(keep),1])
    
    keep_idxs <- coverage(keep, width = width(target))
    offset_idxs <- .offsetIndices(nchar(ref_result), offsets)
    keep_idxs[keep_idxs == 1] <- offset_idxs
    keep_idxs <- as.numeric(keep_idxs)
    
    # Joins include border elements, empty if border.gaps = FALSE
    paste_segs <- function(joins, segs){
       paste(.intersperse(joins, segs), collapse = "")
    }
    
    ref_return <- paste_segs(seg_joins[,1], as.character(ref_result))
    aln_return <- unlist(lapply(result, function(x){ 
      paste_segs(seg_joins[,2], as.character(x))
    })) 
    
    return(list(alns = aln_return, ref = ref_return, keep = keep,
                nchar_join = offsets, indices = keep_idxs))
} # ------

# .invertKeepRanges -----
#'@title Helper functions for selectAlnRegions
#'@description (.invertKeepRanges) Internal CrispRVariants function used
#'by seqsToPartialAlns for checking arguments and getting region to delete.
#'Returns FALSE if no region to delete found, or region to be deleted is
#'entire target.
#'@param target The complete region spanned by the alignments (GRanges)
#'@param keep Region to display, relative to the target region, i.e.
#'not genomic coords (IRanges or GRanges)
#'@return Gaps between keep (IRanges), or FALSE if no gap ranges found
#'@rdname selectAlnRegionsHelpers
.invertKeepRanges <- function(target, keep){
    if (! class(keep) %in% c("IRanges", "GRanges")){
      stop("Ranges to keep should be class IRanges or GRanges")
    }
    
    # Get the region to delete
    keepr <- keep
    if (class(keep) == "GRanges") keepr <- ranges(keep)
    to_delete <- Biostrings::gaps(keepr, start = 1, end = width(target))
    
    # If the region to be deleted is the target region,
    # check if it's in genomic coordinates
    if (identical(to_delete, IRanges(1, width(target)))){
      # Check if all regions to keep are contained within target
      warning("Region to delete is identical to the target region, \n",
              "or was of class IRanges and could not be shifted\n",
              "to relative coordinates. Returning")
      return(FALSE) 
    }
    
    # If there is nothing to delete, warn and return
    if (length(to_delete) == 0){
      warning("Nothing to delete.  Returning")
      return(FALSE)
    } 
    
    return(to_delete)
} # -----

# .checkRelativeLocs -----
#'@description (.checkRelativeLocs) Shift keep to start at 1 if it is
#'within the target
#'@rdname selectAlnRegionsHelpers
.checkRelativeLocs <- function(target, keep){
    # Can only check for contained ranges if keep is a GRanges object
    # (Or both are IRanges)
    if (! (class(keep) == "GRanges" & class(target) == "GRanges")) return(keep)
    ovs <- queryHits(findOverlaps(keep, target, type = "within"))
    if (length(setdiff(ovs, seq_along(keep))) == 0){
      keep <- shift(keep, 1-start(target))
    }
    ranges(keep)
} # -----

# .adjustRelativeInsLocs -----
#'@description (.adjustRelativeInsLocs) Internal CrispRVariants function
#'for shifting insertion locations relative to the target region when
#'removing a segment of the alignments.  Note that this function does not
#'do input checking but assumes this has been done upstream. Insertions at
#'the left border of a gap region are removed.
#'@param starts numeric(n) Insertion locations. When plotting,
#'the insertion symbol appears at the left border of the
#'start location.
#'@param gap_nchars character(n) Number of letters added to when joining
#'segments before each region in keep.  If first base of keep is 1,
#'the first entry of gap_nchars should be 0.
#'@return insertion_sites (data.frame) with modified start column
#'@rdname selectAlnRegionsHelpers
.adjustRelativeInsLocs <- function(target, keep, starts, gap_nchars){
    if ( length(gap_nchars) > length(keep) + 2 ){
      # Can be at most 2 more gaps than kept (boundaries)
      stop("gap_nchars should be the number of characters used\n",
           "to separate segments in keep when creating alignments.\n",
           "length(gap_nchars) should be at most two more than length(keep)") 
    }
    # This is the same as the indices in selectAlnRegions except that
    # left borders of gaps are included. 
  
    # As the insertion is placed at the leftmost border of a nucleotide,
    # it is still possible to display insertions at the left border of
    # the region(s) to remove
    not_rightmost <- ! end(keep) == width(target)
    end(keep[not_rightmost]) <- end(keep)[not_rightmost] + 1
    keep_cov <- as.logical(coverage(keep, width = width(target)))
    new_idxs <- rep(NA, length(keep_cov))
    new_idxs[keep_cov] <- seq_along(which(keep_cov))
    new_starts <- new_idxs[starts]
    
    # Offset the new insertion locations by the number of bases
    # added when joining sequences
    all_offsets <- rep(gap_nchars, width(keep))
    to_display <- ! is.na(new_starts)
    new_starts[to_display] <- new_starts[to_display] + all_offsets[new_starts[to_display]] 
    new_starts
    
} # -----

# .offsetIndices -----
#' @description (.offsetIndices) Get indices of a vector grouped by "x",
#' cumulatively adding offsets to each group according to "offset"
#' @param x  A vector of group lengths
#' @param offset A vector of offset lengths matching x
#' @author Helen Lindsay
#' @examples 
#' CrispRVariants:::.offsetIndices(rep(2,5), c(0:4)*10)
#' @rdname selectAlnRegionsHelpers
.offsetIndices <- function(x, offset){
  stopifnot(length(x) == length(offset))
  indices <- seq_len(sum(x))
  indices <- indices + rep(cumsum(offset), x)
  indices
} # -----

context("Testing seqsToAln correctly truncates alignments")

# Setup data -----

target <- GenomicRanges::GRanges("1", IRanges::IRanges(10,19), "+")
cigar1 <- "10D20M"
seq1 <- Biostrings::DNAStringSet("AAAAACCCCCTTTTTGGGGG")
# -----

test_that("seqsToAln correctly handles overlapping gaps", {
    expect_equal(seqsToAln(cigar1, seq1, target, aln_start = 5), "-----AAAAA")
    expect_equal(seqsToAln(cigar1, seq1, target, aln_start = 0), "AAAAACCCCC")
    expect_equal(seqsToAln(cigar1, seq1, target, 
                  aln_start = 5, reverse_complement = TRUE), "TTTTT-----")
})


# Data for examples with partial alignments -----
data("gol_clutch1")
gol_alns <- unlist(alns(gol))
aln_seqs <- CrispRVariants:::seqsToAln(cigar(gol_alns),
                                       dnaseq = mcols(gol_alns)$seq,
                                       target = gol$target,
                                       aln_start = start(gol_alns))

keep_wrt_target <- GRanges(18, IRanges(start = c(4647372, 4647396),
                                       end = c(4647392,4647404)))

target <- gol$target

keep <- IRanges(start = c(1,25), end = c(21,33))
# Delete characters at the start
keep_l <- IRanges(start = c(5,25), end = c(21,33))
# Delete characters at the end
keep_r <- IRanges(start = c(1,25), end = c(21,30))
# Delete characters at both ends
keep_b <- IRanges(start = c(5,25), end = c(21,30))

#-----


test_that("selectAlnRegions converts GRanges if possible", {
    expect_identical(.checkRelativeLocs(target, keep_wrt_target), keep)
    
    # Function should fail with a warning if genomic coordinates are given
    # as IRanges
    expect_warning(result <- selectAlnRegions(5, seq1, seq1, target, 
                                              ranges(keep_wrt_target)))
    expect_equal(result, NULL)
})

test_that("Insertions on the left boundary of a gap are retained", {
    original_ins <- gol$insertion_sites$start
    result <- .adjustRelativeInsLocs(gol$target, keep, original_ins, c(0,5))
    expect_equal(length(result), length(original_ins))
    
    # Check insertions at first gap base pos 22 are kept 
    expect_true(! any(is.na(result[original_ins == 22])))
    
    # Check insertions at last gap base 24 are ignored
    expect_true(all(is.na(result[original_ins == 24])))
})

test_that("selectAlnRegions correctly joins multiple segments", {
    select_args <- list(alns = aln_seqs[1:10], reference = gol$ref,
                        target = gol$target, join = " del %s bp ")
  
    run_selectRegions <- function(keep){
       do.call(selectAlnRegions,
               modifyList(select_args, list(keep = keep)))
    }
    
    result <- run_selectRegions(keep)
    result_l <- run_selectRegions(keep_l)
    result_r <- run_selectRegions(keep_r)
    result_b <- run_selectRegions(keep_b)
    # Same thing allowing gaps at borders
    select_args["border.gaps"] <- TRUE
    result_bd <- run_selectRegions(keep)
    result_lbd <- run_selectRegions(keep_l)
    result_rbd <- run_selectRegions(keep_r)
    result_bbd <- run_selectRegions(keep_b)
    
    expect_equal(result$ref, "GTCTTGGTCTCTCGCAGGATG del 3 bp CTGGAGCCA")
    expect_equal(result_l$ref, "TGGTCTCTCGCAGGATG del 3 bp CTGGAGCCA" )
    expect_equal(result_r$ref, "GTCTTGGTCTCTCGCAGGATG del 3 bp CTGGAG")
    expect_equal(result_b$ref, "TGGTCTCTCGCAGGATG del 3 bp CTGGAG")
    expect_equal(result_bd$ref, "GTCTTGGTCTCTCGCAGGATG del 3 bp CTGGAGCCA")
    expect_equal(result_lbd$ref,
                 " del 4 bp TGGTCTCTCGCAGGATG del 3 bp CTGGAGCCA")
    expect_equal(result_rbd$ref,
                 "GTCTTGGTCTCTCGCAGGATG del 3 bp CTGGAG del 3 bp ")
    expect_equal(result_bbd$ref,
                 " del 4 bp TGGTCTCTCGCAGGATG del 3 bp CTGGAG del 3 bp ")
})


test_that("selectAlnRegions works starting from partial alignments", {
  
  
})

#'@title mergeChimeras
#'@description Merges chimeric alignments where the individual segments
#' border an unmapped region (a long deletion).  If bases of the read are
#' mapped to both ends of the gap, the multimapped reads are only included
#' in the leftmost genomic segment. If there are more than max_unmapped
#' unmapped bases between the mapped bases, the read is not considered
#' mergeable.  Currently experimental and only tested with reads mapped by
#' bwa mem.
#'@param bam A GenomicAlignments::GAlignments object
#'@param chimera_idxs Indices of chimeric reads within bam
#'@param verbose  Should information about the number of mergeable
#' alignments be printed?  (Default: TRUE)
#'@param max_read_overlap  Maximum number of bases in a mergeable read
#'that are aligned to two genomic locations (Default: 10)
#'@param max_unmapped  Maximum number of bases in a mergeable read
#' that are unmapped and located between two mapped segments (Default: 4)
#'@param name Name of the sample, used when reporting verbose output.
#'@author Helen Lindsay
#'@return A list of the merged and unmerged chimeric alignments
#'@rdname mergeChimeras
mergeChimeras <- function(bam, chimera_idxs = NULL, verbose = TRUE,
                        max_read_overlap = 10, max_unmapped = 4, name = NULL){
    
    # max_unmapped refers to unmapped sections between chimeric segments
    
    # Case: Aligned regions overlap
    #  1-2-3-4-5
    #      3-4-5-6-7
    #
    # Case: Inversion:
    # 1-2-3-4-5
    #            9-8-7-6

    message(paste0("Caution: mergeChimeras assumes a sorted bam file\n",
                   "and has only been tested with bwa mem alignments!\n"))

    if (is.null(chimera_idxs)){
        chimera_idxs <- findChimeras(bam)
    }

    if (length(chimera_idxs) == 0){                          
        return(list(merged = bam, unmerged = GenomicAlignments::GAlignments()))
    }

    # Do all reads within a chimera map to the same chromosome?
    nms <- rle(names(bam)[chimera_idxs])
    nms_codes <- rep(1:length(nms$lengths), nms$lengths)
    sqs <- seqnames(bam)[chimera_idxs]
    sqs_codes <- rep(1:length(sqs@lengths), sqs@lengths)
    codes <- rle(paste(nms_codes, sqs_codes, sep = "."))
    one_chr <- rep(codes$lengths, codes$lengths) == rep(nms$lengths, nms$lengths)
    
    # And onto the same strand? (i.e. not inversion)
    strds <- strand(bam)[chimera_idxs]
    strd_rle <- rle(paste0(nms_codes, strds))
    same_strd <- rep(strd_rle$lengths, strd_rle$lengths) ==
                    rep(nms$lengths, nms$lengths)
  
    # Are single chr chimeras gaps? (start(n+1) > end(n))
    del_lns <- start(bam)[chimera_idxs[-1]] -
                           end(bam)[chimera_idxs[-length(chimera_idxs)]]
    is_after <- c(TRUE, del_lns > 0)
    change_pts <- cumsum(nms$lengths) + 1 # note starts from second and includes last
    change_pts <- c(1, change_pts[1:length(change_pts) -1])
    is_after[change_pts] <- TRUE
    codes <- rle(paste(nms_codes, is_after, sep = "."))
    has_genome_gap <- rep(codes$lengths, codes$lengths) ==
                          rep(nms$lengths, nms$lengths)

    # Is the same read segment used in multiple sections of a chimera?
    # For merge-able alignments, the sum of the widths of the aligned regions of read n-1
    # should be less than or equal to the first aligned base of read n wrt the full seq
    cigars <- cigar(bam)[chimera_idxs]
    qrng <- GenomicAlignments::cigarRangesAlongQuerySpace(cigars,
               before.hard.clipping = TRUE, ops = c("M", "I"))
    first_aligned <- min(start(qrng))
    last_aligned <- max(end(qrng))

    # Gaps not correct: if the first part of the read maps after the
    # second part of the read gap - however, here only care about +ve / -ve
    gaps <- c(1,  first_aligned[-1] - last_aligned[-length(last_aligned)])
    gaps[change_pts] <- 1
    read_mapped_uniq <- gaps > -1 * max_read_overlap # 
    read_covered <- gaps <= max_unmapped
       
    gap_codes <- rle(paste(read_mapped_uniq & read_covered, nms_codes, sep = "."))
    has_read_gap <- rep(gap_codes$lengths, gap_codes$lengths) ==
                    rep(nms$lengths, nms$lengths)

    # Rearrangements: where the first aligned base of the second segment is
    # earlier than the first 
    rearr <- first_aligned[-1] - first_aligned[-length(first_aligned)]
    rearr <- c(1, rearr)
    rearr[change_pts] <- 1
    rearr <- rearr < 0
    
    # Remove sections of a read that map to two genomic locations
    # - identify reads with negative gap = overlap between segments
    read_gaps <- c(0, first_aligned[-1] - last_aligned[-length(last_aligned)] - 1)
    read_gaps[change_pts] <- 0
    to_cut <- read_gaps < 0
    
    # Start constructing new cigars and test for gaps in cut sections
    ch_ends <- cumsum(nms$lengths)
    new_cigars <- GenomicAlignments::cigarNarrow(cigars, start = 1,
                                                 end = width(bam[chimera_idxs]))
    new_cigars <- as.character(new_cigars)
    
    first_range <- as.numeric(gsub('M.*', "", new_cigars[to_cut]))
    # Cut overlap off rightmost read, adjust genomic coordinates
    first_range <- first_range + read_gaps[to_cut]
      
    # Remove reads with indels in the segment to exclude.
    rm_nms <- inverse.rle(nms)[which(to_cut)[which(first_range < 0)]]
    indel_in_cut <- names(bam[chimera_idxs]) %in% rm_nms
  
    mergeable <- one_chr & same_strd & has_genome_gap &
                 has_read_gap & !rearr & ! indel_in_cut
    
    chimeras <- bam[chimera_idxs][mergeable]
    chimeras <- chimeras[!duplicated(names(chimeras))] # select the leftmost
    remaining <- bam[chimera_idxs][!mergeable]
    
    if (!any(mergeable)){                          
      return(list(merged = chimeras, unmerged = remaining))
    }
    
    if (isTRUE(verbose)){ 
      format_zero <- function(x) ifelse(is.nan(x), 0, x)
      nchm <- length(chimera_idxs)
      noc <- sum(one_chr == "TRUE")
      nss <- sum(one_chr & !same_strd == "TRUE")
      nrearr <- sum(one_chr & same_strd & rearr == "TRUE")
      ngdup <- sum(!has_genome_gap & one_chr & same_strd & !rearr == "TRUE")
      nrdup <- sum(has_genome_gap & one_chr & same_strd &
                   !read_mapped_uniq & !rearr == "TRUE")
      nrumap <- sum(has_genome_gap & one_chr & same_strd &
                   !read_covered & !rearr == "TRUE")
      mrg <- sum(one_chr & same_strd & has_genome_gap & has_read_gap & ! rearr == "TRUE")
      if (! is.null(name)) cat(sprintf("Chimera statistics for %s:\n", name))  
      cat(sprintf(paste0("%s (%.2f%%) chimeras in %s reads\n",
      "  %s (%.2f%%) map to the same chromosome\n", 
      "    %s (%.2f%%) map to different strands (inversions)\n",
      "    %s (%.2f%%) rearrangements (end of read maps before start)\n",
      "    %s (%.2f%%) genomic duplications (different read locs mapped",
           " to same genomic loc)\n",
      "    %s (%.2f%%) read duplications (different genomic locs mapped",
           " to same read loc)\n",
      "    %s (%.2f%%) unmapped segments between mapped segments\n",
      "    %s (%.2f%%) are long gaps\n\n"),
      nchm, format_zero(nchm/length(bam)*100), length(bam),
      noc, format_zero(noc/nchm*100),
      nss, format_zero(nss/noc*100),
      nrearr, format_zero(nrearr/noc*100),
      ngdup, format_zero(ngdup/noc*100),
      nrdup, format_zero(nrdup/noc*100),
      nrumap, format_zero(nrumap/noc*100),
      mrg, format_zero(mrg/noc*100))) 
    }
    
    # For first member of chimera: get everything up to and including the last M
    new_cigars[change_pts] <- gsub("(^.*M)[0-9]+[HS]","\\1", cigars[change_pts])
    # For last member of chimera: get everything except for clipping at the start
    new_cigars[ch_ends] <- gsub("H","S",gsub("^[0-9]+[HS](.*)", "\\1", cigars[ch_ends]))
    
    new_cigars[to_cut] <- paste0(first_range, gsub('[0-9]+(M.*)', "\\1",
                                                   new_cigars[to_cut]))
    
    # Stick cigars together padding segments with deletions
    
    ch_gstarts <- start(bam)[chimera_idxs]
    ch_gends <- end(bam)[chimera_idxs]
    ### NEED TO ADJUST ENDS FOR READS TRIMMED
    ch_gstarts[to_cut] <- ch_gstarts[to_cut] - read_gaps[to_cut]

    ggaps <- c(sprintf("%sD", -1*(ch_gends[-length(chimera_idxs)] - ch_gstarts[-1] +1)),0)
    ggaps[ch_ends] <- ""
    new_cigars <- paste0(new_cigars, ggaps)

    new_cigars <- aggregate(new_cigars, list(nms_codes), FUN = paste0, collapse = "")$x

    # WARNING: assumption:  The primary alignment is not hard clipped
    new_cigars <- gsub("H", "S", new_cigars)    

    not_suppl <- !bitwAnd(mcols(bam[chimera_idxs])$flag, 2048)
    sqs <- mcols(bam[chimera_idxs])$seq[not_suppl]
    names(sqs) <- names(bam[chimera_idxs])[not_suppl]
    sqs <- unname(sqs[names(chimeras)])
    keep_chs <- mergeable[!duplicated(nms_codes)]
   
    # WARNING: if there is an unmapped section of the read < max_unmapped,
    # it is deleted 
    if (any(read_gaps > 0 )){
      keep_chs <- mergeable[!duplicated(nms_codes)]
      ch_qr <- sum(relist(elementNROWS(qrng), PartitioningByWidth(nms$lengths)))
      qrng <- relist(unlist(qrng), PartitioningByWidth(ch_qr))
      #qrng <- relist(unlist(qrng), IRanges::PartitioningByWidth(nms$lengths))
      gps <- Biostrings::gaps(qrng)[keep_chs]
      sqs <- Biostrings::replaceAt(sqs, gps, "")
    }
    
    galns <- GAlignments(names = names(chimeras),
                    seqnames = as.factor(seqnames(chimeras)),
                    pos = start(chimeras), cigar = new_cigars[keep_chs],
                    strand = strand(chimeras),
                    seqlengths = seqlengths(chimeras),
                    seq = sqs, flag = 0)

    return(list(merged = galns, unmerged = remaining))

}

# CrisprRun class definition -----
#'@title CrisprRun class
#'@description A ReferenceClass container for a single sample of alignments narrowed
#'to a target region.  Typically CrisprRun objects will not be accessed directly,
#'but if necessary via a CrisprSet class which contains a list of CrisprRun objects.  
#'Note that the CrispRVariants plotting functions don't work on CrisprRun objects.
#'@param bam a GAlignments object containing (narrowed) alignments to the target region.
#' Filtering of the bam should generally be done before initialising a CrisprRun object
#'@param target The target location, a GRanges object
#'@param genome.ranges A GRangesList of genomic coordinates for the cigar operations.
#' If bam is a standard GAlignments object, this is equivalent to
#' cigarRangesAlongReferenceSpace + start(bam)
#'@param rc (reverse complement)  Should the alignments be reverse complemented,
#'i.e. displayed with respect to the negative strand?  (Default: FALSE)
#'@param name A name for this set of reads, used in plots if present (Default: NULL)
#'@param chimeras Off-target chimeric alignments not in bam.  (Default: empty)
#'@param verbose Print information about initialisation progress (Default: FALSE)
#'@field alns A GAlignments object containing the narrowed reads.  Note that if the alignments
#'are represented with respect to the reverse strand, the "start" remains with repect to the
#'forward strand, whilst the cigar and the sequence are reverse complemented.
#'@field name The name of the sample
#'@field cigar_labels A vector of labels for the reads, based on the cigar strings,
#'optionally renumbered with respect to a new zero point (e.g. the cut site) and
#'shortened to only insertion and deletion locations.
#'Set at initialisation of a CrisprSet object, but not at
#'initialisation of a CrisprRun object.
#'@field chimeras Chimeric, off-target alignments corresponding to alignments in alns
#'@seealso \code{\link{CrisprSet}}
#'@author Helen Lindsay
#'@examples
#'# readsToTarget with signature("GAlignments", "GRanges") returns a 
#'# CrisprRun object
#'
#'bam_fname <- system.file("extdata", "gol_F1_clutch_1_embryo_1_s.bam",
#'                         package = "CrispRVariants")
#'param <- Rsamtools::ScanBamParam(what = c("seq", "flag"))
#'alns <- GenomicAlignments::readGAlignments(bam_fname, param = param, 
#'          use.names = TRUE)
#'
#'reference <- Biostrings::DNAString("GGTCTCTCGCAGGATGTTGCTGG")
#'gd <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399), strand = "+")
#'
#'crispr_run <- readsToTarget(alns, target = gd, reference = reference,
#'                            name = "Sample name", target.loc = 17)
#'
#'# Alternatively, CrisprRun objects can be accessed from a CrisprSet object
#'# e.g. crispr_set$crispr_runs[[1]]
#'@export CrisprRun
#'@exportClass CrisprRun
CrisprRun = setRefClass(
  Class = "CrisprRun",
  fields = c(alns = "GAlignments",
             name = "character",
             cigar_labels = "character",
             chimeras = "GAlignments",
             chimera_combs = "data.frame")
) # -----

# CrisprRun initializer -----
CrisprRun$methods(
  initialize = function(bam, target, rc = FALSE, name = NULL,
                        chimeras = GenomicAlignments::GAlignments(),
                        verbose = FALSE){
    
    # If no name is provided, use the coordinates
    if (is.null(name)){
        name <<- sprintf("%s:%s-%s", seqnames(target), start(target), end(target))
    } else { name <<- name}

    if (isTRUE(verbose)){
      message(sprintf("\nInitialising CrisprRun %s\n", .self$name))
    }
    
    alns <<- bam
    chimeras <<- chimeras
    chimera_combs <<- .self$.splitChimeras()

    if (length(bam) == 0) { return() }

    # recalculate genome.ranges in case of keep_unpaired = FALSE, not tested
    .self$getInsertionSeqs(target = target)
  }, # -----

  # show -----
  show = function(){
    print(c(class(.self), sprintf("CrisprRun object named %s, with %s on target alignments.",
                                  .self$name, length(.self$alns)), .self$alns))
  }, # ------

  # getInsertionSeqs -----
  getInsertionSeqs = function(target){
' 
Description:
  Return a table relating insertion sequences to alignment indices
Input parameters:
'
    df <- getInsertionsTable(.self$alns, pos = start(target))
    if (is.null(df)) {return(NULL)}
    df$label <- .self$cigar_labels[df$idx]
    
    agg <- aggregate(df[,4], by = df[,c(1:3,5)], c, simplify=FALSE)
    agg$count <- lengths(agg$x)
    colnames(agg) <- c("start", "seq", "genomic_start",
                       "cigar_label", "idxs", "count")
    return(agg)
  }, # -----

  # .checkNonempty -----
  .checkNonempty = function(){
    if (length(.self$alns) == 0){
      message("No on target alignments")
      return(FALSE)
    }
    TRUE
  }, # -----

  # splitChimeras -----
  .splitChimeras = function(){
    splits <- split(cigar(.self$chimeras), names(.self$chimeras))
    if (length(splits) == 0) return(data.frame())
    combination <- sapply(splits, base::paste, collapse=";")
    tt <- as.data.frame(table(combination))
    tt <- tt[order(tt$Freq, decreasing = TRUE),]
    tt
  }, # -----

  # getCigarLabels -----
  getCigarLabels = function(target, target.loc, genome_to_target, ref,
                            separate.snv, rc, match.label, mismatch.label,
                            keep.ops = c("I","D","N"),
                            upstream = min(target.loc, 8),
                            downstream = min(6, width(ref) - target.loc + 1),
                            regions = NULL, snv.regions = NULL){
    '
Description:
  Sets the "cig_labels" field, returns the cigar labels.

Input parameters:
  target:           (GRanges) the counting region.
  target.loc:       The location of the cut site with respect to the target
  genome_to_target: A vector with names being genomic locations and values
                    being locations with respect to the cut site
  separate.snv:     Should single nucleotide variants be called?  
                    (Default: TRUE)
  match.label:      Label for non-variant reads (Default: no variant)
  mismatch.label:   Label for single nucleotide variants (Default: SNV)
  rc:               Should the variants be displayed with respect to the 
                    negative strand? (Default: FALSE)
  keep.ops:         CIGAR operations to remain in the variant label
                    (usually indels)
  upstream:         distance upstream of the cut site to call SNVs
  downstream:       distance downstream of the cut site to call SNVs
  regions:          IRanges(k) Regions for counting insertions and
                    deletions.  Insertions on the right border are not
                    counted.
  snv.regions       Regions for calling SNVS'
    
    
    # target.loc is wrt reference sequence, -ve if ref is -ve
    # upstream and downstream defined wrt the target.loc
    
    # Find indels
    
    labels <- indelLabels(.self$alns, rc,
                          genome.to.pos = genome_to_target)
    
    relative_start <- max(1, target.loc - upstream + 1)
    relative_end <- min(target.loc + downstream, nchar(ref))
    regions <- IRanges(relative_start, relative_end)
    
    # Find snvs
    
    if (any(labels == "") & isTRUE(separate.snv)){
      mm_labs <- mismatchLabels(.self$alns[labels == ""], target, ref, 
                       regions = IRanges(relative_start, relative_end), 
                       genome.to.pos = genome_to_target)
    
      labels[labels == ""] <- mm_labs  
    }
    
    # Remaining are either no variant or partial
    
    # Adjust cigar for partial alignments
    spans <- width(.self$alns) == nchar(ref) 
    labels[labels == "" & spans] <- match.label
    labels[labels == "" & !spans]  <- cigar(.self$alns)[labels == "" & ! spans]
    
    .self$field("cigar_labels", labels)
    mcols(.self$alns)$"allele" = labels
    labels

    ## Adjust cigar for partial alignments
    #spans <- width(.self$alns) == nchar(ref) 
    #temp[ops_per_aln == 0 & spans] <- match.label
    #temp[ops_per_aln == 0 & ! spans] <- cigs[ops_per_aln == 0 & ! spans]
#
     #__________
    # Check if partial alns starting from different places have same labels
    #strts <- start(.self$alns)[ops_per_aln == 0 & ! spans]
    #temp <- split(strts, renamed[ops_per_aln == 0 & ! spans])
    #if (! all(lengths(lapply(temp, unique)) == 1) ){
    #   rn <- unlist(renamed[ops_per_aln == 0 & ! spans]) 
    #   gen_strt <- genome_to_target[as.character(unlist(temp))]
    #    
    #}
    
    #renamed
  } # -----

  # .splitNonIndel -----
#  .splitNonIndel = function(ref, cig_labels, rc, match_label = "no variant",
#                          mismatch_label = "SNV", cut_site = 17,
#                          upstream = 8, downstream = 6){
#
#    # NOTE: SNVS not called in partial alignments
#    # Only consider mismatches up to (upstream) to the left of the cut and
#    # (downstream) to the right of the cut
#    # The cut site is between cut_site and cut_site + 1
#    upstream = min(cut_site, upstream)
#    downstream = min(downstream, nchar(ref) - cut_site)
#    
#    is_match <- cig_labels == match_label
#    
#    # If negative strand, rc reference for checking identity
#    # Sequences are later reverse complemented to match the ref
#    test_ref <- ref 
#    if(isTRUE(rc)){ test_ref <- Biostrings::reverseComplement(test_ref)}
#    no_var <- which(is_match & mcols(.self$alns)$seq != test_ref)
#    
#    if (length(no_var) == 0) return(cig_labels)
#  
#    if ((cut_site-upstream + 1) < 0 | (cut_site + downstream) > length(ref)){
#      stop("Specified range for detecting SNVs is greater than target range")
#    }
#  
#    snv_range <- c((cut_site-upstream + 1):(cut_site + downstream))
#    sqs <- mcols(.self$alns)$seq[no_var]
#    if (isTRUE(rc)) sqs <- reverseComplement(sqs)
#  
#    no_var_seqs <- as.matrix(sqs)
#    no_var_seqs <- no_var_seqs[,snv_range, drop = FALSE]
#  
#    rr <- strsplit(as.character(ref[snv_range]), "")[[1]]
#    result <- apply(no_var_seqs, 1, function(x){
#      snvs <- which((x != rr & x != "N")) - upstream - 1
#      snvs[snvs >= 0] <- snvs[snvs >= 0] + 1
#      sprintf("%s:%s", mismatch_label, paste(snvs, collapse = ","))
#    })
#    result[result == sprintf("%s:", mismatch_label)] <- match_label
#    cig_labels[no_var] <- result
#    cig_labels
#    } # -----

)

# plotVariants generic -----
#'@title Plot alignments, frequencies and location of target sequence
#'@description Combines a plot of transcript structure, alleles
#' aligned with respect to a reference genome and a heatmap of
#' counts or proportions of each allele in a set of data.
#'@rdname plotVariants
#'@param obj The object to be plotted
#'@return A ggplot2 plot of the variants
#'@export
setGeneric("plotVariants", function(obj, ...) {
  standardGeneric("plotVariants")})
# -----

# plotVariants CrisprSet -----
#'@rdname plotVariants
#'@param txdb GenomicFeatures:TxDb object (default: NULL)
#'@param plotAlignments.args Extra arguments for plotAlignments
#'@param plotFreqHeatmap.args Extra arguments for plotFreqHeatmap
#'@param add.chr If target chromosome does not start with "chr", e.g.
#'"chr5", add the "chr" prefix.  (Default:TRUE)
#'@param ... extra arguments for plot layout
#'@seealso \code{\link{arrangePlots}} for general layout options
#' and \code{\link{annotateGenePlot}} for options relating
#' to the transcript plot.
#'@examples
#'#Load a CrisprSet object for plotting
#'data("gol_clutch1")
#'
#'#Load the transcript db.  This is a subset of the Ensembl Danio Rerio v73 gtf
#'# for the region 18:4640000-4650000 which includes the targeted gol gene
#'
#'library(GenomicFeatures)
#'fn <- system.file("extdata", "Danio_rerio.Zv9.73.gol.sqlite",
#'                  package = "CrispRVariants")
#'txdb <- loadDb(fn)
#'
#'# Plot the variants
#'p <- plotVariants(gol, txdb = txdb)
#'
#'#In the above plot, the bottom margin is too large, the legend is
#'#cut off, and the text within the plots should be larger.
#'#These issues can be fixed with some adjustments:
#'p <- plotVariants(gol, txdb = txdb,
#'                  plotAlignments.args = list(plot.text.size = 4, legend.cols = 2),
#'                  plotFreqHeatmap.args = list(plot.text.size = 4),
#'                  left.plot.margin = grid::unit(c(0.1,0.2,0.5,1), "lines"))
#'
setMethod("plotVariants", signature("CrisprSet"),
          function(obj, ..., txdb = NULL, add.chr = TRUE,
                   plotAlignments.args = list(),
                   plotFreqHeatmap.args = list()){

    include_txs <- TRUE
    if(!(class(txdb) == "TxDb" | class(txdb) == "TranscriptDb") ){
      if (is.null(txdb)){
        include_txs <- FALSE
      } else{
        stop("txdb should be a (GenomicFeatures) transcript database object")
      }
    }
    if (isFALSE(plotAlignments.args$create.plot) |
        isFALSE(plotFreqHeatmap.args$create.plot) ){
      stop("Argument create.plot can not be FALSE for plotVariants.\n",
        "Call plotAlignments or plotFreqHeatmap directly to get plot data.")
    }
    
    dots <- list(...)
    annotate_nms <- c("target.colour", "target.size",
                      "gene.text.size", "panel.spacing")

    annotate_args <- dots[names(dots) %in% annotate_nms]
    dots[annotate_nms] <- NULL

    arrange_nms <-  c("fig.height","col.wdth.ratio",
                      "row.ht.ratio", "left.plot.margin")
    arrange_args <- dots[names(dots) %in% arrange_nms]

    target <- obj$target
    if (isTRUE(add.chr) & isTRUE(include_txs)){
      # If adding "chr" to target chromosomes matches txdb chromosomes, do so
      target_levels <- GenomeInfoDb::seqlevels(target)
      txdb_levels <- GenomeInfoDb::seqlevels(txdb)
      wchr <- paste0("chr", target_levels)
      idxs <- wchr %in% txdb_levels
      target_levels[idxs] <- wchr[idxs]
      target <- GenomeInfoDb::renameSeqlevels(target, target_levels)
    }

    if (isTRUE(include_txs)){
      annotate_args <- modifyList(list(txdb = txdb, target = target),
                                  annotate_args)
      gene_p <- do.call(annotateGenePlot, annotate_args)
      gene_p <- ggplot2::ggplotGrob(gene_p)
    } else {
      arrange_args[["row.ht.ratio"]] <- c(0,1)
      gene_p <- grid::grid.rect(gp=grid::gpar(col="white"), draw = FALSE)
      no_ins <- nrow(obj$insertion_sites) == 0
      if (no_ins & ! "left.plot.margin" %in% names(arrange_args)){
        # Names tend to clip if there are no insertions, increase default
        arrange_args[["left.plot.margin"]] <- grid::unit(c(0.2,0,3,0.5), "lines")
      }
    }

    plotAlignments.args[["obj"]] <-  obj
    aln_p <- do.call(plotAlignments, plotAlignments.args)
    aln_p <- aln_p + theme(legend.spacing = grid::unit(0.2,"cm"))
  
    plotFreqHeatmap.args[["obj"]] <- obj
    heat_p <- do.call(plotFreqHeatmap, plotFreqHeatmap.args)
    heat_p <- heat_p + theme(plot.background=element_rect(fill = "transparent",
                                                        colour = NA),
                           plot.margin = grid::unit(c(1, 0.25, 0.5, 0), "lines"))

    arrange_args = modifyList(list("top.plot" = gene_p, "left.plot" = aln_p,
                                   "right.plot" = heat_p), arrange_args)
    result <- do.call(arrangePlots, arrange_args)

    return(result)
}) # -----

# arrangePlots ------ 
#'@title Arrange plots for plotVariants:CrisprSet
#'@description Arranges 3 plots in two rows.  The vertical margins of the
#'left.plot and right.plot constrained to be equal
#'@param top.plot ggplot grob, placed on top of the figure, spanning the figure
#'width
#'@param left.plot ggplot, placed in the second row on the left
#'@param right.plot ggplot, placed in the second row on the right.
#'y-axis labels are removed.
#'@param fig.height Actual height for the figure. If not provided,
#'figure height is the sum of the row.ht.ratio (Default: NULL)
#'@param row.ht.ratio Vector specifying row height ratio (Default: c(1,6))
#'@param col.wdth.ratio  Vector specifying column width ratio (Default: c(2, 1))
#'@param left.plot.margin Unit object specifying margins of left.plot.
#'Margins of right.plot are constrained by the left.plot.
#'@return The arranged plots
arrangePlots <- function(top.plot, left.plot, right.plot, fig.height = NULL,
                      col.wdth.ratio  = c(2, 1), row.ht.ratio = c(1,6),
                      left.plot.margin = grid::unit(c(0.1,0.2,3,0.2), "lines")){

  # Set the size ratio of the top and bottom rows
  plot_hts <- if (is.null(fig.height)){ row.ht.ratio
  }else { fig.height/sum(row.ht.ratio)*row.ht.ratio }

  # Remove y-axis labels from right plot
  right.plot <- right.plot + theme(axis.text.y = element_blank(),
                                   axis.ticks.y = element_blank())

  # Adjust margins of left.plot
  left.plot <- left.plot + theme(plot.margin = left.plot.margin)

  # Convert plots to grobs, lock plot heights
  p2 <- ggplot2::ggplotGrob(left.plot)
  p3 <- ggplot2::ggplotGrob(right.plot)
  p3$heights <- p2$heights

  # Return arranged plots
  return(gridExtra::grid.arrange(top.plot,
         gridExtra::arrangeGrob(p2, p3, ncol = 2, widths = col.wdth.ratio),
         nrow = 2, heights = plot_hts, newpage = FALSE))
} # -----

# getOverlappingGenes -----
.getOverlappingGenes <- function(txdb, target, all.transcripts = TRUE){
    genomicfeatures <- requireNamespace("GenomicFeatures")
    stopifnot(isTRUE(genomicfeatures))

    columns <- c("GENEID","TXNAME", "EXONSTART", "EXONEND", "TXSTRAND",
                 "CDSCHROM", "CDSSTART", "CDSEND")

    trns <- GenomicFeatures::transcripts(txdb)
    exs <- findOverlaps(target, trns, ignore.strand = TRUE)

    if (length(exs) == 0){
        return(grid::grid.rect(gp=grid::gpar(col="white"), draw = FALSE))
    }
    # Find the genes that overlap
    genes <- AnnotationDbi::select(txdb,
              keys = as.character(mcols(trns[subjectHits(exs)])$tx_id),
              keytype = "TXID", columns = columns)
              

    # Find all (possibly non-overlapping) transcripts of overlapping genes
    if (isTRUE(all.transcripts)){
        genes <- suppressWarnings(AnnotationDbi::select(txdb,
              keys = unique(genes$GENEID),
              keytype = "GENEID",
              columns = c("TXID", columns) ))
    }
    
    genes
} # -----

# makeGeneSegments -----
.makeGeneSegments <- function(genes, txdb, target){
    gene_gr <- GRanges(seqnames(target)[1],
                     IRanges(genes$EXONSTART, genes$EXONEND),
                     strand = genes$TXSTRAND, txid = genes$TXID)
 
    # Assumption: if no end then also no start
    #no_cds <- is.na(genes$CDSSTART)
    #strts <- genes$CDSSTART
    #ends <- genes$CDSEND
    #strts[no_cds] <- genes$EXONSTART[no_cds]
    #ends[no_cds] <- genes$EXONEND[no_cds]
 
    has_cds <- ! is.na(genes$CDSSTART)
    cds_gr <- GRanges(seqnames(target)[1], 
                      IRanges(genes$CDSSTART[has_cds], genes$CDSEND[has_cds]),
                      strand = genes$TXSTRAND[has_cds], txid = genes$TXID[has_cds])
    #cds_gr <- GRanges(seqnames(target)[1], 
    #                 IRanges(strts, ends),
    #                 strand = genes$TXSTRAND, txid = genes$TXID)
 
    txid <- as.character(unique(genes$TXID))
    all_rngs <- c(cds_gr, gene_gr)
  

    # Get UTRs matching each transcript
    all_sections <- lapply(txid, function(tid) {
        exons <- disjoin(all_rngs[all_rngs$txid == tid]) 
        exons$type <- "exon"
        utr <- ! exons %in% cds_gr
        if (any(utr)) exons[utr]$type <- "utr"
        exons
    })

    gene_spans <- do.call(c,unname(lapply(all_sections, range)))
    all_exs <- do.call(c, all_sections)

    all_exs <- data.frame(start = start(all_exs),
                end = end(all_exs),
                ts = rep(1:length(all_sections), lapply(all_sections, length)),
                type = all_exs$type)
  
    colnames(all_exs) <- c("start", "end", "ts", "type")
  
    list("all_exs" = all_exs, "gene_spans" = gene_spans)
} # -----

# annotateGenePlot -----
#'@title Plots and annotates transcripts
#'@description Plots the gene structure, annotates this with the
#'target location
#'@param txdb A GenomicFeatures:TxDb object
#'@param target Location of target (GRanges)
#'@param target.colour Colour of box indicating targt region
#'@param target.size Thickness of box indicating target region
#'@param gene.text.size Size for figure label
#'@param panel.spacing Unit object, margin size
#'@param plot.title A title for the plot.  If no plot.title is supplied,
#'the title is the list of gene ids shown (default).
#'If plot.title == FALSE, the plot will not have a title.
#'@param all.transcripts If  TRUE (default), all transcripts of genes overlapping
#'the target are shown, including transcripts that do not themselves overlap the target.
#'If FALSE, only the transcripts that overlap the target are shown.
#'@return A ggplot2 plot of the transcript structures
annotateGenePlot <- function(txdb, target, target.colour = "red",
                        target.size = 1, gene.text.size = 10,
                        panel.spacing = grid::unit(c(0.1,0.1,0.1,0.1), "lines"),
                        plot.title = NULL, all.transcripts = TRUE){

    genomicfeatures <- requireNamespace("GenomicFeatures")
    stopifnot(isTRUE(genomicfeatures))

    genes <- .getOverlappingGenes(txdb, target, all.transcripts = all.transcripts)
    if ("grob" %in% class(genes)) return(genes)

    result <- .makeGeneSegments(genes, txdb, target)
    all_exs <- result$all_exs
    gene_spans <- result$gene_spans

    min_st <- min(all_exs$start)
    max_end <- max(all_exs$end)

    tcks <- unname(quantile(min_st:max_end, seq(1,100, by = 2)*0.01))
    tcks <- lapply(as(gene_spans, "GRangesList"), function(sp){
      tcks[tcks > start(sp) & tcks < end(sp)]
    })

    tck_lns <- lapply(tcks, length)
    tcks <- data.frame("tloc" = unlist(tcks),
                       "ys" = rep(1:length(tcks), lapply(tcks, length)))
    lns <- data.frame(tloc = c(start(gene_spans),end(gene_spans)),
                      ys = rep(seq_along(gene_spans),2))

    all_exs$ymax <- all_exs$ts + 0.3
    all_exs$ymin <- all_exs$ts - 0.3
    is_utr <- all_exs$type == "utr"
    all_exs$ymax[is_utr] <- all_exs$ts[is_utr] + 0.2
    all_exs$ymin[is_utr] <- all_exs$ts[is_utr] - 0.2

    target_df <- data.frame(xmin = start(target), xmax = end(target),
                            ymin = 0, ymax = ceiling(max(all_exs$ymax)))

    if (is.null(plot.title)){ plot.title <- paste(unique(genes$GENEID), sep = ";")}

    # Choose either right or left pointing arrows for the transcript plots
    #strands <- unlist(lapply(all_sections, function(x) as.character(strand(x[1]))))

    strands <- rep(as.character(strand(gene_spans)), tck_lns)
    strands[strands == "-"] <- 60
    strands[strands == "+"] <- 62
    tcks$shp <- as.integer(strands)

    p <- ggplot2::ggplot(tcks) +
      geom_point(aes_(x = quote(tloc), y = quote(ys), group = quote(ys),
                       shape = quote(shp)), size = 2) +
      geom_line(data = lns, aes_(x = quote(tloc), y = quote(ys),
                                  group = quote(ys))) +
      scale_shape_identity()

    p <- p + geom_rect(data = all_exs, fill = "black", color = "black",
                       aes_(xmin = quote(start), xmax = quote(end),
                             ymin = quote(ymin), ymax = quote(ymax)))

    p <- p + geom_rect(data = target_df,
                       aes_(xmin = quote(xmin), xmax = quote(xmax),
                             ymin = quote(ymin), ymax = quote(ymax)),
                       colour = target.colour, fill = NA, size = target.size)

    if (! isFALSE(plot.title)){
      p <- p + ggtitle(plot.title)
    }
    p <- p + theme_minimal() +
         theme(axis.text.x = element_text(size = gene.text.size),
            axis.text.y = element_blank(),
            panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            plot.background = element_rect(fill = "white", colour=  NA),
            panel.background = element_rect(fill = "white", colour = NA),
            panel.spacing = panel.spacing,
            text = element_text(size = gene.text.size),
            axis.ticks.y = element_blank()) +
         ylab(NULL) + xlab(NULL)

    return(p)
} # -----

context("Test annotation and plotting of targets to genes")

suppressPackageStartupMessages(library(GenomicFeatures))
data(gol_clutch1)

txdb_fname <- system.file("extdata", "Danio_rerio.Zv9.73.gol.sqlite",
                   package = "CrispRVariants")
txdb <- loadDb(txdb_fname)

genes <- CrispRVariants:::.getOverlappingGenes(txdb, gol$target, TRUE)
result <- CrispRVariants:::.makeGeneSegments(genes, txdb, gol$target)
all_exons <- result$all_exs

x <- CrispRVariants:::annotateGenePlot(txdb, gol$target)
y <- CrispRVariants:::annotateGenePlot(txdb, 
                             GenomicRanges::GRanges("18", IRanges(1,10)))

test_that("UTR coordinates for gol are corrrect", {
  expect_equal(all_exons[all_exons$type == "utr","start"], 4644226)
  expect_equal(all_exons[all_exons$type == "utr","end"], 4644285)
})


test_that("Annotate gene plot produces a ggplot if genes match",{
  expect_equal(any(class(x) == "ggplot"), TRUE)
  expect_equal(any(class(x) == "grob"), FALSE)
})


test_that("Annotate gene plot produces an empty grob if no genes match",{
  expect_equal(any(class(y) == "ggplot"), FALSE)
  expect_equal(any(class(y) == "grob"), TRUE)
})

# plotAlignments generic -----
#'@title Plot alignments with respect to a reference sequence
#'@rdname plotAlignments
#'@param obj The object to be plotted
#'@param ... Additional arguments
#'@return A ggplot2 figure
#'@seealso \code{\link{seqsToAln}}, \code{\link[ggplot2]{ggplot}}
#'@author Helen Lindsay
#'@export
setGeneric("plotAlignments", function(obj, ...) {
  standardGeneric("plotAlignments")})
# -----

# plotAlignments CrisprSet -----
#'@rdname plotAlignments
#'@description (signature("CrisprSet")) Wrapper for CrisprSet$plotVariants.
#'Optionally filters a CrisprSet frequency table, then plots variants.
#'More information in \code{\link[CrispRVariants]{CrisprSet}}
#'@param min.freq i (%) only plot variants with frequency >= i% in at least
#' one sample (default: 0, i.e no frequency cutoff)
#'@param min.count i (integer) only plot variants with count >= i in at least
#' one sample (default: 0, i.e no count cutoff)
#'@param top.n (integer) Plot only the n most frequent variants
#' (default: 50)
#'@param renumbered If TRUE, the x-axis is numbered with respect to the target
#' (default: TRUE)
#'@param add.other Add a blank row labelled "Other" to the plot, for combining
#'with plotFreqHeatmap (default: TRUE (signature "CrisprSet") FALSE (signature "matrix"))
#'@param create.plot Should the data be plotted?  If false, returns the data used
#'for plotting (Default: TRUE) 
#'@examples
#'#Load a CrisprSet object and plot
#'data("gol_clutch1")
#'plotAlignments(gol)
setMethod("plotAlignments", signature("CrisprSet"),
          function(obj, ..., min.freq = 0, min.count = 1,
                   top.n = 50, renumbered = obj$pars[["renumbered"]],
                   add.other = TRUE, create.plot = TRUE) {

            plot_obj <- obj$plotVariants(min.freq = min.freq,
                                         min.count = min.count,
                                         top.n = top.n,
                                         renumbered = renumbered,
                                         add.other = add.other,
                                         create.plot = create.plot, ...)

            return(plot_obj)
          }) # -----


# plotAlignments character -----
#'@title Plots pairwise alignments
#'@description (signature("DNAString"))  Plots a set of pairwise alignments to a reference sequence.
#'Alignments should all be the same length as the reference sequences.
#'This is achieved by removing insertions with respect to the reference,
#'see \code{\link[CrispRVariants]{seqsToAln}}.
#'Insertions are indicated by symbols in the plot and a table showing the
#'inserted sequences below the plot.  The default options are intended for a
#'figure 6-8 inches wide, with figure height best chosen according to the number
#'of different variants and insertions to be displayed.
#'@param alns A named character vector of aligned sequences, with insertions removed
#'@param ins.sites A table of insertion_sites, which must include cols
#'named "start", "cigar", "seq" and "count" for the start of the insertion in the
#'corresponding sequence
#'@param highlight.pam should location of PAM with respect to the target site be
#'indicated by a box? (Default: TRUE)  If TRUE, and pam.start and pam.end are not
#'supplied, PAM is inferred from target.loc
#'@param show.plot  Should the plot be displayed (TRUE) or just returned as
#'a ggplot object (FALSE).  (Default: FALSE)
#'@param target.loc The location of the zero point / cleavage location.  Base n, where
#'the zero point is between bases n and n+1
#'@param pam.start  The first location of the PAM with respect to the reference.
#'@param pam.end    The last location of the PAM with respect to the reference.
#'Default is two bases after the pam.start
#'@param ins.size   The size of the symbols representing insertions within the plot.
#'@param legend.cols  The number of columns in the legend.  (Default:3)
#'@param xlab   A title for the x-axis (Default: NULL)
#'@param xtick.labs Labels for the x-axis ticks (Default: NULL)
#'@param xtick.breaks Locations for x-axis tick breaks (Default: NULL)
#'@param plot.text.size The size of the text inside the plot
#'@param axis.text.size The size of the axis labels
#'@param legend.text.size The size of the legend labels
#'@param highlight.guide  Should the guide be indicated by a box in
#'the reference sequence?  (Default: TRUE)
#'@param guide.loc  The location of the guide region to be highlighted,
#' as an IRanges object. Will be inferred from target.loc if
#' highlight.guide = TRUE and no guide.loc is supplied, assuming the guide
#' plus PAM is 23bp (Default: NULL)
#'@param tile.height  The height of the tiles within the plot. (Default: 0.55)
#'@param max.insertion.size  The maximum length of an insertion to be shown in the
#'legend.  If max.insertion.size = n, an insertion of length m > n will
#'be annotated as "mI" in the figure.  (Default: 20)
#'@param min.insertion.freq  Display inserted sequences with frequency at least x
#'amongst the sequences with an insertion of this size and length (Default: 5)
#'@param line.weight  The line thickness for the vertical line indicating the
#'zero point (cleavage site) and the boxes for the guide and PAM.  (Default: 1)
#'@param legend.symbol.size The size of the symbols indicating insertions
#'in the legend.  (Default: ins.size)
#'@param codon.frame Codon position of the leftmost nucleotide.  If provided,
#'codon positions in the specified frame are indicated. (Default: NULL)
#'@param style One of "all" (colour all tiles) and "mismatches" (colour
#'only mismatch positions)
#'@rdname plotAlignments
setMethod("plotAlignments", signature("character"),
  function(obj, ..., alns, ins.sites, highlight.pam = TRUE, show.plot = FALSE,
           target.loc = 17, pam.start = NA, pam.end = NA,
           ins.size = 2, legend.cols = 3, xlab = NULL, xtick.labs = NULL,
           xtick.breaks = NULL, plot.text.size = 2, axis.text.size = 8,
           legend.text.size = 6, highlight.guide=TRUE, guide.loc = NULL,
           tile.height = 0.55, max.insertion.size = 20, min.insertion.freq = 5,
           line.weight = 1, legend.symbol.size = ins.size, add.other = FALSE,
           codon.frame = NULL, style = c("all", "mismatches")){


  # Insertion locations are determined by matching ins.sites$cigar with names(alns)
  ref <- obj
  plot_style <- match.arg(style)
  colour_tiles <- ifelse(plot_style == "all", 
                         setDNATileColours,
                         setMismatchTileColours)
  m <- transformAlnsToLong(ref, alns, add.other = add.other)
  m <- colour_tiles(m)
  nms <- m$Var1[1:(length(alns) + 1)]

  p <- makeAlignmentTilePlot(m, ref = ref, xlab = xlab,
          plot.text.size = plot.text.size, axis.text.size = axis.text.size,
          xtick.labs = xtick.labs, xtick.breaks = xtick.breaks,
          tile.height = tile.height)

  # Vertical lines for guide and codon.frame
  if (! is.null(codon.frame)){
    p <- addCodonFrame(p, nchar(ref), codon.frame)    
  }
  
  if (! is.null(target.loc)){
    p <- p + geom_vline(xintercept = target.loc + 0.5,
                        colour = "black", size = line.weight)
  }
  
  # Colours and shapes for the insertion markers and tiles
  shps <- c(21,23,25)
  clrs <- c("#E69F00","#56B4E9","#009E73","#F0E442","#0072B2","#D55E00",
            "#CC79A7","#332288","#88CCEE","#44AA99","#117733","#999933",
            "#DDCC77","#661100","#CC6677","#882255", "#AA4499")

  # Should a blank line be added to the bottom of the plot for "Other"?
  top_row <- ifelse(add.other, length(nms) + 1, length(nms))

  # Add the guide box
  if (isTRUE(highlight.guide)){
    ymin = top_row - (tile.height / 2 + 0.25)
    ymax = top_row + (tile.height / 2 + 0.25)

    if (is.null(guide.loc) & ! is.null(target.loc)){
      xmin <- max(target.loc - 16.5, 0.5)
      xmax <- min(xmin + 23, nchar(obj) + 0.5)
    } else {
      xmin <- start(guide.loc) - 0.5
      xmax <- end(guide.loc) + 0.5
    }

    guide_df <- data.frame(xmin = xmin, xmax = xmax, ymin = ymin, ymax = ymax)
    p <- p + geom_rect(data = guide_df,
                       aes_(xmin = quote(xmin), xmax = quote(xmax),
                             ymin = quote(ymin), ymax = quote(ymax),
                             color = "black"),
                       size = line.weight, fill = "transparent")
  }

  # If pam_loc is given, highlight the pam in the reference
  #  - 0.5 for tile boundaries not centres
  if (isTRUE(highlight.pam)){
    if (! anyNA(pam.start)){
      if (anyNA(pam.end)){
        pam.end <- pam.start + 2
      }
    } else {
      if (is.na(target.loc)) { break }
      # Infer from the target location
      pam.start <- target.loc + 4
      pam.end <- target.loc + 6
    }

    pam_df <- data.frame(xmin = pam.start - 0.5, xmax = pam.end + 0.5,
                         ymin = top_row - (tile.height / 2 + 0.2),
                         ymax = top_row + (tile.height / 2 + 0.2))
    p <- p + geom_rect(data=pam_df,
                       aes_(xmin = quote(xmin), xmax = quote(xmax),
                             ymin = quote(ymin), ymax = quote(ymax)),
                       color = "black", size = line.weight, fill = "transparent")

  }
 
  # Make a data frame of insertion locations
  # Remove insertions that are being ignored
  if (nrow(ins.sites) > 1){
    ins.sites <- ins.sites[!is.na(ins.sites$start), , drop = FALSE]
    ins_ord <- match(ins.sites$cigar, nms)
  } else { ins_ord <- vector() }
    
  if (nrow(ins.sites) > 0 & length(na.omit(ins_ord)) > 0){
    ins_points <- data.frame(x = ins.sites[!is.na(ins_ord),"start"] - 0.5,
                             y = na.omit(ins_ord) + 0.45,
                             seq = ins.sites[!is.na(ins_ord),"seq"],
                    count = as.integer(ins.sites[!is.na(ins_ord),"count"]))

    # Aggregate identical insertions across samples
    ins_points <- aggregate(ins_points$count,
                            by = as.list(ins_points[,c(1:3)]), FUN = sum)
    colnames(ins_points) <- c("x","y","seq", "count")

    ## Merge multiple insertions at single plotting location, format to fixed width
    xy_locs <- paste(ins_points$x, ins_points$y, sep = "_")
  
    # Remove low frequency alleles
    temp <- rowsum(ins_points$count, xy_locs)
    totals <- as.vector(temp)
    names(totals) <- rownames(temp)
  
    temp <- ! duplicated(xy_locs)
    wdths <- nchar(as.character(ins_points[temp, "seq"]))
    
    omit <- (ins_points$count/totals[xy_locs])*100 < min.insertion.freq
    ins_points[omit,"seq"] <- NA

    names(wdths) <- xy_locs[temp]
    splits <- split(ins_points$seq, xy_locs)
    
    # Collapse sequences longer than max.insertion.size
    x <- lapply(seq_along(splits), function(i){
      result <- as.character(na.omit(splits[[i]]))
      wdth <- wdths[[names(splits)[i]]]
      
      if (length(result) != 1){
        # If there are multiple sequences
        if (wdth > max.insertion.size | length(result) == 0){
          result <- sprintf("%sI (%s common alleles)", wdth, length(result))
        } else {  
          # Collapse, one sequence per line
          result <- paste(result, collapse = ",\n")
        }
      } else {
          # If only one sequence
          if (wdth > max.insertion.size) result <- sprintf("%sI", wdth)
      }
      result
    })
    names(x) <- names(splits)

    # Make all sequences same length for better legend placement
    new_seqs <- unlist(x)[unique(xy_locs)]
    max_seq_ln <- max(sapply(gsub("\n.*", "", new_seqs), nchar)) + 3
    new_seqs <- sprintf(paste0("%-",max_seq_ln,"s"), new_seqs)
    
    ins_points <- ins_points[!duplicated(ins_points[,c("x","y")]),]
    ins_points$seq <- new_seqs
    
    # Specify colours and shapes for insertion symbols
    sq_f <- factor(ins_points$seq, levels = unique(ins_points$seq))
    temp <- seq_len(nrow(ins_points))[sq_f]
    ins_points$shapes <- as.factor(temp)
    nins <- max(temp)
    fill_clrs <- rep(clrs, length.out = nins)#[temp]
    ins_points$colours <- as.factor(fill_clrs[temp])
    fill_shps <- rep(shps, length.out = nins)

    #legend_nrow <- ceiling(nrow(ins_points)/ legend.cols)
    legend_nrow <- ceiling(nins / legend.cols)
    
    # Indicate insertions
    p <- p + geom_point(data = ins_points,
                        aes_(x = quote(x), y = quote(y),
                              shape = quote(shapes), fill = quote(colours)),
                        colour = "#000000", size = ins.size)  +
      scale_fill_identity() +
      scale_shape_manual(name = "", values = fill_shps, breaks = ins_points$shapes,
                         labels = ins_points$seq) +
      guides(shape = guide_legend(nrow = legend_nrow,
                            override.aes = list(fill = fill_clrs,
                                                size = legend.symbol.size)))
    p <- p + theme(legend.key = element_blank(),
                   legend.text = element_text(size = legend.text.size),
                   legend.spacing = grid::unit(0.2,"cm"))

  } else{
    p <- p + scale_fill_identity()
  }

  if (isTRUE(show.plot)){
    print(p)
  }
  p
}) # -----


# plotAlignments DNAString -----
#'@rdname plotAlignments
setMethod("plotAlignments", signature("DNAString"),
    function(obj, ..., alns, ins.sites, highlight.pam = TRUE, show.plot = FALSE,
           target.loc = 17, pam.start = NA, pam.end = NA,
           ins.size = 2, legend.cols = 3, xlab = NULL, xtick.labs = NULL,
           xtick.breaks = NULL, plot.text.size = 2, axis.text.size = 8,
           legend.text.size = 6, highlight.guide=TRUE, guide.loc = NULL,
           tile.height = 0.55, max.insertion.size = 20, min.insertion.freq = 5,
           line.weight = 1, legend.symbol.size = ins.size, add.other = FALSE,
           codon.frame = NULL){

    plotAlignments(as.character(obj), alns = alns, ins.sites = ins.sites,
           highlight.pam = highlight.pam, show.plot = show.plot,
           target.loc = target.loc, pam.start = pam.start, pam.end = pam.end,
           ins.size = ins.size, legend.cols = legend.cols, xlab = xlab,
           xtick.labs = xtick.labs, xtick.breaks = xtick.breaks,
           plot.text.size = plot.text.size, axis.text.size = axis.text.size,
           legend.text.size = legend.text.size,
           highlight.guide = highlight.guide, guide.loc = guide.loc,
           tile.height = tile.height, max.insertion.size = max.insertion.size,
           min.insertion.freq = min.insertion.freq, line.weight = line.weight,
           legend.symbol.size = legend.symbol.size, add.other = add.other,
           codon.frame = codon.frame, ...)

}) # -----


# addCodonFrame -----
#'@title Internal CrispRVariants function for indicating codon frame on an
#'alignment tile plot 
#'@description Adds vertical dotted lines in intervals of three nucleotides.
#'Codon frame is supplied, alignments are assumed not to span an intron-exon
#'junction. 
#'@param p A ggplot object, typically from CrispRVariants:::makeAlignmentTilePlot
#'@param width The number of nucleotides in the alignments  
#'@param codon.frame The leftmost starting location of the next codon - 1,2,or 3 
#'@return A ggplot object with added vertical lines indicating the frame
#'@author Helen Lindsay
addCodonFrame <- function(p, width, codon.frame){
    stopifnot(codon.frame %in% c(1,2,3))     
    p <- p + theme(panel.grid = element_blank()) 
    codon_locs <- seq(codon.frame, width, by = 3)  
    p <- p + geom_vline(xintercept = codon_locs - 0.5, 
               linetype = "dotted", color = "lightslategray", size = 0.7)
    p
} # -----


# transformAlnsToLong -----
#'@title Transform data for plotting
#'@description Orders and transforms a reference sequence and a set of aligned sequences
#'into long format, i.e. one observation (tile position) per row.  Used internally by
#'\code{\link[CrispRVariants]{plotAlignments}}.
#'@param ref The reference sequence
#'@param alns Character vector of aligned sequences
#'@param add.other Add a blank row labelled "Other" (Default: FALSE)
#'@return A matrix of characters and plotting locations
#'@author Helen Lindsay
transformAlnsToLong <- function(ref, alns, add.other = FALSE){
  # Reverse alignment order, as ggplot geom_tile plots bottom up
  aln_chrs <- strsplit(c(rev(alns), Reference = as.character(ref)), "")

  # Test that all alignments and reference have the same length
  if (! length(unique(lapply(aln_chrs, length))) == 1){
    stop("The reference sequence and the alignments must all have the same length")
  }
  
  # Add a blank row which will get white tiles
  if (isTRUE(add.other)){
    aln_chrs <- c(list(rep("",length(aln_chrs[[1]]))), aln_chrs)
    names(aln_chrs)[[1]] <- "Other"
  }

  temp <- t(as.data.frame(aln_chrs))
  rownames(temp) <- names(aln_chrs)
  m <- reshape2::melt(temp)

  m
} # -----


# .getDNAColours -----
.getDNAColours <- function(x){
    ambig_codes <- c('K','M','R','Y','S','W','B','V','H','D')
    dna_chrs <- c(c("A", "C", "T", "G", "N", "-", ""),
                  ambig_codes, c(">","<"))
    extra <- setdiff(x, dna_chrs)
    
    cols <- c(c("#4daf4a", "#377eb8", "#e41a1c", "#000000", "#CCCCCC",
                  "#FFFFFF", "#FFFFFF"), 
                rep("#CCCCCC", length(ambig_codes) + 2),
                rep("#FFFFFF", length(extra)))
    names(cols) <- c(dna_chrs, extra)
    cols
} # -----


# setDNATileColours -----
#'@title Sets colours for plotting aligned DNA sequences.
#'@description Sets tile colours for \code{\link[CrispRVariants]{plotAlignments}} with a
#'DNA alphabet
#'@param m A matrix with a column named "value" of the characters at each tile position.
#'@return A matrix with additional columns specifying tile and text colours
#'@author Helen Lindsay
setDNATileColours <- function(m){
  m$value <- as.character(m$value)
  #m$value <- factor(m$value, levels = c(dna_chrs, extra))
  m$isref <- as.character(ifelse(m$Var1 == "Reference", 1, 0.75))
  m_cols <- .getDNAColours(m$value) 
  m$cols <- m_cols[m$value]
  m$text_cols <- ifelse(m$cols == "#000000" & m$isref == 1, "#FFFFFF", "#000000")
  return(m)
} # -----


# setMismatchTileColours -----
#'@title Sets colours for plotting mismatches in aligned DNA sequences.
#'@description Sets tile colours for \code{\link[CrispRVariants]{plotAlignments}} with a
#'DNA alphabet.
#'@param m A data frame of nucleotides and plotting locations, e.g. created
#'by \code{\link[CrispRVariants]{transformAlnsToLong}}
#'@return A matrix with additional columns specifying tile and text colours
#'@author Helen Lindsay
setMismatchTileColours <- function(m){
    m$isref <- m$Var1 == "Reference"
    mref <- m[m$isref,]
    m$ref <- mref[match(m$Var2, mref$Var2), "value"]
    m$cols <- "#FFFFFF"
    dna_cols <- .getDNAColours(m$value)
    # Use the IUPAC map as only nucleotide mismatches should be coloured
    is_mm <- m$value %in% names(Biostrings::IUPAC_CODE_MAP) & !(m$value == m$ref)
    m$value <- as.character(m$value)
    m$cols[is_mm] <- dna_cols[m$value[is_mm]]
    # Highlight the gaps in light gray as they aren't visible otherwise
    m$cols[m$value == "-"] <- "#A0A0A0" 
    m$cols[m$Var1 == "Reference"] <- dna_cols[m[m$Var1 == "Reference", "value"]]
    m$text_cols <- ifelse(m$cols == "#000000" & m$isref == 1, "#FFFFFF", "#000000")
    m$ref <- NULL
    return(m)
} # -----


# makeAlignmentTilePlot -----
#'@title Internal CrispRVariants function for creating the plotAlignments background
#'@description Takes a matrix of characters, x and y locations and colours, creates
#'a ggplot geom_tile plot with tiles labelled by the characters.
#'@param m A matrix with column headings Var1: y location, Var2: x location, 
#'cols: tile fill colour, isref: transparency value text_cols: text colour
#'@param ref  The reference sequence, only used for checking the number of
#'x-tick labels when x-tick breaks are not supplied 
#'@param xlab Label for the x axis
#'@param plot.text.size Size for text within plot
#'@param axis.text.size Size for text on axes
#'@param xtick.labs x axis labels
#'@param xtick.breaks Locations of x labels
#'@param tile.height Controls whitespace between tiles
#'@return A ggplot object
#'@author Helen Lindsay
makeAlignmentTilePlot <- function(m, ref, xlab, plot.text.size, axis.text.size,
                                  xtick.labs, xtick.breaks, tile.height){
    alpha_v <- c(0.5,1)
    # Change alpha values if only plotting the reference
    if (length(unique(m$Var1)) == 1) alpha_v <- 1
    # Plot aligned sequences
    p <- ggplot(m) +
      geom_tile(aes_(x = quote(Var2), y = quote(Var1),
                      fill = quote(cols), alpha = quote(isref),
                      height = tile.height)) +
      geom_text(aes_(x = quote(Var2), y = quote(Var1),
                      label = quote(value), colour = quote(text_cols)),
                      size = plot.text.size) +
      scale_alpha_manual(values = alpha_v, guide = "none") +
      ylab(NULL) + xlab(xlab) + scale_colour_identity() +
      theme_bw() + theme(axis.text.y = element_text(size = axis.text.size),
                         axis.text.x = element_text(size = axis.text.size),
                         axis.title.x = element_text(vjust = -0.5),
                         legend.position = "bottom")

    if (is.null(xtick.labs)){
      # expand is the distance from the axis, multiplicative + additive
      p <- p + scale_x_continuous(expand = c(0,0.25))
    } else {
      if (is.null(xtick.breaks)) {
        stopifnot(length(xtick.labs == nchar(ref)))
        p <- p + scale_x_continuous(expand = c(0,0.25), breaks = 1:nchar(ref),
                                    labels = xtick.labs)
      } else {
        p <- p + scale_x_continuous(expand = c(0,0.25), breaks = xtick.breaks,
                                    labels = xtick.labs)
      }

    }
    return(p)
} # -----

#__________________________________________________________________
# Input checks used during initialisation
#__________________________________________________________________
.checkReadsToTarget <- function(target, reference, target.loc,
                                reverse.complement, orientation,
                                chimeras){
  
  if (! class(target.loc) %in% c("numeric", "integer", "NULL")){
    stop("target.loc should be a single integer")
  }
  
  # Check lengths match
  
  ln_msg <- "readsToTarget accepts a single %s, as a%s object.\n"
  ln_msg2 <- "Use readsToTargets for processing multiple targets at once"
  if (length(target) > 1){
    stop(sprintf(ln_msg, "target", " GRanges"), ln_msg2)
  }
  if (! class(reference) %in% c("DNAString", "NULL")){
    if (length(reference) != 1){
      stop(sprintf(ln_msg, "reference sequence", " DNAString"), ln_msg2)
    }
  }  
  
  if (length(target.loc) > 1){
    stop(sprintf(ln_msg, "target.loc", "n integer"))
  }
  
  if (! is.null(reference)){
    # readsToTarget signature GAlignments does not take a reference
    if (! width(target) == nchar(reference)){
      stop("The width of the target should equal the ",
           "number of characters in the reference sequence")
    }  
  }
  
  # Warn if target.loc is larger than width of target
  if (! is.null(target.loc)){
    if (target.loc > width(target)){
      warning(sprintf("target.loc (%s) > target width (%s).", 
                      target.loc, width(target)),
              "Is this intentional?")
    }
  }
  
  # Check reverse.complement and target are compatible
  if (reverse.complement == FALSE & orientation == "target"){
    warning(paste0("Conflicting choice of 'reverse.complement'",
                   " and 'orientation'.\nOrienting to the target",
                   " strand.\nSpecify 'orientation' for additional",
                   " options."))
  }
  
  if (is.character(chimeras)){
    # Chimeras can either be a GAlignments object or a tag
    # indicating how they are to be treated
    if (chimeras == "merge"){
      message(paste0("Caution: mergeChimeras assumes a sorted bam file\n",
                     "and has only been tested with bwa mem alignments!\n"))
    }
  }
}

.checkFnamesExist <- function(reads){
  if (! all(file.exists(reads))){
    stop("reads should be a vector of file names. ",
         "No file found matching some entries in reads")
  }
}

.checkReadsToTargets <- function(targets, primer.ranges, references){
  if (length(primer.ranges) > 0 & length(primer.ranges) != length(targets)){
    stop("primer.ranges should be the amplified regions, one per target")
  }
  if (length(targets) != length(references)){
    stop("A reference sequence for each target must be provided")
  }
  TRUE
}

.checkForPaired <- function(bams){
  is_first <- function(bams){ bitwAnd(mcols(bams)$flag, 64) }
  if ("flag" %in% names(mcols(bams))){
    if (any(is_first(bams))){
      warning("collapse.pairs set to FALSE but flags indicate paired reads",
              immediate. = TRUE)
      return(FALSE)
    }
  }
  TRUE
} 

context("Text access of attributes from CrisprSet objects")

data("gol_clutch1")

test_that("consensusSeqs returns the correct sequence", {
    expected <- Biostrings::DNAString("GTCTTGGTCTCTCGCAGGATGCTGGAGCCA")
    alleles <- consensusSeqs(gol)
    expect_true(alleles[["-3:3D"]] == expected)
    expect_true(identical(rownames(gol$cigar_freqs), names(alleles)))
})

context("Testing recreation of reference from alignments")

sq_ln <- c(500)
names(sq_ln) <- "1"

alns <- GenomicAlignments::GAlignments(seqnames=rep("1",6),
                                       pos=as.integer(seq(1,30,5)),
    cigar=c("10M1I11M", "9M1I10M", "10M1D5M", "3M1I7M1D9M", "2M3I2M3I2M","5M1I3M"),
    strand = S4Vectors::Rle(factor(rep("+", 6), levels = c("+","-","*"))),
    seqlengths = sq_ln,
    MD = c("22", "5A4A8", "10^A5", "A1A1A2A1A^A3A2AA1", "AA1A2", "7A"),
    seq = Biostrings::DNAStringSet(c("AAAAAAAAAATAAAAAAAAAAA",
                                     "AAAAATAAACAGAAAAAAAA",
                                     "AAAAAAAAAAAAAAA",
                                     "CAGTAGAACACAAATAAGGA",
                                     "TTCCCAGCCCAA",
                                     "AAAAAGAAT"))
)


test_that("Recreation of reference when location not provided", {
    lf <- Biostrings::letterFrequency(refFromAlns(alns), letters = c("A"), as.prob = TRUE)
    expect_equal(unname(unique(lf)[,"A"]), 1)
})


test_that("Recreation of reference when location provided", {
    test_loc <- GenomicRanges::GRanges("1", IRanges::IRanges(10,15))
    test_outside_loc <- GenomicRanges::GRanges("1", IRanges::IRanges(30,40))
    expect_equal(refFromAlns(alns, location = test_loc), Biostrings::DNAString("AAAAAA"))
    expect_error(refFromAlns(alns, location = test_outside_loc))
})

context("Test alignment plot")

# Setup data for testing plotAlignments -----
data("gol_clutch1")

ref_only <- plotAlignments(Biostrings::DNAString("AACCTTGG"), alns = NULL,
                  ins.sites = data.frame())

crispr_plot <- plotAlignments(gol)
# -----

test_that("plotAlignments returns a ggplot object", {
    # plotAlignments should produce a ggplot that has layers
    expect_is(ref_only, "ggplot")
    expect_true(nrow(ref_only$data) > 0)
    
    # The same should be true when plotAlignments is called with a CrisprSet
    expect_is(crispr_plot, "ggplot")
    expect_true(nrow(crispr_plot$data) > 0)
    
    # Original sequence should be present
    expect_identical(as.character(ref_only$data$value), 
                     strsplit("AACCTTGG", "")[[1]])
})

context("Narrowing alignments to a target region")

# Setup data
cigars <- c("5M5D20M","10M10D20M","5M10D20M","5M20D10M","1M3I2M3I3M10D10M",
            "10M5I30M", "15M2D20M", "5M", "12M5I15M", "12M9I10M", "3M6D15M",
            "4S3M1I6M4D8M")
wdths <- GenomicAlignments::cigarWidthAlongPairwiseSpace(cigars)
gr <- GenomicRanges::GRanges("chr1", IRanges(start = 1, width = wdths), 
                             cigar = cigars, strand = "+")
galns <- as(gr, "GAlignments")
target <- GenomicRanges::GRanges("chr1", IRanges(11, 20))
expected <- c("10M", "10D", "10D5M", "20D", "10D4M", "10M", 
              "5M2D3M", "2M5I8M","2M9I8M","10M", "4D7M")
narrowed <- narrowAlignments(galns, target)


# Test 1
test_that("narrowAlignments correctly narrows to the nearest operation",{
  expect_equal(cigar(narrowed), expected)
})


# Test 2
quals <- Biostrings::DNAStringSet(sapply(wdths, function(x){
  paste0(rep("H",x), collapse = "")})) 
mcols(galns)$qual <- quals

test_that("narrowAlignments with qual but no seq produces an error",{
  expect_error(narrowAlignments(galns, target))
})


# Test 3
seqs <- Biostrings::DNAStringSet(sapply(wdths, function(x) paste0(rep("A",x), collapse = ""))) 
mcols(galns)$seq <- seqs
narrowed <- narrowAlignments(galns, target)

test_that("narrowAlignments narrows quality scores",{
  expect_equal(width(mcols(narrowed)$qual), width(mcols(narrowed)$seq))
})


# Test 4
mcols(galns)$dat <- seq_along(galns)
test_that("narrowAlignments preserves metadata",{
  expect_equal(length(mcols(narrowAlignments(galns, target))), 3)
})

---
title: "CrispRVariants User Guide"
author: "Helen Lindsay, Mark Robinson"
output: 
  BiocStyle::html_document:
    fig_caption: true
package: "CrispRVariants"
vignette: >
  %\VignetteIndexEntry{CrispRVariants}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

<!-- can build with:
rmarkdown::render("user_guide.Rmd", rmarkdown::pdf_document())
Bams created running from extdata dir
If running all sections remove fastqs with
unlink("fastq/*")
-->



# Introduction

The CRISPR-Cas9 system is an efficient method of introducing mutations into 
genomic DNA. A guide RNA directs nuclease activity to an approximately 20
nucleotide target region, resulting in efficient mutagenesis.  Repair of
the cleaved DNA can introduce insertions and deletions centred around the
cleavage site.  Once the target sequence is mutated, the guide RNA will no
longer bind and the DNA will not be cleaved again.  SNPs within the target
region, depending on their location, may also disrupt cleavage.  The
efficiency of a CRISPR-Cas9 experiment is typically measured by amplifying
and sequencing the region surrounding the target sequence, then counting the
number of sequenced reads that have insertions and deletions at the target
site.  The **CrispRVariants** package formalizes this process and takes
care of various details of managing and manipulating data for such confirmatory
and exploratory experiments.

This guide shows an example illustrating how raw data is preprocessed and
mapped and how mutation information is extracted relative to the reference
sequence. The package comprehensively summarizes and plots the spectrum of
variants introduced by CRISPR-Cas9 or similar genome editing experiments.

# Quickstart

This section is intended for people familiar with mapping reads and working
with core Bioconductor classes.  See the case study in the next section 
for a complete step-by-step analysis.

The ```CrisprSet``` class stores aligned reads which have been trimmed to a target
region along with annotations of where insertion and deletions are located
with respect to a specified location.  ```CrisprSet``` objects are created
using the functions ```readsToTarget```
(for a single target region) and ```readsToTargets``` (for multiple target
locations). The following objects are needed to create a ```CrisprSet```
for a single guide sequence.  For multiple guides, the equivalent 
parameters to **target** and **reference** are named **targets** and
**references** respectively.

* *reads* - may be a vector of bam filenames, a ```GAlignments``` object
   or a ```GAlignmentsList``` object.  Bam files are assumed to represent
   individual experimental samples (possibly containing reads from more
   than one guide).  If the bam files contain multiplexed
   reads that should be separated into groups, first read the alignments
   into R, separate as required and then provide the separated alignments
   to ```readsToTarget```.  (See package [GenomicAlignments](https://bioconductor.org/packages/release/bioc/html/GenomicAlignments.html)
   for more details about ```GAlignments``` and ```GAlignmentsList``` objects).  
* *target* - A ```GRanges``` object indicating the genomic range to analyse.
  The sequence name and coordinates should match regions found in the bam file(s).
  For ```readsToTarget```, the ```target``` must contain a single range.  The target
  range can be found by searching [BLAST](https://blast.ncbi.nlm.nih.gov/Blast.cgi) or
[BLAT](https://genome.ucsc.edu/FAQ/FAQblat.html) for the guide sequence and extending
  the found range if desired - be careful that the genome used by BLAST matches the 
  genome used for mapping!  Alternatively, the target region
  can be found by mapping the guide sequence to the genome or amplicon reference with a short
  read aligner (we typically use **bwa fastmap**); or if reference sequence
  is not too large by reading the reference sequence into R and using ```gregexpr```
  to search the reference for the guide sequence. (See package [GenomicRanges](http://bioconductor.org/packages/release/bioc/html/GenomicRanges.html)
  for more details about ```GRanges``` objects).  
* *reference* - A ```DNAString``` object, containing the reference sequence at the
  target location.  This can be fetched from the genome using the command line
  tool ```samtools faidx``` or from within R using the Bioconductor package
  ```RSamtools```; fetched from a ```BSgenome``` object using ```Biostrings::getSeq```;
  or reconstructed from a bam file using the CrispRVariants function ```refFromAlns```
  providing the bam file has an MD tag. (See package
  [Biostrings](http://bioconductor.org/packages/release/bioc/html/Biostrings.html)
  for more details about ```DNAString``` objects).
  
*  *target.loc* This is the base that should be considered base zero, with respect
   to the target.  For example, if using a 23 nucleotide guide + PAM sequence as the
   reference, the target.loc would be 17, meaning that bases 17 and 18 are numbered
  -1 and 1 respectively.  If considering the 23bp guide region plus 10 bases on both
  sides, the target.loc would be 27.

Other important ```readsToTarget``` parameters:

*  If the bam file contains **paired end** data, set `collapse.pairs = TRUE` so
   that each read pair is only counted once.
*  By default CrispRVariants is conservative when dealing with **large gaps**, and
  requires one mapped endpoint to be within 5 bases of the target.loc.
  To change this, increase the value of the parameter chimera.to.target, e.g.
  `chimera.to.target = 200`
*  If the parameter **names** is set, the sample names will be used when plotting.
*  If using *readsToTargets*, providing *primer.ranges* (amplicon ranges) as
   well as *targets* will help CrispRVariants disambiguate reads from nearby
   guide sequences.
*  By default, CrispRVariants displays the variant alleles with respect to the
   **strand** of the target.  To change this behaviour, set ``orientation = "positive"``
   to always display with respect to the plus strand or ``orientation = "opposite"``
   to display the opposite strand to the target.
*  Long gaps are typically mapped in separate segments.  These are called
  **chimeric** mappings.  In this release CrispRVariants introduces an
  experimental parameter `chimeras = "merge"`, which reconstructs a linear
  alignment for the simplest case of two aligned regions separated by a large
  gap with at most 10 bases multi-mapped to both segments.  Setting
  `chimeras = "merge"` means that these simple, "long-gap" chimeras can
  be counted and displayed separately from more complex chimeric reads.
  However, be aware that the exact endpoints of the gaps may be ambiguous and
  we do not at present have a method for indicating ambiguous mapping.
*  If considering a **large region**, e.g. the entire amplicon, use the minoverlap
  parameter to set the minimum number of aligned positions overlapping the
  target required for a read to be counted.  For example, `minoverlap = 10`
  means that reads with an aligned range spanning at least 10 bases of the
  target will be counted.
  
Assuming the above parameters are defined, the following code will set up
a CrisprSet object and plot the variants:

```{r, eval = FALSE}
crispr_set <- readsToTarget(reads, target = target, reference = reference,
                            target.loc = target.loc)
plotVariants(crispr_set)
# or use plotVariants(crispr_set, txdb) to additionally show the target
# location with respect to the transcripts if a Transcript Database 
# txdb is available
```


# Case study: Analysis of ptena mutant spectrum in zebrafish

The data used in this case study is from the Mosimann laboratory, UZH.

## Convert AB1-format Sanger sequences to FASTQ

This data set is from 5 separate clutches of fish (1 control - uninjected, 2
injected with strong phenotype, 2 injected with mild phenotype), with injections
from a guide against the *ptena* gene.  For this exercise, the raw data comes as
AB1 (Sanger) format.  To convert AB1 files to FASTQ, we use ab1ToFastq(), which
is a wrapper for functions in the "sangerseqR" package with additional quality 
score trimming.

Although there are many ways to organize such a project, we organize the data
(raw and processed) data into a set of directories, with a directory for each
type of data (e.g., 'ab1' for AB1 files, 'fastq' for FASTQ files, 'bam' for BAM
files, etc.); this can continue with directories for scripts, for figures, and
so on.  With this structure in place, the following code sets up various 
directories.

```{r, message=FALSE, warning=FALSE}
library(CrispRVariants)
library(sangerseqR)

# List AB1 filenames, get sequence names,  make names for the fastq files
# Note that we only include one ab1 file with CrispRVariants because
# of space constraints.  All bam files are included

data_dir <- system.file(package="CrispRVariants", "extdata/ab1/ptena")
fq_dir <- tempdir()
ab1_fnames <- dir(data_dir, "ab1$", recursive=TRUE, full=TRUE)
sq_nms <- gsub(".ab1","",basename(ab1_fnames))

# Replace spaces and slashes in filename with underscores
fq_fnames  <- paste0(gsub("[\ |\\/]", "_", dirname(ab1_fnames)), ".fastq")

# abifToFastq to read AB1 files and write to FASTQ
dummy <- mapply( function(u,v,w) {
        abifToFastq(u,v,file.path(fq_dir,w))
}, sq_nms, ab1_fnames, fq_fnames)
```

We will collect sequences from each embryo into the same FASTQ file.  Note that
abifToFastq *appends* output to existing files where possible.  In this
example, there is only `r length(unique(ab1_fnames))` sequence, which will
be output to `r length(unique(fq_fnames))` file:
 
```{r, message=FALSE, warning = FALSE}
length(unique(ab1_fnames))
length(unique(fq_fnames))
```

Some of the AB1 files may not have a sufficient number of bases after quality
score trimming (default is 20 bases).  In these cases, abifToFastq() issues a
warning (suppressed here).

## Map the FASTQ reads

We use FASTQ format because it is the major format used by most genome alignment
algorithms.  At this stage, the alignment *could* be done outside of R (e.g.,
using command line tools), but below we use R and a call to system() to keep the
whole workflow within R.  Note that this also requires various software tools 
(e.g., **bwa**, **samtools**) to already be installed.

The code below iterates through all the FASTQ files generated above and aligns
them to a pre-indexed genome. 

```{r, message = FALSE, warning=FALSE, eval=FALSE}
library("Rsamtools")

# BWA indices were generated using bwa version 0.7.10
bwa_index <- "GRCHz10.fa.gz"
bam_dir <- system.file(package="CrispRVariants", "extdata/bam")
fq_fnames <- file.path(fq_dir,unique(fq_fnames))
bm_fnames <- gsub(".fastq$",".bam",basename(fq_fnames))
srt_bm_fnames <- file.path(bam_dir, gsub(".bam","_s",bm_fnames))

# Map, sort and index the bam files, remove the unsorted bams
for(i in 1:length(fq_fnames)) {
  cmd <- paste0("bwa mem ", bwa_index, " ", fq_fnames[i],
                " | samtools view -Sb - > ", bm_fnames[i])
  message(cmd, "\n"); system(cmd)
  indexBam(sortBam(bm_fnames[i],srt_bm_fnames[i]))
  unlink(bm_fnames[i])
}
```

See the help for **bwa index** at the [bwa man page](http://bio-bwa.sourceforge.net/bwa.shtml)
and for general details on mapping sequences to a genome reference.

## List the BAM files

To allow easy matching to experimental condition (e.g., useful for colour labeling)
and for subsetting to experiments of interest, we often organize the list of BAM
files together with accompanying metadata in a machine-readable table beforehand.
Here we read the bam filenames from a metadata table which also contains sample
names and experimental grouping information. Note that we could also have used the
bam filenames listed above.

```{r, message=FALSE}
# The metadata and bam files for this experiment are included with CrispRVariants
library("readxl")
md_fname <- system.file(package="CrispRVariants", "extdata/metadata/metadata.xls")
md <- readxl::read_xls(md_fname, 1)
md

# Get the bam filenames from the metadata table
bam_dir <- system.file(package="CrispRVariants", "extdata/bam")
bam_fnames <- file.path(bam_dir, md$bamfile)

# check that all files exist
all( file.exists(bam_fnames) )
```


## Create the target location and reference sequence

Given a set of BAM files with the amplicon sequences of interest mapped to the
reference genome, we need to collect a few additional pieces of information
about the guide sequence and define the area around the guide that we want to
summarize the mutation spectrum over.

The coordinates of the region of interest can be obtained by running
[BLAST](https://blast.ncbi.nlm.nih.gov/Blast.cgi) or
[BLAT](https://genome.ucsc.edu/FAQ/FAQblat.html) on the guide sequence or
by mapping the guide sequence to the reference sequence.  The
coordinates, or "target" should be represented as a **GenomicRanges::GRanges**
object.  This can be created directly, but here we will import the coordinates
of the guide sequence from a BED file using the **rtracklayer** package.
The import() commmand below returns a GRanges object.

```{r, message=FALSE}
library(rtracklayer)
# Represent the guide as a GenomicRanges::GRanges object
gd_fname <- system.file(package="CrispRVariants", "extdata/bed/guide.bed")
gd <- rtracklayer::import(gd_fname)
gd
```

The 23bp (including PAM) *ptena* guide sequence used in this experiment is
located on chromosome `r as.character(seqnames(gd)[1])` from 
`r start(gd)[1]`-`r end(gd)[1]`.  We prefer to analyse a slightly larger
region.  Below, we'll extend the guide region by 5 bases on each side when
counting variants.  Note that the expected cut site (used later for labeling
variants), after extension, isat base 22 with respect to the start of the new
target sequence.

```{r, message=FALSE}
gdl <- GenomicRanges::resize(gd, width(gd) + 10, fix = "center")
```

With the Bioconductor **BSgenome** packages, the reference sequence itself can be
retrieved directly into a DNAStringSet object.  For other genomes, the reference
sequence can be retrieved from a genome by first indexing the genome with samtools
faidx and then fetching the required region (for an alternative method, see the 
note for Windows and Galaxy users below). Here we are using the GRCHz10 zebrafish
genome.  The reference sequence was fetched and saved as follows:

```{r, eval=FALSE}
system("samtools faidx GRCHz10.fa.gz")

reference=system(sprintf("samtools faidx GRCHz10.fa.gz %s:%s-%s",
                         seqnames(gdl)[1], start(gdl)[1], end(gdl)[1]),
                 intern = TRUE)[[2]]

# The guide is on the negative strand, so the reference needs to be reverse complemented
reference=Biostrings::reverseComplement(Biostrings::DNAString(reference))
save(reference, file = "ptena_GRCHz10_ref.rda")
```

We'll load the previously saved reference sequence.

```{r}
ref_fname <- system.file(package="CrispRVariants", "extdata/ptena_GRCHz10_ref.rda")
load(ref_fname)
reference
```

Note the NGG sequence (here, TGG) is present with the 5 extra bases on the end.

### Note for Windows and Galaxy Users

If you do not have a copy of the genome you used for mapping on the computer
you are using to analyse your data, or you cannot install *samtools* because
you are working on Windows, *CrispRVariants* provides an alternative, albeit
slower, method for fetching the reference sequence:

```{r, tidy = FALSE}
# First read the alignments into R.  The alignments must include
# the read sequences and the MD tag
alns <- GenomicAlignments::readGAlignments(bam_fnames[[1]], 
          param = Rsamtools::ScanBamParam(tag = "MD", what = c("seq", "flag")),
          use.names = TRUE)

# Then reconstruct the reference for the target region.
# If no target region is given, this function will reconstruct
# the complete reference sequence for all reads.
rfa <- refFromAlns(alns, gdl)

# The reconstructed reference sequence is identical to the sequence
# extracted from the reference above
print(rfa == reference)
```

Note that the object ```alns``` created above can be directly passed to
the function ```readsToTarget``` (see below) instead of the bam filenames.
If there is more than one bam file, ```readsToTarget``` can also accept
a ```GAlignmentsList``` object (see the [GenomicAlignments](https://bioconductor.org/packages/release/bioc/html/GenomicAlignments.html) package) for more details).

## Creating a CrisprSet 
The next step is to create a CrisprSet object, which is the container that stores
the relevant sequence information, alignments, observed variants and their frequencies.

```{r, message=FALSE}
# Note that the zero point (target.loc parameter) is 22
crispr_set <- readsToTarget(bam_fnames, target = gdl, reference = reference,
                            names = md$Short.name, target.loc = 22)
crispr_set

# The counts table can be accessed with the "variantCounts" function
vc <- variantCounts(crispr_set)
print(class(vc))
```

You can see that in the table of variant counts, variants are summarised by the
location of their insertions and deletions with respect to the target site.
Non-variant sequences and sequences with a single nucleotide variant (SNV) but
no insertion or deletion (indel) are displayed first, followed by the indel
variants from most to least frequent  For example, the most frequent
non-wild-type variant, "-1:4D" is a 4 base pair deletion starting 1 base
upstream of the zero point.

## Creating summary plots of variants

We want to plot the variant frequencies along with the location of the guide
sequence relative to the known transcripts.  If you do this repeatedly for the
same organism, it is worthwhile to save the database in a local file and read
in with loadDb(), since this is quicker than retrieving it from UCSC
(or Ensembl) each time.

We start by creating a transcript database of Ensembl genes.  The gtf was
downloaded from Ensembl version 81.  We first took a subset of just the genes
on chromosome 17 and then generated a transcript database.

```{r, engine='bash', eval=FALSE}
# Extract genes on chromosome 17 (command line)
# Note that the Ensembl gtf does not include the "chr" prefix, so we add it here 
gtf=Danio_rerio.GRCz10.81.gtf.gz
zcat ${gtf} | awk '($1 == 17){print "chr"$0}' > Danio_rerio.GRCz10.81_chr17.gtf
```

```{r, eval = FALSE}
# In R
library(GenomicFeatures)
gtf_fname <- "Danio_rerio.GRCz10.81_chr17.gtf"
txdb <- GenomicFeatures::makeTxDbFromGFF(gtf_fname, format = "gtf")
saveDb(txdb, file= "GRCz10_81_chr17_txdb.sqlite")
```
We now load the the previously saved database 

```{r, echo=FALSE, message=FALSE}
library(GenomicFeatures)
txdb_fname <- system.file("extdata/GRCz10_81_ptena_txdb.sqlite", 
                          package="CrispRVariants")
txdb <- loadDb(txdb_fname)
```

plotVariants() is a wrapper function that groups together a plot of the
transcripts of the gene/s overlapping the guide (optional),
CrispRVariants::plotAlignments(), which displays the alignments of the
consensus variant sequences to the reference, and
CrispRVariants::plotFreqHeatmap(), which produces a table of the variant
counts per sample, coloured by either their counts or percentage contribution
to the variants observed for a given sample.  If a transcript database is supplied,
the transcript plot is  annotated with the guide location. Arguments for
plotAlignments() and plotFreqHeatmap() can be passed to plotVariants() as lists
named plotAlignments.args and plotFreqHeatmap.args, respectively.

```{r, message = FALSE}
# The gridExtra package is required to specify the legend.key.height 
# as a "unit" object.  It is not needed to call plotVariants() with defaults
library(gridExtra)

# Match the clutch id to the column names of the variants
group <- md$Group
```


```{r ptena-plot, fig.width = 8.5, fig.height = 7.5, message = FALSE, fig.cap = "(Top) schematic of gene structure showing guide location (left) consensus sequences for variants (right) variant counts in each embryo."}
p <- plotVariants(crispr_set, txdb = txdb, gene.text.size = 8, 
    row.ht.ratio = c(1,8), col.wdth.ratio = c(4,2),
    plotAlignments.args = list(line.weight = 0.5, ins.size = 2, 
                               legend.symbol.size = 4),
    plotFreqHeatmap.args = list(plot.text.size = 3, x.size = 8, group = group, 
                                legend.text.size = 8, 
                                legend.key.height = grid::unit(0.5, "lines"))) 
```

The plotVariants() options set the text size of the transcript plot annotation
(gene.text.size) and the relative heights (row.ht.ratio) and widths
(col.wdth.ratio) of the plots. 

The plotAlignments arguments set the symbol size in the figure (ins.size)
and in the legend (legend.symbol), the line thickness for the (optional)
annotation of the guide region and cleavage site (line.weight). 

For plotFreqHeatmap we define an grouping variable for colouring the x-axis
labels (group), the size of the text within the plot (plot.text.size) and on
the x-axis (x.size) and set the size of the legend text (legend.text.size).

## Calculating the mutation efficiency

The mutation efficiency is the number of reads that include an insertion or
deletion.  Chimeric reads and reads containing single nucleotide variants near
the cut site may be counted as variant reads, non-variant reads, or excluded
entirely.  See the help page for the function **mutationEfficiency** for more
details.

We can see in the plot above that the control sample includes a variant
sequence 6:1D, also present in sample ptena 4.  We will exclude all sequences
with this variant from the efficiency calculation.  We also demonstrate below
how to exclude particular variants. 


```{r}
# Calculate the mutation efficiency, excluding indels that occur in the "control" sample
# and further excluding the "control" sample from the efficiency calculation
eff <- mutationEfficiency(crispr_set, filter.cols = "control", exclude.cols = "control")
eff

# Suppose we just wanted to filter particular variants, not an entire sample.
# This can be done using the "filter.vars" argument
eff2 <- mutationEfficiency(crispr_set, filter.vars = "6:1D", exclude.cols = "control")

# The results are the same in this case as only one variant was filtered from the control
identical(eff,eff2)
```

We see above that sample ptena 4 has an efficiency of 80%, i.e. 4 variant sequences,
plus one sequence "6:1D" which is counted as a non-variant sequence as it also
occurs in the control sample.

## Get consensus alleles

The consensus sequences for variant alleles can be accessed using **consensusSeqs**.
This function allows filtering by variant frequency or read count, as for 
**plotAlignments** and **plotFreqHeatmap**.  Consensus alleles are returned with
respect to the positive strand.

```{r}
sqs <- consensusSeqs(crispr_set)
sqs

# The ptena guide is on the negative strand.
# Confirm that the reverse complement of the "no variant" allele
# matches the reference sequence:
Biostrings::reverseComplement(sqs[["no variant"]]) == reference
```


## Plot chimeric alignments

When deciding whether chimeric alignments should be considered as variant sequences,
it can be useful to plot the frequent chimeras.  


```{r}
ch <- getChimeras(crispr_set, sample = "ptena 4")

# Confirm that all chimeric alignments are part of the same read
length(unique(names(ch))) == 1

# Set up points to annotate on the plot
annotations <- c(resize(gd, 1, fix = "start"), resize(gd, 1, fix = "end"))
annotations$name <- c("ptena_start", "ptena_end")

plotChimeras(ch, annotations = annotations)

```

Here we see the read aligns as two tandem copies of the region chr17:23648420-23648656.
The endpoint of each copy is not near the guide sequence.  We do not consider this a
genuine mutation, so we'll recalculate the mutation efficiency excluding the chimeric
reads and the control variant as before.

```{r}
mutationEfficiency(crispr_set, filter.cols = "control", exclude.cols = "control",
                   include.chimeras = FALSE)
```

We see that the mutation effiency for "ptena 4" is now 75%, i.e. 3 genuine variant
sequences, 1 sequence counted as "non-variant" because it occurs in the control,
and the chimeric read excluded completely

# Choosing the strand for display

**CrispRVariants** is capable of tabulating variants with respect to either
strand. By default, variant alleles are displayed with respect to the target
strand, i.e. sequences for a guide on the negative strand are reverse complemented
for display.  For some applications it may be preferable to display the variants
on the opposite strand, for example if a guide on the negative strand is used 
to target a gene on the positive strand.  The display strand is controlled using
the **orientation** parameter in **readsToTarget(s)** during initialization.

To illustrate, we will plot the variants for *ptena* on the positive strand.
Note that the only changes to the initialization code is the *orientation*
parameter.  In particular, the *target.loc* is still specified with respect
to the guide sequence and the reference is still the guide sequence, not
its reverse complement.

```{r, fig.width = 8.5, fig.height = 7.5, message = FALSE, warning = FALSE}

crispr_set_rev <- readsToTarget(bam_fnames, target = gdl, reference = reference,
                                names = md$Short.name, target.loc = 22, 
                                orientation = "opposite")
plotVariants(crispr_set_rev)
```

Note that variants are labelled with respect to their leftmost coordinate,
so the labelled variant location changes when plotting on the opposite strand.

# Multiple guides

```CrispRVariants``` accepts an arbitrarily long reference sequence and target region.
By default, reads must span the target region to be counted. Since v1.3.6, a new
argument ```minoverlap``` to ```readsToTarget``` is available, which allows reads
which do not span the target region to be counted, provided they have at least 
```minoverlap``` aligned bases overlapping the target.  This is particularly important
when the target region is close to or greater than the sequencing read length.

When using CrispRVariants with multiple guides, initialisation of a ```CrisprSet```
object is done as for a single guide, but with the ```reference``` and ```target```
parameters corresponding to a region spanning the guides of interest.   One
important parameter is the target location, or ```target.loc``` which determines
how the variant alleles are numbered. For a single guide, position zero would 
typically be the cut site.  With multiple guides, possible zero points might
include the cut site of the leftmost guide or the first base of the amplified
sequence.  Multiple guide sequences are first indicated at the stage of plotting.  

In the example below, we reuse the *ptena* data used in the case study.  In this
experiment, a single guide was injected.  However, for illustrative purposes we
will treat the data as if it was a paired injection of two nearby guides.


```{r, warning = FALSE}
# We create a longer region to use as the "target"
# and the corresponding reference sequence
gdl <- GenomicRanges::resize(gd, width(gd) + 20, fix = "center")
reference <- Biostrings::DNAString("TCATTGCCATGGGCTTTCCAGCCGAACGATTGGAAGGTGTTTA")

# At this stage, target should be the entire region to display and target.loc should
# be the zero point with respect to this region
crispr_set <- readsToTarget(bam_fnames, target = gdl, reference = reference,
                            names = md$Short.name, target.loc = 10,
                            verbose = FALSE)

# Multiple guides are added at the stage of plotting
# The boundaries of the guide regions must be specified with respect to the
# given target region
p <- plotVariants(crispr_set, 
       plotAlignments.args = list(pam.start = c(6,35),
                              target.loc = c(10, 32),
                              guide.loc = IRanges::IRanges(c(6, 25),c(20, 37))))
p
```

In the above call to ```plotAlignments```, ```pam.start``` and ```pam.end``` control
where the box around the PAM sequence is drawn, ```target.loc``` controls where vertical
lines are drawn (note this does not have to match the ```target.loc``` passed to
```readsToTarget```), and ```guide.loc``` controls where the box around the guide is
drawn.


# Changing the appearance of plots

Note that arguments for CrispRVariants::plotAlignments described below 
can be passed to CrispRVariants::plotVariants as a list, 
e.g. ```plotAlignments.args = list(axis.text.size = 14)```.  Similarly,
arguments for CrispRVariants::plotFreqHeatmap are passed through plotVariants
via ```plotFreqHeatmap.args```.

## Filtering data in plotVariants

For the following examples, we will use the *ptena* data set.
We must first load the data and create a ```CrispRVariants::CrisprSet```
object.

```{r, message = FALSE}
# Setup for ptena data set
library("CrispRVariants")
library("rtracklayer")
library("GenomicFeatures")
library("readxl")

# Load the guide location
gd_fname <- system.file(package="CrispRVariants", "extdata/bed/guide.bed")
gd <- rtracklayer::import(gd_fname)
gdl <- resize(gd, width(gd) + 10, fix = "center")

# The saved reference sequence corresponds to the guide 
# plus 5 bases on either side, i.e. gdl
ref_fname <- system.file(package="CrispRVariants", 
                         "extdata/ptena_GRCHz10_ref.rda")
load(ref_fname)

# Load the metadata table, which gives the sample names
md_fname <- system.file(package="CrispRVariants",
                        "extdata/metadata/metadata.xls")
md <- readxl::read_xls(md_fname, 1)

# Get the list of bam files
bam_dir <- system.file(package="CrispRVariants", "extdata/bam")
bam_fnames <- file.path(bam_dir, md$bamfile)

# Check that all files were found
all(file.exists(bam_fnames))

crispr_set <- readsToTarget(bam_fnames, target = gdl, reference = reference,
                            names = md$Short.name, target.loc = 22,
                            verbose = FALSE)

# Load the transcript database
txdb_fname <- system.file("extdata/GRCz10_81_ptena_txdb.sqlite", 
                          package="CrispRVariants")
txdb <- AnnotationDbi::loadDb(txdb_fname)

```

Here is the ptena data set plotted with default options:

```{r, fig.height = 5, warning = FALSE}
p <- plotVariants(crispr_set, txdb = txdb)
```

The layout of this plot is controlled mainly by two parameters:
```row.ht.ratio``` and ```col.wdth.ratio```.  ```row.ht.ratio```
(default ```c(1,6)```) controls the relative sizes of the transcript
plot and the other plots.  Below we show how to change the ratio
so that the transcript plot is relatively larger:

```{r, fig.height = 5, warning = FALSE}
p <- plotVariants(crispr_set, txdb = txdb, row.ht.ratio = c(1,3))
```

Similarly, ```col.wdth.ratio``` controls the width ratio of the
alignment plot and the heatmap (default ```c(2,1)```, i.e. the
alignment plot is twice as wide as the heatmap).  Below we alter
this to make the alignment plot comparatively wider:

```{r, fig.height = 5, message = FALSE, warning = FALSE}
p <- plotVariants(crispr_set, txdb = txdb, col.wdth.ratio = c(4,1))
```

The remaining examples in this section use the *gol* data set.

```{r}
# Load gol data set
library("CrispRVariants")
data("gol_clutch1")
```

The data used in ```plotAlignments``` and ```plotFreqHeatmap``` can
be filtered by either frequency via ```min.freq```, count via 
```min.count```, or to show a set number of alleles sorted by frequency,
via ```top.n```.  Within ```plotVariants```, these filtering options
need to be set for both ```plotAlignments``` and ```plotFreqHeatmap```.
We also add space to the bottom of the plot to prevent clipping of the
labels.

```{r, fig.height = 2.5, message = FALSE, warning = FALSE}
library(GenomicFeatures)
p <- plotVariants(gol, plotAlignments.args = list(top.n = 3),
             plotFreqHeatmap.args = list(top.n = 3),
             left.plot.margin = ggplot2::unit(c(0.1,0,5,0.2), "lines"))
```

At present, filtering by sample (column) is possible for ```plotFreqHeatmap```
via the ```order``` parameter (which can also be used to reorder columns),
but not ```plotAlignments```.  

```{r, fig.height = 2.5, message = FALSE, warning = FALSE}
plotVariants(gol, plotAlignments.args = list(top.n = 3),
             plotFreqHeatmap.args = list(top.n = 3, order = c(1,5,3)),
             left.plot.margin = ggplot2::unit(c(0.1,0,5,0.2), "lines"))
```

## plotAlignments

### Insertion symbols

The symbols indicating insertions are controlled by four parameters.
```ins.size``` (default 3) controls the size of the symbols within the
plot area.

```{r, fig.height = 2.5, warning = FALSE}
plotAlignments(gol, top.n = 3, ins.size = 6)
```

By default the symbols in the legend are the same size as those in the
plot, but this can be controlled separately with ```legend.symbol.size```.

```{r, fig.height = 2.5}
plotAlignments(gol, top.n = 3, legend.symbol.size = 6)
```

As long sequences can make the plot difficult to read, by default
only the length of insertions greater then 20bp is shown.  This can
be changed with the ```max.insertion.size``` parameter.  If there is
more than one allele, the number of (frequent) alleles is indicated.

```{r, fig.height = 3, warning = FALSE}
plotAlignments(gol, top.n = 5, max.insertion.size = 25)
```

Finally, the parameter ```min.insertion.freq``` (default 5%) controls how
many alleles are displayed at each insertion locus.  In large data sets,
there will be a substantial proportion of reads with sequencing errors, 
and we may only wish to display the most common sequences.

```{r, fig.height = 3, warning = FALSE}
# Here we set a fairly high value of 50% for min.insertion.freq
# As ambiguous nucleotides occur frequently in this data set,
# there are no alleles passing this cutoff.
plotAlignments(gol, top.n = 5, min.insertion.freq = 50)
```

```max.insertion.size``` and ```min.insertion.freq``` can be combined.
In this case, alleles longer than ```max.insertion.size``` but less
frequent than ```min.insertion.freq``` will be collapsed.

```{r, fig.height = 3, warning = FALSE}
plotAlignments(gol, top.n = 5, max.insertion.size = 25, min.insertion.freq = 50)
```

### Whitespace between rows

The space between rows is controlled with the ```tile.height``` parameter (default 0.55).
Values closer to 0 increase the space between rows, whilst values closer to 1 decrease the
space between rows.

```{r, fig.height = 2.5, warning = FALSE}
# No white space between rows
plotAlignments(gol, top.n = 3, tile.height = 1)
```


```{r, fig.height = 3, warning = FALSE}
# More white space between rows
plotAlignments(gol, top.n = 3, tile.height = 0.3)
```

### Box around guide

The black box around the guide sequence can be removed by setting 
```highlight.guide = FALSE```.

```{r, fig.height = 2.5, warning = FALSE}
plotAlignments(gol, top.n = 3, highlight.guide = FALSE)
```

By default, the box around the guide is drawn from 17 bases upstream of the
```target.loc``` to 6 bases downstream.  For experiments with a truncated guide,
or other non-standard guide location, the box must be manually specified.
The guide location can be altered by setting the ```guide.loc``` parameter.
This can be either an ```IRanges::IRanges``` or ```GenomicRanges::GRanges``` object.

```{r, fig.height = 3, message = FALSE}
library(IRanges)
guide <- IRanges::IRanges(15,28)
plotAlignments(gol, top.n = 3, guide.loc = guide)
```

### Text sizes

The text showing bases within the alignment plot is controlled by 
```plot.text.size``` (default 2), and can be removed completely by
setting ```plot.text.size = 0```.  The axis labels and legend labels
are controlled with ```axis.text.size``` (default 8) and
```legend.text.size``` (default 6) respectively.  The number of columns
in the legend is controlled by ```legend.cols``` (default 3).  

```{r, fig.height = 2.5}
# Here we increase the size of the axis labels and make
# two columns for the legend
plotAlignments(gol, top.n = 5, axis.text.size = 12, 
               legend.text.size = 12, legend.cols = 2)

```

### Box around PAM

The argument ```highlight.pam``` determines whether a box around the PAM should be drawn.

```{r, fig.height = 3, warning = FALSE}
# Don't highlight the PAM sequence
plotAlignments(gol, top.n = 3, highlight.pam = FALSE)
```

By default this box is drawn 3 nucleotides downstream of the ```target.loc```.  Other
applications might require a different region highlighted.  This can be achieved by
explicitly setting the start and end positions of the box, with respect to the reference
sequence.

```{r, fig.height = 3, warning = FALSE}

# Highlight 3 bases upstream to 3 bases downstream of the target.loc
plotAlignments(gol, top.n = 3, pam.start = 19, pam.end = 25)
```

The boxes around the guide and the PAM can both be changed to arbitrary locations,
however note that the guide box is specified by a ranges object whilst the PAM
box is specified by start and end coordinates.  Both coordinates are with respect
to the start of the reference sequence.  The box around the guide is slightly wider
than the box around the PAM.

```{r, fig.height = 3, warning = FALSE}

plotAlignments(gol, top.n = 3, guide.loc = IRanges(5,10),
               pam.start = 8, pam.end = 13)

```

The thickness of the lines showing the cut site, the guide and the PAM are 
controlled with ```line.weight``` (default 1).

```{r, fig.height = 3, warning = FALSE}
plotAlignments(gol, top.n = 3, line.weight = 3)
```

### Add a codon frame

If the codon frame with respect to the first base of the
target region is known, it can be added to
```plot.alignments``` using the argument ```codon.frame```

```{r, fig.height = 3, warning = FALSE}
plotAlignments(gol, top.n = 3, codon.frame = 1)
```

### Other modifications

To retreive the information used in ```plotAlignments```
when starting from a ```CrisprSet``` object, use the argument
`create.plot = FALSE`.

```{r, eval = FALSE}
plot_data <- plotAlignments(gol, top.n = 3, create.plot = FALSE)
names(plot_data)
# This data can be modified as required, then replotted using:
do.call(plotAlignments, plot_data)
```

## plotFreqHeatmap

```plotFreqHeatmap``` produces a heatmap of the counts or proportions
of the variant alleles.  Typically, ```plotFreqHeatmap``` is passed
a ```CrisprSet``` object, but it can also accept a ```matrix``` if greater
flexibility is required (see below).  As ```plotFreqHeatmap``` returns a
```ggplot``` object, it can also be modified using standard ```ggplot2```
syntax.  For example, we add a title to the plot below.  

By default, when given an object of class ```CrisprSet```,
```plotFreqHeatmap``` shows the allele counts and the header shows
the total number of on-target reads in each sample. For example,
the following code shows the three most common variant alleles in
the gol dataset.  The header here does not equal the sum of the
columns as not all variants are shown in the plot.

```{r hmap-default, fig.height = 3, fig.width = 4, fig.align='center', fig.cap = "plotFreqHeatmap with default options"}
# Save the plot to a variable then add a title using ggplot2 syntax.
# If the plot is not saved to a variable the unmodified plot is displayed.
p <- plotFreqHeatmap(gol, top.n = 3)
p + labs(title = "A. plotFreqHeatmap with default options")
```

### Plotting allele proportions

When calling ```plotFreqHeatmap``` with a ```CrisprSet``` object the
```type``` argument controls the information shown in text in the heatmap.
Setting ```type = "counts"``` (the default) shows allele counts, setting
```type = "proportions"``` shows allele proportions.  This also affects
the default header values.  When ```type = "proportions"``` the header
shows the column sums, i.e. the percentage of the total number
of reads shown in the plot.

```{r, fig.height = 2.5, fig.width = 5, fig.align='center', fig.cap = "plotFreqHeatmap showing allele proportions"}
    
plotFreqHeatmap(gol, top.n = 3, type = "proportions")
```

### Changing the header

There are three standard options for the header when calling ```plotFreqHeatmap```
with an object of class ```CrisprSet```:

* ```header = "default"``` shows total read counts when ```type = "counts"```
  or column sums when ```type = "proportions"```.  See the examples above.
* ```header = "counts"``` shows total read counts.  If variants are excluded,
the values in the header do necessarily equal the column totals.  For example,
see plot "C. Modified plotFreqHeatmap" below.
* ```header = "efficiency"``` shows the mutation efficiency, i.e. the percentage
of reads that have an insertion or deletion variant.  The mutation efficiency is
calculated using the default options of the function ```mutationEfficiency```.  

### Heatmap colours

The tiles may be coloured by either the percentage of the column totals
(default), or by the counts, by setting ```as.percent = FALSE```.  For
example, see plot "B. coloured X labels with tiles coloured by count"
below and contrast with plot "A. plotFreqHeatmap with default options"
above.

### Changing colours of x-labels

The x-labels can be coloured by experimental group.  To do this,
a grouping vector must be supplied by setting parameter ```group```.
Columns are ordered according to the levels of the group.  There
should be one group value per column in the data.

```{r, fig.height = 2.5, fig.width = 4, fig.align='center', fig.cap = "plotFreqHeatmap with X-axis labels coloured by experimental group and tiles coloured by count instead of proportion"}
ncolumns <- ncol(variantCounts(gol))
ncolumns
grp <- rep(c(1,2), each = ncolumns/2)
p <- plotFreqHeatmap(gol, top.n = 3, group = grp, as.percent = FALSE)
p + labs(title = "B. coloured X labels with tiles coloured by count")
```

The default colours are designed to be readable on a white background
and colour-blind safe.  These can be changed by supplying a vector of 
colours for each level of the group.  Colours must be supplied if there
are more than 7 experimental groups.

```{r, fig.height = 2.5, fig.width = 5, fig.align='center', fig.cap = "plotFreqHeatmap with labels showing allele proportions, header showing counts per sample and modified legend position."}
grp_clrs <- c("red", "purple")
p <- plotFreqHeatmap(gol, top.n = 3, group = grp, group.colours = grp_clrs,
                type = "proportions", header = "counts",
                legend.position = "bottom")
p <- p + labs(title = "C. Modified plotFreqHeatmap")
p
```


### Controlling the appearance of the legend

The legend position is controlled via the ```plotFreqHeatmap```
argument ```legend.position```, which is passed to ```ggplot2::theme```.
Similarly ```legend.key.height``` controls the height of the legend. See the 
[ggplot docs](http://docs.ggplot2.org/current/theme.html) for 
more information.  

```{r, fig.height = 2.5, fig.width = 4, fig.align='center'}
plotFreqHeatmap(gol, top.n = 3, 
                legend.key.height = ggplot2::unit(1.5, "lines"))
```

An additional example where the legend is placed at the bottom is shown
above in plot C named "Modified plotFreqHeatmap" above.

### Further customisation

The function ```variantCounts``` returns a matrix of allele counts or proportions
which can be passed to ```plotFreqHeatmap```.  ```variantCounts``` allows filtering
by number of alleles or allele frequency.  When passing ```plotFreqHeatmap``` a
```matrix``` instead of a ```CrisprSet```, a header vector can also be supplied.
If no header is supplied, the header is the column sums.

```{r, eval = FALSE}
var_counts <- variantCounts(gol, top.n = 3)
# (additional modifications to var_counts can be added here)
plotFreqHeatmap(var_counts)
```



## barplotAlleleFreqs

```barplotAlleleFreqs``` includes two different colour schemes - a default rainbow
scheme and a blue-red gradient.  Note that the transcript database ```txdb``` must
be passed by name as this function accepts ellipsis arguments.

Here ```barplotAlleleFreqs``` is run with the default parameters:

```{r, fig.height = 2.5}
barplotAlleleFreqs(crispr_set, txdb = txdb)
```

In this case ```barplotAlleleFreqs``` is run with the alternative palette.

```{r, fig.height = 2.5, message = FALSE}
barplotAlleleFreqs(crispr_set, txdb = txdb, palette = "bluered")
```

By default, a table of the number of sequences and alleles is plotted next to
the barplot.  This can be switched off.  In this case, ```barplotAlleleFreqs```
will return an ```ggplot``` object, allowing further alteration of the appearance
through the usual ```ggplot2::theme``` settings.

```{r, fig.height = 2.5, message = FALSE}
barplotAlleleFreqs(crispr_set, txdb = txdb, include.table = FALSE)
```

```barplotAlleleFreqs.CrisprSet``` uses ```VariantAnnotation::locateVariants```
to look up the variant locations with respect to a transcript database.  The default
behaviour of ```barplotAlleleFreqs.matrix``` is to perform a naive classification of
the variants as frameshift or non-frameshift by size.  This approach ignores transcript
scructure, but can be useful to give a faster overview, or in cases where the transcript
structure is unknown.

```{r, fig.height = 2.5}
var_counts <- variantCounts(crispr_set)
barplotAlleleFreqs(var_counts)
```

If the parameter ```classify``` is set to FALSE, the variants are plotted with no
further aggregation.  If there are more than seven variants, colours must be provided.

```{r, fig.height = 2.5}
rainbowPal10 <- c("#781C81","#3F479B",
                  "#4277BD","#529DB7",
                  "#62AC9B","#86BB6A",
                  "#C7B944","#E39C37",
                  "#E76D2E","#D92120")

barplotAlleleFreqs(var_counts, classify = FALSE, bar.colours = rainbowPal10)

```

An arbitrary classification can also be used.  ```CrispRVariants``` provides some utility
functions to assist in classifying variants.  Note that methods of the ```CrisprSet```
class are accessed with ```crisprSet$function()``` rather than ```function(crisprSet)```.

Here are some examples of variant classification:

```{r, fig.height = 2.5}
# Classify variants as insertion/deletion/mixed
byType <- crispr_set$classifyVariantsByType()
byType

# Classify variants by their location, without considering size
byLoc <- crispr_set$classifyVariantsByLoc(txdb=txdb)
byLoc
# Coding variants can then be classified by setting a size cutoff
byLoc <- crispr_set$classifyCodingBySize(byLoc, cutoff = 6)
byLoc

# Combine filtering and variant classification, using barplotAlleleFreqs.matrix
vc <- variantCounts(crispr_set)

# Select variants that occur in at least two samples
keep <- names(which(rowSums(vc > 0) > 1))
keep

# Use this classification and the selected variants
barplotAlleleFreqs(vc[keep,], category.labels = byLoc[keep])
```


### Other modifications

```plotAlignments``` and ```plotFreqHeatmap``` both return ```ggplot``` objects,
which can be adjusted via ```theme()```.  For example, to decrease the space
between the legend and the plot:

```{r, fig.height = 2.5}
p <- plotAlignments(gol, top.n = 3)
p + theme(legend.margin = ggplot2::unit(0, "cm"))
```

# Using CrispRVariants plotting functions independently

The CrispRVariants plotting functions are intended to be used within a typical
CrispRVariants pipeline, where the correct arguments are extracted from a
CrisprSet object.  However, with some data formatting, it is also possible to
use these functions with standard R objects. 

An example adapting ```CrispRVariants::plotVariants``` to display pairwise
alignments can be found in the code accompanying the CrispRVariants paper:
https://github.com/markrobinsonuzh/CrispRvariants_manuscript

## Plot the reference sequence

Processing large data with CrispRVariants requires some time.  It can be useful
to first plot the reference sequence to check that the intended target location
is specified.  Here we use the reference sequence from the *gol* data set
included in CrispRVariants.  Any Biostrings::DNAString can be used.  Note that
CrispRVariants::plotAlignments accepts elliptical arguments in its signature,
so non-signature arguments must be supplied by name.  The code below shows the
minimum arguments required for running CrispRVariants::plotAlignments.

```{r, fig.height = 1}

# Get a reference sequence
library("CrispRVariants")
data("gol_clutch1")
ref <- gol$ref

#Then to make the plot:
plotAlignments(ref, alns = NULL, target.loc = 22, ins.sites = data.frame())

```

# Note about handling of large deletions

`BWA` reports deletions above a threshold length as "chimeric" reads, with separate entries
in the bam file for each mapped segment. By default, `CrispRVariants` only counts chimeric 
reads where one mapped endpoint is near the cut site.  This setting was chosen as we
observed long chimeric deletions in both on- and off-target CRISPR amplicon sequencing 
experiments in several independent data sets.  The mapped endpoints were more likely to 
be in the vicinity of the cut site in on-target experiments.  The off-target experiments
did not have the other mutant alleles we expect to see if the long deletions are genuine CRISPR-induced variants.  Some of the chimeric reads we observed appeared to be primer dimers.
See the supplementary material of the CrispRVariants paper for more details:

```
Lindsay H, Burger A, Biyong B, Felker A, Hess C, Zaugg J, Chiavacci E, Anders C, Jinek M, 
Mosimann C and Robinson MD (2016). “CrispRVariants charts the mutation spectrum of genome
engineering experiments.” Nature Biotechnology, 34, pp. 701–702. doi: 10.1038/nbt.3628.
```

The default chimera setting prioritises avoiding false positives such as primer dimers at
the expense of potentially missing some genuine variants. This can be changed during
initialisation by setting the `chimera.to.target` parameter to a large value.   

```{r, message = FALSE, warning = FALSE}
library(Biostrings)
library(CrispRVariants)
library(rtracklayer)
```


```{r, warning = FALSE}
# This is a small, manually generated data set with a variety of different mutations 
bam_fname <- system.file("extdata", "cntnap2b_test_data_s.bam", 
                         package = "CrispRVariants")
guide_fname <- system.file("extdata", "cntnap2b_test_data_guide.bed",
                           package = "CrispRVariants")
guide <- rtracklayer::import(guide_fname)
guide <- guide + 5
reference <- Biostrings::DNAString("TAGGCGAATGAAGTCGGGGTTGCCCAGGTTCTC")

cset <- readsToTarget(bam_fname, guide, reference = reference, verbose = FALSE, 
                      name = "Default")
cset2 <- readsToTarget(bam_fname, guide, reference = reference, verbose = FALSE, 
                       chimera.to.target = 100, name = "Including long dels")

default_var_counts <- variantCounts(cset)
print(default_var_counts)
print(c("Total number of reads: ", colSums(default_var_counts)))

# With chimera.to.target = 100, an additional read representing a large deletion is 
# reported in the "Other" category.
var_counts_inc_long_dels <- variantCounts(cset2)
print(var_counts_inc_long_dels)
print(c("Total number of reads: ", colSums(var_counts_inc_long_dels)))

# This alignment can be viewed using `plotChimeras` 
ch <- getChimeras(cset2, sample = 1)
plotChimeras(ch, annotations = cset2$target)
```

# Session Info

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAlignments.R
\name{makeAlignmentTilePlot}
\alias{makeAlignmentTilePlot}
\title{Internal CrispRVariants function for creating the plotAlignments background}
\usage{
makeAlignmentTilePlot(
  m,
  ref,
  xlab,
  plot.text.size,
  axis.text.size,
  xtick.labs,
  xtick.breaks,
  tile.height
)
}
\arguments{
\item{m}{A matrix with column headings Var1: y location, Var2: x location, 
cols: tile fill colour, isref: transparency value text_cols: text colour}

\item{ref}{The reference sequence, only used for checking the number of
x-tick labels when x-tick breaks are not supplied}

\item{xlab}{Label for the x axis}

\item{plot.text.size}{Size for text within plot}

\item{axis.text.size}{Size for text on axes}

\item{xtick.labs}{x axis labels}

\item{xtick.breaks}{Locations of x labels}

\item{tile.height}{Controls whitespace between tiles}
}
\value{
A ggplot object
}
\description{
Takes a matrix of characters, x and y locations and colours, creates
a ggplot geom_tile plot with tiles labelled by the characters.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findChimeras.R
\name{findChimeras}
\alias{findChimeras}
\title{Find chimeric reads}
\usage{
findChimeras(bam, by.flag = FALSE)
}
\arguments{
\item{bam}{A GAlignments object, must include names}

\item{by.flag}{Can the chimeras be detected just using the supplementary
alignment flag?  (Default: FALSE).  If TRUE, detects supplementary alignments
and returns reads with the same name as a supplementary alignment (quicker).
If FALSE, all alignments with duplicated names are returned.}
}
\value{
A vector of indices of chimeric sequences within the original bam
}
\description{
Find chimeric reads, assuming that the GAlignments object
does not contain multimapping reads. That is, read names that appear
more than ones in the file are considered chimeras.  Chimeric reads
are reads that cannot be mapped as a single, linear alignment.  Reads
from structual rearrangements such as inversions can be mapped as chimeras.
Note that the indices of all chimeric reads are returned, these are not
separated into individual chimeric sets.
}
\examples{
bam_fname <- system.file("extdata", "gol_F1_clutch_2_embryo_4_s.bam",
                         package = "CrispRVariants")
bam <- GenomicAlignments::readGAlignments(bam_fname, use.names = TRUE)
chimera_indices <- findChimeras(bam)
chimeras <- bam[chimera_indices]
}
\seealso{
\code{\link{plotChimeras}} for plotting chimeric alignment sets.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{mutationEfficiency}
\alias{mutationEfficiency}
\alias{mutationEfficiency,CrisprSet-method}
\title{Get mutation efficiency}
\usage{
mutationEfficiency(obj, ...)

\S4method{mutationEfficiency}{CrisprSet}(
  obj,
  ...,
  snv = c("non_variant", "include", "exclude"),
  include.chimeras = TRUE,
  exclude.cols = NULL,
  filter.vars = NULL,
  filter.cols = NULL,
  group = NULL
)
}
\arguments{
\item{obj}{An object containing variant counts}

\item{...}{additional arguments}

\item{snv}{Single nucleotide variants (SNVs) may be considered as
mutations ("include"), treated as ambiguous sequences and not counted
at all ("exclude"), or treated as non-mutations, e.g. sequencing errors
or pre-existing SNVs ("non_variant", default)}

\item{include.chimeras}{Should chimeric alignments be counted as variants
when calculating mutation efficiency (Default: TRUE}

\item{exclude.cols}{A vector of names of columns in the variant counts table
that will not be considered when counting mutation efficiency}

\item{filter.vars}{Variants to remove before calculating efficiency.
May be either a variant size, e.g. "1D", or a particular 
variant/variant combination, e.g. -5:3D}

\item{filter.cols}{A vector of control sample names.  Any variants present in the control
samples will be counted as non-variant, unless they also contain another indel.  Note that
this is not compatible with counting snvs as variants.}

\item{group}{A grouping vector.  If provided, efficiency will be calculated
per group (Default: NULL)}
}
\value{
A vector of efficiency statistics per sample and overall, or 
a matrix of efficiency statistics per group if a group is provided
}
\description{
Returns the percentage of sequences that contain at least
one mutation.
}
\examples{
data("gol_clutch1")
mutationEfficiency(gol)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotVariants.R
\name{arrangePlots}
\alias{arrangePlots}
\title{Arrange plots for plotVariants:CrisprSet}
\usage{
arrangePlots(
  top.plot,
  left.plot,
  right.plot,
  fig.height = NULL,
  col.wdth.ratio = c(2, 1),
  row.ht.ratio = c(1, 6),
  left.plot.margin = grid::unit(c(0.1, 0.2, 3, 0.2), "lines")
)
}
\arguments{
\item{top.plot}{ggplot grob, placed on top of the figure, spanning the figure
width}

\item{left.plot}{ggplot, placed in the second row on the left}

\item{right.plot}{ggplot, placed in the second row on the right.
y-axis labels are removed.}

\item{fig.height}{Actual height for the figure. If not provided,
figure height is the sum of the row.ht.ratio (Default: NULL)}

\item{col.wdth.ratio}{Vector specifying column width ratio (Default: c(2, 1))}

\item{row.ht.ratio}{Vector specifying row height ratio (Default: c(1,6))}

\item{left.plot.margin}{Unit object specifying margins of left.plot.
Margins of right.plot are constrained by the left.plot.}
}
\value{
The arranged plots
}
\description{
Arranges 3 plots in two rows.  The vertical margins of the
left.plot and right.plot constrained to be equal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{dispatchDots}
\alias{dispatchDots}
\title{dispatchDots}
\usage{
dispatchDots(func, ..., call = FALSE)
}
\arguments{
\item{func}{Function to call}

\item{...}{dot args to pass to function}

\item{call}{If TRUE, call the function with the argument list and
return this result (Default: FALSE)}
}
\value{
A list of arguments to pass to func, or if call is TRUE, the result
of calling func with these arguments.
}
\description{
Update default values for func with values from dot args
}
\examples{
# Set up a function to dispatch dot arguments to:
f <- function(a=1, b=2, c=3){
 print(c(a,b,c))
}
# Set up a function for passing dots:
g <- function(...){
 CrispRVariants:::dispatchDots(f, ...)
}

g(a = 5)
g(a = 5, call = TRUE)
# Unrelated arguments will not be passed on
g(a = 5, d = 6)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialisers.R
\name{readTargetBam}
\alias{readTargetBam}
\title{Internal CrispRVariants function for reading and filtering a bam file}
\usage{
readTargetBam(
  file,
  target,
  exclude.ranges = GRanges(),
  exclude.names = NA,
  chimera.to.target = 5,
  chimeras = c("count", "ignore", "exclude", "merge"),
  max.read.overlap = 10,
  max.unmapped = 4,
  by.flag = TRUE,
  verbose = TRUE
)
}
\arguments{
\item{file}{The name of a bam file to read in}

\item{target}{A GRanges object containing a single target range}

\item{exclude.ranges}{A GRanges object of regions that should not be counted,
e.g. primer or cloning vector sequences that have a match in the genome}

\item{exclude.names}{A vector of read names to exclude.}

\item{chimera.to.target}{Maximum distance between endpoints of chimeras and
target.loc for assigning chimeras to targets (default: 5)}

\item{chimeras}{Flag to determine how chimeric reads are treated.  One of
"ignore", "exclude", "count" and "merge".  Default "ignore".}

\item{max.read.overlap}{Maximum number of bases mapped to two positions
for chimeras to be merged (Default: 10)}

\item{max.unmapped}{Maximum number of bases that are unmapped for chimeras
to be merged (Default: 4)}

\item{by.flag}{Is the supplementary alignment flag set?  Used for identifying chimeric
alignments, function is much faster if TRUE.  Not all aligners set this flag.  If FALSE,
chimeric alignments are identified using read names (Default: TRUE)}

\item{verbose}{Print stats about number of alignments read and filtered.  (Default: TRUE)}
}
\value{
A GenomicAlignments::GAlignment obj
}
\description{
Includes options for excluding reads either by name or range.
The latter is useful if chimeras are excluded.  Reads are excluded before
chimeras are detected, thus a chimeric read consisting of two sections, one of
which overlaps an excluded region, will not be considered chimeric.
Chimeric reads can be ignored, excluded, which means that all sections of a
chimeric read will be removed, or merged, which means that chimeras will be
collapsed into a single read where possible. (Not implemented yet)
If chimeras = "merge", chimeric reads are merged if all segments
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.getAxisCoords}
\alias{.getAxisCoords}
\title{.getAxisCoords}
\usage{
.getAxisCoords(
  locations,
  labels = NULL,
  loc.boundaries = NULL,
  lab.boundaries = c(-1, 1),
  label.at = 5,
  min.tick.sep = 1
)
}
\arguments{
\item{locations}{character(n) Actual x coordinates, or the desired
range of the x coordinates.  If labels are provided, all tick locations
must be in locations and have a matching label.}

\item{labels}{character(n) labels for the x axis ticks.  Should be
the same length as locations if provided.  Note that if not all
tick locations are included in locations, it must be possible to
extrapolate labels from locations  (Default: NULL)}

\item{loc.boundaries}{numeric(i) Locations that must be included.
(Default: NULL)}

\item{lab.boundaries}{numeric(j) Labels that must be included.
(Default: c(-1,1), for showing the cut sites).  Boundaries must
be in labels and have a matching tick location.}

\item{label.at}{numeric(1) Add ticks when label modulo label.at
is zero (Default = 5)}

\item{min.tick.sep}{numeric(1) Minimum distance between ticks, excluding
boundary ticks.  (Default: 1)}
}
\value{
A list containing vectors named tick_locs and tick_labs
}
\description{
Manually specify x-tick locations and labels,
as sometimes ggplot defaults are too dense. Used internally
by CrispRVariants for creating alignment plot with plotAlignments.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAlignments.R
\name{transformAlnsToLong}
\alias{transformAlnsToLong}
\title{Transform data for plotting}
\usage{
transformAlnsToLong(ref, alns, add.other = FALSE)
}
\arguments{
\item{ref}{The reference sequence}

\item{alns}{Character vector of aligned sequences}

\item{add.other}{Add a blank row labelled "Other" (Default: FALSE)}
}
\value{
A matrix of characters and plotting locations
}
\description{
Orders and transforms a reference sequence and a set of aligned sequences
into long format, i.e. one observation (tile position) per row.  Used internally by
\code{\link[CrispRVariants]{plotAlignments}}.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAlignments.R
\name{plotAlignments}
\alias{plotAlignments}
\alias{plotAlignments,CrisprSet-method}
\alias{plotAlignments,character-method}
\alias{plotAlignments,DNAString-method}
\title{Plot alignments with respect to a reference sequence}
\usage{
plotAlignments(obj, ...)

\S4method{plotAlignments}{CrisprSet}(
  obj,
  ...,
  min.freq = 0,
  min.count = 1,
  top.n = 50,
  renumbered = obj$pars[["renumbered"]],
  add.other = TRUE,
  create.plot = TRUE
)

\S4method{plotAlignments}{character}(
  obj,
  ...,
  alns,
  ins.sites,
  highlight.pam = TRUE,
  show.plot = FALSE,
  target.loc = 17,
  pam.start = NA,
  pam.end = NA,
  ins.size = 2,
  legend.cols = 3,
  xlab = NULL,
  xtick.labs = NULL,
  xtick.breaks = NULL,
  plot.text.size = 2,
  axis.text.size = 8,
  legend.text.size = 6,
  highlight.guide = TRUE,
  guide.loc = NULL,
  tile.height = 0.55,
  max.insertion.size = 20,
  min.insertion.freq = 5,
  line.weight = 1,
  legend.symbol.size = ins.size,
  add.other = FALSE,
  codon.frame = NULL,
  style = c("all", "mismatches")
)

\S4method{plotAlignments}{DNAString}(
  obj,
  ...,
  alns,
  ins.sites,
  highlight.pam = TRUE,
  show.plot = FALSE,
  target.loc = 17,
  pam.start = NA,
  pam.end = NA,
  ins.size = 2,
  legend.cols = 3,
  xlab = NULL,
  xtick.labs = NULL,
  xtick.breaks = NULL,
  plot.text.size = 2,
  axis.text.size = 8,
  legend.text.size = 6,
  highlight.guide = TRUE,
  guide.loc = NULL,
  tile.height = 0.55,
  max.insertion.size = 20,
  min.insertion.freq = 5,
  line.weight = 1,
  legend.symbol.size = ins.size,
  add.other = FALSE,
  codon.frame = NULL
)
}
\arguments{
\item{obj}{The object to be plotted}

\item{...}{Additional arguments}

\item{min.freq}{i (%) only plot variants with frequency >= i% in at least
one sample (default: 0, i.e no frequency cutoff)}

\item{min.count}{i (integer) only plot variants with count >= i in at least
one sample (default: 0, i.e no count cutoff)}

\item{top.n}{(integer) Plot only the n most frequent variants
(default: 50)}

\item{renumbered}{If TRUE, the x-axis is numbered with respect to the target
(default: TRUE)}

\item{add.other}{Add a blank row labelled "Other" to the plot, for combining
with plotFreqHeatmap (default: TRUE (signature "CrisprSet") FALSE (signature "matrix"))}

\item{create.plot}{Should the data be plotted?  If false, returns the data used
for plotting (Default: TRUE)}

\item{alns}{A named character vector of aligned sequences, with insertions removed}

\item{ins.sites}{A table of insertion_sites, which must include cols
named "start", "cigar", "seq" and "count" for the start of the insertion in the
corresponding sequence}

\item{highlight.pam}{should location of PAM with respect to the target site be
indicated by a box? (Default: TRUE)  If TRUE, and pam.start and pam.end are not
supplied, PAM is inferred from target.loc}

\item{show.plot}{Should the plot be displayed (TRUE) or just returned as
a ggplot object (FALSE).  (Default: FALSE)}

\item{target.loc}{The location of the zero point / cleavage location.  Base n, where
the zero point is between bases n and n+1}

\item{pam.start}{The first location of the PAM with respect to the reference.}

\item{pam.end}{The last location of the PAM with respect to the reference.
Default is two bases after the pam.start}

\item{ins.size}{The size of the symbols representing insertions within the plot.}

\item{legend.cols}{The number of columns in the legend.  (Default:3)}

\item{xlab}{A title for the x-axis (Default: NULL)}

\item{xtick.labs}{Labels for the x-axis ticks (Default: NULL)}

\item{xtick.breaks}{Locations for x-axis tick breaks (Default: NULL)}

\item{plot.text.size}{The size of the text inside the plot}

\item{axis.text.size}{The size of the axis labels}

\item{legend.text.size}{The size of the legend labels}

\item{highlight.guide}{Should the guide be indicated by a box in
the reference sequence?  (Default: TRUE)}

\item{guide.loc}{The location of the guide region to be highlighted,
as an IRanges object. Will be inferred from target.loc if
highlight.guide = TRUE and no guide.loc is supplied, assuming the guide
plus PAM is 23bp (Default: NULL)}

\item{tile.height}{The height of the tiles within the plot. (Default: 0.55)}

\item{max.insertion.size}{The maximum length of an insertion to be shown in the
legend.  If max.insertion.size = n, an insertion of length m > n will
be annotated as "mI" in the figure.  (Default: 20)}

\item{min.insertion.freq}{Display inserted sequences with frequency at least x
amongst the sequences with an insertion of this size and length (Default: 5)}

\item{line.weight}{The line thickness for the vertical line indicating the
zero point (cleavage site) and the boxes for the guide and PAM.  (Default: 1)}

\item{legend.symbol.size}{The size of the symbols indicating insertions
in the legend.  (Default: ins.size)}

\item{codon.frame}{Codon position of the leftmost nucleotide.  If provided,
codon positions in the specified frame are indicated. (Default: NULL)}

\item{style}{One of "all" (colour all tiles) and "mismatches" (colour
only mismatch positions)}
}
\value{
A ggplot2 figure
}
\description{
(signature("CrisprSet")) Wrapper for CrisprSet$plotVariants.
Optionally filters a CrisprSet frequency table, then plots variants.
More information in \code{\link[CrispRVariants]{CrisprSet}}

(signature("DNAString"))  Plots a set of pairwise alignments to a reference sequence.
Alignments should all be the same length as the reference sequences.
This is achieved by removing insertions with respect to the reference,
see \code{\link[CrispRVariants]{seqsToAln}}.
Insertions are indicated by symbols in the plot and a table showing the
inserted sequences below the plot.  The default options are intended for a
figure 6-8 inches wide, with figure height best chosen according to the number
of different variants and insertions to be displayed.
}
\examples{
#Load a CrisprSet object and plot
data("gol_clutch1")
plotAlignments(gol)
}
\seealso{
\code{\link{seqsToAln}}, \code{\link[ggplot2]{ggplot}}
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getInsertionsTable.R
\name{getInsertionsTable}
\alias{getInsertionsTable}
\title{getInsertionsTable}
\usage{
getInsertionsTable(alns, pos = 1L)
}
\arguments{
\item{alns}{A GAlignments object}

\item{pos}{(Integer(1)) The amount by which to shift genomic
coordinates upstream to get coordinates relative to a display region}
}
\value{
A data frame of insertion sequences, genomic and
relative locations
}
\description{
Returns a table of insertion sequences present in
a GAlignments object.  This table is aggregated and used by
plotAlignments.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.intersperse}
\alias{.intersperse}
\title{.intersperse}
\usage{
.intersperse(outer, inner)
}
\arguments{
\item{outer}{vector that will be the first and last elements}

\item{inner}{vector that will join elements of outer}
}
\value{
A vector interspersing elements of outer and inner.  If
outer is c(a,b,c) and inner is c(d,e), returns c(a,d,b,e,c)
}
\description{
create a vector of elements in outer interspersed with
elements in inner.  Similar to python zip. No element checking.
}
\examples{
CrispRVariants:::.intersperse(c(1:10), c(1:9)*10)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.explodeCigarOpCombs}
\alias{.explodeCigarOpCombs}
\title{.explodeCigarOpCombs}
\usage{
.explodeCigarOpCombs(cigar, ops = GenomicAlignments::CIGAR_OPS)
}
\arguments{
\item{cigar}{character(m) A vector of cigar strings}

\item{ops}{character(n) Which operations should be kept?}
}
\value{
The operations, as a CharacterList

Exploded cigar operations with operation widths
}
\description{
Breaks cigar strings into individual operations
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialisers.R
\name{rcAlns}
\alias{rcAlns}
\title{Internal CrispRVariants function for determining read orientation}
\usage{
rcAlns(target.strand, orientation)
}
\arguments{
\item{target.strand}{The target strand (one of "+","-","*")}

\item{orientation}{One of "target", "opposite" and "positive" (Default: "target")}
}
\value{
A logical value indicating whether reads should be reverse complemented
}
\description{
Function for determining whether reads should be oriented to the
target strand, always displayed on the positive strand, or oriented to
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotFreqHeatmap.R
\name{plotFreqHeatmap}
\alias{plotFreqHeatmap}
\alias{plotFreqHeatmap,matrix-method}
\alias{plotFreqHeatmap,CrisprSet-method}
\title{Plot a table of counts with colours indicating frequency}
\usage{
plotFreqHeatmap(obj, ...)

\S4method{plotFreqHeatmap}{matrix}(
  obj,
  ...,
  col.sums = NULL,
  header = NA,
  header.name = "Total",
  group = NULL,
  group.colours = NULL,
  as.percent = TRUE,
  x.axis.title = NULL,
  x.size = 6,
  y.size = 8,
  x.angle = 90,
  legend.text.size = 6,
  plot.text.size = 3,
  line.width = 1,
  x.hjust = 1,
  legend.position = "right",
  x.labels = NULL,
  legend.key.height = grid::unit(1, "lines")
)

\S4method{plotFreqHeatmap}{CrisprSet}(
  obj,
  ...,
  top.n = 50,
  min.freq = 0,
  min.count = 1,
  type = c("counts", "proportions"),
  order = NULL,
  alleles = NULL
)
}
\arguments{
\item{obj}{A matrix of counts with rows = feature, columns = sample}

\item{...}{additional arguments}

\item{col.sums}{Alternative column sums to be used for calculating
the tile colours if as.percent = TRUE, e.g. if "obj" is a subset of
a larger data set.  If "NULL" (default), the column sums of "obj" are used.}

\item{header}{Alternative column titles, e.g. column sums for the
unfiltered data set when obj is a subset.  If set to "NA", column sums
of obj are displayed. If "NULL", no header is displayed (Default: NA).}

\item{header.name}{Label for the header row (Default: "Total")}

\item{group}{Grouping factor for columns.  If supplied, columns are
ordered to match the levels  (Default: NULL)}

\item{group.colours}{Colours for column groups, should match levels of "group".
If "NULL", groups are coloured differently (Default: NULL)}

\item{as.percent}{Should colours represent the percentage of reads
per sample (TRUE) or the actual counts (FALSE)?  (Default: TRUE)}

\item{x.axis.title}{A title for the x-axis.  (Default: NULL)}

\item{x.size}{Font size for x-labels (Default: 16)}

\item{y.size}{Font size for y-labels (Default: 16)}

\item{x.angle}{Angle for x-labels (Default: 90, i.e. vertical)}

\item{legend.text.size}{Font size for legend (Default: 16)}

\item{plot.text.size}{Font size counts within plot (Default: 3)}

\item{line.width}{Line thickness of title box'}

\item{x.hjust}{Horizontal justification of x axis labels (Default: 1)}

\item{legend.position}{The position of the legend (Default: right)}

\item{x.labels}{X-axis labels (Default: NULL, column.names of the matrix,
doesn't do anything at the moment)}

\item{legend.key.height}{The height of the legend key, as a "unit" object.
(See \code{\link[grid]{unit}}).}

\item{top.n}{Show the n top ranked variants.  Note that if the nth and n+1th
variants have equal rank, they will not be shown.   (Default: 50)}

\item{min.freq}{i (%) only plot variants with frequency >= i% in at least
one sample (Default: 0, i.e no frequency cutoff)}

\item{min.count}{i (integer) only plot variants with count >= i in at least
one sample (default: 0, i.e no count cutoff)}

\item{type}{Plot either "counts" or "proportions"}

\item{order}{A list of column names or indices specifying the order of the
columns in the plot}

\item{alleles}{A list of alleles to include.  Can be used to display
only alleles of interest or to order the alleles.
The default value NULL means all alleles passing the frequency cut offs 
will be included.}
}
\value{
The ggplot2 plot of the variant frequencies
}
\description{
Creates a heatmap from a matrix of counts or proportions,
where tiles are coloured by the proportion and labeled with the value.
}
\examples{
#Load a CrisprSet object for plotting
data("gol_clutch1")

# Plot the frequency heatmap
plotFreqHeatmap(gol)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{alns}
\alias{alns}
\alias{alns,CrisprSet-method}
\title{Get alignments}
\usage{
alns(obj, ...)

\S4method{alns}{CrisprSet}(obj, ...)
}
\arguments{
\item{obj}{An object containing aligned sequences}

\item{...}{additional arguments}
}
\value{
A GAlignmentsList of consensus sequences on the positive strand.
}
\description{
Return alignments from an object that contains them.
For a CrisprSet object, these are truncated, non-chimeric alignments
}
\examples{
data("gol_clutch1")
alns <- alns(gol)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mergeChimeras.R
\name{mergeChimeras}
\alias{mergeChimeras}
\title{mergeChimeras}
\usage{
mergeChimeras(
  bam,
  chimera_idxs = NULL,
  verbose = TRUE,
  max_read_overlap = 10,
  max_unmapped = 4,
  name = NULL
)
}
\arguments{
\item{bam}{A GenomicAlignments::GAlignments object}

\item{chimera_idxs}{Indices of chimeric reads within bam}

\item{verbose}{Should information about the number of mergeable
alignments be printed?  (Default: TRUE)}

\item{max_read_overlap}{Maximum number of bases in a mergeable read
that are aligned to two genomic locations (Default: 10)}

\item{max_unmapped}{Maximum number of bases in a mergeable read
that are unmapped and located between two mapped segments (Default: 4)}

\item{name}{Name of the sample, used when reporting verbose output.}
}
\value{
A list of the merged and unmerged chimeric alignments
}
\description{
Merges chimeric alignments where the individual segments
border an unmapped region (a long deletion).  If bases of the read are
mapped to both ends of the gap, the multimapped reads are only included
in the leftmost genomic segment. If there are more than max_unmapped
unmapped bases between the mapped bases, the read is not considered
mergeable.  Currently experimental and only tested with reads mapped by
bwa mem.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAlignments.R
\name{addCodonFrame}
\alias{addCodonFrame}
\title{Internal CrispRVariants function for indicating codon frame on an
alignment tile plot}
\usage{
addCodonFrame(p, width, codon.frame)
}
\arguments{
\item{p}{A ggplot object, typically from CrispRVariants:::makeAlignmentTilePlot}

\item{width}{The number of nucleotides in the alignments}

\item{codon.frame}{The leftmost starting location of the next codon - 1,2,or 3}
}
\value{
A ggplot object with added vertical lines indicating the frame
}
\description{
Adds vertical dotted lines in intervals of three nucleotides.
Codon frame is supplied, alignments are assumed not to span an intron-exon
junction.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{consensusSeqs}
\alias{consensusSeqs}
\alias{consensusSeqs,CrisprSet-method}
\title{Get consensus sequences for variant alleles}
\usage{
consensusSeqs(obj, ...)

\S4method{consensusSeqs}{CrisprSet}(obj, ..., top.n = NULL, min.freq = 0, min.count = 1)
}
\arguments{
\item{obj}{An object containing aligned sequences}

\item{...}{additional arguments}

\item{top.n}{(Integer n) If specified, return variants ranked at least n according
to frequency across all samples (Default: 0, i.e. no cutoff)}

\item{min.freq}{(Float n%) Return variants with frequency at least n% in at
least one sample (Default: 0)}

\item{min.count}{(Integer n) Return variants with count greater than n
in at least one sample (Default: 0)}
}
\value{
A DNAStringSet of consensus sequences on the positive strand.
}
\description{
Return consensus sequences of variant alleles.  At
present, chimeric alignments are not included.
}
\examples{
data("gol_clutch1")
seqs <- consensusSeqs(gol, sample = 2)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{variantCounts}
\alias{variantCounts}
\alias{variantCounts,CrisprSet-method}
\title{Get variant counts}
\usage{
variantCounts(obj, ...)

\S4method{variantCounts}{CrisprSet}(
  obj,
  ...,
  top.n = NULL,
  min.freq = 0,
  min.count = 1,
  include.chimeras = TRUE,
  include.nonindel = TRUE,
  result = "counts",
  filter.vars = NULL
)
}
\arguments{
\item{obj}{An object containing variant counts}

\item{...}{Additional arguments}

\item{top.n}{(Integer n) If specified, return variants ranked at least n
according to frequency across all samples (Default: 0, i.e. no cutoff)}

\item{min.freq}{(Float n%) Return variants with frequency at least n% in at
least one sample (Default: 0)}

\item{min.count}{(Integer n) Return variants with count greater than n
in at least one sample (Default: 0)}

\item{include.chimeras}{Should chimeric reads be included in the counts
table? (Default: TRUE)}

\item{include.nonindel}{Should sequences without indels be returned?
(Default:TRUE)}

\item{result}{Return variants as either counts ("counts", default) or
proportions ("proportions")}

\item{filter.vars}{Labels of variants alleles to remove (Default: NULL)}
}
\value{
A matrix of counts where rows are variants and columns are samples
}
\description{
Returns a matrix of counts where rows are sequence variants
and columns are samples
}
\examples{
data("gol_clutch1")

#Return a matrix of the 5 most frequent variants
variantCounts(gol, top.n = 5)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{getChimeras}
\alias{getChimeras}
\alias{getChimeras,CrisprSet-method}
\title{Get chimeric alignments}
\usage{
getChimeras(obj, ...)

\S4method{getChimeras}{CrisprSet}(obj, ..., sample)
}
\arguments{
\item{obj}{An object containing aligned sequences}

\item{...}{additional arguments}

\item{sample}{The sample name or sample index to return}
}
\value{
A GAlignment object containing the chimeric read groups
}
\description{
Return chimeric alignments from a collection of aligned sequences
}
\examples{
data("gol_clutch1")
chimeras <- getChimeras(gol, sample = 2)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{selectOps}
\alias{selectOps}
\alias{selectOps,character-method}
\title{selectOps}
\usage{
selectOps(cigar, ...)

\S4method{selectOps}{character}(
  cigar,
  ...,
  ops = GenomicAlignments::CIGAR_OPS,
  op.regions = NULL,
  pos = 1L
)
}
\arguments{
\item{cigar}{CIGAR strings}

\item{...}{Extra arguments (Not currently used)}

\item{ops}{CIGAR operations to consider (Default: all)}

\item{op.regions}{(GRanges) Return operations only in these regions}

\item{pos}{An offset for the cigar ranges}
}
\value{
A GRanges list of opertion locations in reference space
with a metadata column for the operation width in query space.
}
\description{
select CIGAR operations in a region of interest.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/narrowAlignments.R
\name{narrowAlignments}
\alias{narrowAlignments}
\alias{narrowAlignments,GAlignments,GRanges-method}
\title{Narrow a set of aligned reads to a target region}
\usage{
narrowAlignments(alns, target, ...)

\S4method{narrowAlignments}{GAlignments,GRanges}(
  alns,
  target,
  ...,
  reverse.complement,
  minoverlap = NULL,
  verbose = FALSE,
  clipping.ops = c("S", "H"),
  match.ops = c("M", "X", "=")
)
}
\arguments{
\item{alns}{A GAlignments object including a metadata column "seq"
containing the sequence}

\item{target}{A GRanges object}

\item{...}{additional arguments}

\item{reverse.complement}{Should the aligned reads be reverse complemented?}

\item{minoverlap}{Minimum overlapping region between alignments and target.
If not specified, alignments must span the entire target region.
(Default: NULL)}

\item{verbose}{(Default: FALSE)}

\item{clipping.ops}{CIGAR operations corresponding to clipping
(Default: c("S","H"))}

\item{match.ops}{CIGAR operations corresponding to a match, i.e.
a non-indel position (Default: c("M","X","="))}
}
\value{
The narrowed alignments (GAlignments)
}
\description{
Aligned reads are narrowed to the target region.  In
the case of reads with deletions spanning the boundaries of the target,
reads are narrowed to the start of the deletion,
}
\examples{
bam_fname <- system.file("extdata", "gol_F1_clutch_2_embryo_4_s.bam",
                         package = "CrispRVariants")
bam <- GenomicAlignments::readGAlignments(bam_fname, use.names = TRUE)
target <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399),
          strand = "+")
narrowAlignments(bam, target, reverse.complement = FALSE)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAlignments.R
\name{setMismatchTileColours}
\alias{setMismatchTileColours}
\title{Sets colours for plotting mismatches in aligned DNA sequences.}
\usage{
setMismatchTileColours(m)
}
\arguments{
\item{m}{A data frame of nucleotides and plotting locations, e.g. created
by \code{\link[CrispRVariants]{transformAlnsToLong}}}
}
\value{
A matrix with additional columns specifying tile and text colours
}
\description{
Sets tile colours for \code{\link[CrispRVariants]{plotAlignments}} with a
DNA alphabet.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/crispRvariants_data.R
\docType{data}
\name{gol_clutch1}
\alias{gol_clutch1}
\alias{gol}
\title{Variant sequences from golden clutch 1 (Burger et al)}
\format{
A CrisprSet object countaining 8 samples
}
\usage{
data(gol_clutch1)
}
\value{
A CrisprSet object named "gol"
}
\description{
This dataset is a subset of the crispant data for the golden gene used by Burger et al (submitted).
}
\details{
\itemize{
\item gol The variants as a CrisprSet object
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{mergeCrisprSets}
\alias{mergeCrisprSets}
\alias{mergeCrisprSets,CrisprSet,CrisprSet-method}
\title{Merge two CrisprSets}
\usage{
mergeCrisprSets(x, y, ...)

\S4method{mergeCrisprSets}{CrisprSet,CrisprSet}(
  x,
  y,
  ...,
  x.samples = NULL,
  y.samples = NULL,
  names = NULL,
  order = NULL
)
}
\arguments{
\item{x}{A CrisprSet object}

\item{y}{A second CrisprSet object}

\item{...}{extra arguments}

\item{x.samples}{A subset of column names or indices to keep from CrispRSet x
(Default: NULL, i.e. keep all)}

\item{y.samples}{A subset of column names or indices to keep from CrispRSet y
(Default: NULL, i.e. keep all)}

\item{names}{New names for the merged CrisprSet object (Default: NULL)}

\item{order}{A list of sample names, matching the names in x and y,
specifying the order of the samples in the new CrisprSet. (Not implemented yet)}
}
\value{
A merged CrisprSet object
}
\description{
Merge two CrisprSet objects sharing a reference and target location
}
\examples{
# Load the metadata table
md_fname <- system.file("extdata", "gol_F1_metadata_small.txt", package = "CrispRVariants")
md <- read.table(md_fname, sep = "\t", stringsAsFactors = FALSE)

# Get bam filenames and their full paths
bam_fnames <- sapply(md$bam.filename, function(fn){
 system.file("extdata", fn, package = "CrispRVariants")})

reference <- Biostrings::DNAString("GGTCTCTCGCAGGATGTTGCTGG")
gd <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399),
      strand = "+")

crispr_set1 <- readsToTarget(bam_fnames[c(1:4)], target = gd,
      reference = reference, names = md$experiment.name[1:4], target.loc = 17)
crispr_set2 <- readsToTarget(bam_fnames[c(5:8)], target = gd,
      reference = reference, names = md$experiment.name[5:8], target.loc = 17)
mergeCrisprSets(crispr_set1,crispr_set2)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readsByPCRPrimer.R
\name{addClipped}
\alias{addClipped}
\alias{addClipped,GAlignments-method}
\title{Extrapolates mapping location from clipped, aligned reads}
\usage{
addClipped(bam, ...)

\S4method{addClipped}{GAlignments}(bam, ...)
}
\arguments{
\item{bam}{A GAlignments object}

\item{...}{additional arguments}
}
\value{
A \code{\link[GenomicRanges]{GRanges}} representation of the extended
mapping locations
}
\description{
Extrapolates the mapping location of a read by assuming that
the clipped regions should map adjacent to the mapped locations.  This
is not always a good assumption, particularly in the case of chimeric reads!
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/barplotAlleleFreqs.R
\name{barplotAlleleFreqs}
\alias{barplotAlleleFreqs}
\alias{barplotAlleleFreqs,CrisprSet-method}
\alias{barplotAlleleFreqs,matrix-method}
\title{Plots barplots of the spectrum of variants for a sample set}
\usage{
barplotAlleleFreqs(obj, ...)

\S4method{barplotAlleleFreqs}{CrisprSet}(
  obj,
  ...,
  txdb,
  min.freq = 0,
  include.chimeras = TRUE,
  group = NULL,
  palette = c("rainbow", "bluered")
)

\S4method{barplotAlleleFreqs}{matrix}(
  obj,
  category.labels = NULL,
  group = NULL,
  bar.colours = NULL,
  group.colours = NULL,
  legend.text.size = 10,
  axis.text.size = 10,
  legend.symbol.size = 1,
  snv.label = "SNV",
  novar.label = "no variant",
  chimera.label = "Other",
  include.table = TRUE,
  classify = TRUE
)
}
\arguments{
\item{obj}{The object to be plotted}

\item{...}{additional arguments}

\item{txdb}{A transcript database object}

\item{min.freq}{Include variants with at frequency least min.freq in at least
one sample.  (Default: 0, i.e. no cutoff)}

\item{include.chimeras}{Should chimeric reads be included in results?
(Default: TRUE)}

\item{group}{A grouping factor for the columns in obj.  Columns in the
same group will be displayed in the same text colour (Default: NULL)}

\item{palette}{Colour palette.  Options are "rainbow", a quantitative palette
(default) or "bluered", a gradient palette.}

\item{category.labels}{Labels for each category, corresponding to the
rows of obj.  Only applicable when categories are provided, i.e.
"classify" is FALSE.  (Default: NULL)}

\item{bar.colours}{Colours for the categories in the barplot.
Colours must be provided if there are more than 6 different categories.}

\item{group.colours}{Colours for the text labels for the experimental groups
A set of 15 different colours is provided.}

\item{legend.text.size}{The size of the legend text, in points.}

\item{axis.text.size}{The size of the axis text, in points}

\item{legend.symbol.size}{The size of the symbols in the legend}

\item{snv.label}{The row label for single nucleotide variants}

\item{novar.label}{The row label for non-variant sequences}

\item{chimera.label}{The row label for chimeric (non-linearly aligned)
variant alleles}

\item{include.table}{Should a table of allele (variant combination)
counts and total sequences be plotted? (Default: TRUE)}

\item{classify}{If TRUE, performs a naive classification by size 
(Default:TRUE)}
}
\value{
A ggplot2 barplot of the allele distribution and optionally a table
of allele counts
}
\description{
For signature "matrix", this function optionally does a very
naive classification of variants by size.  Frameshift variant combinations are
those whose sum is not divisible by three.  Intron boundaries are *NOT* considered,
use with caution!
For signature "CrisprSet", the function uses the VariantAnnotation package to
localize variant alleles with respect to annotated transcripts.  Variants are 
annotated as "coding" when they are coding in any transcript.

(signature("CrisprSet")) Groups variants by size and type
and produces a barplot showing the variant spectrum for each sample.
Accepts all arguments accepted by barplotAlleleFreqs for signature("matrix").
Requires package "VariantAnnotation"

signature("matrix") Accepts a matrix of allele counts,
with rownames being alleles and column names samples.
}
\examples{
data("gol_clutch1")
barplotAlleleFreqs(variantCounts(gol))

# Just show the barplot without the counts table:
barplotAlleleFreqs(variantCounts(gol), include.table = FALSE)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readsByPCRPrimer.R
\name{rmMultiPCRChimera}
\alias{rmMultiPCRChimera}
\alias{rmMultiPCRChimera,character,Hits,integer-method}
\title{Remove chimeric reads overlapping multiple primers}
\usage{
rmMultiPCRChimera(readnames, pcrhits, chimera_idxs, ...)

\S4method{rmMultiPCRChimera}{character,Hits,integer}(readnames, pcrhits, chimera_idxs, ..., verbose = TRUE)
}
\arguments{
\item{readnames}{A set of read names, used for identifying chimeric read sets}

\item{pcrhits}{A mapping between indices of reads and a set of pcr primers}

\item{chimera_idxs}{location of chimeric reads within the bam}

\item{...}{Additional arguments}

\item{verbose}{Display information about the chimeras (Default: TRUE)}
}
\value{
pcrhits, with chimeric reads mapping to different primers omitted.
}
\description{
Finds and removes sets of chimeric read alignments
that overlap more than one guide, i.e. that cannot be unambiguously
assigned to a single guide.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abifToFastq.R
\name{abifToFastq}
\alias{abifToFastq}
\title{Read a file in ab1 (Sanger) format and convert to fastq}
\usage{
abifToFastq(
  seqname,
  fname,
  outfname,
  trim = TRUE,
  cutoff = 0.05,
  min_seq_len = 20,
  offset = 33,
  recall = FALSE
)
}
\arguments{
\item{seqname}{name of sequence, to appear in fastq file}

\item{fname}{filename of sequence in ab1 format}

\item{outfname}{filename to append the fastq output to}

\item{trim}{should low quality bases be trimmed from the ends?  TRUE or FALSE}

\item{cutoff}{probability cutoff}

\item{min_seq_len}{minimum number of sequenced bases required in order to trim
the read}

\item{offset}{phred offset for quality scores}

\item{recall}{Use sangerseqR to resolve the primary sequence if two sequences
are present.  May cause quality scores to be ignored. (Default: FALSE)}
}
\value{
None.  Sequences are appended to the outfname.
}
\description{
This is an R implementation of Wibowo Arindrarto's abifpy.py trimming module,
which itself implement's Richard Mott's trimming algorithm
See \url{https://github.com/bow/abifpy} for more details.
}
\details{
Requires Bioconductor package SangerseqR
}
\examples{
\donttest{
# Running this code will write the fastq file to "IM2033.fastq"
ab1_fname <- system.file("extdata", "IM2033.ab1", package = "CrispRVariants")
abifToFastq("IM2033", ab1_fname, "IM2033.fastq")
}
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotVariants.R
\name{plotVariants}
\alias{plotVariants}
\alias{plotVariants,CrisprSet-method}
\title{Plot alignments, frequencies and location of target sequence}
\usage{
plotVariants(obj, ...)

\S4method{plotVariants}{CrisprSet}(
  obj,
  ...,
  txdb = NULL,
  add.chr = TRUE,
  plotAlignments.args = list(),
  plotFreqHeatmap.args = list()
)
}
\arguments{
\item{obj}{The object to be plotted}

\item{...}{extra arguments for plot layout}

\item{txdb}{GenomicFeatures:TxDb object (default: NULL)}

\item{add.chr}{If target chromosome does not start with "chr", e.g.
"chr5", add the "chr" prefix.  (Default:TRUE)}

\item{plotAlignments.args}{Extra arguments for plotAlignments}

\item{plotFreqHeatmap.args}{Extra arguments for plotFreqHeatmap}
}
\value{
A ggplot2 plot of the variants
}
\description{
Combines a plot of transcript structure, alleles
aligned with respect to a reference genome and a heatmap of
counts or proportions of each allele in a set of data.
}
\examples{
#Load a CrisprSet object for plotting
data("gol_clutch1")

#Load the transcript db.  This is a subset of the Ensembl Danio Rerio v73 gtf
# for the region 18:4640000-4650000 which includes the targeted gol gene

library(GenomicFeatures)
fn <- system.file("extdata", "Danio_rerio.Zv9.73.gol.sqlite",
                 package = "CrispRVariants")
txdb <- loadDb(fn)

# Plot the variants
p <- plotVariants(gol, txdb = txdb)

#In the above plot, the bottom margin is too large, the legend is
#cut off, and the text within the plots should be larger.
#These issues can be fixed with some adjustments:
p <- plotVariants(gol, txdb = txdb,
                 plotAlignments.args = list(plot.text.size = 4, legend.cols = 2),
                 plotFreqHeatmap.args = list(plot.text.size = 4),
                 left.plot.margin = grid::unit(c(0.1,0.2,0.5,1), "lines"))

}
\seealso{
\code{\link{arrangePlots}} for general layout options
and \code{\link{annotateGenePlot}} for options relating
to the transcript plot.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotVariants.R
\name{annotateGenePlot}
\alias{annotateGenePlot}
\title{Plots and annotates transcripts}
\usage{
annotateGenePlot(
  txdb,
  target,
  target.colour = "red",
  target.size = 1,
  gene.text.size = 10,
  panel.spacing = grid::unit(c(0.1, 0.1, 0.1, 0.1), "lines"),
  plot.title = NULL,
  all.transcripts = TRUE
)
}
\arguments{
\item{txdb}{A GenomicFeatures:TxDb object}

\item{target}{Location of target (GRanges)}

\item{target.colour}{Colour of box indicating targt region}

\item{target.size}{Thickness of box indicating target region}

\item{gene.text.size}{Size for figure label}

\item{panel.spacing}{Unit object, margin size}

\item{plot.title}{A title for the plot.  If no plot.title is supplied,
the title is the list of gene ids shown (default).
If plot.title == FALSE, the plot will not have a title.}

\item{all.transcripts}{If  TRUE (default), all transcripts of genes overlapping
the target are shown, including transcripts that do not themselves overlap the target.
If FALSE, only the transcripts that overlap the target are shown.}
}
\value{
A ggplot2 plot of the transcript structures
}
\description{
Plots the gene structure, annotates this with the
target location
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/writeFastq.R
\name{writeFastq}
\alias{writeFastq}
\title{Append a sequence to a fastq file}
\usage{
writeFastq(outf, vals, allow_spaces = FALSE, check = TRUE)
}
\arguments{
\item{outf}{Name of fastq file to append sequence}

\item{vals}{A list containing entries named "seq" (sequence) and
"quals" (quality scores, in ASCII format)}

\item{allow_spaces}{Should spaces in the sequence name be
substituted with underscores?  TRUE or FALSE}

\item{check}{Check whether reads with the same name already
exist in the output fastq.  (Default: TRUE)}
}
\value{
None.  The sequences in "vals" are written to outf
}
\description{
Used by abifToFastq to write sanger sequences
to fastq format  As abifToFastq appends output to files,
writeFastq checks that sequence names are unique.  This
function is faster with checking switched off.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{alleles}
\alias{alleles}
\alias{alleles,CrisprSet-method}
\title{Get allele names}
\usage{
alleles(obj, ...)

\S4method{alleles}{CrisprSet}(obj, ...)
}
\arguments{
\item{obj}{An object containing variant alleles}

\item{...}{additional arguments}
}
\value{
A data frame relating CIGAR strings to variant labels
}
\description{
Function to access allele names
}
\examples{
data("gol_clutch1")
alleles <- alleles(gol)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqsToAln.R
\name{seqsToAln}
\alias{seqsToAln}
\alias{selectAlnRegions}
\title{Creates a text alignment from a set of cigar strings}
\usage{
seqsToAln(
  cigar,
  dnaseq,
  target,
  del_char = "-",
  aln_start = NULL,
  reverse_complement = FALSE,
  allow_partial = FALSE
)

selectAlnRegions(
  alns,
  reference,
  target,
  keep,
  join = "/ \%s /",
  border.gaps = FALSE
)
}
\arguments{
\item{cigar}{A list of cigar strings to align}

\item{dnaseq}{The set of sequences corresponding to the cigars, as Biostrings::DNAStrings}

\item{target}{The target region to return, as GRanges.  Sequences overlapping
the target region are trimmed to exactly match it.}

\item{del_char}{The character to represent deleted bases. Default "-"}

\item{aln_start}{Genomic start locations of aligned sequences. Should be
used in conjunction with target_start and target_end.}

\item{reverse_complement}{(Default: FALSE)}

\item{allow_partial}{Are alignments that do not span the target region allowed?
(Default: FALSE)}

\item{alns}{Character vector of pairwise alignments, with insertions removed}

\item{reference}{Reference sequence}

\item{keep}{Region to display, relative to the target region, i.e.
not genomic coords (IRanges or GRanges)}

\item{join}{character(1) String used for joining alignment segments.
Can accept a placeholder to fill in the number of bases deleted with
"%s", e.g. the default "/ %s /" will appear as "/ 3 /" if 3 bases are
deleted}

\item{border.gaps}{(logical(1)) Should bases deleted from the borders
be shown?  (Default: FALSE)}
}
\value{
The sequences with insertions collapsed and deletions padded

A list of the truncated alignments (alns) and reference (ref)
}
\description{
Creates a one-to-one text alignment of a set of cigar strings with respect
to the reference sequence by collapsing insertions and introducing gaps
across deletions.

When genomic coordinates for the alignment start and the target region
are provided, aligned sequences are cropped to the target region

Given a character vector of pairwise alignments and a
region to display, trims alignments to the display regions, joined by
a separator "join".  Alignments should be equal length, e.g.
created by seqsToAln
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reverseCigar.R
\name{reverseCigar}
\alias{reverseCigar}
\title{Reverses the order of operations in a cigar string}
\usage{
reverseCigar(cigars)
}
\arguments{
\item{cigars}{the cigar strings.}
}
\value{
The reversed cigar string
}
\description{
For example, the string "20M5D15M" would become "15M5D20M"
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CrisprRun.R
\docType{class}
\name{CrisprRun-class}
\alias{CrisprRun-class}
\alias{CrisprRun}
\title{CrisprRun class}
\arguments{
\item{bam}{a GAlignments object containing (narrowed) alignments to the target region.
Filtering of the bam should generally be done before initialising a CrisprRun object}

\item{target}{The target location, a GRanges object}

\item{genome.ranges}{A GRangesList of genomic coordinates for the cigar operations.
If bam is a standard GAlignments object, this is equivalent to
cigarRangesAlongReferenceSpace + start(bam)}

\item{rc}{(reverse complement)  Should the alignments be reverse complemented,
i.e. displayed with respect to the negative strand?  (Default: FALSE)}

\item{name}{A name for this set of reads, used in plots if present (Default: NULL)}

\item{chimeras}{Off-target chimeric alignments not in bam.  (Default: empty)}

\item{verbose}{Print information about initialisation progress (Default: FALSE)}
}
\description{
A ReferenceClass container for a single sample of alignments narrowed
to a target region.  Typically CrisprRun objects will not be accessed directly,
but if necessary via a CrisprSet class which contains a list of CrisprRun objects.  
Note that the CrispRVariants plotting functions don't work on CrisprRun objects.
}
\section{Fields}{

\describe{
\item{\code{alns}}{A GAlignments object containing the narrowed reads.  Note that if the alignments
are represented with respect to the reverse strand, the "start" remains with repect to the
forward strand, whilst the cigar and the sequence are reverse complemented.}

\item{\code{name}}{The name of the sample}

\item{\code{cigar_labels}}{A vector of labels for the reads, based on the cigar strings,
optionally renumbered with respect to a new zero point (e.g. the cut site) and
shortened to only insertion and deletion locations.
Set at initialisation of a CrisprSet object, but not at
initialisation of a CrisprRun object.}

\item{\code{chimeras}}{Chimeric, off-target alignments corresponding to alignments in alns}
}}

\section{Methods}{

\describe{
\item{\code{getCigarLabels(
  target,
  target.loc,
  genome_to_target,
  ref,
  separate.snv,
  rc,
  match.label,
  mismatch.label,
  keep.ops = c("I", "D", "N"),
  upstream = min(target.loc, 8),
  downstream = min(6, width(ref) - target.loc + 1),
  regions = NULL,
  snv.regions = NULL
)}}{Description:
  Sets the "cig_labels" field, returns the cigar labels.

Input parameters:
  target:           (GRanges) the counting region.
  target.loc:       The location of the cut site with respect to the target
  genome_to_target: A vector with names being genomic locations and values
                    being locations with respect to the cut site
  separate.snv:     Should single nucleotide variants be called?  
                    (Default: TRUE)
  match.label:      Label for non-variant reads (Default: no variant)
  mismatch.label:   Label for single nucleotide variants (Default: SNV)
  rc:               Should the variants be displayed with respect to the 
                    negative strand? (Default: FALSE)
  keep.ops:         CIGAR operations to remain in the variant label
                    (usually indels)
  upstream:         distance upstream of the cut site to call SNVs
  downstream:       distance downstream of the cut site to call SNVs
  regions:          IRanges(k) Regions for counting insertions and
                    deletions.  Insertions on the right border are not
                    counted.
  snv.regions       Regions for calling SNVS}

\item{\code{getInsertionSeqs(target)}}{Description:
  Return a table relating insertion sequences to alignment indices
Input parameters:}
}}

\examples{
# readsToTarget with signature("GAlignments", "GRanges") returns a 
# CrisprRun object

bam_fname <- system.file("extdata", "gol_F1_clutch_1_embryo_1_s.bam",
                        package = "CrispRVariants")
param <- Rsamtools::ScanBamParam(what = c("seq", "flag"))
alns <- GenomicAlignments::readGAlignments(bam_fname, param = param, 
         use.names = TRUE)

reference <- Biostrings::DNAString("GGTCTCTCGCAGGATGTTGCTGG")
gd <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399), strand = "+")

crispr_run <- readsToTarget(alns, target = gd, reference = reference,
                           name = "Sample name", target.loc = 17)

# Alternatively, CrisprRun objects can be accessed from a CrisprSet object
# e.g. crispr_set$crispr_runs[[1]]
}
\seealso{
\code{\link{CrisprSet}}
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqsToAln.R
\name{.invertKeepRanges}
\alias{.invertKeepRanges}
\alias{.checkRelativeLocs}
\alias{.adjustRelativeInsLocs}
\alias{.offsetIndices}
\title{Helper functions for selectAlnRegions}
\usage{
.invertKeepRanges(target, keep)

.checkRelativeLocs(target, keep)

.adjustRelativeInsLocs(target, keep, starts, gap_nchars)

.offsetIndices(x, offset)
}
\arguments{
\item{target}{The complete region spanned by the alignments (GRanges)}

\item{keep}{Region to display, relative to the target region, i.e.
not genomic coords (IRanges or GRanges)}

\item{starts}{numeric(n) Insertion locations. When plotting,
the insertion symbol appears at the left border of the
start location.}

\item{gap_nchars}{character(n) Number of letters added to when joining
segments before each region in keep.  If first base of keep is 1,
the first entry of gap_nchars should be 0.}

\item{x}{A vector of group lengths}

\item{offset}{A vector of offset lengths matching x}
}
\value{
Gaps between keep (IRanges), or FALSE if no gap ranges found

insertion_sites (data.frame) with modified start column
}
\description{
(.invertKeepRanges) Internal CrispRVariants function used
by seqsToPartialAlns for checking arguments and getting region to delete.
Returns FALSE if no region to delete found, or region to be deleted is
entire target.

(.checkRelativeLocs) Shift keep to start at 1 if it is
within the target

(.adjustRelativeInsLocs) Internal CrispRVariants function
for shifting insertion locations relative to the target region when
removing a segment of the alignments.  Note that this function does not
do input checking but assumes this has been done upstream. Insertions at
the left border of a gap region are removed.

(.offsetIndices) Get indices of a vector grouped by "x",
cumulatively adding offsets to each group according to "offset"
}
\examples{
CrispRVariants:::.offsetIndices(rep(2,5), c(0:4)*10)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alleleLabels.R
\name{.formatVarLabels}
\alias{.formatVarLabels}
\alias{.findMismatches}
\title{formatVarLabels}
\usage{
.formatVarLabels(
  grl,
  labels,
  position = c("start", "end"),
  genome.to.pos = NULL,
  pos.to.lab = ":",
  as.string = TRUE
)

.findMismatches(
  alns,
  ref.seq,
  ref.start,
  regions = NULL,
  strand = "+",
  min.pct = 0
)
}
\arguments{
\item{grl}{(GRangesList) A GRangesList of variants.  The position
of the variants is used in labels}

\item{labels}{(character(n)) A vector of labels for each variant.
In CrispRVariants, this is the size and type of the variant, e.g. "9D"
for a 9 bp deletion.}

\item{position}{One of "start" and "end".  Determines whether the
start or the end coordinate is used when labeling variants.}

\item{genome.to.pos}{Optional named vector for transforming 
variant coordinates into another coordinate system (Default: NULL)}

\item{pos.to.lab}{(character(1)) Character to join positions and labels
(Default: ":", e.g. -3:9D)}

\item{as.string}{Should individual variant labels be pasted into
a single comma separated string when one alignment has multiple variants?
(Default: TRUE)}

\item{alns}{A GAlignments object, where the aligned sequences should span the
reference sequence}

\item{ref.seq}{A DNAString object, the sequence for comparison when checking
for mismatches.  The sequence does not necessarily have to match the mapping
reference sequence.  Must span all regions if regions are provided.}

\item{ref.start}{(numeric(1)) The genomic start position of the reference sequence}

\item{regions}{A GRanges object, regions to check for mismatches with coordinates
relative to the reference sequence}

\item{strand}{One of "+", "-"}

\item{min.pct}{(numeric(1), between 0 and 100) Only return SNVs that occur
at in least min.pct % of reads.  This tests the occurrence of the exact base
change, not any change at a position.}
}
\value{
A data frame of sequence indices, genomic position of mismatch
and mismatch base
}
\description{
Internal CrispRVariants function for creating allele
labels given variants and positions

Assume that the reference may be on the negative strand and
regions are given with respect to the reference sequence.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readsByPCRPrimer.R
\name{readsByPCRPrimer}
\alias{readsByPCRPrimer}
\alias{readsByPCRPrimer,GAlignments,GRanges-method}
\alias{readsByPCRPrimer,GRanges,GRanges-method}
\title{Finds overlaps between aligned reads and PCR primers}
\usage{
readsByPCRPrimer(bam, primers, ...)

\S4method{readsByPCRPrimer}{GAlignments,GRanges}(
  bam,
  primers,
  ...,
  tolerance = 0,
  verbose = TRUE,
  ignore.strand = TRUE,
  allow.partial = TRUE,
  chimera.idxs = NULL
)

\S4method{readsByPCRPrimer}{GRanges,GRanges}(
  bam,
  primers,
  ...,
  tolerance = 0,
  verbose = TRUE,
  ignore.strand = TRUE,
  allow.partial = TRUE,
  chimera.idxs = NULL
)
}
\arguments{
\item{bam}{A set of aligned reads}

\item{primers}{A set of ranges that the unclipped reads may map to}

\item{...}{Additional arguments}

\item{tolerance}{Number of bases by which reads and primers may differ
at each end (Default: 0)}

\item{verbose}{Print number of full and partial matches (Default: TRUE)}

\item{ignore.strand}{Passed to \code{\link[GenomicAlignments]{findOverlaps}}
and \code{\link[GenomicRanges]{disjoin}}. Should strand be ignored when
finding overlaps.  (Default: TRUE)}

\item{allow.partial}{Should reads that do not match the PCR boundaries, but
map to a region covered by only one primer be considered matches?  (Default: TRUE)}

\item{chimera.idxs}{Indices of chimeric reads within the bam.  If specified,
chimeras overlapping multiple pcr primers will be removed.}
}
\value{
A \code{\link[S4Vectors]{Hits}} object where "query" is the index with
respect to bam and "subject" is the index with respect to the primers.
}
\description{
Short reads amplified with PCR primers should start and end
at defined positions.  However, the ends of an aligned read may be clipped
as sequencing technologies are prone to making errors at the start and end.
readsByPCRPrimer extrapolates the genomic location of entire reads
from their aligned sections by adding clipped sections, then finds near
exact matches to a set of PCR primers.  Note that this is not always a good
assumption, and is misleading in the case of chimeric reads where sections
clipped in one part of a chimera are aligned in another.
}
\seealso{
\code{\link[GenomicRanges]{GRanges}}, \code{\link[GenomicAlignments]{GAlignments}}
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alleleLabels.R
\name{mismatchLabels}
\alias{mismatchLabels}
\title{nonindelLabels}
\usage{
mismatchLabels(
  alns,
  target,
  ref.seq,
  regions = NULL,
  min.pct = 0,
  mismatch.label = "SNV",
  genome.to.pos = NULL,
  as.string = TRUE
)
}
\arguments{
\item{alns}{A GAlignments object, where the aligned sequences should span the
reference sequence}

\item{target}{(GRanges(1)) The region for counting mismatches}

\item{ref.seq}{A DNAString object, the sequence for comparison when checking
for mismatches.  The sequence does not necessarily have to match the mapping
reference sequence.  Must span all regions if regions are provided.}

\item{regions}{A GRanges object, regions to check for mismatches with coordinates
relative to the reference sequence}

\item{min.pct}{(numeric(1), between 0 and 100) Only return SNVs that occur
at in least min.pct % of reads.  This tests the occurrence of the exact base
change, not any change at a position.}

\item{mismatch.label}{(character(1)) Label to append to the start of mismatch
strings, if returning as a single string (Default: "SNV:")}

\item{genome.to.pos}{Optional named vector for transforming 
variant coordinates into another coordinate system (Default: NULL)}

\item{as.string}{Should individual variant labels be pasted into
a single comma separated string when one alignment has multiple variants?
(Default: TRUE)}
}
\value{
A data frame of sequence indices, genomic position of mismatch
and mismatch base
}
\description{
Make variant labels for variants without an insertion or deletion
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialisers.R
\name{readsToTarget}
\alias{readsToTarget}
\alias{readsToTarget,GAlignments,GRanges-method}
\alias{readsToTarget,GAlignmentsList,GRanges-method}
\alias{readsToTarget,character,GRanges-method}
\alias{readsToTargets}
\alias{readsToTargets,character,GRanges-method}
\alias{readsToTargets,GAlignmentsList,GRanges-method}
\title{Trims reads to a target region.}
\usage{
readsToTarget(reads, target, ...)

\S4method{readsToTarget}{GAlignments,GRanges}(
  reads,
  target,
  ...,
  reverse.complement = TRUE,
  chimeras = NULL,
  collapse.pairs = FALSE,
  use.consensus = FALSE,
  store.chimeras = FALSE,
  verbose = TRUE,
  name = NULL,
  minoverlap = NULL,
  orientation = c("target", "opposite", "positive")
)

\S4method{readsToTarget}{GAlignmentsList,GRanges}(
  reads,
  target,
  ...,
  reference = reference,
  names = NULL,
  reverse.complement = TRUE,
  target.loc = 17,
  chimeras = NULL,
  collapse.pairs = FALSE,
  use.consensus = FALSE,
  orientation = c("target", "opposite", "positive"),
  minoverlap = NULL,
  verbose = TRUE
)

\S4method{readsToTarget}{character,GRanges}(
  reads,
  target,
  ...,
  reference,
  reverse.complement = TRUE,
  target.loc = 17,
  exclude.ranges = GRanges(),
  exclude.names = NA,
  chimeras = c("count", "exclude", "ignore", "merge"),
  collapse.pairs = FALSE,
  use.consensus = FALSE,
  orientation = c("target", "opposite", "positive"),
  names = NULL,
  minoverlap = NULL,
  verbose = TRUE
)

readsToTargets(reads, targets, ...)

\S4method{readsToTargets}{character,GRanges}(
  reads,
  targets,
  ...,
  references,
  primer.ranges = NULL,
  target.loc = 17,
  reverse.complement = TRUE,
  collapse.pairs = FALSE,
  use.consensus = FALSE,
  ignore.strand = TRUE,
  names = NULL,
  bpparam = BiocParallel::SerialParam(),
  orientation = c("target", "opposite", "positive"),
  chimera.to.target = 5,
  verbose = TRUE
)

\S4method{readsToTargets}{GAlignmentsList,GRanges}(
  reads,
  targets,
  ...,
  references,
  primer.ranges = NULL,
  target.loc = 17,
  reverse.complement = TRUE,
  collapse.pairs = FALSE,
  use.consensus = FALSE,
  ignore.strand = TRUE,
  names = NULL,
  bpparam = BiocParallel::SerialParam(),
  chimera.to.target = 5,
  orientation = c("target", "opposite", "positive"),
  verbose = TRUE
)
}
\arguments{
\item{reads}{A GAlignments object, or a character vector of the filenames}

\item{target}{A GRanges object specifying the range to narrow alignments to}

\item{...}{Extra arguments for initialising CrisprSet}

\item{reverse.complement}{(Default: TRUE)  Should the alignments be
oriented to match the strand of the target? If TRUE, targets located 
strand and targets on the negative strand with respect to the 
negative strand. If FALSE, the parameter 'orientation' must be set
to determine the orientation.  
'reverse.complement' will be replaced by 'orientation' in a later release.}

\item{chimeras}{Flag to determine how chimeric reads are treated.  One of
"ignore", "exclude", and "merge".  Default "count", "merge" not implemented yet}

\item{collapse.pairs}{If reads are paired, should pairs be collapsed? 
(Default: FALSE) Note: only collapses primary alignments, 
and assumes that there is only one primary alignment per read.}

\item{use.consensus}{Take the consensus sequence for non-matching pairs? If FALSE,
the sequence of the first read is used.  Can be very slow. (Default: FALSE)}

\item{store.chimeras}{Should chimeric reads be stored?  (Default: FALSE)}

\item{verbose}{Print progress and statistics (Default: TRUE)}

\item{name}{An experiment name for the reads.  (Default: NULL)}

\item{minoverlap}{Minimum number of bases the aligned read must 
share with the target site.  If not specified, the aligned
read must completely span the target region.  (Default: NULL)}

\item{orientation}{One of "target" (reads are displayed on the same
strand as the target) "opposite" (reads are displayed on the opposite)
strand from the target or "positive" (reads are displayed on the forward
strand regardless of the strand of the target)   (Default:"target")}

\item{reference}{The reference sequence}

\item{names}{Experiment names for each bam file.  If not supplied, filenames are used.}

\item{target.loc}{The zero point for renumbering (Default: 17)}

\item{exclude.ranges}{Ranges to exclude from consideration, e.g. homologous to a pcr primer.}

\item{exclude.names}{Alignment names to exclude}

\item{targets}{A set of targets to narrow reads to}

\item{references}{A set of reference sequences matching the targets.
References for negative strand targets should be on the negative strand.}

\item{primer.ranges}{A set of GRanges, corresponding to the targets.
Read lengths are typically greater than target regions, and it can
be that reads span multiple targets.  If primer.ranges are available,
they can be used to assign such reads to the correct target.}

\item{ignore.strand}{Should strand be considered when finding overlaps?
(See \code{\link[GenomicAlignments]{findOverlaps}} )}

\item{bpparam}{A BiocParallel parameter for parallelising across reads.
Default: no parallelisation.  (See \code{\link[BiocParallel]{bpparam}})}

\item{chimera.to.target}{Number of bases that may separate a chimeric read
set from the target.loc for it to be assigned to the target. (Default: 5)}
}
\value{
(signature("GAlignments", "GRanges")) A \code{\link{CrisprRun}} object

(signature("character", "GRanges")) A \code{\link{CrisprSet}} object
}
\description{
Trims aligned reads to one or several target regions,
optionally reverse complementing the alignments.
}
\examples{
# Load the metadata table
md_fname <- system.file("extdata", "gol_F1_metadata_small.txt", package = "CrispRVariants")
md <- read.table(md_fname, sep = "\t", stringsAsFactors = FALSE)

# Get bam filenames and their full paths
bam_fnames <- sapply(md$bam.filename, function(fn){
 system.file("extdata", fn, package = "CrispRVariants")})

reference <- Biostrings::DNAString("GGTCTCTCGCAGGATGTTGCTGG")
gd <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399),
       strand = "+")

crispr_set <- readsToTarget(bam_fnames, target = gd, reference = reference,
                           names = md$experiment.name, target.loc = 17)

}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAlignments.R
\name{setDNATileColours}
\alias{setDNATileColours}
\title{Sets colours for plotting aligned DNA sequences.}
\usage{
setDNATileColours(m)
}
\arguments{
\item{m}{A matrix with a column named "value" of the characters at each tile position.}
}
\value{
A matrix with additional columns specifying tile and text colours
}
\description{
Sets tile colours for \code{\link[CrispRVariants]{plotAlignments}} with a
DNA alphabet
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/excludeFromBam.R
\name{excludeFromBam}
\alias{excludeFromBam}
\title{Removes reads from a bam file}
\usage{
excludeFromBam(bam, exclude.ranges = GRanges(), exclude.names = NA)
}
\arguments{
\item{bam}{a GAlignments object}

\item{exclude.ranges}{Regions to exclude, as \code{\link[GenomicRanges]{GRanges}}.}

\item{exclude.names}{A character vector of alignments names to exclude}
}
\value{
The bam minus the excluded regions
}
\description{
Returns a GAlignments excluding reads based on either name and/or location
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CrisprSet.R
\docType{class}
\name{CrisprSet-class}
\alias{CrisprSet-class}
\alias{CrisprSet}
\title{CrisprSet class}
\arguments{
\item{crispr.runs}{A list of CrisprRun objects, typically representing individual samples
within an experiment}

\item{reference}{The reference sequence, must be the same length as the target region}

\item{target}{The target location (GRanges).  Variants will be counted over this region.
Need not correspond to the guide sequence.}

\item{rc}{Should the alignments be reverse complemented,
i.e. displayed w.r.t the reverse strand? (default: FALSE)}

\item{names}{A list of names for each of the samples, e.g. for displaying in plots.
If not supplied, the names of the crispr.runs are used, which default to the filenames
of the bam files if available (Default: NULL)}

\item{renumbered}{Should the variants be renumbered using target.loc as the zero point?
If TRUE, variants are described by the location of their 5'-most base with respect to the
target.loc.  A 3bp deletion starting 5bp 5' of the cut site would be labelled
as -5:3D (Default: TRUE)}

\item{target.loc}{The location of the Cas9 cut site with respect to the supplied target.
(Or some other central location).  Can be displayed on plots and used as the zero point
for renumbering variants. For a target region with the PAM location from bases 21-23,
the target.loc is base 17 (default: 17)}

\item{match.label}{Label for sequences with no variants (default: "no variant")}

\item{mismatch.label}{Label for sequences with only single nucleotide variants
(default: "SNV")}

\item{bpparam}{A BiocParallel parameter object specifying how many cores to use.
The parallelisable step is calling SNVs. Parallelisation is by sample.
(default: SerialParam, i.e. no parallelization)}

\item{verbose}{If true, prints information about initialisation progress (default: TRUE)}
}
\description{
A ReferenceClass container for holding a set of narrowed alignments,
each corresponding to the same target region.  Individual samples are
represented as CrisprRun objects.  CrisprRun objects with no on-target
reads are excluded.
CrisprSet objects are constructed with \code{\link{readsToTarget}} or
\code{\link{readsToTargets}}.  For most use cases, a CrisprSet object should not
be initialized directly.
}
\section{Fields}{

\describe{
\item{\code{crispr_runs}}{A list of CrisprRun objects, typically corresponding to samples
of an experiment.}

\item{\code{ref}}{The reference sequence for the target region, as a Biostrings::DNAString object}

\item{\code{cigar_freqs}}{A matrix of counts for each variant}

\item{\code{target}}{The target location, as a GRanges object}
}}

\section{Methods}{

\describe{
\item{\code{classifyCodingBySize(var_type, cutoff = 10)}}{Description:
    This is a naive classification of variants as frameshift or in-frame
    Coding indels are summed, and indels with sum divisible by 3 are
    considered frameshift.  Note that this may not be correct for variants
    that span an intron-exon boundary
Input paramters:
    var_type:   A vector of var_type. Only variants with var_type == "coding" 
                are considered.  Intended to work with classifyVariantsByLoc
    cutoff:     Variants are divided into those less than and greater 
                than "cutoff" (Default: 10)
Result:
    A character vector with a classification for each variant allele}

\item{\code{classifyVariantsByLoc(txdb, add_chr = TRUE, verbose = TRUE, ...)}}{Description:
  Uses the VariantAnnotation package to look up the location of the
  variants.  VariantAnnotation allows multiple classification tags per variant,
  this function returns a single tag.  The following preference order is used:
  spliceSite > coding > intron > fiveUTR > threeUTR > promoter > intergenic

Input parameters:
  txdb:     A BSgenome transcription database
  add_chr:  Add "chr" to chromosome names to make compatible with UCSC (default: TRUE)
  verbose:  Print progress (default: TRUE)
  ...:      Filtering arguments for variantCounts

Return value:
  A vector of classification tags, matching the rownames of .self$cigar_freqs
  (the variant count table)
  }

\item{\code{classifyVariantsByType(...)}}{Description:
  Classifies variants as insertions, deletions, or complex (combinations).
  In development
Input parameters:
  ...   Optional arguments to "variantCounts" for filtering variants
        before classification
Return value:
  A named vector classifying variant alleles as insertions, deletions, etc}

\item{\code{consensusAlleles(
  cig_freqs = .self$cigar_freqs,
  return_nms = TRUE,
  match.ops = c("M", "X", "=")
)}}{Description:
Get variants by their cigar string, make the pairwise alignments for the consensus
sequence for each variant allele

Input parameters:
cig_freqs:  A table of variant allele frequencies (by default: .self$cigar_freqs,
but could also be filtered)
return_nms: If true, return a list of sequences and labels (Default:FALSE)
match.ops:  CIGAR operations for 1-1 alignments

Return:
A DNAStringSet of the consensus sequences for the specified alleles,
or a list containing the consensus sequences and names for the labels
if return_nms = TRUE}

\item{\code{filterUniqueLowQual(min_count = 2, max_n = 0, verbose = TRUE)}}{Description:
  Deletes reads containing rare variant combinations and more than
  a minimum number of ambiguity characters within the target region.
  These are assumed to be alignment errors.

Input parameters:
  min_count:    the number of times a variant combination must occur across
                all samples to keep (default: 2, i.e. a variant must occur
                at least twice in one or more samples to keep)
  max_n:        maximum number of ambiguity ("N") bases a read with a rare
                variant combination may contain.  (default: 0)
  verbose:      If TRUE, print the number of sequences removed (default: TRUE)}

\item{\code{filterVariants(
  cig_freqs = NULL,
  names = NULL,
  columns = NULL,
  include.chimeras = TRUE
)}}{Description:
  Relabels specified variants in a table of variant allele counts as 
  non-variant, e.g. variants known to exist in control samples.
  Accepts either a size, e.g. "1D", or a specific mutation, e.g. "-4:3D".
  For alleles that include one variant to be filtered and one other variant,
  the other variant will be retained.
  If SNVs are included, these will be removed entirely, but note that SNVs
  are only called in reads that do not contain an insertion/deletion variant

Input parameters:
  cig_freqs:        A table of variant allele counts 
                    (Default: NULL, i.e. .self$cigar_freqs)
  names:            Labels of variants alleles to remove (Default: NULL)
  columns:          Indices or names of control samples.  Remove all variants that 
                    occur in these columns.  (Default: NULL)
  include.chimeras: Should chimeric reads be included? (Default: TRUE)}

\item{\code{heatmapCigarFreqs(
  as.percent = TRUE,
  x.size = 8,
  y.size = 8,
  x.axis.title = NULL,
  x.angle = 90,
  min.freq = 0,
  min.count = 0,
  top.n = nrow(.self$cigar_freqs),
  type = c("counts", "proportions"),
  header = c("default", "counts", "efficiency"),
  order = NULL,
  alleles = NULL,
  create.plot = TRUE,
  ...
)}}{Description:
    Internal method for CrispRVariants:plotFreqHeatmap, optionally filters the table
    of variants, then a table of variant counts, coloured by counts or proportions.

Input parameters:
    as.percent:   Should colours represent the percentage of reads per sample 
                  (TRUE) or the actual counts (FALSE)?  (Default: TRUE)
    x.size:       Font size for x axis labels (Default: 8)
    y.size:       Font size for y axis labels (Default: 8)
    x.axis.title: Title for x axis
    min.freq:     Include only variants with frequency at least min.freq in at 
                  least one sample
    min.count:    Include only variants with count at least min.count in at 
                  least one sample
    top.n:        Include only the n most common variants
    type:         Should labels show counts or proportions?  (Default: counts)
    header:       What should be displayed in the header of the heatmap.
                  Default: total count for type = "counts" or proportion of
                  reads shown in the matrix for type = "proportions".
                  If "counts" is selected, total counts will be shown for both
                  types.  "efficiency" shows the mutation efficiency
                  (calculated with default settings)
    order:        Reorder the columns according to this order (Default: NULL)
    alleles:      Names of alleles to include.  Selection of alleles takes
                  place after filtering (Default: NULL).
    exclude:      Names of alleles to exclude (Default: NULL)
    create.plot:  Should the plot be created (TRUE, default), or the data used in
                  the plot returned.
    ...:          Extra filtering or plotting options

Return value:
    A ggplot2 plot object.  Call "print(obj)" to display

See also:
    CrispRVariants::plotFreqHeatmap
    }

\item{\code{makePairwiseAlns(cig_freqs = .self$cigar_freqs, ...)}}{Description:
Get variants by their cigar string, make the pairwise alignments for the consensus
sequence for each variant allele

Input parameters:
cig_freqs:  A table of variant allele frequencies (by default: .self$cigar_freqs,
            but could also be filtered)
...:        Extra arguments for CrispRVariants::seqsToAln, e.g. which symbol
            should be used for representing deleted bases}

\item{\code{mutationEfficiency(
  snv = c("non_variant", "include", "exclude"),
  include.chimeras = TRUE,
  exclude.cols = NULL,
  group = NULL,
  filter.vars = NULL,
  filter.cols = NULL,
  count.alleles = FALSE,
  per.sample = TRUE,
  min.freq = 0
)}}{Description:
  Calculates summary statistics for the mutation efficiency, i.e.
  the percentage of reads that contain a variant.  Reads that do not
  contain and insertion or deletion, but do contain a single nucleotide
  variant (snv) can be considered as mutated, non-mutated, or not
  included in efficiency calculations as they are ambiguous.
  Note: mutationEfficiency does not treat partial alignments differently


Input parameters:
  snv:    One of "include" (consider reads with mismatches to be mutated),
          "exclude" (do not include reads with snvs in efficiency calculations),
          and "non_variant" (consider reads with mismatches to be non-mutated).
  include.chimeras: Should chimeras be counted as variants?  (Default: TRUE)
  exclude.cols:   A list of column names to exclude from calculation, e.g. if one
                  sample is a control (default: NULL, i.e. include all columns)
  group:          A grouping variable.  Efficiency will be calculated per group,
                  instead of for individual.
                  Cannot be used with exclude.cols.
  filter.vars:    Variants that should not be counted as mutations.
  filter.cols:    Column names to be considered controls.  Variants occuring in
                  a control sample will not be counted as mutations.
  count.alleles:  If TRUE, also report statistics about the number of alleles
                  per sample/per group. (Default:  FALSE)
  per.sample:     Return efficiencies for each sample (Default: TRUE)
  min.freq:       Minimum frequency for counting alleles.  Does not apply to
                  calculating efficiency.  To filter when calculating 
                  efficiency, first use "variantCounts".
                  (Default: 0, i.e. no filtering)
Return value:
  A vector of efficiency statistics per sample and overall, or a
  matrix if a group is supplied.}

\item{\code{plotVariants(
  min.freq = 0,
  min.count = 0,
  top.n = nrow(.self$cigar_freqs),
  alleles = NULL,
  renumbered = .self$pars["renumbered"],
  add.other = TRUE,
  create.plot = TRUE,
  plot.regions = NULL,
  allow.partial = TRUE,
  ...
)}}{Description:
  Internal method for CrispRVariants:plotAlignments, optionally filters the table
  of variants, then plots variants with respect to the reference sequence,
  collapsing insertions and displaying insertion sequences below the plot.

Input parameters:
  min.freq:         i(%) include variants that occur in at least i% of reads
                    in at least one sample
  min.count         i (integer) include variants that occur at leas i times in
                    at least one sample
  top.n:            n (integer) Plot only the n most frequent variants
                    (default: plot all)
                    Note that if there are ties in variant ranks,
                    top.n only includes ties with all members ranking <= top.n
  alleles:          Alleles to include after filtering.  Default NULL means use all
                    alleles that pass filtering.
  renumbered:       If TRUE, the x-axis is numbered with respect to the target
                    (cut) site.  If FALSE, x-axis shows genomic locations.
                    (default: TRUE)
  add.other         Add a blank row named "Other" for chimeric alignments,
                    if there are any (Default: TRUE)
  create.plot       Data is plotted if TRUE and returned without if FALSE.
                    (Default: TRUE)
  plot.regions      Subregion of the target to plot (Default: NULL)
  allow.partial     Should partial alignments be allowed?  (Default: TRUE)
  ...               additional arguments for plotAlignments

Return value:
  A ggplot2 plot object.  Call "print(obj)" to display}
}}

\examples{
# Load the metadata table
md_fname <- system.file("extdata", "gol_F1_metadata_small.txt", package = "CrispRVariants")
md <- read.table(md_fname, sep = "\t", stringsAsFactors = FALSE)

# Get bam filenames and their full paths
bam_fnames <- sapply(md$bam.filename, function(fn){
 system.file("extdata", fn, package = "CrispRVariants")})

reference <- Biostrings::DNAString("GGTCTCTCGCAGGATGTTGCTGG")
gd <- GenomicRanges::GRanges("18", IRanges::IRanges(4647377, 4647399), strand = "+")

crispr_set <- readsToTarget(bam_fnames, target = gd, reference = reference,
                           names = md$experiment.name, target.loc = 17)
}
\seealso{
\code{\link{readsToTarget}} and \code{\link{readsToTargets}}
for initialising a CrisprSet, \code{\link{CrisprRun}} container for sample data.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialisers.R
\name{collapsePairs}
\alias{collapsePairs}
\title{Internal CrispRVariants function for collapsing pairs with concordant indels}
\usage{
collapsePairs(
  alns,
  use.consensus = TRUE,
  keep.unpaired = TRUE,
  verbose = TRUE,
  ...
)
}
\arguments{
\item{alns}{A GAlignments object.  We do not use GAlignmentPairs because amplicon-seq
can result in pairs in non-standard pairing orientation.
Must include BAM flag, must not include unmapped reads.}

\item{use.consensus}{Should the consensus sequence be used if pairs have a mismatch?
Setting this to be TRUE makes this function much slower (Default: TRUE)}

\item{keep.unpaired}{Should unpaired and chimeric reads be included?  (Default: TRUE)}

\item{verbose}{Report statistics on reads kept and excluded}

\item{...}{Additional items with the same length as alns,
that should be filtered to match alns.}
}
\value{
The alignments, with non-concordant pairs removed and concordant pairs
represented by a single read.
}
\description{
Given a set of alignments to a target region, finds read pairs.
Compares insertion/deletion locations within pairs using the cigar string.
Pairs with non-identical indels are excluded.  Pairs with identical indels are
collapsed to a single read, taking the consensus sequence of the pairs.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{findSNVs}
\alias{findSNVs}
\alias{findSNVs,CrisprSet-method}
\title{Find frequent SNVs}
\usage{
findSNVs(obj, ...)

\S4method{findSNVs}{CrisprSet}(obj, ..., freq = 0.25, include.chimeras = TRUE)
}
\arguments{
\item{obj}{An object containing variant counts}

\item{...}{additional arguments}

\item{freq}{minimum frequency snv to return (Default: 0.25)}

\item{include.chimeras}{include chimeric reads when calculating SNV frequencies
(Default: TRUE)}
}
\value{
A vector of SNVs and their frequencies
}
\description{
Find single nucleotide variants (SNVs) above a specified frequency
in a table of variants.
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alleleLabels.R
\name{indelLabels}
\alias{indelLabels}
\title{indelLabels}
\usage{
indelLabels(
  alns,
  rc = FALSE,
  genome.to.pos = NULL,
  keep.ops = c("I", "D", "N"),
  regions = NULL,
  as.string = TRUE,
  ...
)
}
\arguments{
\item{alns}{(GAligments) aligned reads for finding variants}

\item{rc}{Should the variants be displayed with respect to the 
negative strand? (Default: FALSE)}

\item{genome.to.pos}{A vector with names being genomic locations and
values being positions to use in labels (Default: NULL)}

\item{keep.ops}{CIGAR operations to remain in the variant label
(usually indels)}

\item{regions}{IRanges(k) Regions for counting insertions and
deletions.  Insertions on the right border are not counted.}

\item{as.string}{Return labels as strings (Default: TRUE)}

\item{...}{extra formatting arguments}
}
\value{
A vector of labels for alns
}
\description{
Makes allele labels for insertion / deletion variants
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/refFromAlns.R
\name{refFromAlns}
\alias{refFromAlns}
\alias{refFromAlns,GAlignments,ANY-method}
\alias{refFromAlns,GAlignments,GRanges-method}
\title{refFromAlns}
\usage{
refFromAlns(alns, location, ...)

\S4method{refFromAlns}{GAlignments,ANY}(alns, location, ..., keep.names = FALSE)

\S4method{refFromAlns}{GAlignments,GRanges}(alns, location, ...)
}
\arguments{
\item{alns}{Alignments to use for inferring the reference sequence}

\item{location}{The location to infer the reference for.}

\item{...}{additional arguments}

\item{keep.names}{Should read names be added to the result if present?
(Default: FALSE)}
}
\value{
The reference sequences corresponding to the provided alignments

A DNAStringSet (signature = c("GAlignments", "ANY"))

A DNAString (signature = c("GAlignments", "GRanges"))
}
\description{
Reconstruct the reference sequence from alignments reads using the CIGAR
}
\examples{
bam <- system.file("extdata", "bam/ab1_ptena_wildtype_looking_embryo_1_s.bam",
                  package = "CrispRVariants")
alns <- GenomicAlignments::readGAlignments(bam,
          param = Rsamtools::ScanBamParam(tag = "MD", what = "seq"))
# To get the reference sequence from the a given location:
location <- GenomicRanges::GRanges("chr17", IRanges::IRanges(23648420,23648430))
refFromAlns(alns, location = location)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{countDeletions}
\alias{countDeletions}
\alias{countDeletions,GAlignments-method}
\alias{countInsertions}
\alias{countInsertions,GAlignments-method}
\alias{countIndels}
\alias{countIndels,GAlignments-method}
\alias{indelPercent}
\alias{indelPercent,GAlignments-method}
\title{Count the number of reads containing an insertion or deletion}
\usage{
countDeletions(alns, ...)

\S4method{countDeletions}{GAlignments}(
  alns,
  ...,
  multi.del = FALSE,
  del.and.ins = FALSE,
  del.ops = c("D")
)

countInsertions(alns, ...)

\S4method{countInsertions}{GAlignments}(
  alns,
  ...,
  ins.and.del = FALSE,
  multi.ins = FALSE,
  del.ops = c("D")
)

countIndels(alns)

\S4method{countIndels}{GAlignments}(alns)

indelPercent(alns)

\S4method{indelPercent}{GAlignments}(alns)
}
\arguments{
\item{alns}{The aligned reads}

\item{...}{extra arguments}

\item{multi.del}{If TRUE, returns the exact number of deletions,
i.e., if one read contains 2 deletions, it contributes 2 to the
total count (default: FALSE)}

\item{del.and.ins}{If TRUE, counts deletions regardless of whether
reads also contain insertions.  If FALSE, counts reads that contain
deletions but not insertions (default: FALSE)}

\item{del.ops}{Cigar operations counted as deletions.  Default: c("D")}

\item{ins.and.del}{If TRUE, counts insertions regardless of whether
reads also contain deletions  If FALSE, counts reads that contain
insertions but not deletions (default: FALSE)}

\item{multi.ins}{If TRUE, returns the exact number of insertions,
i.e., if one read contains 2 insertions, it contributes 2 to the
total count (default: FALSE)}
}
\value{
countDeletions: The number of reads containing a deletion (integer)

countInsertions: The number of reads containing an insertion (integer)

countIndels: The number of reads containing at least one insertion

indelPercent: The percentage of reads containing an insertion or
deletion (numeric)
}
\description{
Counts the number of reads containing a deletion or insertion
(indel) of any size in a set of aligned reads.
For countDeletions and countInsertions Reads may be filtered according to
whether they contain more than one indel of the same or different types.
}
\examples{
bam_fname <- system.file("extdata", "gol_F1_clutch_2_embryo_4_s.bam",
                         package = "CrispRVariants")
bam <- GenomicAlignments::readGAlignments(bam_fname, use.names = TRUE)
countDeletions(bam)
countInsertions(bam)
countIndels(bam)
indelPercent(bam)
}
\author{
Helen Lindsay
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotChimeras.R
\name{plotChimeras}
\alias{plotChimeras}
\title{Display a dot plot of chimeric alignments}
\usage{
plotChimeras(
  chimeric.alns,
  max.gap = 10,
  tick.sep = 20,
  text.size = 10,
  title.size = 16,
  gap.pad = 20,
  legend.title = "Chromosome",
  xangle = 90,
  wrt.forward = FALSE,
  annotate.within = 20,
  annotations = GenomicRanges::GRanges()
)
}
\arguments{
\item{chimeric.alns}{A GAlignments object containing only the chimeric
reads to be plotted}

\item{max.gap}{If aligned segments are separated by more than max.gap,}

\item{tick.sep}{How many bases should separate tick labels on plot.  Default 20.}

\item{text.size}{Size of X and Y tick labels on plot.  Default 12}

\item{title.size}{Size of X and Y axis labels on plot.  Default 16}

\item{gap.pad}{How much should aligned blocks be separated by?  (Default: 20)}

\item{legend.title}{Title for the legend.  Default "Chromosome"}

\item{xangle}{Angle for x axis text (Default 90, i.e vertical)}

\item{wrt.forward}{Should chimeric alignments where all members map to the
negative strand be displayed with respect to the forward strand, i.e. as the
cigar strand is written (TRUE), or the negative strand (FALSE) (Default: FALSE)}

\item{annotate.within}{annot_aln ranges in "annotations" within n bases of a chimeric
alignment (Default 50)}

\item{annotations}{A list of GRanges.  Any that overlap with the chimeric alignments
are highlighed in the plot.}
}
\value{
A ggplot2 dotplot of the chimeric alignments versus the reference sequence
}
\description{
Produces a dot plot of a set of chimeric alignments.  For chimeric alignments,
a single read is split into several, possibly overlapping alignmed blocks.
Aligned sections of chimeric reads can be separated by large genomic distances,
or on separate chromosomes.  plotChimeras produces a dot plot, each aligned block
highlighted, and chromosomes shown in different colours. Large gaps between
aligned segments are collapsed and indicated on the plot with horizontal lines.
The X-axis shows each base of the entire read. Note that the mapping to the fwd strand
is shown if all strands agree.  The chimeric alignments must be sorted!
}
\examples{
bam_fname <- system.file("extdata", "gol_F1_clutch_2_embryo_4_s.bam",
                         package = "CrispRVariants")
bam <- GenomicAlignments::readGAlignments(bam_fname, use.names = TRUE)
# Choose a single chimeric read set to plot:
chimeras <- bam[names(bam) == "AB3092"]

# This read aligns in 3 pieces, all on chromosome 18.
# The plot shows the alignment annot_alns a small duplication and
# a long gap.
plotChimeras(chimeras)
}
\seealso{
\code{\link{findChimeras}} for finding chimeric alignment sets.
}
\author{
Helen Lindsay
}
